<?php 
/** 
* Magento Module developed by NoStress Commerce 
* 
* NOTICE OF LICENSE 
* 
* This source file is subject to the Open Software License (OSL 3.0) 
* that is bundled with this package in the file LICENSE.txt. 
* It is also available through the world-wide-web at this URL: 
* http://opensource.org/licenses/osl-3.0.php 
* If you did of the license and are unable to 
* obtain it through the world-wide-web, please send an email 
* to info@nostresscommerce.cz so we can send you a copy immediately. 
* 
* @copyright Copyright (c) 2009 NoStress Commerce (http://www.nostresscommerce.cz) 
* 
*/ 

/** 
* 
* @category Nostress 
* @package Nostress_Nscexport
* 
*/

class Nostress_Nscexport_Model_Data_Reader_Abstract_Csv extends Nostress_Nscexport_Model_Data_Reader_Abstract_Text
{   
	const DELIMITER = 'delimiter';	
	protected $_columnDelimiter = "|";
		
	protected function initParam(&$param,$value)
	{
		if(isset($value) && !empty($value))
			$param = $value;
	}
	
	protected function initParams($params)
	{
		$this->initParam($this->_columnDelimiter,$params[self::DELIMITER]); 
	}
	/**
	 * Returns one record from file as array 
	 */
	public function getRecord()
	{				
		if(isset($this->_handle))
			return fgetcsv($this->_handle,null,$this->_columnDelimiter);
		else 
			return false;
	}
}
?>