<?php
/**
 * Pre-Orders
 *
 * @category:    Aitoc
 * @package:     Aitoc_Aitpreorder
 * @version      1.1.40
 * @license:     0DMhQYOdlQVaorpLyxYHyL27EIMKklPz0C7NSJhsna
 * @copyright:   Copyright (c) 2014 AITOC, Inc. (http://www.aitoc.com)
 */
/**
* @copyright  Copyright (c) 2009 AITOC, Inc. 
*/

class Aitoc_Aitpreorder_Block_Rewrite_AdminhtmlCatalogProductEditTabInventory extends Mage_Adminhtml_Block_Catalog_Product_Edit_Tab_Inventory
{	
	private $_restrictedTypes = array(
		Mage_Catalog_Model_Product_Type::TYPE_BUNDLE,
		Mage_Catalog_Model_Product_Type::TYPE_CONFIGURABLE,
		Mage_Catalog_Model_Product_Type::TYPE_GROUPED,
		Mage_Catalog_Model_Product_Type::TYPE_VIRTUAL,
	);
	private $_currentAitProduct = null;	

	public function getAitCurrentProduct()
	{
		return $this->getProduct();		
	}

	public function getDisabled()
	{
		return $this->isPreorder() ? '' : 'disabled="disabled"';
	}

	public function getPreorderDescription()
	{
		$description = $this->getAitCurrentProduct()->getPreorderdescript();
		return strlen($description) ? $description : '';
	}

	public function isPreorder()
	{
		return (int) $this->getAitCurrentProduct()->getPreorder() == 1;
	}

	public function getDataArray()
	{
		return array(			
			'is_preorder' => $this->isPreorder(),
			'preorder_description' => $this->getPreorderDescription(),
			'disabled' => $this->getDisabled(),
		);
	}

	public function getRestrictedTypes()
	{
		return $this->_restrictedTypes;
	}

	public function canShowBlock()
	{
		return !in_array($this->getAitCurrentProduct()->getData('type_id'), $this->getRestrictedTypes());
	}

	public function getDescriptionAttributeScope()
	{
		$html = '';
		$attribute = Mage::getSingleton('eav/config')->getAttribute('catalog_product', 'preorderdescript');
		
        if ($attribute->isScopeGlobal()) {
            $html.= '[GLOBAL]';
        }
        elseif ($attribute->isScopeWebsite()) {
            $html.= '[WEBSITE]';
        }
        elseif ($attribute->isScopeStore()) {
            $html.= '[STORE VIEW]';
        }

        return $html;
	}
	
    protected function _toHtml()
    {
		$result = parent::_toHtml();

		if ($this->canShowBlock())
		{
			$preorder = $this->getLayout()
				->createBlock('core/template', '', $this->getDataArray())
				->setTemplate('aitpreorder/preorderinventory.phtml')
				->setDescriptionAttributeScope($this->getDescriptionAttributeScope())
				->toHtml();
			
			$result = str_replace(__('Backorders') . '</label>', __('Backorders') . '\\' . __('Pre-Orders')  . '</label>', $result);
			$result = str_replace('</table>', $preorder, $result);
		}

		return $result;
    }     
    
}