<?php
/**
* @author Amasty Team
* @copyright Copyright (c) Amasty (http://www.amasty.com)
* @package Amasty_Rules
*/
class Amasty_Rules_Helper_Data extends Mage_Core_Helper_Abstract 
{
    const TYPE_CHEAPEST         = 'the_cheapest';
    const TYPE_EXPENCIVE        = 'the_most_expencive';
    const TYPE_FIXED            = 'fixed';
    const TYPE_EACH_N           = 'each_n';
    const TYPE_EACH_N_FIXDISC   = 'each_n_fixdisc';    
    const TYPE_GROUP_N          = 'group_n';
    const TYPE_GROUP_N_DISC     = 'group_n_disc';    
    const TYPE_XY_PERCENT       = 'buy_x_get_y_percent';
    const TYPE_XY_FIXED         = 'buy_x_get_y_fixed';
    const TYPE_XY_FIXDISC       = 'buy_x_get_y_fixdisc';
    const TYPE_AFTER_N_FIXED    = 'after_n_fixed';
    const TYPE_AFTER_N_DISC     = 'after_n_disc';
    const TYPE_AFTER_N_FIXDISC  = 'after_n_fixdisc';
    const TYPE_AMOUNT           = 'money_amount';
    const TYPE_SETOF_PERCENT    = 'setof_percent';
    const TYPE_SETOF_FIXED      = 'setof_fixed';

    public function getDiscountTypes($asOptions=false)
    {
        $types = array(
            self::TYPE_CHEAPEST        => $this->__('The Cheapest, also for Buy 1 get 1 free'),
            self::TYPE_EXPENCIVE       => $this->__('The Most Expensive'),
            self::TYPE_AMOUNT          => $this->__('Get $Y for each $X spent'),
			
            self::TYPE_EACH_N          => $this->__('Percent Discount: each 2-d, 4-th, 6-th with 15% 0ff'),
            self::TYPE_EACH_N_FIXDISC  => $this->__('Fixed Discount: each 3-d, 6-th, 9-th with $15 0ff'),    
            self::TYPE_FIXED           => $this->__('Fixed Price: each 5th, 10th, 15th for $49'), 
			
            self::TYPE_GROUP_N         => $this->__('Fixed Price: Each 5 items for $50'),
            self::TYPE_GROUP_N_DISC    => $this->__('Percent Discount: Each 5 items with 10% off'),   
			
            self::TYPE_XY_PERCENT      => $this->__('Percent Discount: Buy X get Y Free'),   
            self::TYPE_XY_FIXDISC      => $this->__('Fixed Discount:  Buy X get Y with $10 Off .'),
            self::TYPE_XY_FIXED        => $this->__('Fixed Price: Buy X get Y for $9.99'),
			
            self::TYPE_AFTER_N_DISC    => $this->__('Percent Discount'),   
            self::TYPE_AFTER_N_FIXDISC => $this->__('Fixed Discount'),   
            self::TYPE_AFTER_N_FIXED   => $this->__('Fixed Price'),
			
            self::TYPE_SETOF_PERCENT   => $this->__('Percent discount for product set'), 
            self::TYPE_SETOF_FIXED     => $this->__('Fixed price for product set'), 

        );
        
        if (!$asOptions){
		
			$groups = array(
				'Popular'         => array(self::TYPE_CHEAPEST, self::TYPE_EXPENCIVE, self::TYPE_AMOUNT),
				'Buy X Get Y (X and Y are different products)' => array(self::TYPE_XY_PERCENT, self::TYPE_XY_FIXDISC, self::TYPE_XY_FIXED),
				'Each N-th'       => array(self::TYPE_EACH_N, self::TYPE_EACH_N_FIXDISC, self::TYPE_FIXED),
				'Each Group of N' => array(self::TYPE_GROUP_N, self::TYPE_GROUP_N_DISC),
				'All products after N' => array(self::TYPE_AFTER_N_DISC, self::TYPE_AFTER_N_FIXDISC, self::TYPE_AFTER_N_FIXED),
				'Product Set (beta)'   => array(self::TYPE_SETOF_PERCENT, self::TYPE_SETOF_FIXED),
			);
			
			$result = array();
			
			foreach ($groups as $groupName => $groupActions){
				$values = array();
				foreach ($groupActions as $k){
					$values[] = array(
						'value' => $k, 
						'label' => $types[$k],                
					);
				}
				$result[] = array(
                    'label' => $this->__($groupName),
                    'value' => $values,				
				);
			}
            $types = $result;
        }

        return $types;
    }
    
    public function getMembership($created)
    {
        return round((time() - strtotime($created))  /60 / 60 /24);
    }
}