<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2018 Amasty (https://www.amasty.com)
 * @package Amasty_SeoGoogleSitemap
 */


class Amasty_SeoGoogleSitemap_Block_Adminhtml_Sitemap_Edit_Tab_Blog extends Mage_Adminhtml_Block_Widget_Form
{
    protected function _prepareForm()
    {
        $form = new Varien_Data_Form();
        $this->setForm($form);
        $model = Mage::registry('am_sitemap_profile');
        $this->_blogFields();
        $this->getForm()->setValues($model->getData());

        return parent::_prepareForm();
    }

    protected function _blogFields()
    {
        /** @var Amasty_SeoGoogleSitemap_Helper_Data $helper */
        $helper = Mage::helper('amseogooglesitemap');

        $fieldset = $this->getForm()->addFieldset(
            'amseogooglesitemap_form_content_blog',
            array('legend' => $helper->__('Blog Pages'))
        );
        $fieldset->addField(
            'blog', 'select',
            array(
                'label' => $helper->__('Include blog pages'),
                'name' => 'blog',
                'title' => $helper->__('Include blog pages'),
                'options' => $helper->getYesNo()
            )
        );

        $fieldset->addField(
            'blog_priority',
            'text',
            array(
                'label' => $helper->__('Priority'),
                'name' => 'blog_priority',
                'note' => '0.0-1.0',
                'class' => 'validate-number validate-number-range number-range-0.0-1.0'
            )
        );
        $fieldset->addField(
            'blog_frequency',
            'select',
            array(
                'label' => $helper->__('Frequency'),
                'name' => 'blog_frequency',
                'title' => $helper->__('Frequency'),
                'options' => $helper->getFrequency()
            )
        );
    }
}
