<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2018 Amasty (https://www.amasty.com)
 * @package Amasty_SeoGoogleSitemap
 */


class Amasty_SeoGoogleSitemap_Block_Adminhtml_Sitemap_Edit_Tab_Categories extends Mage_Adminhtml_Block_Widget_Form
{
    protected function _prepareForm()
    {
        $form = new Varien_Data_Form();
        $this->setForm($form);
        $model = Mage::registry('am_sitemap_profile');
        $this->_categoryFields();
        $this->getForm()->setValues($model->getData());
        $this->setChild(
            'form_after',
            $this->getLayout()
                ->createBlock('adminhtml/widget_form_element_dependence')
                ->addFieldMap('categories_thumbs', 'categories_thumbs')
                ->addFieldMap('categories_captions', 'categories_captions')
                ->addFieldDependence('categories_captions', 'categories_thumbs', 1)
        );

        return parent::_prepareForm();
    }

    protected function _categoryFields()
    {
        /** @var Amasty_SeoGoogleSitemap_Helper_Data $helper */
        $helper = Mage::helper('amseogooglesitemap');

        $fieldset = $this->getForm()->addFieldset(
            'amseogooglesitemap_form_content_categories',
            array('legend' => $helper->__('Categories'))
        );
        $fieldset->addField(
            'categories',
            'select',
            array(
                'label' => $helper->__('Include categories'),
                'name' => 'categories',
                'title' => $helper->__('Include categories'),
                'options' => $helper->getYesNo()
            )
        );

        $fieldset->addField(
            'hreflang_cat',
            'select',
            array(
                'label' => $helper->__('Add Hreflang'),
                'name' => 'hreflang_cat',
                'title' => $helper->__('Add Hreflang'),
                'options' => $helper->getYesNo()
            )
        );

        $fieldset->addField(
            'categories_thumbs',
            'select',
            array(
                'label' => $helper->__('Add Images'),
                'name' => 'categories_thumbs',
                'title' => $helper->__('Add Images'),
                'options' => $helper->getYesNo()
            )
        );

        $fieldset->addField(
            'categories_priority',
            'text',
            array(
                'label' => $helper->__('Priority'),
                'name' => 'categories_priority',
                'note' => '0.0-1.0',
                'class' => 'validate-number validate-number-range number-range-0.0-1.0'
            )
        );

        $fieldset->addField(
            'categories_frequency',
            'select',
            array(
                'label' => $helper->__('Frequency'),
                'name' => 'categories_frequency',
                'title' => $helper->__('Frequency'),
                'options' => $helper->getFrequency()
            )
        );

        $fieldset->addField(
            'categories_modified',
            'select',
            array(
                'label' => $helper->__('Include Last Modified'),
                'name' => 'categories_modified',
                'title' => $helper->__('Include Last Modified'),
                'options' => $helper->getYesNo()
            )
        );

        $fieldset->addField(
            'batch_size_cat',
            'text',
            array(
                'label' => $helper->__('Batch Size'),
                'name' => 'batch_size_cat',
                'title' => $helper->__('Batch Size'),
                'note' => $helper->__('Indicate how many items will be handled during one iteration.')
            )
        );
    }
}
