<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2018 Amasty (https://www.amasty.com)
 * @package Amasty_SeoGoogleSitemap
 */


class Amasty_SeoGoogleSitemap_Block_Adminhtml_Sitemap_Edit_Tab_Landing extends Mage_Adminhtml_Block_Widget_Form
{
    protected function _prepareForm()
    {
        $form = new Varien_Data_Form();
        $this->setForm($form);
        $model = Mage::registry('am_sitemap_profile');
        $this->_landingFields();
        $this->getForm()->setValues($model->getData());

        return parent::_prepareForm();
    }

    private function _landingFields()
    {
        /** @var Amasty_SeoGoogleSitemap_Helper_Data $helper */
        $helper = Mage::helper('amseogooglesitemap');

        $fieldset = $this->getForm()->addFieldset(
            'amseogooglesitemap_form_content_landing',
            array('legend' => $helper->__('Landing Pages'))
        );

        $fieldset->addField(
            'landing',
            'select',
            array(
                'label' => $helper->__('Include landing pages'),
                'name' => 'landing',
                'title' => $helper->__('Include landing pages'),
                'options' => $helper->getYesNo(),
                'note' => 'See <a href="//amasty.com/landing-pages.html">Landing Pages</a> module.'
            )
        );

        $fieldset->addField(
            'landing_priority',
            'text',
            array(
                'label' => $helper->__('Priority'),
                'name' => 'landing_priority',
                'note' => '0.0-1.0',
                'class' => 'validate-number validate-number-range number-range-0.0-1.0'
            )
        );

        $fieldset->addField(
            'landing_frequency',
            'select',
            array(
                'label' => $helper->__('Frequency'),
                'name' => 'landing_frequency',
                'title' => $helper->__('Frequency'),
                'options' => $helper->getFrequency()
            )
        );

    }
}
