<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2018 Amasty (https://www.amasty.com)
 * @package Amasty_SeoGoogleSitemap
 */


class Amasty_SeoGoogleSitemap_Block_Adminhtml_Sitemap_Edit_Tab_Navigation extends Mage_Adminhtml_Block_Widget_Form
{
    protected function _prepareForm()
    {
        $form = new Varien_Data_Form();
        $this->setForm($form);
        $model = Mage::registry('am_sitemap_profile');
        $this->_navigationFields();
        $this->getForm()->setValues($model->getData());

        return parent::_prepareForm();
    }

    protected function _navigationFields()
    {
        /** @var Amasty_SeoGoogleSitemap_Helper_Data $helper */
        $helper = Mage::helper('amseogooglesitemap');

        $fieldset = $this->getForm()->addFieldset(
            'amseogooglesitemap_form_content_navigation',
            array('legend' => $helper->__('Improved Navigation Pages'))
        );

        $note = 'See <a href="//amasty.com/improved-layered-navigation.html">Improved Layered Navigation</a> module.    
                Please fill canonical urls of  navigation pages manually.';
        $fieldset->addField(
            'navigation',
            'select',
            array(
                'label' => $helper->__('Include Improved Navigation Pages'),
                'name' => 'navigation',
                'title' => $helper->__('Include Improved Navigation Pages'),
                'options' => $helper->getYesNo(),
                'note' => $note
            )
        );

        $fieldset->addField(
            'navigation_priority',
            'text',
            array(
                'label' => $helper->__('Priority'),
                'name' => 'navigation_priority',
                'note' => '0.0-1.0',
                'class' => 'validate-number validate-number-range number-range-0.0-1.0'
            )
        );

        $fieldset->addField(
            'navigation_frequency',
            'select',
            array(
                'label' => $helper->__('Frequency'),
                'name' => 'navigation_frequency',
                'title' => $helper->__('Frequency'),
                'options' => $helper->getFrequency()
            )
        );
    }
}
