<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2018 Amasty (https://www.amasty.com)
 * @package Amasty_SeoGoogleSitemap
 */


class Amasty_SeoGoogleSitemap_Block_Adminhtml_Sitemap_Edit_Tab_Pages extends Mage_Adminhtml_Block_Widget_Form
{
    protected function _prepareForm()
    {
        $form = new Varien_Data_Form();
        $this->setForm($form);
        $model = Mage::registry('am_sitemap_profile');
        $this->_pagesFields();
        $this->getForm()->setValues($model->getData());

        return parent::_prepareForm();
    }

    protected function _pagesFields()
    {
        /** @var Amasty_SeoGoogleSitemap_Helper_Data $helper */
        $helper = Mage::helper('amseogooglesitemap');

        $fieldset = $this->getForm()->addFieldset(
            'amseogooglesitemap_form_content_pages',
            array('legend' => $helper->__('Pages'))
        );

        $fieldset->addField(
            'pages',
            'select',
            array(
                'label' => $helper->__('Include pages'),
                'name' => 'pages',
                'title' => $helper->__('Include pages'),
                'options' => $helper->getYesNo()
            )
        );

        $fieldset->addField(
            'hreflang_page',
            'select',
            array(
                'label' => $helper->__('Add Hreflang'),
                'name' => 'hreflang_page',
                'title' => $helper->__('Add Hreflang'),
                'options' => $helper->getYesNo()
            )
        );

        $fieldset->addField(
            'pages_priority',
            'text',
            array(
                'label' => $helper->__('Priority'),
                'name' => 'pages_priority',
                'note' => '0.0-1.0',
                'class' => 'validate-number validate-number-range number-range-0.0-1.0'
            )
        );
        $fieldset->addField(
            'pages_frequency',
            'select',
            array(
                'label' => $helper->__('Frequency'),
                'name' => 'pages_frequency',
                'title' => $helper->__('Frequency'),
                'options' => $helper->getFrequency()
            )
        );

        $fieldset->addField(
            'pages_modified',
            'select',
            array(
                'label' => $helper->__('Include Last Modified'),
                'name' => 'pages_modified',
                'title' => $helper->__('Include Last Modified'),
                'options' => $helper->getYesNo()
            )
        );

        $fieldset->addField(
            'exclude_cms_aliases',
            'textarea',
            array(
                'label' => $helper->__('Exclude CMS pages'),
                'name' => 'exclude_cms_aliases',
                'note' => $helper->__('URL Keys of CMS Pages to exclude, one per line')
            )
        );

        $fieldset->addField(
            'batch_size_page',
            'text',
            array(
                'label' => $helper->__('Batch Size'),
                'name' => 'batch_size_page',
                'title' => $helper->__('Batch Size'),
                'note' => $helper->__('Indicate how many items will be handled during one iteration.')
            )
        );
    }
}
