<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2018 Amasty (https://www.amasty.com)
 * @package Amasty_SeoGoogleSitemap
 */


class Amasty_SeoGoogleSitemap_Block_Adminhtml_Sitemap_Edit_Tab_ShopByBrands extends Mage_Adminhtml_Block_Widget_Form
{
    /** @var  Amasty_SeoGoogleSitemap_Helper_Data $_helper */
    protected $_helper;

    protected function _prepareForm()
    {
        $form = new Varien_Data_Form();
        $this->setForm($form);
        $model = Mage::registry('am_sitemap_profile');
        $this->_brandFields();
        $this->getForm()->setValues($model->getData());

        return parent::_prepareForm();
    }

    protected function _brandFields()
    {
        /** @var Amasty_SeoGoogleSitemap_Helper_Data $helper */
        $helper = Mage::helper('amseogooglesitemap');

        $fieldset = $this->getForm()->addFieldset(
            'amseogooglesitemap_form_content_landing',
            array('legend' => $helper->__('Brand Pages'))
        );

        $note = 'See <a href="//amasty.com/magento-shop-by-brand.html">Shop by Brand</a> module.';
        $fieldset->addField(
            'by_brands', 'select',
            array(
                'label' => $helper->__('Include brand pages'),
                'name' => 'by_brands',
                'title' => $helper->__('Include brand pages'),
                'options' => $helper->getYesNo(),
                'note' => $helper->__($note)
            )
        );

        $fieldset->addField(
            'by_brands_priority', 'text',
            array(
                'label' => $helper->__('Priority'),
                'name' => 'by_brands_priority',
                'note' => '0.0-1.0',
                'class' => 'validate-number validate-number-range number-range-0.0-1.0'
            )
        );

        $fieldset->addField(
            'by_brands_frequency', 'select',
            array(
                'label' => $helper->__('Frequency'),
                'name' => 'by_brands_frequency',
                'title' => $helper->__('Frequency'),
                'options' => $helper->getFrequency()
            )
        );

    }
}
