<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2018 Amasty (https://www.amasty.com)
 * @package Amasty_SeoGoogleSitemap
 */


class Amasty_SeoGoogleSitemap_Block_Adminhtml_Sitemap_Edit_Tab_Tags extends Mage_Adminhtml_Block_Widget_Form
{
    protected function _prepareForm()
    {
        $form = new Varien_Data_Form();
        $this->setForm($form);
        $model = Mage::registry('am_sitemap_profile');
        $this->_tagFields();
        $this->getForm()->setValues($model->getData());

        return parent::_prepareForm();
    }

    protected function _tagFields()
    {
        /** @var Amasty_SeoGoogleSitemap_Helper_Data $helper */
        $helper = Mage::helper('amseogooglesitemap');

        $fieldset = $this->getForm()->addFieldset(
            'amseogooglesitemap_form_content_tags',
            array('legend' => $helper->__('Tags'))
        );

        $fieldset->addField(
            'tags',
            'select',
            array(
                'label' => $helper->__('Include tags'),
                'name' => 'tags',
                'title' => $helper->__('Include tags'),
                'options' => $helper->getYesNo()
            )
        );

        $fieldset->addField(
            'tags_priority',
            'text',
            array(
                'label' => $helper->__('Priority'),
                'name' => 'tags_priority',
                'note' => '0.0-1.0',
                'class' => 'validate-number validate-number-range number-range-0.0-1.0'
            )
        );

        $fieldset->addField(
            'tags_frequency',
            'select',
            array(
                'label' => $helper->__('Frequency'),
                'name' => 'tags_frequency',
                'title' => $helper->__('Frequency'),
                'options' => $helper->getFrequency()
            )
        );

        $fieldset->addField(
            'batch_size_tag',
            'text',
            array(
                'label' => $helper->__('Batch Size'),
                'name' => 'batch_size_tag',
                'title' => $helper->__('Batch Size'),
                'note' => $helper->__('Indicate how many items will be handled during one iteration.')
            )
        );
    }
}
