<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2018 Amasty (https://www.amasty.com)
 * @package Amasty_SeoGoogleSitemap
 */


class Amasty_SeoGoogleSitemap_Block_Adminhtml_Sitemap_Edit_Tabs extends Mage_Adminhtml_Block_Widget_Tabs
{

    public function __construct()
    {
        parent::__construct();
        $this->setId('amsitemap_tabs');
        $this->setDestElementId('edit_form');
        $this->setTitle(Mage::helper('amseogooglesitemap')->__('Manage profile'));
    }

    protected function _beforeToHtml()
    {
        /** @var Amasty_SeoGoogleSitemap_Helper_Data $helper */
        $helper = Mage::helper('amseogooglesitemap');

        $this->addTab(
            'general',
            array(
                'label' => $helper->__('General'),
                'title' => $helper->__('General'),
                'content' => $this->getLayout()->createBlock('amseogooglesitemap/adminhtml_sitemap_edit_tab_general')->toHtml(),
            )
        );

        $this->addTab(
            'products',
            array(
                'label' => $helper->__('Products'),
                'title' => $helper->__('Products'),
                'content' => $this->getLayout()->createBlock('amseogooglesitemap/adminhtml_sitemap_edit_tab_products')->toHtml(),
            )
        );

        $this->addTab(
            'categories',
            array(
                'label' => $helper->__('Categories'),
                'title' => $helper->__('Categories'),
                'content' => $this->getLayout()->createBlock('amseogooglesitemap/adminhtml_sitemap_edit_tab_categories')->toHtml(),
            )
        );

        $this->addTab(
            'pages',
            array(
                'label' => $helper->__('Pages'),
                'title' => $helper->__('Pages'),
                'content' => $this->getLayout()->createBlock('amseogooglesitemap/adminhtml_sitemap_edit_tab_pages')->toHtml(),
            )
        );

        $this->addTab(
            'tags',
            array(
                'label' => $helper->__('Tags'),
                'title' => $helper->__('Tags'),
                'content' => $this->getLayout()->createBlock('amseogooglesitemap/adminhtml_sitemap_edit_tab_tags')->toHtml(),
            )
        );

        $this->addTab(
            'extra', array(
                'label' => $helper->__('Extra Links'),
                'title' => $helper->__('Extra Links'),
                'content' => $this->getLayout()->createBlock('amseogooglesitemap/adminhtml_sitemap_edit_tab_extra')->toHtml(),
            )
        );

        if (Mage::helper('core')->isModuleEnabled('Amasty_Shopby')) {
            $this->addTab(
                'brands',
                array(
                    'label' => $helper->__('Improved Navigation Brand Pages'),
                    'title' => $helper->__('Improved Navigation Brand Pages'),
                    'content' => $this->getLayout()->createBlock('amseogooglesitemap/adminhtml_sitemap_edit_tab_brands')->toHtml(),
                )
            );
            $this->addTab(
                'navigation',
                array(
                    'label' => $helper->__('Improved Navigation Pages'),
                    'title' => $helper->__('Improved Navigation Pages'),
                    'content' => $this->getLayout()->createBlock('amseogooglesitemap/adminhtml_sitemap_edit_tab_navigation')->toHtml(),
                )
            );
        }

        if (Mage::helper('core')->isModuleEnabled('Amasty_Brands')) {
            $this->addTab(
                'by_brands',
                array(
                    'label' => $helper->__('Shop by Brand Pages'),
                    'title' => $helper->__('Shop by Brand Pages'),
                    'content' => $this->getLayout()->createBlock('amseogooglesitemap/adminhtml_sitemap_edit_tab_shopByBrands')->toHtml(),
                )
            );
        }

        if (Mage::helper('core')->isModuleEnabled('Magpleasure_Blog')) {
            $this->addTab(
                'blog', array(
                    'label' => $helper->__('Blog Pages'),
                    'title' => $helper->__('Blog Pages'),
                    'content' => $this->getLayout()->createBlock('amseogooglesitemap/adminhtml_sitemap_edit_tab_blog')->toHtml(),
                )
            );
        }


        if (Mage::helper('core')->isModuleEnabled('Amasty_Xlanding')) {
            $this->addTab(
                'landing',
                array(
                    'label' => $helper->__('Landing Pages'),
                    'title' => $helper->__('Landing Pages'),
                    'content' => $this->getLayout()->createBlock('amseogooglesitemap/adminhtml_sitemap_edit_tab_landing')->toHtml(),
                )
            );
        }

        return parent::_beforeToHtml();
    }
}
