<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2018 Amasty (https://www.amasty.com)
 * @package Amasty_SeoGoogleSitemap
 */


class Amasty_SeoGoogleSitemap_Helper_Hrefurl extends Amasty_SeoToolKit_Helper_Hrefurl
{
    const CURRENT_HREFLANG_CODES = 'hreflang_codes_';

    /**
     * @return array
     */
    public function getHreflangCodes()
    {
        $hreflangCodes = $this->getSession()->getData(static::CURRENT_HREFLANG_CODES);
        if ($hreflangCodes === null) {
            $hreflangCodes = parent::getHreflangCodes();
            $this->getSession()->setData(static::CURRENT_HREFLANG_CODES, $hreflangCodes);
        }

        return $hreflangCodes;
    }

    /**
     * @return Mage_Core_Model_Abstract|Mage_Core_Model_Session
     */
    protected function getSession()
    {
        return Mage::getSingleton('core/session');
    }

    /**
     * @return $this
     */
    public function clean()
    {
        $this->_storeIds = $this->_storeUrls = $this->homepages = null;
        return $this;
    }
}
