<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2018 Amasty (https://www.amasty.com)
 * @package Amasty_SeoGoogleSitemap
 */


$this->startSetup();
$connection = $this->getConnection();

$tableName = $this->getTable('amseogooglesitemap/sitemap');

if ($connection->tableColumnExists($tableName, 'batch_size_prod') === false) {
    $connection->addColumn(
        $tableName,
        'batch_size_prod',
        array(
            'type'      => Varien_Db_Ddl_Table::TYPE_INTEGER,
            'nullable'  => false,
            'default'   => Amasty_SeoGoogleSitemap_Model_Sitemap::DEFAULT_SIZE_PROD,
            'comment'   => 'Products Batch Size'
        )
    );
    $connection->addColumn(
        $tableName,
        'batch_size_cat',
        array(
            'type'      => Varien_Db_Ddl_Table::TYPE_INTEGER,
            'nullable'  => false,
            'default'   => Amasty_SeoGoogleSitemap_Model_Sitemap::DEFAULT_SIZE_CAT,
            'comment'   => 'Category Batch Size'
        )
    );
    $connection->addColumn(
        $tableName,
        'batch_size_page',
        array(
            'type'      => Varien_Db_Ddl_Table::TYPE_INTEGER,
            'nullable'  => false,
            'default'   => Amasty_SeoGoogleSitemap_Model_Sitemap::DEFAULT_SIZE_PAGE,
            'comment'   => 'Pages Batch Size'
        )
    );
    $connection->addColumn(
        $tableName,
        'batch_size_tag',
        array(
            'type'      => Varien_Db_Ddl_Table::TYPE_INTEGER,
            'nullable'  => false,
            'default'   => Amasty_SeoGoogleSitemap_Model_Sitemap::DEFAULT_SIZE_TAG,
            'comment'   => 'Tags Batch Size'
        )
    );
}

$this->endSetup();
