<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2018 Amasty (https://www.amasty.com)
 * @package Amasty_SeoGoogleSitemap
 */


$this->startSetup();
$connection = $this->getConnection();
$tableName = $this->getTable('amseogooglesitemap/sitemap');

if ($connection->tableColumnExists($tableName, 'hreflang_prod') === false) {
    $connection->addColumn(
        $tableName,
        'hreflang_prod',
        array(
            'type' => Varien_Db_Ddl_Table::TYPE_SMALLINT,
            'nullable' => false,
            'default' => 0,
            'comment' => 'Product Hreflang'
        )
    );
}

if ($connection->tableColumnExists($tableName, 'hreflang_cat') === false) {
    $connection->addColumn(
        $tableName,
        'hreflang_cat',
        array(
            'type'      => Varien_Db_Ddl_Table::TYPE_SMALLINT,
            'nullable'  => false,
            'default'   => 0,
            'comment'   => 'Category Hreflang'
        )
    );
}

if ($connection->tableColumnExists($tableName, 'hreflang_page') === false) {
    $connection->addColumn(
        $tableName,
        'hreflang_page',
        array(
            'type'      => Varien_Db_Ddl_Table::TYPE_SMALLINT,
            'nullable'  => false,
            'default'   => 0,
            'comment'   => 'CMS Page Hreflang'
        )
    );
}

$uuidField = Amasty_SeoToolKit_Helper_Hrefurl::CMS_UUID;
$tableName = $this->getTable('cms_page');
if ($connection->tableColumnExists($tableName, $uuidField) === false) {
    $connection->addColumn(
        $tableName,
        $uuidField,
        array(
            'type'      => Varien_Db_Ddl_Table::TYPE_TEXT,
            'nullable'  => false,
            'default'   => '',
            'comment'   => 'Seo Toolkit UUID'
        )
    );
}

$tableName = $this->getTable('enterprise_cms_page_revision');
if ($connection->showTableStatus($tableName)) {
    if ($connection->tableColumnExists($tableName, $uuidField) === false) {
        $connection->addColumn(
            $tableName,
            $uuidField,
            array(
                'type'      => Varien_Db_Ddl_Table::TYPE_TEXT,
                'nullable'  => false,
                'default'   => '',
                'comment'   => 'Seo Toolkit UUID'
            )
        );
    }
}

$this->endSetup();
