<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2018 Amasty (https://www.amasty.com)
 * @package Amasty_SeoToolKit
 */


class Amasty_SeoToolKit_Model_Source_Country
{
    public function toOptionArray()
    {
        $hlp = Mage::helper('amseotoolkit');

        //All the countries Google can handle.
        return array(
            array('value' => Amasty_SeoToolKit_Helper_Hrefurl::COUNTRY_DONT_ADD,
                'label' => $hlp->__('Don\'t Add')),
            array('value' => Amasty_SeoToolKit_Helper_Hrefurl::COUNTRY_DEFAULT,
                'label' => $hlp->__('From Current Store Default Country')),
            array('value' => 'AF', 'label' => $hlp->__('Afghanistan') . ' (AF)'),
            array('value' => 'AL', 'label' => $hlp->__('Albania') . ' (AL)'),
            array('value' => 'DZ', 'label' => $hlp->__('Algeria') . ' (DZ)'),
            array('value' => 'AD', 'label' => $hlp->__('Andorra') . ' (AD)'),
            array('value' => 'AO', 'label' => $hlp->__('Angola') . ' (AO)'),
            array('value' => 'AG', 'label' => $hlp->__('Antigua and Barbuda') . ' (AG)'),
            array('value' => 'AR', 'label' => $hlp->__('Argentina') . ' (AR)'),
            array('value' => 'AM', 'label' => $hlp->__('Armenia') . ' (AM)'),
            array('value' => 'AU', 'label' => $hlp->__('Australia') . ' (AU)'),
            array('value' => 'AT', 'label' => $hlp->__('Austria') . ' (AT)'),
            array('value' => 'AZ', 'label' => $hlp->__('Azerbaijan') . ' (AZ)'),
            array('value' => 'BS', 'label' => $hlp->__('Bahamas') . ' (BS)'),
            array('value' => 'BH', 'label' => $hlp->__('Bahrain') . ' (BH)'),
            array('value' => 'BD', 'label' => $hlp->__('Bangladesh') . ' (BD)'),
            array('value' => 'BB', 'label' => $hlp->__('Barbados') . ' (BB)'),
            array('value' => 'BY', 'label' => $hlp->__('Belarus') . ' (BY)'),
            array('value' => 'BE', 'label' => $hlp->__('Belgium') . ' (BE)'),
            array('value' => 'BZ', 'label' => $hlp->__('Belize') . ' (BZ)'),
            array('value' => 'BJ', 'label' => $hlp->__('Benin') . ' (BJ)'),
            array('value' => 'BT', 'label' => $hlp->__('Bhutan') . ' (BT)'),
            array('value' => 'BO', 'label' => $hlp->__('Bolivia') . ' (BO)'),
            array('value' => 'BA', 'label' => $hlp->__('Bosnia and Herzegovina') . ' (BA)'),
            array('value' => 'BW', 'label' => $hlp->__('Botswana') . ' (BW)'),
            array('value' => 'BR', 'label' => $hlp->__('Brazil') . ' (BR)'),
            array('value' => 'BN', 'label' => $hlp->__('Brunei') . ' (BN)'),
            array('value' => 'BG', 'label' => $hlp->__('Bulgaria') . ' (BG)'),
            array('value' => 'BF', 'label' => $hlp->__('Burkina Faso') . ' (BF)'),
            array('value' => 'BI', 'label' => $hlp->__('Burundi') . ' (BI)'),
            array('value' => 'KH', 'label' => $hlp->__('Cambodia') . ' (KH)'),
            array('value' => 'CM', 'label' => $hlp->__('Cameroon') . ' (CM)'),
            array('value' => 'CA', 'label' => $hlp->__('Canada') . ' (CA)'),
            array('value' => 'CV', 'label' => $hlp->__('Cape Verde') . ' (CV)'),
            array('value' => 'CF', 'label' => $hlp->__('Central African Republic') . ' (CF)'),
            array('value' => 'TD', 'label' => $hlp->__('Chad') . ' (TD)'),
            array('value' => 'CL', 'label' => $hlp->__('Chile') . ' (CL)'),
            array('value' => 'CN', 'label' => $hlp->__('China, People\'s Republic of') . ' (CN)'),
            array('value' => 'CO', 'label' => $hlp->__('Colombia') . ' (CO)'),
            array('value' => 'KM', 'label' => $hlp->__('Comoros') . ' (KM)'),
            array('value' => 'CD', 'label' => $hlp->__('Congo, (Congo Â– Kinshasa)') . ' (CD)'),
            array('value' => 'CG', 'label' => $hlp->__('Congo, (Congo Â– Brazzaville)') . ' (CG)'),
            array('value' => 'CR', 'label' => $hlp->__('Costa Rica') . ' (CR)'),
            array('value' => 'CI', 'label' => $hlp->__('Cote d\'Ivoire (Ivory Coast)') . ' (CI)'),
            array('value' => 'HR', 'label' => $hlp->__('Croatia') . ' (HR)'),
            array('value' => 'CU', 'label' => $hlp->__('Cuba') . ' (CU)'),
            array('value' => 'CY', 'label' => $hlp->__('Cyprus') . ' (CY)'),
            array('value' => 'CZ', 'label' => $hlp->__('Czech Republic') . ' (CZ)'),
            array('value' => 'DK', 'label' => $hlp->__('Denmark') . ' (DK)'),
            array('value' => 'DJ', 'label' => $hlp->__('Djibouti') . ' (DJ)'),
            array('value' => 'DM', 'label' => $hlp->__('Dominica') . ' (DM)'),
            array('value' => 'DO', 'label' => $hlp->__('Dominican Republic') . ' (DO)'),
            array('value' => 'EC', 'label' => $hlp->__('Ecuador') . ' (EC)'),
            array('value' => 'EG', 'label' => $hlp->__('Egypt') . ' (EG)'),
            array('value' => 'SV', 'label' => $hlp->__('El Salvador') . ' (SV)'),
            array('value' => 'GQ', 'label' => $hlp->__('Equatorial Guinea') . ' (GQ)'),
            array('value' => 'ER', 'label' => $hlp->__('Eritrea') . ' (ER)'),
            array('value' => 'EE', 'label' => $hlp->__('Estonia') . ' (EE)'),
            array('value' => 'ET', 'label' => $hlp->__('Ethiopia') . ' (ET)'),
            array('value' => 'FJ', 'label' => $hlp->__('Fiji') . ' (FJ)'),
            array('value' => 'FI', 'label' => $hlp->__('Finland') . ' (FI)'),
            array('value' => 'FR', 'label' => $hlp->__('France') . ' (FR)'),
            array('value' => 'GA', 'label' => $hlp->__('Gabon') . ' (GA)'),
            array('value' => 'GM', 'label' => $hlp->__('Gambia') . ' (GM)'),
            array('value' => 'GE', 'label' => $hlp->__('Georgia') . ' (GE)'),
            array('value' => 'DE', 'label' => $hlp->__('Germany') . ' (DE)'),
            array('value' => 'GH', 'label' => $hlp->__('Ghana') . ' (GH)'),
            array('value' => 'GR', 'label' => $hlp->__('Greece') . ' (GR)'),
            array('value' => 'GD', 'label' => $hlp->__('Grenada') . ' (GD)'),
            array('value' => 'GT', 'label' => $hlp->__('Guatemala') . ' (GT)'),
            array('value' => 'GN', 'label' => $hlp->__('Guinea') . ' (GN)'),
            array('value' => 'GW', 'label' => $hlp->__('Guinea-Bissau') . ' (GW)'),
            array('value' => 'GY', 'label' => $hlp->__('Guyana') . ' (GY)'),
            array('value' => 'HT', 'label' => $hlp->__('Haiti') . ' (HT)'),
            array('value' => 'HN', 'label' => $hlp->__('Honduras') . ' (HN)'),
            array('value' => 'HU', 'label' => $hlp->__('Hungary') . ' (HU)'),
            array('value' => 'IS', 'label' => $hlp->__('Iceland') . ' (IS)'),
            array('value' => 'IN', 'label' => $hlp->__('India') . ' (IN)'),
            array('value' => 'ID', 'label' => $hlp->__('Indonesia') . ' (ID)'),
            array('value' => 'IR', 'label' => $hlp->__('Iran') . ' (IR)'),
            array('value' => 'IQ', 'label' => $hlp->__('Iraq') . ' (IQ)'),
            array('value' => 'IE', 'label' => $hlp->__('Ireland') . ' (IE)'),
            array('value' => 'IL', 'label' => $hlp->__('Israel') . ' (IL)'),
            array('value' => 'IT', 'label' => $hlp->__('Italy') . ' (IT)'),
            array('value' => 'JM', 'label' => $hlp->__('Jamaica') . ' (JM)'),
            array('value' => 'JP', 'label' => $hlp->__('Japan') . ' (JP)'),
            array('value' => 'JO', 'label' => $hlp->__('Jordan') . ' (JO)'),
            array('value' => 'KZ', 'label' => $hlp->__('Kazakhstan') . ' (KZ)'),
            array('value' => 'KE', 'label' => $hlp->__('Kenya') . ' (KE)'),
            array('value' => 'KI', 'label' => $hlp->__('Kiribati') . ' (KI)'),
            array('value' => 'KP', 'label' => $hlp->__('Korea, North') . ' (KP)'),
            array('value' => 'KR', 'label' => $hlp->__('Korea, South') . ' (KR)'),
            array('value' => 'KW', 'label' => $hlp->__('Kuwait') . ' (KW)'),
            array('value' => 'KG', 'label' => $hlp->__('Kyrgyzstan') . ' (KG)'),
            array('value' => 'LA', 'label' => $hlp->__('Laos') . ' (LA)'),
            array('value' => 'LV', 'label' => $hlp->__('Latvia') . ' (LV)'),
            array('value' => 'LB', 'label' => $hlp->__('Lebanon') . ' (LB)'),
            array('value' => 'LS', 'label' => $hlp->__('Lesotho') . ' (LS)'),
            array('value' => 'LR', 'label' => $hlp->__('Liberia') . ' (LR)'),
            array('value' => 'LY', 'label' => $hlp->__('Libya') . ' (LY)'),
            array('value' => 'LI', 'label' => $hlp->__('Liechtenstein') . ' (LI)'),
            array('value' => 'LT', 'label' => $hlp->__('Lithuania') . ' (LT)'),
            array('value' => 'LU', 'label' => $hlp->__('Luxembourg') . ' (LU)'),
            array('value' => 'MK', 'label' => $hlp->__('Macedonia') . ' (MK)'),
            array('value' => 'MG', 'label' => $hlp->__('Madagascar') . ' (MG)'),
            array('value' => 'MW', 'label' => $hlp->__('Malawi') . ' (MW)'),
            array('value' => 'MY', 'label' => $hlp->__('Malaysia') . ' (MY)'),
            array('value' => 'MV', 'label' => $hlp->__('Maldives') . ' (MV)'),
            array('value' => 'ML', 'label' => $hlp->__('Mali') . ' (ML)'),
            array('value' => 'MT', 'label' => $hlp->__('Malta') . ' (MT)'),
            array('value' => 'MH', 'label' => $hlp->__('Marshall Islands') . ' (MH)'),
            array('value' => 'MR', 'label' => $hlp->__('Mauritania') . ' (MR)'),
            array('value' => 'MU', 'label' => $hlp->__('Mauritius') . ' (MU)'),
            array('value' => 'MX', 'label' => $hlp->__('Mexico') . ' (MX)'),
            array('value' => 'FM', 'label' => $hlp->__('Micronesia') . ' (FM)'),
            array('value' => 'MD', 'label' => $hlp->__('Moldova') . ' (MD)'),
            array('value' => 'MC', 'label' => $hlp->__('Monaco') . ' (MC)'),
            array('value' => 'MN', 'label' => $hlp->__('Mongolia') . ' (MN)'),
            array('value' => 'ME', 'label' => $hlp->__('Montenegro') . ' (ME)'),
            array('value' => 'MA', 'label' => $hlp->__('Morocco') . ' (MA)'),
            array('value' => 'MZ', 'label' => $hlp->__('Mozambique') . ' (MZ)'),
            array('value' => 'MM', 'label' => $hlp->__('Myanmar') . ' (Burma) (MM)'),
            array('value' => 'NA', 'label' => $hlp->__('Namibia') . ' (NA)'),
            array('value' => 'NR', 'label' => $hlp->__('Nauru') . ' (NR)'),
            array('value' => 'NP', 'label' => $hlp->__('Nepal') . ' (NP)'),
            array('value' => 'NL', 'label' => $hlp->__('Netherlands') . ' (NL)'),
            array('value' => 'NZ', 'label' => $hlp->__('New Zealand') . ' (NZ)'),
            array('value' => 'NI', 'label' => $hlp->__('Nicaragua') . ' (NI)'),
            array('value' => 'NE', 'label' => $hlp->__('Niger') . ' (NE)'),
            array('value' => 'NG', 'label' => $hlp->__('Nigeria') . ' (NG)'),
            array('value' => 'NO', 'label' => $hlp->__('Norway') . ' (NO)'),
            array('value' => 'OM', 'label' => $hlp->__('Oman') . ' (OM)'),
            array('value' => 'PK', 'label' => $hlp->__('Pakistan') . ' (PK)'),
            array('value' => 'PW', 'label' => $hlp->__('Palau') . ' (PW)'),
            array('value' => 'PA', 'label' => $hlp->__('Panama') . ' (PA)'),
            array('value' => 'PG', 'label' => $hlp->__('Papua New Guinea') . ' (PG)'),
            array('value' => 'PY', 'label' => $hlp->__('Paraguay') . ' (PY)'),
            array('value' => 'PE', 'label' => $hlp->__('Peru') . ' (PE)'),
            array('value' => 'PH', 'label' => $hlp->__('Philippines') . ' (PH)'),
            array('value' => 'PL', 'label' => $hlp->__('Poland') . ' (PL)'),
            array('value' => 'PT', 'label' => $hlp->__('Portugal') . ' (PT)'),
            array('value' => 'QA', 'label' => $hlp->__('Qatar') . ' (QA)'),
            array('value' => 'RO', 'label' => $hlp->__('Romania') . ' (RO)'),
            array('value' => 'RU', 'label' => $hlp->__('Russia') . ' (RU)'),
            array('value' => 'RW', 'label' => $hlp->__('Rwanda') . ' (RW)'),
            array('value' => 'KN', 'label' => $hlp->__('Saint Kitts and Nevis') . ' (KN)'),
            array('value' => 'LC', 'label' => $hlp->__('Saint Lucia') . ' (LC)'),
            array('value' => 'VC', 'label' => $hlp->__('Saint Vincent and the Grenadines') . ' (VC)'),
            array('value' => 'WS', 'label' => $hlp->__('Samoa') . ' (WS)'),
            array('value' => 'SM', 'label' => $hlp->__('San Marino') . ' (SM)'),
            array('value' => 'ST', 'label' => $hlp->__('Sao Tome and Principe') . ' (ST)'),
            array('value' => 'SA', 'label' => $hlp->__('Saudi Arabia') . ' (SA)'),
            array('value' => 'SN', 'label' => $hlp->__('Senegal') . ' (SN)'),
            array('value' => 'RS', 'label' => $hlp->__('Serbia') . ' (RS)'),
            array('value' => 'SC', 'label' => $hlp->__('Seychelles') . ' (SC)'),
            array('value' => 'SL', 'label' => $hlp->__('Sierra Leone') . ' (SL)'),
            array('value' => 'SG', 'label' => $hlp->__('Singapore') . ' (SG)'),
            array('value' => 'SK', 'label' => $hlp->__('Slovakia') . ' (SK)'),
            array('value' => 'SI', 'label' => $hlp->__('Slovenia') . ' (SI)'),
            array('value' => 'SB', 'label' => $hlp->__('Solomon Islands') . ' (SB)'),
            array('value' => 'SO', 'label' => $hlp->__('Somalia') . ' (SO)'),
            array('value' => 'ZA', 'label' => $hlp->__('South Africa') . ' (ZA)'),
            array('value' => 'ES', 'label' => $hlp->__('Spain') . ' (ES)'),
            array('value' => 'LK', 'label' => $hlp->__('Sri Lanka') . ' (LK)'),
            array('value' => 'SD', 'label' => $hlp->__('Sudan') . ' (SD)'),
            array('value' => 'SR', 'label' => $hlp->__('Suriname') . ' (SR)'),
            array('value' => 'SZ', 'label' => $hlp->__('Swaziland') . ' (SZ)'),
            array('value' => 'SE', 'label' => $hlp->__('Sweden') . ' (SE)'),
            array('value' => 'CH', 'label' => $hlp->__('Switzerland') . ' (CH)'),
            array('value' => 'SY', 'label' => $hlp->__('Syria') . ' (SY)'),
            array('value' => 'TJ', 'label' => $hlp->__('Tajikistan') . ' (TJ)'),
            array('value' => 'TZ', 'label' => $hlp->__('Tanzania') . ' (TZ)'),
            array('value' => 'TH', 'label' => $hlp->__('Thailand') . ' (TH)'),
            array('value' => 'TL', 'label' => $hlp->__('Timor-Leste (East Timor)') . ' (TL)'),
            array('value' => 'TG', 'label' => $hlp->__('Togo') . ' (TG)'),
            array('value' => 'TO', 'label' => $hlp->__('Tonga') . ' (TO)'),
            array('value' => 'TT', 'label' => $hlp->__('Trinidad and Tobago') . ' (TT)'),
            array('value' => 'TN', 'label' => $hlp->__('Tunisia') . ' (TN)'),
            array('value' => 'TR', 'label' => $hlp->__('Turkey') . ' (TR)'),
            array('value' => 'TM', 'label' => $hlp->__('Turkmenistan') . ' (TM)'),
            array('value' => 'TV', 'label' => $hlp->__('Tuvalu') . ' (TV)'),
            array('value' => 'UG', 'label' => $hlp->__('Uganda') . ' (UG)'),
            array('value' => 'UA', 'label' => $hlp->__('Ukraine') . ' (UA)'),
            array('value' => 'AE', 'label' => $hlp->__('United Arab Emirates') . ' (AE)'),
            array('value' => 'GB', 'label' => $hlp->__('United Kingdom') . ' (GB)'),
            array('value' => 'US', 'label' => $hlp->__('United States') . ' (US)'),
            array('value' => 'UY', 'label' => $hlp->__('Uruguay') . ' (UY)'),
            array('value' => 'UZ', 'label' => $hlp->__('Uzbekistan') . ' (UZ)'),
            array('value' => 'VU', 'label' => $hlp->__('Vanuatu') . ' (VU)'),
            array('value' => 'VA', 'label' => $hlp->__('Vatican City') . ' (VA)'),
            array('value' => 'VE', 'label' => $hlp->__('Venezuela') . ' (VE)'),
            array('value' => 'VN', 'label' => $hlp->__('Vietnam') . ' (VN)'),
            array('value' => 'YE', 'label' => $hlp->__('Yemen') . ' (YE)'),
            array('value' => 'ZM', 'label' => $hlp->__('Zambia') . ' (ZM)'),
            array('value' => 'ZW', 'label' => $hlp->__('Zimbabwe') . ' (ZW)'),
            array('value' => 'GE', 'label' => $hlp->__('Abkhazia') . ' (GE)'),
            array('value' => 'TW', 'label' => $hlp->__('China, Republic of (Taiwan)') . ' (TW)'),
            array('value' => 'AZ', 'label' => $hlp->__('Nagorno-Karabakh') . ' (AZ)'),
            array('value' => 'CY', 'label' => $hlp->__('Northern Cyprus') . ' (CY)'),
            array('value' => 'MD', 'label' => $hlp->__('Pridnestrovie (Transnistria)') . '(MD)'),
            array('value' => 'SO', 'label' => $hlp->__('Somaliland') . ' (SO)'),
            array('value' => 'GE', 'label' => $hlp->__('South Ossetia') . ' (GE)'),
            array('value' => 'AU', 'label' => $hlp->__('Ashmore and Cartier Islands') . ' (AU)'),
            array('value' => 'CX', 'label' => $hlp->__('Christmas Island') . ' (CX)'),
            array('value' => 'CC', 'label' => $hlp->__('Cocos') . ' (Keeling) Islands (CC)'),
            array('value' => 'AU', 'label' => $hlp->__('Coral Sea Islands') . ' (AU)'),
            array('value' => 'HM', 'label' => $hlp->__('Heard Island and McDonald Islands') . ' (HM)'),
            array('value' => 'NF', 'label' => $hlp->__('Norfolk Island') . ' (NF)'),
            array('value' => 'NC', 'label' => $hlp->__('New Caledonia') . ' (NC)'),
            array('value' => 'PF', 'label' => $hlp->__('French Polynesia') . ' (PF)'),
            array('value' => 'YT', 'label' => $hlp->__('Mayotte') . ' (YT)'),
            array('value' => 'GP', 'label' => $hlp->__('Saint Barthelemy') . ' (GP)'),
            array('value' => 'GP', 'label' => $hlp->__('Saint Martin') . ' (GP)'),
            array('value' => 'PM', 'label' => $hlp->__('Saint Pierre and Miquelon') . ' (PM)'),
            array('value' => 'WF', 'label' => $hlp->__('Wallis and Futuna') . ' (WF)'),
            array('value' => 'TF', 'label' => $hlp->__('French Southern and Antarctic Lands') . ' (TF)'),
            array('value' => 'PF', 'label' => $hlp->__('Clipperton Island') . ' (PF)'),
            array('value' => 'BV', 'label' => $hlp->__('Bouvet Island') . ' (BV)'),
            array('value' => 'CK', 'label' => $hlp->__('Cook Islands') . ' (CK)'),
            array('value' => 'NU', 'label' => $hlp->__('Niue') . ' (NU)'),
            array('value' => 'TK', 'label' => $hlp->__('Tokelau') . ' (TK)'),
            array('value' => 'GG', 'label' => $hlp->__('Guernsey') . ' (GG)'),
            array('value' => 'IM', 'label' => $hlp->__('Isle of Man') . ' (IM)'),
            array('value' => 'JE', 'label' => $hlp->__('Jersey') . ' (JE)'),
            array('value' => 'AI', 'label' => $hlp->__('Anguilla') . ' (AI)'),
            array('value' => 'BM', 'label' => $hlp->__('Bermuda') . ' (BM)'),
            array('value' => 'IO', 'label' => $hlp->__('British Indian Ocean Territory') . ' (IO)'),
            array('value' => 'VG', 'label' => $hlp->__('British Virgin Islands') . ' (VG)'),
            array('value' => 'KY', 'label' => $hlp->__('Cayman Islands') . ' (KY)'),
            array('value' => 'FK', 'label' => $hlp->__('Falkland Islands (Islas Malvinas)') . ' (FK)'),
            array('value' => 'GI', 'label' => $hlp->__('Gibraltar') . ' (GI)'),
            array('value' => 'MS', 'label' => $hlp->__('Montserrat') . ' (MS)'),
            array('value' => 'PN', 'label' => $hlp->__('Pitcairn Islands') . ' (PN)'),
            array('value' => 'SH', 'label' => $hlp->__('Saint Helena') . ' (SH)'),
            array('value' => 'GS', 'label' => $hlp->__('South Georgia & South Sandwich Islands') . ' (GS)'),
            array('value' => 'TC', 'label' => $hlp->__('Turks and Caicos Islands') . ' (TC)'),
            array('value' => 'MP', 'label' => $hlp->__('Northern Mariana Islands') . ' (MP)'),
            array('value' => 'PR', 'label' => $hlp->__('Puerto Rico') . ' (PR)'),
            array('value' => 'AS', 'label' => $hlp->__('American Samoa') . ' (AS)'),
            array('value' => 'UM', 'label' => $hlp->__('Baker Island') . ' (UM)'),
            array('value' => 'GU', 'label' => $hlp->__('Guam') . ' (GU)'),
            array('value' => 'UM', 'label' => $hlp->__('Howland Island') . ' (UM)'),
            array('value' => 'UM', 'label' => $hlp->__('Jarvis Island') . ' (UM)'),
            array('value' => 'UM', 'label' => $hlp->__('Johnston Atoll') . ' (UM)'),
            array('value' => 'UM', 'label' => $hlp->__('Kingman Reef') . ' (UM)'),
            array('value' => 'UM', 'label' => $hlp->__('Midway Islands') . ' (UM)'),
            array('value' => 'UM', 'label' => $hlp->__('Navassa Island') . ' (UM)'),
            array('value' => 'UM', 'label' => $hlp->__('Palmyra Atoll') . ' (UM)'),
            array('value' => 'VI', 'label' => $hlp->__('U.S. Virgin Islands') . ' (VI)'),
            array('value' => 'UM', 'label' => $hlp->__('Wake Island') . ' (UM)'),
            array('value' => 'HK', 'label' => $hlp->__('Hong Kong') . ' (HK)'),
            array('value' => 'MO', 'label' => $hlp->__('Macau') . ' (MO)'),
            array('value' => 'FO', 'label' => $hlp->__('Faroe Islands') . ' (FO)'),
            array('value' => 'GL', 'label' => $hlp->__('Greenland') . ' (GL)'),
            array('value' => 'GF', 'label' => $hlp->__('French Guiana') . ' (GF)'),
            array('value' => 'GP', 'label' => $hlp->__('Guadeloupe') . ' (GP)'),
            array('value' => 'MQ', 'label' => $hlp->__('Martinique') . ' (MQ)'),
            array('value' => 'RE', 'label' => $hlp->__('Reunion') . ' (RE)'),
            array('value' => 'AX', 'label' => $hlp->__('Aland') . ' (AX)'),
            array('value' => 'AW', 'label' => $hlp->__('Aruba') . ' (AW)'),
            array('value' => 'AN', 'label' => $hlp->__('Netherlands Antilles') . ' (AN)'),
            array('value' => 'SJ', 'label' => $hlp->__('Svalbard') . ' (SJ)'),
            array('value' => 'AC', 'label' => $hlp->__('Ascension') . ' (AC)'),
            array('value' => 'TA', 'label' => $hlp->__('Tristan da Cunha') . ' (TA)'),
            array('value' => 'AQ', 'label' => $hlp->__('Australian Antarctic Territory') . ' (AQ)'),
            array('value' => 'AQ', 'label' => $hlp->__('Ross Dependency') . ' (AQ)'),
            array('value' => 'AQ', 'label' => $hlp->__('Peter I Island') . ' (AQ)'),
            array('value' => 'AQ', 'label' => $hlp->__('Queen Maud Land') . ' (AQ)'),
            array('value' => 'AQ', 'label' => $hlp->__('British Antarctic Territory') . ' (AQ)')
        );
    }
}
