<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2018 Amasty (https://www.amasty.com)
 * @package Amasty_SeoToolKit
 */


class Amasty_SeoToolKit_Model_Source_Language
{
    public function toOptionArray()
    {
        $hlp = Mage::helper('amseotoolkit');

        //All the languages Google can handle.
        return array(
            array('value' => Amasty_SeoToolKit_Helper_Hrefurl::LANGUAGE_DEFAULT,
                'label' => $hlp->__('From Current Store Locale')),
            array('value' => 'ab', 'label' => $hlp->__('Abkhaz') . ' (ab)'),
            array('value' => 'aa', 'label' => $hlp->__('Afar') . ' (aa)'),
            array('value' => 'af', 'label' => $hlp->__('Afrikaans') . ' (af)'),
            array('value' => 'ak', 'label' => $hlp->__('Akan') . ' (ak)'),
            array('value' => 'sq', 'label' => $hlp->__('Albanian') . ' (sq)'),
            array('value' => 'am', 'label' => $hlp->__('Amharic') . ' (am)'),
            array('value' => 'ar', 'label' => $hlp->__('Arabic') . ' (ar)'),
            array('value' => 'an', 'label' => $hlp->__('Aragonese') . ' (an)'),
            array('value' => 'hy', 'label' => $hlp->__('Armenian') . ' (hy)'),
            array('value' => 'as', 'label' => $hlp->__('Assamese') . ' (as)'),
            array('value' => 'av', 'label' => $hlp->__('Avaric') . ' (av)'),
            array('value' => 'ae', 'label' => $hlp->__('Avestan') . ' (ae)'),
            array('value' => 'ay', 'label' => $hlp->__('Aymara') . ' (ay)'),
            array('value' => 'az', 'label' => $hlp->__('Azerbaijani') . ' (az)'),
            array('value' => 'bm', 'label' => $hlp->__('Bambara') . ' (bm)'),
            array('value' => 'ba', 'label' => $hlp->__('Bashkir') . ' (ba)'),
            array('value' => 'eu', 'label' => $hlp->__('Basque') . ' (eu)'),
            array('value' => 'be', 'label' => $hlp->__('Belarusian') . ' (be)'),
            array('value' => 'bn', 'label' => $hlp->__('Bengali, Bangla') . ' (bn)'),
            array('value' => 'bh', 'label' => $hlp->__('Bihari') . ' (bh)'),
            array('value' => 'bi', 'label' => $hlp->__('Bislama') . ' (bi)'),
            array('value' => 'bs', 'label' => $hlp->__('Bosnian') . ' (bs)'),
            array('value' => 'br', 'label' => $hlp->__('Breton') . ' (br)'),
            array('value' => 'bg', 'label' => $hlp->__('Bulgarian') . ' (bg)'),
            array('value' => 'my', 'label' => $hlp->__('Burmese') . ' (my)'),
            array('value' => 'ca', 'label' => $hlp->__('Catalan') . ' (ca)'),
            array('value' => 'ch', 'label' => $hlp->__('Chamorro') . ' (ch)'),
            array('value' => 'ce', 'label' => $hlp->__('Chechen') . ' (ce)'),
            array('value' => 'ny', 'label' => $hlp->__('Chichewa, Chewa, Nyanja') . ' (ny)'),
            array('value' => 'zh', 'label' => $hlp->__('Chinese') . ' (zh)'),
            array('value' => 'cv', 'label' => $hlp->__('Chuvash') . ' (cv)'),
            array('value' => 'kw', 'label' => $hlp->__('Cornish') . ' (kw)'),
            array('value' => 'co', 'label' => $hlp->__('Corsican') . ' (co)'),
            array('value' => 'cr', 'label' => $hlp->__('Cree') . ' (cr)'),
            array('value' => 'hr', 'label' => $hlp->__('Croatian') . ' (hr)'),
            array('value' => 'cs', 'label' => $hlp->__('Czech') . ' (cs)'),
            array('value' => 'da', 'label' => $hlp->__('Danish') . ' (da)'),
            array('value' => 'dv', 'label' => $hlp->__('Divehi, Dhivehi, Maldivian') . ' (dv)'),
            array('value' => 'nl', 'label' => $hlp->__('Dutch') . ' (nl)'),
            array('value' => 'dz', 'label' => $hlp->__('Dzongkha') . ' (dz)'),
            array('value' => 'en', 'label' => $hlp->__('English') . ' (en)'),
            array('value' => 'eo', 'label' => $hlp->__('Esperanto') . ' (eo)'),
            array('value' => 'et', 'label' => $hlp->__('Estonian') . ' (et)'),
            array('value' => 'ee', 'label' => $hlp->__('Ewe') . ' (ee)'),
            array('value' => 'fo', 'label' => $hlp->__('Faroese') . ' (fo)'),
            array('value' => 'fj', 'label' => $hlp->__('Fijian') . ' (fj)'),
            array('value' => 'fi', 'label' => $hlp->__('Finnish') . ' (fi)'),
            array('value' => 'fr', 'label' => $hlp->__('French') . ' (fr)'),
            array('value' => 'ff', 'label' => $hlp->__('Fula, Fulah, Pulaar, Pular') . ' (ff)'),
            array('value' => 'gl', 'label' => $hlp->__('Galician') . ' (gl)'),
            array('value' => 'ka', 'label' => $hlp->__('Georgian') . ' (ka)'),
            array('value' => 'de', 'label' => $hlp->__('German') . ' (de)'),
            array('value' => 'el', 'label' => $hlp->__('Greek') . ' (modern) (el)'),
            array('value' => 'gn', 'label' => $hlp->__('Guaraní') . ' (gn)'),
            array('value' => 'gu', 'label' => $hlp->__('Gujarati') . ' (gu)'),
            array('value' => 'ht', 'label' => $hlp->__('Haitian, Haitian Creole') . ' (ht)'),
            array('value' => 'ha', 'label' => $hlp->__('Hausa') . ' (ha)'),
            array('value' => 'he', 'label' => $hlp->__('Hebrew ') . ' (he)'),
            array('value' => 'hz', 'label' => $hlp->__('Herero') . ' (hz)'),
            array('value' => 'hi', 'label' => $hlp->__('Hindi') . ' (hi)'),
            array('value' => 'ho', 'label' => $hlp->__('Hiri Motu') . ' (ho)'),
            array('value' => 'hu', 'label' => $hlp->__('Hungarian') . ' (hu)'),
            array('value' => 'ia', 'label' => $hlp->__('Interlingua') . ' (ia)'),
            array('value' => 'id', 'label' => $hlp->__('Indonesian') . ' (id)'),
            array('value' => 'ie', 'label' => $hlp->__('Interlingue') . ' (ie)'),
            array('value' => 'ga', 'label' => $hlp->__('Irish') . ' (ga)'),
            array('value' => 'ig', 'label' => $hlp->__('Igbo') . ' (ig)'),
            array('value' => 'ik', 'label' => $hlp->__('Inupiaq') . ' (ik)'),
            array('value' => 'io', 'label' => $hlp->__('Ido') . ' (io)'),
            array('value' => 'is', 'label' => $hlp->__('Icelandic') . ' (is)'),
            array('value' => 'it', 'label' => $hlp->__('Italian') . ' (it)'),
            array('value' => 'iu', 'label' => $hlp->__('Inuktitut') . ' (iu)'),
            array('value' => 'ja', 'label' => $hlp->__('Japanese') . ' (ja)'),
            array('value' => 'jv', 'label' => $hlp->__('Javanese') . ' (jv)'),
            array('value' => 'kl', 'label' => $hlp->__('Kalaallisut, Greenlandic') . ' (kl)'),
            array('value' => 'kn', 'label' => $hlp->__('Kannada') . ' (kn)'),
            array('value' => 'kr', 'label' => $hlp->__('Kanuri') . ' (kr)'),
            array('value' => 'ks', 'label' => $hlp->__('Kashmiri') . ' (ks)'),
            array('value' => 'kk', 'label' => $hlp->__('Kazakh') . ' (kk)'),
            array('value' => 'km', 'label' => $hlp->__('Khmer') . ' (km)'),
            array('value' => 'ki', 'label' => $hlp->__('Kikuyu, Gikuyu') . ' (ki)'),
            array('value' => 'rw', 'label' => $hlp->__('Kinyarwanda') . ' (rw)'),
            array('value' => 'ky', 'label' => $hlp->__('Kyrgyz') . ' (ky)'),
            array('value' => 'kv', 'label' => $hlp->__('Komi') . ' (kv)'),
            array('value' => 'kg', 'label' => $hlp->__('Kongo') . ' (kg)'),
            array('value' => 'ko', 'label' => $hlp->__('Korean') . ' (ko)'),
            array('value' => 'ku', 'label' => $hlp->__('Kurdish') . ' (ku)'),
            array('value' => 'kj', 'label' => $hlp->__('Kwanyama, Kuanyama') . ' (kj)'),
            array('value' => 'la', 'label' => $hlp->__('Latin') . ' (la)'),
            array('value' => 'lb', 'label' => $hlp->__('Luxembourgish, Letzeburgesch') . ' (lb)'),
            array('value' => 'lg', 'label' => $hlp->__('Ganda') . ' (lg)'),
            array('value' => 'li', 'label' => $hlp->__('Limburgish, Limburgan, Limburger') . ' (li)'),
            array('value' => 'ln', 'label' => $hlp->__('Lingala') . ' (ln)'),
            array('value' => 'lo', 'label' => $hlp->__('Lao') . ' (lo)'),
            array('value' => 'lt', 'label' => $hlp->__('Lithuanian') . ' (lt)'),
            array('value' => 'lu', 'label' => $hlp->__('Luba-Katanga') . ' (lu)'),
            array('value' => 'lv', 'label' => $hlp->__('Latvian') . ' (lv)'),
            array('value' => 'gv', 'label' => $hlp->__('Manx') . ' (gv)'),
            array('value' => 'mk', 'label' => $hlp->__('Macedonian') . ' (mk)'),
            array('value' => 'mg', 'label' => $hlp->__('Malagasy') . ' (mg)'),
            array('value' => 'ms', 'label' => $hlp->__('Malay') . ' (ms)'),
            array('value' => 'ml', 'label' => $hlp->__('Malayalam') . ' (ml)'),
            array('value' => 'mt', 'label' => $hlp->__('Maltese') . ' (mt)'),
            array('value' => 'mi', 'label' => $hlp->__('Māori') . ' (mi)'),
            array('value' => 'mr', 'label' => $hlp->__('Marathi ') . ' (mr)'),
            array('value' => 'mh', 'label' => $hlp->__('Marshallese') . ' (mh)'),
            array('value' => 'mn', 'label' => $hlp->__('Mongolian') . ' (mn)'),
            array('value' => 'na', 'label' => $hlp->__('Nauru') . ' (na)'),
            array('value' => 'nv', 'label' => $hlp->__('Navajo, Navaho') . ' (nv)'),
            array('value' => 'nd', 'label' => $hlp->__('Northern Ndebele') . ' (nd)'),
            array('value' => 'ne', 'label' => $hlp->__('Nepali') . ' (ne)'),
            array('value' => 'ng', 'label' => $hlp->__('Ndonga') . ' (ng)'),
            array('value' => 'nb', 'label' => $hlp->__('Norwegian Bokmål') . ' (nb)'),
            array('value' => 'nn', 'label' => $hlp->__('Norwegian Nynorsk') . ' (nn)'),
            array('value' => 'no', 'label' => $hlp->__('Norwegian') . ' (no)'),
            array('value' => 'ii', 'label' => $hlp->__('Nuosu') . ' (ii)'),
            array('value' => 'nr', 'label' => $hlp->__('Southern Ndebele') . ' (nr)'),
            array('value' => 'oc', 'label' => $hlp->__('Occitan') . ' (oc)'),
            array('value' => 'oj', 'label' => $hlp->__('Ojibwe, Ojibwa') . ' (oj)'),
            array('value' => 'cu', 'label' => $hlp->__('Old Church Slavonic, Old Bulgarian') . ' (cu)'),
            array('value' => 'om', 'label' => $hlp->__('Oromo') . ' (om)'),
            array('value' => 'or', 'label' => $hlp->__('Oriya') . ' (or)'),
            array('value' => 'os', 'label' => $hlp->__('Ossetian, Ossetic') . ' (os)'),
            array('value' => 'pa', 'label' => $hlp->__('Panjabi, Punjabi') . ' (pa)'),
            array('value' => 'pi', 'label' => $hlp->__('Pāli') . ' (pi)'),
            array('value' => 'fa', 'label' => $hlp->__('Persian') . ' (Farsi) (fa)'),
            array('value' => 'pl', 'label' => $hlp->__('Polish') . ' (pl)'),
            array('value' => 'ps', 'label' => $hlp->__('Pashto, Pushto') . ' (ps)'),
            array('value' => 'pt', 'label' => $hlp->__('Portuguese') . ' (pt)'),
            array('value' => 'qu', 'label' => $hlp->__('Quechua') . ' (qu)'),
            array('value' => 'rm', 'label' => $hlp->__('Romansh') . ' (rm)'),
            array('value' => 'rn', 'label' => $hlp->__('Kirundi') . ' (rn)'),
            array('value' => 'ro', 'label' => $hlp->__('Romanian') . ' (ro)'),
            array('value' => 'ru', 'label' => $hlp->__('Russian') . ' (ru)'),
            array('value' => 'sa', 'label' => $hlp->__('Sanskrit ') . ' (sa)'),
            array('value' => 'sc', 'label' => $hlp->__('Sardinian') . ' (sc)'),
            array('value' => 'sd', 'label' => $hlp->__('Sindhi') . ' (sd)'),
            array('value' => 'se', 'label' => $hlp->__('Northern Sami') . ' (se)'),
            array('value' => 'sm', 'label' => $hlp->__('Samoan') . ' (sm)'),
            array('value' => 'sg', 'label' => $hlp->__('Sango') . ' (sg)'),
            array('value' => 'sk', 'label' => $hlp->__('Saraiki,Seraiki,Siraiki') . ' (sk)'),
            array('value' => 'sr', 'label' => $hlp->__('Serbian') . ' (sr)'),
            array('value' => 'gd', 'label' => $hlp->__('Scottish Gaelic, Gaelic') . ' (gd)'),
            array('value' => 'sn', 'label' => $hlp->__('Shona') . ' (sn)'),
            array('value' => 'si', 'label' => $hlp->__('Sinhala') . ' (si)'),
            array('value' => 'sk', 'label' => $hlp->__('Slovak') . ' (sk)'),
            array('value' => 'sl', 'label' => $hlp->__('Slovene') . ' (sl)'),
            array('value' => 'so', 'label' => $hlp->__('Somali') . ' (so)'),
            array('value' => 'st', 'label' => $hlp->__('Southern Sotho') . ' (st)'),
            array('value' => 'es', 'label' => $hlp->__('Spanish') . ' (es)'),
            array('value' => 'su', 'label' => $hlp->__('Sundanese') . ' (su)'),
            array('value' => 'sw', 'label' => $hlp->__('Swahili') . ' (sw)'),
            array('value' => 'ss', 'label' => $hlp->__('Swati') . ' (ss)'),
            array('value' => 'sv', 'label' => $hlp->__('Swedish') . ' (sv)'),
            array('value' => 'ta', 'label' => $hlp->__('Tamil') . ' (ta)'),
            array('value' => 'te', 'label' => $hlp->__('Telugu') . ' (te)'),
            array('value' => 'tg', 'label' => $hlp->__('Tajik') . ' (tg)'),
            array('value' => 'th', 'label' => $hlp->__('Thai') . ' (th)'),
            array('value' => 'ti', 'label' => $hlp->__('Tigrinya') . ' (ti)'),
            array('value' => 'bo', 'label' => $hlp->__('Tibetan') . ' (bo)'),
            array('value' => 'tk', 'label' => $hlp->__('Turkmen') . ' (tk)'),
            array('value' => 'tl', 'label' => $hlp->__('Tagalog') . ' (tl)'),
            array('value' => 'tn', 'label' => $hlp->__('Tswana') . ' (tn)'),
            array('value' => 'to', 'label' => $hlp->__('Tonga ') . ' (to)'),
            array('value' => 'tr', 'label' => $hlp->__('Turkish') . ' (tr)'),
            array('value' => 'ts', 'label' => $hlp->__('Tsonga') . ' (ts)'),
            array('value' => 'tt', 'label' => $hlp->__('Tatar') . ' (tt)'),
            array('value' => 'tw', 'label' => $hlp->__('Twi') . ' (tw)'),
            array('value' => 'ty', 'label' => $hlp->__('Tahitian') . ' (ty)'),
            array('value' => 'ug', 'label' => $hlp->__('Uyghur') . ' (ug)'),
            array('value' => 'uk', 'label' => $hlp->__('Ukrainian') . ' (uk)'),
            array('value' => 'ur', 'label' => $hlp->__('Urdu') . ' (ur)'),
            array('value' => 'uz', 'label' => $hlp->__('Uzbek') . ' (uz)'),
            array('value' => 've', 'label' => $hlp->__('Venda') . ' (ve)'),
            array('value' => 'vi', 'label' => $hlp->__('Vietnamese') . ' (vi)'),
            array('value' => 'vo', 'label' => $hlp->__('Volapük') . ' (vo)'),
            array('value' => 'wa', 'label' => $hlp->__('Walloon') . ' (wa)'),
            array('value' => 'cy', 'label' => $hlp->__('Welsh') . ' (cy)'),
            array('value' => 'wo', 'label' => $hlp->__('Wolof') . ' (wo)'),
            array('value' => 'fy', 'label' => $hlp->__('Western Frisian') . ' (fy)'),
            array('value' => 'xh', 'label' => $hlp->__('Xhosa') . ' (xh)'),
            array('value' => 'yi', 'label' => $hlp->__('Yiddish') . ' (yi)'),
            array('value' => 'yo', 'label' => $hlp->__('Yoruba') . ' (yo)'),
            array('value' => 'za', 'label' => $hlp->__('Zhuang, Chuang') . ' (za)'),
            array('value' => 'zu', 'label' => $hlp->__('Zulu') . ' (zu)')
        );
    }
}
