<?php
/**
 * @copyright   Copyright (c) 2015 blackqubers
 */ 
class Bq_Sequence_Block_Adminhtml_Catalog_Category_Tab_Sequence extends Mage_Adminhtml_Block_Widget_Grid
{

    public function __construct()
    {
        parent::__construct();
        $this->setId('catalog_category_products');
        $this->setDefaultSort('entity_id');
        $this->setUseAjax(true);
        $this->setDefaultLimit('1000');

    }

    public function getCategory()
    {
        return Mage::registry('category');
    }

   /* protected function _addColumnFilterToCollection($column)
    {
        // Set custom filter for in category flag
        if ($column->getId() == 'in_category') {
            $productIds = $this->_getSelectedProducts();
            if (empty($productIds)) {
                $productIds = 0;
            }
            if ($column->getFilter()->getValue()) {
                $this->getCollection()->addFieldToFilter('entity_id', array('in'=>$productIds));
            }
            elseif(!empty($productIds)) {
                $this->getCollection()->addFieldToFilter('entity_id', array('nin'=>$productIds));
            }
        }
        else {
            parent::_addColumnFilterToCollection($column);
        }
        return $this;
    }*/

    protected function _prepareCollection()
    {
        if ($this->getCategory()->getId()) {
           $this->setDefaultFilter(array('in_category'=>1));
        }
        $collection = Mage::getModel('catalog/product')->getCollection()
			->setOrder('position', 'asc')
            ->addAttributeToSelect('name')
            ->addAttributeToSelect('sku')
            ->addAttributeToSelect('price')
            ->addAttributeToSelect('thumbnail')            
            ->addAttributeToSelect('visibility')
            ->addAttributeToFilter('status',array('eq' => Mage_Catalog_Model_Product_Status::STATUS_ENABLED))
            ->addStoreFilter($this->getRequest()->getParam('store'))
            ->addCategoryFilter(Mage::getModel('catalog/category')->load($this->getRequest()->getParam('id')));

        $this->setCollection($collection);
        $this->getCollection()->addFieldToFilter('visibility', array('value' => '2','value' => '4'));
        return parent::_prepareCollection();
    }

}

