<?php
class Katsumi_Ordergrid_Block_Adminhtml_Order_Grid extends Mage_Adminhtml_Block_Widget_Grid
{
     public function __construct()
    {
        parent::__construct();
        $this->setId('sales_order_grid');
        $this->setUseAjax(true);
        $this->setDefaultSort('created_at');
        $this->setDefaultDir('DESC');
        $this->setSaveParametersInSession(true);
    }
 
    /**
     * Retrieve collection class
     *
     * @return string
     */
    protected function _getCollectionClass()
    {
        return 'sales/order_grid_collection';
    }
 
    protected function _prepareCollection()
    {
        $collection = Mage::getResourceModel($this->_getCollectionClass());
        $this->setCollection($collection);
        $adapter = $collection->getResource()->getReadConnection();
        $subSelect = $adapter->select()->from(array('sales_flat_order'), array('entity_id', 'coupon_code'));
        $collection->getSelect()->join(array('order' => $subSelect), '`order`.entity_id = `main_table`.entity_id',array('coupon_code'));
        return parent::_prepareCollection();
    }
 
    protected function _prepareColumns()
    {
		$this->addColumn('coupon_code', array(
            'header' => Mage::helper('sales')->__('Rabattkod'),
            'index' => 'coupon_code',
        ));
		/*
        $this->addColumn('important_comment', array(
            'header' => Mage::helper('sales')->__('Viktig'),
            'index' => 'important_comment',
            'type'  => 'text',
            'width' => '50px',
        ));
		*/
		$this->addColumn('customer_email', array(
			'header' => Mage::helper('sales')->__('E-mail'),
            'index' => 'customer_email',
            'type'  => 'text',
		)); 
 
        return $this;
    }
 
    public function getRowUrl($row)
    {
        if (Mage::getSingleton('admin/session')->isAllowed('sales/order/actions/view')) {
            return $this->getUrl('*/sales_order/view', array('order_id' => $row->getId()));
        }
        return false;
    }
    public function getGridUrl()
    {
        return $this->getUrl('*/*/grid', array('_current'=>true));
    }
}