<?php

class Moogento_Pickpack_Block_Adminhtml_System_Config_Form_Field_Email_Detailed
    extends Mage_Adminhtml_Block_System_Config_Form_Field
{
    protected function _getElementHtml(Varien_Data_Form_Element_Abstract $element)
    {
        $html = $element->getElementHtml();


        $websiteScope = $this->getRequest()->getParam('website');
        $storeScope   = $this->getRequest()->getParam('store');

        $senders = array();

        $possibleSenders = Mage::getSingleton('adminhtml/system_config_source_email_identity')->toOptionArray();
        foreach($possibleSenders as $senderInfo) {
            $senderCode = $senderInfo['value'];
            $namePath = "trans_email/ident_{$senderCode}/name";
            $emailPath = "trans_email/ident_{$senderCode}/email";

            $senderName = $senderEmail = '';

            if ($websiteScope) {
                $senderName = Mage::app()->getWebsite($websiteScope)->getConfig($namePath);
                $senderEmail = Mage::app()->getWebsite($websiteScope)->getConfig($emailPath);
            } else if ($storeScope){
                $senderName = Mage::app()->getStore($storeScope)->getConfig($namePath);
                $senderEmail = Mage::app()->getStore($storeScope)->getConfig($emailPath);
            } else {
                $senderName  = Mage::getStoreConfig($namePath, 0);
                $senderEmail = Mage::getStoreConfig($emailPath, 0);
            }

            $senders[$senderCode] = array(
                'name' => $senderName,
                'email' => $senderEmail
            );
        }

        $currentValue = (string)$element->getValue();

        $html .= '<br>';
        $html .= 'Name : <span id="'.$element->getId().'_descr_name">'. $senders[$currentValue]['name'] . '</span><br>';
        $html .= 'Email: <span id="'.$element->getId().'_descr_email">'. $senders[$currentValue]['email'] . '</span>';
        $html .= '
<script type="text/javascript">
    var '.$element->getId().'_possible_senders = '.Mage::helper('core')->jsonEncode($senders).';
    $("'.$element->getId().'").observe("change", function(event){
        var _element = Event.element(event);
        var _value   = $(_element).getValue();

        $("'.$element->getId().'_descr_name").update(
            '.$element->getId().'_possible_senders[_value].name
        );
        $("'.$element->getId().'_descr_email").update(
            '.$element->getId().'_possible_senders[_value].email
        );
    });
</script>
';
        return $html;
    }

}