<?php

abstract class Moogento_Pickpack_Block_Adminhtml_System_Config_Form_Grouper_Abstract
    extends Mage_Adminhtml_Block_System_Config_Form_Fieldset
{
    protected $_openers = array();
    protected $_closers = array();

    protected function _getFieldsContainerHeader($title)
    {
        $default = !$this->getRequest()->getParam('website') && !$this->getRequest()->getParam('store');
        $colspan = (!$default) ? 5 : 4;

        $html = '<tr><td colspan="'.$colspan.'">';
        $html .= '<fieldset style="text-align:left; margin-top: 20px"><legend style="display: inline; font-weight: bold">&nbsp;'.$title.'&nbsp;</legend>';

        $html.= '<table cellspacing="0" class="form-list"><colgroup class="label" /><colgroup class="value" />';
        if (!$default) {
            $html.= '<colgroup class="use-default" />';
        }
        $html.= '<colgroup class="scope-label" /><colgroup class="" /><tbody>';


        return $html;
    }

    protected function _getFieldsContainerFooter()
    {
        $html = '</tbody></table></fieldset></td></tr>';

        return $html;
    }


    public function render(Varien_Data_Form_Element_Abstract $element)
    {
        $html = $this->_getHeaderHtml($element);

        foreach ($element->getSortedElements() as $field) {
            if (isset($this->_openers[$field->getId()])) {
                $html .= $this->_getFieldsContainerHeader($this->_openers[$field->getId()]);
            }

            $html.= $field->toHtml();

            if (isset($this->_closers[$field->getId()])) {
                $html .= $this->_getFieldsContainerFooter();
            }
        }

        $html .= $this->_getFooterHtml($element);

        return $html;
    }
}