<?php

class Moogento_Pickpack_Model_Adminhtml_Action_Observer
{
    protected function _updateAttribute($configPrefix, $orderIds, $fieldPrefix = '')
    {
        if (!is_array($orderIds)) {
            $orderIds = array($orderIds);
        }

        if (!empty($fieldPrefix)) {
            $fieldPrefix .= '_';
        }

        $resource = Mage::getResourceModel('moogento_shipeasy/sales_order');

        foreach($orderIds as $orderId) {

            $storeId = Mage::getResourceSingleton('pickpack/sales_order')->getOrderStoreId($orderId);
            if (!$storeId) {
                $storeId = 0;
            }

            if (Mage::getStoreConfigFlag("pickpack_options/{$configPrefix}/{$fieldPrefix}additional_action", $storeId)) {

                $attributeToUpdate = Mage::getStoreConfig("pickpack_options/{$configPrefix}/{$fieldPrefix}szy_attribute_to_update", $storeId);
                $postfix = ($attributeToUpdate == 'custom_attribute') ? 'szy_custom_value1' : 'szy_custom_value2';

                $value = Mage::getStoreConfig("pickpack_options/{$configPrefix}/{$fieldPrefix}{$postfix}", $storeId);
                if ($value == '_custom_') {
                    $postfix = ($attributeToUpdate == 'custom_attribute') ? 'szy_own_value1' : 'szy_own_value2';
                    $value = Mage::getStoreConfig("pickpack_options/{$configPrefix}/{$fieldPrefix}{$postfix}", $storeId);
                }

                try {
                    $resource->updateGridRow($orderId, $attributeToUpdate, $value);
                } catch(Exception $e) {
                    Mage::logException($e);
                }
            }
        }

        return $this;
    }

    public function invoiceAfterToPdf($observer)
    {
        $orderIds = $observer->getOrderIds();
        if (Mage::helper('pickpack')->isShipEasyInstalled()) {
            $this->_updateAttribute('wonder_invoice', $orderIds);
        }
    }

    public function invoiceAfterAutoToPdf($observer)
    {
        $orderIds = $observer->getOrderIds();
        if (Mage::helper('pickpack')->isShipEasyInstalled()) {
            $this->_updateAttribute('wonder_invoice', $orderIds, 'auto_processing');
        }
    }

    public function packAfterToPdf($observer)
    {
        $orderIds = $observer->getOrderIds();
        if (Mage::helper('pickpack')->isShipEasyInstalled()) {
            $this->_updateAttribute('wonder', $orderIds);
        }
    }

    public function packAfterAutoToPdf($observer)
    {
        $orderIds = $observer->getOrderIds();
        if (Mage::helper('pickpack')->isShipEasyInstalled()) {
            $this->_updateAttribute('wonder', $orderIds, 'auto_processing');
        }
    }
}