<?php

class Moogento_Pickpack_Model_Sales_Order_Observer
{
    protected $_orderStatus = null;
    protected $_isNewOrder = false;

    public function saveBefore($observer)
    {
        $order = $observer->getOrder();

        if ($order->getId()) {
            $this->_isNewOrder = false;
        } else {
            $this->_isNewOrder = true;
        }

        if (!$this->_isNewOrder && $order->getOrigData('status')) {
            $this->_orderStatus = $order->getOrigData('status');
        } else {
            $this->_orderStatus = $order->getStatus();
        }

        return $this;
    }

    public function saveAfter($observer)
    {
        $order = $observer->getOrder();

        if (!$this->_isNewOrder) {
            if ($order->getStatus() != $this->_orderStatus) {
                Mage::getSingleton('pickpack/sales_order_processor')->processStatusChange($observer->getOrder());
            }
        }

        /**
         * For AMAZON imported orders
         */
        if (($order->getPaymentType() == 'amagento') || ($order->getShippingMethod() == "amagentoshippingrate_amagentoshippingrate")) {
            if ($order->getStatus()) {
                Mage::getSingleton('pickpack/sales_order_processor')->processStatusChange($observer->getOrder());
            }
        }

        return $this;
    }

    public function placeAfter($observer)
    {
        $order = $observer->getOrder();

        if ($this->_isNewOrder && $order->getStatus()) {
            Mage::getSingleton('pickpack/sales_order_processor')->processStatusChange($order);
        }

        return $this;
    }

    public function bulkProcessing($type = null)
    {
        try
		{
			Mage::getSingleton('pickpack/sales_order_processor')->processBulk($type);
		}
		catch(Exception $e)
		{
			Mage::throwException('Error at bulkProcessing');
		}
    }

    public function bulkProcessingWonderInvoice()
    {
        try
		{
        	$this->bulkProcessing('wonder_invoice');
		}
		catch(Exception $e)
		{
			Mage::throwException('Error at bulkProcessingWonderInvoice');
		}
    }

    public function bulkProcessingWonder()
    {
        try
		{
        	$this->bulkProcessing('wonder');
		}
		catch(Exception $e)
		{
			Mage::throwException('Error at bulkProcessingWonder');
		}
    }

    public function bulkProcessingPicks()
    {
        try
		{
			$this->bulkProcessing('picks');
		}
		catch(Exception $e)
		{
			Mage::throwException('Error at bulkProcessingPicks');
		}
    }

    public function bulkProcessingMessages()
    {
		try
		{
			$this->bulkProcessing('messages');
		}
		catch(Exception $e)
		{
			Mage::throwException('Error at bulkProcessingMessages');
		}
    }
}