<?php

class Moogento_Pickpack_Model_Sales_Order_Processor extends Varien_Object
{
    protected $_processors = array(
        'wonder_invoice' => 'pickpack/sales_order_processor_invoice',
        'wonder'         => 'pickpack/sales_order_processor_packingSheet',
        'picks'          => 'pickpack/sales_order_processor_orderPick',
        'messages'       => 'pickpack/sales_order_processor_itemsPick',
    );

    public function processStatusChange($order)
    {
        foreach($this->_processors as $processor) {
            $processor = Mage::getSingleton($processor);
            $processor->processOrderStatusUpdate($order);
        }

        return $this;
    }

    public function processBulk($type = null)
    {
        foreach($this->_processors as $key => $processor) {
            if ($type && ($key != $type)) {
                continue;
            }
            $processor = Mage::getSingleton($processor);
            $processor->processBulk(Mage::app()->getLocale()->date()->toString('e'));
        }
    }
}