<?php

require_once("Mage/Adminhtml/controllers/Sales/OrderController.php");

class Moogento_Pickpack_Adminhtml_Pickpack_Sales_OrderController extends Mage_Adminhtml_Sales_OrderController
{

    /**
     * Class Constructor
     * call the parent Constructor
     */

    public function __constuct()
    {
        parent::__construct();
    }


    protected function _initAction()
    {
        $this->loadLayout()
        ->_setActiveMenu('sales/order')
        ->_addBreadcrumb($this->__('Sales'), $this->__('Sales'));
        // ->_addBreadcrumb($this->__('Orders'), $this->__('Trash Orders'));
        return $this;
    }


    public function indexAction()
    {
        parent::indexAction();
    }

    public function mooinvoiceAction()
    {
        $orderIds = $this->getRequest()->getPost('order_ids');

        $from_shipment = 'order';
        if (!empty($orderIds)) 
        {
            $methodName = (Mage::getStoreConfig('pickpack_options/wonder_invoice/page_template') == 1) ? 'getPdf2' : 'getPdfDefault';
            $pdf = Mage::getModel('sales/order_pdf_invoices')->$methodName($orderIds,$from_shipment,'invoice');

            Mage::dispatchEvent(
                'moo_pp_invoice_pdf_generate_after',
                array('order_ids' => $orderIds)
            );

            return $this->_prepareDownloadResponse('invoice_'.Mage::getSingleton('core/date')->date('Y-m-d_H').'.pdf', $pdf->render(), 'application/pdf');
        }
        $this->_redirect('*/*/');
    }
    
    public function packAction()
    {
        $orderIds = $this->getRequest()->getPost('order_ids');        
        $from_shipment = 'order';

        if (!empty($orderIds))
        {
            $methodName = (Mage::getStoreConfig('pickpack_options/wonder/page_template') == 1) ? 'getPdf2' : 'getPdfDefault';
            $pdf = Mage::getModel('sales/order_pdf_invoices')->$methodName($orderIds,$from_shipment,'pack');

            Mage::dispatchEvent(
                'moo_pp_pack_pdf_generate_after',
                array('order_ids' => $orderIds)
            );

            return $this->_prepareDownloadResponse('packing-sheet_'.Mage::getSingleton('core/date')->date('Y-m-d_H').'.pdf', $pdf->render(), 'application/pdf');
        }
        $this->_redirect('*/*/');
    }

    public function mooinvoicepackAction()
    {
        $orderIds = $this->getRequest()->getPost('order_ids');        
        $flag = false;
        $from_shipment = 'order';

        if (!empty($orderIds)) 
        {     
            if(Mage::getStoreConfig('pickpack_options/general/combined_orders_grouped_by_id_yn') == 1)
            {
                $pdf = new Zend_Pdf(); 
                
                foreach($orderIds as $order_id)
                {
                    $order_id_array = array($order_id);
                    
                    $pdfA = Mage::getModel('sales/order_pdf_invoices')->getPdfDefault($order_id_array,$from_shipment,'invoice');     
                    $pdfB = Mage::getModel('sales/order_pdf_invoices')->getPdfDefault($order_id_array,$from_shipment,'pack');
                    foreach ($pdfB->pages as $page)
                    {
                        $pdfA->pages[] = $page;
                    }
                    foreach ($pdfA->pages as $page)
                    {
                        $pdf->pages[] = $page; 
                    }
                }    
                return $this->_prepareDownloadResponse('invoice+packing-sheet_'.Mage::getSingleton('core/date')->date('Y-m-d_H').'.pdf', $pdf->render(), 'application/pdf');
            }
            else
            {
                    $pdfA = Mage::getModel('sales/order_pdf_invoices')->getPdfDefault($orderIds,$from_shipment,'invoice');     
                    $pdfB = Mage::getModel('sales/order_pdf_invoices')->getPdfDefault($orderIds,$from_shipment,'pack');
                    
                    foreach ($pdfB->pages as $page){
                        $pdfA->pages[] = $page;
                    }                    
                    return $this->_prepareDownloadResponse('invoice+packing-sheet_'.Mage::getSingleton('core/date')->date('Y-m-d_H').'.pdf', $pdfA->render(), 'application/pdf');
            }
        }

        $this->_redirect('*/*/');
    }
    
    public function pickAction(){
        $orderIds = $this->getRequest()->getPost('order_ids');

        if (!empty($orderIds)) 
        {
                $pdf = Mage::getModel('sales/order_pdf_invoices')->getPickSeparated2($orderIds);     
                return $this->_prepareDownloadResponse('pick-list-separated_'.Mage::getSingleton('core/date')->date('Y-m-d_H').'.pdf', $pdf->render(), 'application/pdf');
        }
        $this->_redirect('*/*/');
    }
    
    
    public function enpickAction(){
        $orderIds = $this->getRequest()->getPost('order_ids');

        if (!empty($orderIds)) 
        {
                $pdf = Mage::getModel('sales/order_pdf_invoices')->getPickCombined($orderIds,'order_combined');     
                return $this->_prepareDownloadResponse('pick-list-combined_'.Mage::getSingleton('core/date')->date('Y-m-d_H').'.pdf', $pdf->render(), 'application/pdf');
        }
        $this->_redirect('*/*/');
    }
    
    public function prodpickAction(){
        $orderIds = $this->getRequest()->getPost('order_ids');

        if (!empty($orderIds)) 
        {
                $pdf = Mage::getModel('sales/order_pdf_invoices')->getPickCombined($orderIds,'trolleybox');     
                return $this->_prepareDownloadResponse('pick-list-product-separated_'.Mage::getSingleton('core/date')->date('Y-m-d_H').'.pdf', $pdf->render(), 'application/pdf');
        }
        $this->_redirect('*/*/');
    }
    

    public function stockAction(){
        $orderIds = $this->getRequest()->getPost('order_ids');
        $csv_or_pdf = Mage::getStoreConfig('pickpack_options/stock/csv_or_pdf');

        if (!empty($orderIds)) 
        {
                $pdf = Mage::getModel('sales/order_pdf_invoices')->getPickStock($orderIds);     
                if($csv_or_pdf == 'pdf')
                {
                    return $this->_prepareDownloadResponse('out-of-stock-list_'.Mage::getSingleton('core/date')->date('Y-m-d_H').'.pdf', $pdf->render(), 'application/pdf');
                }
                else
                {
                    return $this->_prepareDownloadResponse('out-of-stock-list_'.Mage::getSingleton('core/date')->date('Y-m-d_H').'.csv', $pdf);
                }
        }
        $this->_redirect('*/*/');
    }
    
    public function labelAction(){
        $orderIds = $this->getRequest()->getPost('order_ids');

        if (!empty($orderIds)) 
        {
                $pdf = Mage::getModel('sales/order_pdf_invoices')->getLabel($orderIds);     
                return $this->_prepareDownloadResponse('address-labels_'.Mage::getSingleton('core/date')->date('Y-m-d_H').'.pdf', $pdf->render(), 'application/pdf');
        }
        $this->_redirect('*/*/');
    }
    
    public function orderscsvAction(){
        $orderIds = $this->getRequest()->getPost('order_ids');

        if (!empty($orderIds)) 
        {
                $pdf = Mage::getModel('sales/order_pdf_invoices')->getCsvOrders($orderIds,false);
                $fileName = 'orders-csv_'.Mage::getSingleton('core/date')->date('Y-m-d').'.csv';
                return $this->_prepareDownloadResponse($fileName, $pdf);
        }
        $this->_redirect('*/*/');
    }
            
    public function pickcsvAction(){
        $orderIds = $this->getRequest()->getPost('order_ids');

        if (!empty($orderIds)) 
        {
                $pdf = Mage::getModel('sales/order_pdf_invoices')->getCsvPickSeparated2($orderIds);     
                $fileName = 'pick-list-separated-csv_'.Mage::getSingleton('core/date')->date('Y-m-d_H').'.csv';
                return $this->_prepareDownloadResponse($fileName, $pdf);
        }
        $this->_redirect('*/*/');
    }
    
    public function pickcsvcombinedAction(){
        $orderIds = $this->getRequest()->getPost('order_ids');
    
        if (!empty($orderIds)) 
        {
                $pdf = Mage::getModel('sales/order_pdf_invoices')->getCsvPickCombined($orderIds,false,'picklist');     
                $fileName = 'pick-list-combined-csv_'.Mage::getSingleton('core/date')->date('Y-m-d_H').'.csv';
                return $this->_prepareDownloadResponse($fileName, $pdf);
        }
        $this->_redirect('*/*/');
    }
    
    public function manifestcsvcombinedAction(){
        $orderIds = $this->getRequest()->getPost('order_ids');

        if (!empty($orderIds)) 
        {
            $pdf = Mage::getModel('sales/order_pdf_invoices')->getCsvPickCombined($orderIds,false,'manifest');     

            if(Mage::getStoreConfig('pickpack_options/csvmanifestcombined/is_excel_yn') == 1)
            {
                $fileName = 'combined-shipping-manifest_'.Mage::getSingleton('core/date')->date('Y-m-d_H').'.xml';
                //$grid       = $this->getLayout()->createBlock('adminhtml/sales_order_grid');
                
                //return $this->_prepareDownloadResponse($fileName, $pdf);
                return $this->_prepareDownloadResponse($fileName, $pdf);

            }
            else
            {
                $fileName = 'combined-shipping-manifest_'.Mage::getSingleton('core/date')->date('Y-m-d_H').'.csv';
                return $this->_prepareDownloadResponse($fileName, $pdf);
            }
        }
        $this->_redirect('*/*/');
    }

/*
    public function pickxlcombinedAction(){
        $orderIds = $this->getRequest()->getPost('order_ids');
    
        if (!empty($orderIds)) 
        {
                $pdf = Mage::getModel('sales/order_pdf_invoices')->getXlPickCombined($orderIds);
            $grid       = $this->getLayout()->createBlock('adminhtml/sales_order_grid');
            //    $grid       = Mage::getModel('sales/order_pdf_invoices')->getXlPickCombined($orderIds);

                $fileName = 'combined-shipping-manifest_'.Mage::getSingleton('core/date')->date('Y-m-d_H').'.xml';
                return $this->_prepareDownloadResponse($fileName, $grid->getExcelFile($fileName));
        }
        $this->_redirect('*');
    }
*/    
}
