<?php
/**
 * Pre-Orders
 *
 * @category:    Aitoc
 * @package:     Aitoc_Aitpreorder
 * @version      1.1.40
 * @license:     0DMhQYOdlQVaorpLyxYHyL27EIMKklPz0C7NSJhsna
 * @copyright:   Copyright (c) 2014 AITOC, Inc. (http://www.aitoc.com)
 */
/**
* @copyright  Copyright (c) 2011 AITOC, Inc.
*/

class Aitoc_Aitpreorder_Model_Rewrite_CatalogProduct extends Mage_Catalog_Model_Product
{
    /**
     * Added for compatibility with Multi-location Inventory.
     * Mage_Catalog_Model_Product::getPreorder() should respect setting
     * "Website Inventory: Use Default Values".
     *
     * @return integer
     */
    public function getPreorder()
    {
        $preorder = parent::getPreorder();
        if(!isset($preorder))
        {
            $preorder = $this->_getPreorder();
        }

        if (Mage::helper('aitpreorder')->checkIfMultilocationInventoryIsEnabled())
        {
            $stockItem = Mage::getModel('aitquantitymanager/stock_item');
            $stockItem->loadByProduct($this);            

            if ($stockItem->getUseDefaultWebsiteStock())
            {
                $preorder = Aitoc_Aitpreorder_Model_Rewrite_SourceBackorders::BACKORDERS_YES_PREORDERS == $stockItem->getBackorders();
            }
        }        

            /* {#AITOC_COMMENT_END#}
            if (!Mage::app()->getStore()->isAdmin())
            {
                $performer = Aitoc_Aitsys_Abstract_Service::get()->platform()->getModule('Aitoc_Aitpreorder')->getLicense()->getPerformer();
                $ruler = $performer->getRuler();
                if (!($ruler->checkRule('store',Mage::app()->getStore()->getId(),'store') || $ruler->checkRule('store',Mage::app()->getStore()->getWebsiteId(),'website')))
                {
                if($preorder==1)
                    {
                        return '0';
                    }
                }
            }
            {#AITOC_COMMENT_START#} */
        return $preorder;
    }
    
    protected function _beforeSave()
    {
        $item = $this->getStockData();
        if(isset($item['use_config_backorders']) && $item['use_config_backorders']=='1')
        {
           $item['backorders']= Mage::getStoreConfig('cataloginventory/item_options/backorders');
           $this->setStockData($item); 
           $this->setPreorder('');
        }
     
        return parent::_beforeSave();
    }
    
    private function _getPreorder()
    {
        $item = $this->getStockItem();
        //new product
        if(!isset($item))
        {
            $confValue = Mage::getStoreConfig('cataloginventory/item_options/backorders');
        }
        //created product
        elseif($item->getUseConfigBackorders()=='1')
        {
            $confValue = Mage::getStoreConfig('cataloginventory/item_options/backorders');
        }
        else
        {
            $confValue = $item->getBackorders();
        }
        $preorder = ($confValue=='30')?'1':'0';
        return $preorder;
    }
}