<?php

class Dv_Labels_Block_Adminhtml_Sales_Order_Labels_View extends Mage_Adminhtml_Block_Widget_Form_Container
{

    public function __construct()
    {
        $this->_objectId    = 'labels_id';
        $this->_blockGroup  = 'xml_labels';
        $this->_controller  = 'adminhtml_sales_order_labels';
        $this->_mode        = 'view';

        parent::__construct();

        $this->_removeButton('reset');
        $this->_removeButton('delete');

//        if ($this->getOrder()->getId()) {
//            $this->_addButton('save_and_upload', array(
//                'label'     => Mage::helper('xml_labels')->__('Save & Upload'),
//                'class'     => 'save',
//                'onclick'   => 'setLocation(\'' . $this->getSaveAndUploadUrl() . '\')'
//                )
//            );
//        }
    }

    /**
     * Retrieve order model instance
     *
     * @return Mage_Sales_Model_Order
     */
    public function getOrder()
    {
        return Mage::registry('sales_order');
    }

    public function getHeaderText()
    {
        return Mage::helper('xml_labels')->__('Generate labels for order #%1$s', $this->getOrder()->getIncrementId());
    }

    public function getBackUrl()
    {
        return $this->getUrl(
            'adminhtml/sales_order/view',
            array(
                'order_id'  => $this->getOrder()->getId(),
                'active_tab'=> 'order_info'
            ));
    }

    public function getSaveUrl()
    {
        return $this->getUrl('xmllabels/adminhtml_generate/save', array(
            'order_id' => $this->getOrder()->getId()
        ));
    }

//    public function getSaveAndUploadUrl()
//    {
//        return $this->getUrl('xmllabels/adminhtml_generate/saveAndUpload', array(
//            'order_id' => $this->getOrder()->getId()
//        ));
//    }

    public function updateBackButtonUrl($flag)
    {
        if ($flag) {
            if ($this->getOrder()->getBackUrl()) {
                return $this->_updateButton('back', 'onclick', 'setLocation(\'' . $this->getOrder()->getBackUrl() . '\')');
            }
            return $this->_updateButton('back', 'onclick', 'setLocation(\'' . $this->getUrl('adminhtml/sales_order/view') . '\')');
        }
        return $this;
    }
}
