<?php

class Moogento_Pickpack_Block_Adminhtml_System_Config_Form_Actions
    extends Mage_Adminhtml_Block_System_Config_Form_Fieldset
{
    protected function _isShipEasyInstalled()
    {
        return Mage::helper('pickpack')->isShipEasyInstalled();
    }

    protected function _getInstallShipEasyMessage()
    {
        $default = !$this->getRequest()->getParam('website') && !$this->getRequest()->getParam('store');
        $colspan = (!$default) ? 5 : 4;

        $html = '<tr><td colspan="'.$colspan.'" style="color:#ff0000">To access this section please install <b><a href="http://www.moogento.com/magento-order-shipping-processing.html" target="_blank">shipEasy</a></b></td></tr>';
        return $html;
    }

    protected function _getFieldsContainerHeader($title)
    {
        $default = !$this->getRequest()->getParam('website') && !$this->getRequest()->getParam('store');
        $colspan = (!$default) ? 5 : 4;

        $html = '<tr><td colspan="'.$colspan.'">';
        $html .= '<fieldset style="text-align:left; margin-top: 20px"><legend style="display: inline; font-weight: bold">&nbsp;'.$title.'&nbsp;</legend>';

        $html.= '<table cellspacing="0" class="form-list"><colgroup class="label" /><colgroup class="value" />';
        if (!$default) {
            $html.= '<colgroup class="use-default" />';
        }
        $html.= '<colgroup class="scope-label" /><colgroup class="" /><tbody>';


        return $html;
    }

    protected function _getFieldsContainerFooter()
    {
        $html = '</tbody></table></fieldset></td></tr>';

        return $html;
    }

    public function render(Varien_Data_Form_Element_Abstract $element)
    {

        $dependingFields = array(
            'pickpack_options_wonder_invoice_additional_action',
            'pickpack_options_wonder_invoice_auto_processing_additional_action',
            'pickpack_options_wonder_additional_action',
        );

        $html = $this->_getHeaderHtml($element);

        foreach ($element->getSortedElements() as $field) {

            /**
             * Additional Action Config
             */
            if (
                ($field->getId() == 'pickpack_options_wonder_invoice_additional_action') ||
                ($field->getId() == 'pickpack_options_wonder_additional_action')
            ) {
                $html .= $this->_getFieldsContainerHeader('Additional Action Configuration (for manual printing only)');
                if (!$this->_isShipEasyInstalled()) {
                    $html .= $this->_getInstallShipEasyMessage();
                }
            }

            /**
             * Auto Processing Additional Action Config
             */
            if (
                ($field->getId() == 'pickpack_options_wonder_invoice_auto_processing_additional_action') ||
                ($field->getId() == 'pickpack_options_wonder_auto_processing_additional_action')
            ) {
                $html .= $this->_getFieldsContainerHeader('Auto Processing Additional Action Configuration');
                if (!$this->_isShipEasyInstalled()) {
                    $html .= $this->_getInstallShipEasyMessage();
                }
            }

            /**
             * Auto Processing Print Condition Config
             */
            if (
                ($field->getId() == 'pickpack_options_wonder_invoice_auto_processing_check') ||
                ($field->getId() == 'pickpack_options_wonder_auto_processing_check')
            ) {
                $html .= $this->_getFieldsContainerHeader('Auto Processing Print Condition');
            }


            if (
                 ($field->getId() == 'pickpack_options_wonder_auto_processing') ||
                 ($field->getId() == 'pickpack_options_wonder_invoice_auto_processing')
            ) {
                $html .= $this->_getFieldsContainerHeader('Auto Processing');
            }

            if (!$this->_isShipEasyInstalled() && in_array($field->getId(), $dependingFields)) {
                $field->setValue(0);
                $field->setReadonly(true, true);
            }
            $html.= $field->toHtml();


            
            if (
                ($field->getId() == 'pickpack_options_wonder_invoice_szy_own_value2') ||
                ($field->getId() == 'pickpack_options_wonder_szy_own_value2')||
                ($field->getId() == 'pickpack_options_wonder_invoice_auto_processing_szy_own_value2') ||
                ($field->getId() == 'pickpack_options_wonder_auto_processing_szy_own_value2')
            ) {
                $html .= $this->_getFieldsContainerFooter();
            }

            if (
                ($field->getId() == 'pickpack_options_wonder_auto_processing_required_stock') ||
                ($field->getId() == 'pickpack_options_wonder_invoice_auto_processing_required_stock')
            ) {
                $html .= $this->_getFieldsContainerFooter();
            }

            if (
                ($field->getId() == 'pickpack_options_wonder_auto_processing_check_attribute_value') ||
                ($field->getId() == 'pickpack_options_wonder_invoice_auto_processing_check_attribute_value')
            ) {
                $html .= $this->_getFieldsContainerFooter();
            }
        }

        $html .= $this->_getFooterHtml($element);
        return $html;
    }
}