
var amSeoGoogle = new Class.create();
amSeoGoogle.prototype = {
    popupElement: null,
    stopped: false,
    completed: false,
    logElementId: 'amseogooglesitemap_popup_log',

    initialize: function(){},

    execute: function(element)
    {
        if(!element.value || !element.value.isJSON()) {
            return;
        }

        var config = element.value.evalJSON();
        if (config.href && config.href.indexOf('amseogooglesitemap_sitemap/generate/id') > 0) {
            this.generateWithAjax(config);
            return false;
        }

        varienGridAction.execute(element);
    },

    generateWithAjax: function(config)
    {
        this.config = config;
        this.stopped = false;

        this.generateEvents();
        this.clearConsole();
        this.showPopup();
        this.sendAjaxRequest(true);
    },

    clearConsole: function()
    {
        $$('#amseogooglesitemap_popup_log li:not(.first-li)').each(function (item) {
            item.remove()
        });
    },

    generateEvents: function()
    {
        this.popupElement = $('amseogooglesitemap_conteiner');

        var self = this;
        $('amseogooglesitemap_overlay').observe('click', function(event) {
            self.hidePopup();
        });
    },

    showPopup: function()
    {
        if (this.popupElement) {
            this.popupElement.show();
            return;
        }

        console.log('Amasty block with popup is missing');
    },

    hidePopup: function()
    {
        if (this.completed || this.stopped) {
            this.popupElement.hide();
            this.updateRow();
        } else {
            if (confirm('Closing this window you will stop the process.\nAre you sure?'))  {
                this.stop(false);
                this.popupElement.hide();
            }
        }
    },

    updateRow: function()
    {
        var url = this.config.href;
        url = url.replace('amseogooglesitemap_sitemap/generate', 'amseogooglesitemap_sitemap/updateurl');
        new Ajax.Request(
            url,
            {
                onSuccess: function(response) {
                    var data = response.responseText;
                    if (data && data.isJSON()) {
                        data = data.evalJSON();
                        if (data.id && data.html) {
                            var element = $('amseogoogle-' + data.id);
                            element.innerHTML = data.html;
                        }
                    }
                }
            }
        );
    },

    log: function(text, isError)
    {
        if (text && $(this.logElementId)) {
            var className = '';
            if (isError) {
                className = ' class="error-message"';
            }

            $(this.logElementId).insert({
                'top' : '<li ' + className + '>' + text + '</li>'
            });
        }
    },

    stop: function(isError)
    {
        this.stopped = true;
    },

    sendAjaxRequest: function(clearSession)
    {
        var self = this;
        if (this.stopped) {
            console.log('Generation process was stopped.');
            return false;
        }

        var params = clearSession ? {'clear' : 1} : {};
        new Ajax.Request(
            this.config.href,
            {
                parameters: params,
                onSuccess: function(response) {
                    var data = response.responseText;
                    if (!data || !data.isJSON()) {
                        self.stop(true);
                        self.log('Error: ' + data);
                    }

                    data = data.evalJSON();

                    if (data.error) {
                        self.log(data.error, true);
                        self.stop(true);
                    }
                    data.log.forEach(function(message) {
                        self.log(message);
                    });

                    if (data.continue === 1) {
                        self.sendAjaxRequest();
                    }

                    if (data.complitedText) {
                        self.stop(false);
                        self.log(data.complitedText);
                    }
                },

                onFailure: function(response) {
                    self.stop(true);
                    self.log('Error: ' + response.responseText);
                }
            }
        );
    }
};

var amSeoGoogleObject = new amSeoGoogle();
