<?php
/* DO NOT MODIFY THIS FILE! THIS IS TEMPORARY FILE AND WILL BE RE-GENERATED AS SOON AS CACHE CLEARED. */
 
/**
* @author Amasty Team
* @copyright Copyright (c) 2012 Amasty (http://www.amasty.com)
* @package Amasty_Xnotif
*/
class Aitoc_Aitpreorder_Block_Rewrite_CatalogProductViewTypeConfigurable extends Mage_Catalog_Block_Product_View_Type_Configurable
{
    protected $_options;
    
    protected function _afterToHtml($html)
    {
        $html = parent::_afterToHtml($html);
        if ('product.info.options.configurable' == $this->getNameInLayout())
        {
            $html = '<script type="text/javascript" src="' . Mage::getBaseUrl('js') . 'amasty/amxnotif/configurable.js"></script>'
                    . $html;
            $allProducts = $this->getProduct()->getTypeInstance(true)
                ->getUsedProducts(null, $this->getProduct());
                
            foreach ($allProducts as $product)
            {
                $key = array();
                for ($i = 0; $i < count($this->_options); $i++)
                {
                    foreach ($this->_options[$i] as $iOptionId => $productIds)
                    {
                        if (in_array($product->getId(), $productIds))
                        {
                            $key[] = $iOptionId;
                        }
                    }
                }
                $stockStatus = '';
                $stockItem = Mage::getModel('cataloginventory/stock_item')->loadByProduct($product);
                if (!$product->isInStock())
                {
                    $stockStatus = Mage::helper('amxnotif')->__('Out of Stock') ;
                } 
                if ($key)
                {
                    $aStockStatus[implode(',', $key)] = array(
                        'is_in_stock'   => $product->isSaleable(),
                        'custom_status' => $stockStatus,
                        'is_qnt_0'      => (int)($product->isInStock() && $stockItem->getData('qty') <= 0),
                        'product_id'    => $product->getId(),
                        'stockalert'	=> Mage::helper('amxnotif')->getStockAlert($product, $this->helper('customer')->isLoggedIn()),
                    );
                }
            }
            foreach ($aStockStatus as $k=>$v){
                if (!$v['is_in_stock'] && !$v['custom_status']){
                    $v['custom_status'] = Mage::helper('amxnotif')->__('Out of Stock');
                    $aStockStatus[$k] = $v;
                }   
            }
            $html .= '<script type="text/javascript">var stStatus = new StockStatus(' . Zend_Json::encode($aStockStatus) . '); spConfig.loadStatus();</script>';
        }
        return $html;
    }
    
    public function getAllowProducts()
    {
        if (!$this->hasAllowProducts()) {
            $products = array();
            $allProducts = $this->getProduct()->getTypeInstance(true)
                ->getUsedProducts(null, $this->getProduct());
            foreach ($allProducts as $product) {
                /**
                * Should show all products (if setting set to Yes), but not allow "out of stock" to be added to cart
                */
                    if ($product->getStatus() != Mage_Catalog_Model_Product_Status::STATUS_DISABLED)
                    {
                        $products[] = $product;
                    }
            }
            $this->setAllowProducts($products);
        }
        return $this->getData('allow_products');
    }
    
    public function getJsonConfig()
    {
        $jsonConfig = parent::getJsonConfig();
        $config = Zend_Json::decode($jsonConfig);
        $i = 0;
        foreach ($config['attributes'] as $key1 => $attr)
        {
            foreach ($attr['options'] as $key2 => $options)
            {
                $this->_options[$i][$options['id']] = $options['products'];
                
                /**
                * this block is to handle 1-attribute products
                */
                if (1 == count($options['products']))
                {
                    $product = Mage::getModel('catalog/product')->load($options['products'][0]);
                    if (!$product->isSaleable())
                    {
                        $statusText = Mage::helper('catalog')->__('Out of Stock');
                        $config['attributes'][$key1]['options'][$key2]['label'] .= ' (' . $statusText . ')';
                    }
                }
                
            }
            $i++;
        }
        return Zend_Json::encode($config);
    }
}


	/**
 * Pre-Orders
 *
 * @category:    Aitoc
 * @package:     Aitoc_Aitpreorder
 * @version      1.1.40
 * @license:     0DMhQYOdlQVaorpLyxYHyL27EIMKklPz0C7NSJhsna
 * @copyright:   Copyright (c) 2014 AITOC, Inc. (http://www.aitoc.com)
 */
/**
* @copyright  Copyright (c) 2009 AITOC, Inc. 
*/

class Amasty_Xnotif_Block_Product_View_Type_Configurable extends Aitoc_Aitpreorder_Block_Rewrite_CatalogProductViewTypeConfigurable
{
    protected function _toHtml()
    {    
      
        if($this->getNameInLayout()=='product.info.options.configurable')
        {
            return parent::_toHtml().'<input type="hidden" value="'.__('Pre-Order_button').'" id="saypreorder"><input type="hidden" value="'.__('Add to Cart').'" id="sayaddtocart"><script type="text/javascript">
            var spConfig = new Product.ConfigPreorder('.$this->getJsonConfig().',{"preorder":'.$this->getJsonConfigWithPreorder().'});
            </script><div id="canBePreorder"></div>';
        }
        else
        {
            return parent::_toHtml();
        }        
    }
    public function getJsonConfigWithPreorder()
    {
		$delivery_time = "";
        foreach ($this->getAllowProducts() as $product) {
            if($product->getPreorder()=='1')
            {
                $options[$product->getId()] = $product->getPreorder();
                $qty_check = $product->getQty();
                if($product->getData('is_in_stock'))
                {
                    $options['descript'][$product->getId()]=$product->getPreorderdescript();
                    if($options['descript'][$product->getId()]=='')
                    {
						
						switch($product->getAttributeText('manufacturer')) {			default : 
								$delivery_time = $this->__('1-3 vardagar'); 
								break;						
						}
						$deliverytext1 = $this->__('Leverans');
						if($product->getAttributeText('base_collection') == true) :
							$options['descript'][$product->getId()]=__('<span class="delivery-date"><span class="delivery-text">'.$deliverytext1.' </span>'.$delivery_time.'</span>');
						else:
							$options['descript'][$product->getId()]=__('Pre-Order');
						endif;
                    }
                }
                else 
                {
                    $options['descript'][$product->getId()]=__('not Available');
                }
                
            }
            else            
            {
                $options[$product->getId()] = 0;
                if($product->getData('is_in_stock'))
                {
                   // $options['descript'][$product->getId()]=$product->getPreorderdescript();
                   // if($options['descript'][$product->getId()]=='')
                    {                    	
						$deliverytext1 = $this->__('Leverans');
						$deliverytext2 = $this->__('1-3 vardagar');
						if($product->getAttributeText('base_collection') == true) :
							$options['descript'][$product->getId()]=__('<span class="delivery-date"><span class="delivery-text">'.$deliverytext1.' </span>'.$deliverytext2.'</span>');
						else:
							$options['descript'][$product->getId()]=__('In stock');
						endif;
                    }
                }
                else 
                {
					if(Mage::app()->getStore()->getStoreId() == 14) :
						$options['descript'][$product->getId()]=__('Tillfälligt slut i lager');
					else :
						$options['descript'][$product->getId()]=__('Out stock');
					endif;
                }
            }  
        }
        return Mage::helper('core')->jsonEncode($options);
    }
}

