<?php
/**
1.7
 * Sales Order Invoice / Packing slip PDF model
 *
 * @category   Mage
 * @package    Mage_Sales
 * @author     Moogento.com <moo@moogento.com>
 * This extension is only licensed for the single original Magento Instance that it was purchased for
 */
function clean_method($dirty,$method='text') {

    $clean = '';
    if(is_object($dirty)) $dirty = strval($dirty);
    $dirty = strip_tags($dirty);

    if($method == 'shipping')
    {
        $shipping_method = trim(str_ireplace(array('Select Delivery Method','Method','Select postage','Select Shipping','Delivery','- '),'',$dirty));

        $shipping_method = trim(str_ireplace(
            array("\n","\r","\t",'  ','Free Shipping Free','Free shipping␣ Free','Free Economy Free Economy','Free Economy␣ Free Economy','Paypal Express Checkout','Pick up Pick up','Pick up at our ','Normal ','Registered',' Postage','Postage','Royal Mail','Mail','RM','Store Pickup Store Pickup','Cash on Delivery','Courier Service','Delivery Charge','International','First','Second','2nd Class 2nd Class','1st Class 1st Class','View a UPS Ground Shipping Map Here',' rate:','Australia Post','Standard','working days with tracking','You qualify for','free ground shipping Free','United States Postal Service','United Parcel Service UPS','Fed Ex','Available Shipping Options','shipping','  '),
            array(' ',' ',' ',' ','Free Shipping','Free Shipping','Free Economy','Free Economy','Paypal Express','Pick up','Pickup@','',"Reg'd",',','','RM','','Royal Mail','Store Pickup','COD','Courier','Charge','Int\'l','1st','2nd','2nd Class','1st Class','','','AusPost','Std','working days','','free ground shipping','USPS','UPS','FedEx','','',' '),
            $shipping_method));

        $shipping_method = preg_replace('~Charge:$~i','',$shipping_method);
        $shipping_method = preg_replace('~^\s*~','',$shipping_method);
        //$shipping_method = trim(preg_replace('~delivery~i','',$shipping_method));
        $shipping_method = trim(preg_replace('~^shipping~i','',$shipping_method));
        $shipping_method = preg_replace('~^\-~','',$shipping_method);
        $shipping_method = preg_replace('~^\:~','',$shipping_method);
        $shipping_method = trim(preg_replace('~^via\s~i','',$shipping_method));
        $shipping_method = trim(preg_replace('~\((.*)$~','',$shipping_method));
        $shipping_method = preg_replace('~,$~i','',$shipping_method);

        // if same name has been configured as title and method, this will trim out the repetition
        $shipping_method_length = strlen($shipping_method);
        $s_a = trim(substr($shipping_method,0,(round($shipping_method_length/2))));
        $s_b = trim(substr($shipping_method,(round($shipping_method_length/2)),$shipping_method_length));

        if($s_a == $s_b) $shipping_method = $s_a;

        $clean = $shipping_method;
    }
    elseif($method == 'payment')
    {

        /* Payment */
        $paymentInfo = $dirty;

        $payment = explode('{{pdf_row_separator}}', $paymentInfo);
        foreach ($payment as $key=>$value)
        {
            if (strip_tags(trim($value))=='')
            {
                unset($payment[$key]);
            }
        }
        reset($payment);

        $payment_test = implode(',',$payment);
        $payment_test = trim(str_ireplace(
            array("\n","\r","\t",'  ',', credit card type:','credit card type:','- Account info','PayPal Secured Payment','credit card number','#: ','Credit Card','American Express','Master Card','Name on the Card',',','(Authorize.net)','Cash on Delivery','Number','Credit / Debit CardCC','Credit / Debit Card','CardCC','payment gateway by','n/a','cccc','cc cc','****','****','***','***','Card: Visa','&rArr;','&amp;','sup3;','rArr','  ','#: ','Purchase Order Purchase Order','Payment:','Payment Visa','Visa#','Payment Mastercard','Mastercard#','COD COD','Reference','Name:','(saved):','Name on the Card:'),
            array(' ',' ',' ',' ',':',':','','Paypal','#','#','CC','Amex','MC','Name','','','COD','#','CC','Card','CC','','CC','CC','CC','**','**','**','**','Visa','','','','','','#','Purchase Order','','Visa','Visa #','MC','MC #','COD','Ref.',':','',''),$payment_test));

            $payment_test = trim(str_ireplace(
                array('Credit or Debit Card'),
                array('Card'),$payment_test));
        $payment_test = preg_replace('~^\s*~','',$payment_test);
        $payment_test = trim(preg_replace('~^:~','',$payment_test));
        $payment_test = preg_replace('~Paypal(.*)$~i','Paypal',$payment_test);
        $payment_test = preg_replace('~Account(.*)$~i','Account',$payment_test);
        $payment_test = preg_replace('~Processed Amount(.*)$~i','',$payment_test);
        $payment_test = preg_replace('~Payer Email(.*)$~i','',$payment_test);
        $payment_test = preg_replace('~Charge:$~i','',$payment_test);
        $payment_test = preg_replace('~Expiration(.*)$~i','',$payment_test);
        $payment_test = preg_replace('~^\-~','',$payment_test);
        $payment_test = preg_replace('~Check / Money order(.*)$~i','Check / Money order',$payment_test);
        $payment_test = preg_replace('~Cheque / Money order(.*)$~i','Cheque / Money order',$payment_test);
        $payment_test = preg_replace('~Make cheque payable(.*)$~i','',$payment_test);
        $payment_test = str_ireplace(
            array('CardCC','CC Type','MasterCardCC','MasterCC',': MC',': Visa','Payment Visa','Payment MC'),
            array('CC','CC, Type','MC','MC',' MC',' Visa','Visa','MC'),$payment_test);
        $payment_test = preg_replace('~:$~','',$payment_test);
        
		preg_match('~\b(?:\d[ -]*?){13,16}\b~',$payment_test,$cc_matches);
		if(isset($cc_matches[0]))
		{	
			//$replacement_cc = str_pad(substr($cc_matches[0], -4), strlen($cc_matches[0]), '*', STR_PAD_LEFT);
			$replacement_cc = str_pad(substr($cc_matches[0], -4), 8, '*', STR_PAD_LEFT);
			$payment_test = str_replace($cc_matches[0],$replacement_cc,$payment_test);
		}

        $payment_test = trim($payment_test);

        // if same name has been configured as title and method, this will trim out the repetition
        $payment_method_length = strlen($payment_test);
        $p_a = trim(substr($payment_test,0,(round($payment_method_length/2))));
        $p_b = trim(substr($payment_test,(round($payment_method_length/2)),$payment_method_length));

        if($p_a == $p_b && (strlen($p_a) > 4)) $payment_test = $p_a;

        $clean = $payment_test;
    }
	elseif($method == 'text')
	{
		$clean = strip_tags($dirty);
		$clean = str_replace(array("\n","\r",'<br />','<br>'),'~',$clean);//,'\n','\r'
		$clean = trim(preg_replace("/[^A-Za-z~0-9\'\"\.\,\-\\\ ]/", '', $clean));
		$clean = str_replace('~',"\n",$clean);
	}
	else
	{
		// currently only order notes comes through here
		$clean = str_replace('M2E Pro Notes:','',$clean);
	}

    return $clean;
}

function split_words($string, $split_regex='/\s/', $max = 1) 
{ 
    $replace_word = str_replace(array('/','\\'),'',$split_regex);
    $words = preg_split($split_regex, $string); 
    $lines = array(); 
    $line = ''; 
    
    foreach ($words as $k => $word) { 
        $length = strlen($line . $replace_word . $word); 
        if ($length <= $max) { 
            $line .= $replace_word . $word; 
            $line = str_replace($replace_word.$replace_word,$replace_word,$line);
        } else if ($length > $max) { 
            if (!empty($line)) $lines[] = trim($line); 
            $line = $replace_word . $word; 
        } else { 
            $lines[] = trim($line) . $replace_word . $word . $replace_word; 
            $line = ''; 
        } 
    } 
    $lines[] = ($line = trim($line)) ? $line : $word; 

    return $lines; 
}

function search($array, $key='', $value='')
{
    $results = array();
    if(!$value) $value = '';
    
    if (is_array($array))
    {

        if (isset($array[$key]) && ($array[$key] == $value))
        {
            $results[] = $array;
        }
        foreach ($array as $subarray)
        {
            $results = array_merge($results, search($subarray, $key, $value));
        }
    }


    return $results;
}
    
if (!function_exists('mb_strlen')) { 
    function mb_strlen($str) { 
        return strlen(iconv("UTF-8","cp1251", $str));
    }
}

if (!function_exists('mb_substr')) {
    function mb_substr($data,$start,$length = null, $encoding = null) {
        return substr($data,$start,$length);
    }
}

if(!function_exists('sksort'))
{
   function sksort(&$array, $subkey, $sort_ascending=false) 
   {

       if (count($array)) $temp_array[key($array)] = array_shift($array);

       foreach($array as $key => $val)
		{
           $offset = 0;
           $found = false;
           foreach($temp_array as $tmp_key => $tmp_val)
           {
               if(!$found and strtolower($val[$subkey]) > strtolower($tmp_val[$subkey]))
               {
                   $temp_array = array_merge(    (array)array_slice($temp_array,0,$offset),
                                               array($key => $val),
                                               array_slice($temp_array,$offset)
                                             );
                   $found = true;
               }
               $offset++;
           }
           if(!$found) $temp_array = array_merge($temp_array, array($key => $val));
       }

       if ($sort_ascending) $array = array_reverse($temp_array);
       else $array = $temp_array;
   }
}

function utf8_wordwrap($str, $width, $break, $cut = false) {
    if (!$cut) {
        $regexp = '#^(?:[\x00-\x7F]|[\xC0-\xFF][\x80-\xBF]+){'.$width.',}\b#U';
    } else {
        $regexp = '#^(?:[\x00-\x7F]|[\xC0-\xFF][\x80-\xBF]+){'.$width.'}#';
    }
    if (function_exists('mb_strlen')) {
        $str_len = mb_strlen($str,'UTF-8');
    } else {
        $str_len = preg_match_all('/[\x00-\x7F\xC0-\xFD]/', $str, $var_empty);
    }
    $while_what = ceil($str_len / $width);
    $i = 1;
    $return = '';
    while ($i < $while_what) {
        preg_match($regexp, $str,$matches);
        $string = $matches[0];
        $return .= $string.$break;
        $str = substr($str, strlen($string));
        $i++;
    }
    return $return.$str;
}


function mb_wordwrap_array($string, $width)
{
    if (($len = mb_strlen($string, 'UTF-8')) <= $width)
    {
        return array($string);
    }

    $return = array();
    $last_space = FALSE;
    $i = 0;

    do
    {
        if (mb_substr($string, $i, 1, 'UTF-8') == ' ')
        {
            $last_space = $i;
        }

        if ($i > $width)
        {
            $last_space = ($last_space == 0) ? $width : $last_space;

            $return[] = trim(mb_substr($string, 0, $last_space, 'UTF-8'));
            $string = mb_substr($string, $last_space, $len, 'UTF-8');
            $len = mb_strlen($string, 'UTF-8');
            $i = 0;
        }

        $i++;
    }
    while ($i < $len);

    $return[] = trim($string);

    return $return;
}

function isInstalled($moduleName)
{
    $modules = array_keys((array)Mage::getConfig()->getNode('modules')->children());
    if(in_array($moduleName,$modules)) return true;
    return false;
}

function checkColor($colorName)
{    
    $colorName = trim($colorName);
    
    if(preg_match('/^#[0-9a-f]{3}([0-9a-f]{3})?$/i', $colorName)) //hex color is valid
    {
        return '#'.strtoupper($colorName);
    }
    elseif(preg_match('/^[0-9a-f]{3}([0-9a-f]{3})?$/i', $colorName)) //hex color is valid
    {
        return '#'.strtoupper($colorName);
    }
    else
    {
    	$colorName = str_ireplace('Grey','Gray',$colorName);
        $html_color_names = 'aliceblue,lightpink,antiquewhite,lightsalmon,aqua,lightseagreen,aquamarine,lightskyblue,azure,lightslategray,beige,lightsteelblue,bisque,lightyellow,black,lime,blanchedalmond,limegreen,blue,linen,blueviolet,magenta,brown,maroon,burleywood,mediumaquamarine,burlywood,mediumblue,cadetblue,mediumorchid,chartreuse,mediumpurple,chocolate,mediumseagreen,coral,mediumslateblue,cornflowerblue,mediumspringgreen,cornsilk,mediumturquoise,crimson,mediumvioletred,cyan,midnightblue,darkblue,mintcream,darkcyan,mistyrose,darkgoldenrod,moccasin,darkgray,navajowhite,darkgreen,navy,darkkhaki,oldlace,darkmagenta,olive,darkolivegreen,olivedrab,darkorange,orange,darkorchid,orangered,darkred,orchid,darksalmon,palegoldenrod,darkseagreen,palegreen,darkslateblue,paleturquoise,darkslategray,palevioletred,darkturquoise,papayawhip,darkviolet,peachpuff,deeppink,peru,deepskyblue,pink,dimgray,plum,dodgerblue,powderblue,firebrick,purple,floralwhite,red,forestgreen,rosybrown,fuchsia,royalblue,gainsboro,saddlebrown,ghostwhite,salmon,gold,sandybrown,goldenrod,seagreen,gray,seashell,green,sienna,greenyellow,silver,honeydew,skyblue,hotpink,slateblue,indianred,slategray,indigo,snow,ivory,springgreen,khaki,steelblue,lavender,tan,lavenderblush,teal,lawngreen,thistle,lemonchiffon,tomato,lightblue,turquoise,lightcoral,violet,lightcyan,wheat,lightgoldenrodyellow,white,lightgreen,whitesmoke,lightgrey,yellow,yellowgreen';
        $html_color_array = explode(',',$html_color_names);
        if(in_array(strtolower($colorName),$html_color_array)) return $colorName;
        else return '#333333';//false;
    }
}

function widthForStringUsingFontSize($string, $font, $font_size)
{
     $drawingString = iconv('UTF-8', 'UTF-16BE//IGNORE', $string);
     $characters = array();
     for ($i = 0; $i < strlen($drawingString); $i++) {
         $characters[] = (ord($drawingString[$i++]) << 8 ) | ord($drawingString[$i]);
     }
     $glyphs = $font->glyphNumbersForCharacters($characters);
     $widths = $font->widthsForGlyphs($glyphs);
     $stringWidth = (array_sum($widths) / $font->getUnitsPerEm()) * $font_size;
     
     //
     $stringWidth = ceil($stringWidth);
     return $stringWidth;
 }
 
function stringBreak($string, $max_length, $font_size, $font='helvetica')
{
	$string = trim($string);
	if($string == '') return '';
	if(!$font_size) $font_size = $this->_getConfig('font_size_body', 10, false,'general');
	if(!$font || $font == 'helvetica') $font = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
	
	$string_width = widthForStringUsingFontSize($string, $font, $font_size);

	$pt_per_char = ($string_width/strlen($string));
    $character_breakpoint   = floor($max_length/$pt_per_char);
    
    return $character_breakpoint;
}
 

 
function pre($array){
  echo '<pre>';
  if(is_array($array)) print_r($array);
    else echo $array;
  echo '</pre>';
}

function getPrevNext($haystack,$needle,$prevnext = 'next') {
    $prev = $next = null;

    $aKeys = array_keys($haystack);
    $k = array_search($needle,$aKeys);
    if ($k !== false) {
        if ($k > 0)
            $prev = array($aKeys[$k-1] => $haystack[$aKeys[$k-1]]);
        if ($k < count($aKeys)-1)
            $next = array($aKeys[$k+1] => $haystack[$aKeys[$k+1]]);
    }
	$next_key = 0;
	$next_key = $next[$aKeys[$k+1]];
	if(!isset($next_key) || $next_key == 0) $next_key = 560;
	$prev_key = 0;
	$prev_key = $prev[$aKeys[$k-1]];
    if($prevnext == 'next') return $next_key;
    elseif($prevnext == 'prev') return $prev_key;
    else return array($prev,$next);
}

function strstr_after($haystack, $needle, $case_insensitive = false) {
    $strpos = ($case_insensitive) ? 'stripos' : 'strpos';
    $pos = $strpos($haystack, $needle);
    if (is_int($pos)) {
        return substr($haystack, $pos + strlen($needle));
    }
    // Most likely false or null
    return $pos;
}

class Mage_Sales_Model_Order_Pdf_Invoices extends Mage_Sales_Model_Order_Pdf_Aabstract
{    
    
    
    private $_nudgeY;
    private $_itemsY;    
       
	public function getPdfLetter($orders=array(), $from_shipment = 'order', $invoice_or_pack = 'letter')
    {
            $wonder = 'mooletter';
            $storeId = Mage::app()->getStore()->getId();

            foreach ($orders as $orderSingle)
            {
                $order             = Mage::getModel('sales/order')->load($orderSingle);
                $order_id          = $order->getRealOrderId();
                $order_storeId     = $order->getStore()->getId();

                if($storeId != $order_storeId || $config_first_run === true)
                {
                    $get_store                     = $order->getStore();
                    $config_first_run             = false;
                    $storeId                     = $order_storeId;
                    $page_size                     = $this->_getConfig('page_size', 'a4', false,'general',$order_storeId);
                    $page_top                     = 820; //$page_top = 820;
                    $padded_right                 = 570; //$padded_right = 570;
                    $padded_left                 = 60;
                }
            }

            $this->_beforeGetPdf();
            $this->_initRenderer('invoices');
            $pdf = new Zend_Pdf();
            $this->_setPdf($pdf);
            $style = new Zend_Pdf_Style();

            /*
            Letter        612x792 587x770 (-25 -22)
            A4             595x842 570x820 (-25 -22)
            A5             420x595 395x573
            A5(L)        595x420 573x395
            */

            $page = $pdf->newPage(Zend_Pdf_Page::SIZE_A4);

            $pdf->pages[] = $page;
            $this->y = $page_top;

            $s = 0;
            $first_page_yn             = 'y';

            foreach ($orders as $orderSingle)
            {
                $order                 = Mage::getModel('sales/order')->load($orderSingle);
                $order_id              = $order->getRealOrderId();
                $store_id             = $order->getStore()->getId();

                /**
                config inputs
                */
                $second_page_start            = $this->_getConfig('second_page_start', 'top', false,'general',$store_id); // top or asfirst
                $date_format                = $this->_getConfig('date_format', 'M. j, Y', false,'general',$store_id);
                $page_pad                      = explode(',', trim($this->_getConfig('page_pad', '0,0',false,$wonder,$store_id)));
                $page_pad_leftright            = $page_pad[0];
                $page_pad_topbottom            = $page_pad[1];

                // 595 pt x 842 pt
                $page_top                     = ($page_top-$page_pad_topbottom);
                $padded_right                 = ($padded_right-$page_pad_leftright);
                $padded_left                 = (20+$page_pad_leftright);

                 $non_standard_characters     = $this->_getConfig('non_standard_characters', 0, false,'general',$store_id);

                if($font_family_subtitles == 'custom')
                {
                    $packlogo_filename     = $this->_getConfig('font_custom_subtitles', '', false,'general',$store_id);
                    $sub_folder         = 'custom_font';
                    $option_group         = 'general';
                    if($packlogo_filename)
                    {
                        $packlogo_path = Mage::getStoreConfig('system/filesystem/media', $store_id) . '/sales/store/'.$sub_folder.'/' . $packlogo_filename;
                        if (is_file($packlogo_path))
                        {
                            // gonna pass the font file path through the style attribute
                            $font_style_subtitles    = $packlogo_path;
                        }
                        else $font_family_subtitles = 'helvetica';
                    }
                }
                else $font_custom_subtitles    = '';

                $font_family_body             = $this->_getConfig('font_family_body', 'helvetica', false,'general',$store_id);
                $font_style_body             = $this->_getConfig('font_style_body', 'regular', false,'general',$store_id);
                $font_size_body             = $this->_getConfig('font_size_body', 10, false,'general',$store_id);
                $font_color_body             = trim($this->_getConfig('font_color_body', 'Black', false,'general',$store_id));
                $font_color_grey         =     '#666666';

                if($non_standard_characters == 'msgothic')
                {
                    $font_family_body = 'msgothic';
                    $non_standard_characters = 1;
                }

                $has_shipping_address = false;
                foreach ($order->getAddressesCollection() as $address)
                {
                    if ($address->getAddressType() == 'shipping' && !$address->isDeleted()) {
                        $has_shipping_address = true;
                    }
                }

                $show_top_logo_yn            = $this->_getConfig('pickpack_packlogo', 0, false,$wonder,$store_id);
                $logo_position                = $this->_getConfig('pickpack_logo_position', 'left', false,$wonder,$store_id);
                $address_format             = $this->_getConfig('address_format', '', false,'general',$store_id);
                $address_countryskip          = trim(strtolower($this->_getConfig('address_countryskip', 0,false,'general',$store_id)));
                $message_yn                    = $this->_getConfig('custom_message_yn', '', false,$wonder,$store_id);
                  $message                    = $this->_getConfig('custom_message', '', false,$wonder,$store_id);


                $max_chars = 20;
                $font_temp = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
                $font_size_compare = ($font_size_body*0.8);
                $line_width = $this->parseString('1234567890',$font_temp,$font_size_compare); // bigger = left
                $char_width = $line_width/10;
                $max_chars = round(($padded_right-$padded_left)/$char_width);
                $line_spacing = 1.4;

                /**
                end config
                */

                if($first_page_yn == 'n')
                {
                    $page = $this->newPage();
                }
                else $first_page_yn = 'n';

                if(($logo_position == 'left') && ($page_size == 'letter'))
                {
                    $x1 = $padded_left;
                    $y1 = ($page_top - 5 - 41);//734; 41?
                    $x2 = ($padded_left + 269);
                    $y2 = ($page_top - 5);//775;
                }
                elseif(($logo_position == 'left') && ($page_size == 'a4'))
                {
                    $x1 = $padded_left;
                    $y1 = ($page_top - 5 - 41);//784; 41?
                    $x2 = ($padded_left + 269);
                    $y2 = ($page_top - 5);//825;
                }

                # HEADER
                $order_date = '';
                if($order->getCreatedAtStoreDate()) $order_date = Mage::helper('core')->formatDate($order->getCreatedAtStoreDate(), 'long', false);

                $invoice_number_display = '';
                $order_number_display     = '';
                foreach ($order->getInvoiceCollection() as $_tmpInvoice)
                {
                         if($_tmpInvoice->getIncrementId())
                    {
                        if($invoice_number_display != '') $invoice_number_display .= ',';
                        $invoice_number_display = $_tmpInvoice->getIncrementId();
                    }
                         break;
                     }

                $order_number_display = $order->getRealOrderId();
                if($order_or_invoice == 'invoice')
                {
                    $order_number_display = $invoice_number_display;
                }

                /**
                START
                */
                /*
                    $order_date
                    $order_number_display
                */
                $orderIdXY[0] = 20;
                $orderIdXY[1] = 100;

                $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);

                if (!isset($store) && $order->getStoreId()) {$store=$order->getStoreId();}
                else $store = null;

                if($show_top_logo_yn == 1)
                {
                    $sub_folder = 'logo_letter';
                    $option_group = 'mooletter';

                        $packlogo_filename = Mage::getStoreConfig('pickpack_options/'.$option_group.'/pack_logo', $store);
                        if($packlogo_filename)
                        {
                            $packlogo_path = Mage::getBaseDir('media') . '/moogento/pickpack/'.$sub_folder.'/' . $packlogo_filename;
                            if (is_file($packlogo_path))
                            {
                                $packlogo = Zend_Pdf_Image::imageWithPath($packlogo_path);
                                $page->drawImage($packlogo, $x1, $y1, $x2, $y2);

                                $this->y = ($y1-60);
                            }
                        }
                }

                   // HEADER STORE ADDRESS
                $customer_phone     = '';
                $customer_company     = '';
                $customer_name         = '';
                $customer_city         = '';
                $customer_postcode     = '';
                $customer_region     = '';
                $customer_region_code = '';
                $customer_suffix     = '';
                $customer_country     = '';

                if($has_shipping_address !== false)
                {
                    if($order->getShippingAddress()->getTelephone())     $customer_phone = trim($order->getShippingAddress()->getTelephone());
                    if($order->getShippingAddress()->getCompany())         $customer_company = trim($order->getShippingAddress()->getCompany());
                    
                    //Moo edits prefix from here
                    
                    if($order->getShippingAddress()->getName())         $customer_name_content = trim($order->getShippingAddress()->getName());
                    if($order->getShippingAddress()->getFirstname())	$customer_firstname = trim($order->getShippingAddress()->getFirstname());
                    if($order->getShippingAddress()->getLastname())     $customer_lastname = trim($order->getShippingAddress()->getLastname());
                    $customer_name = $customer_firstname.' '.$customer_lastname;
                          
                    //End of moo edits prefix
                          
                    if($order->getShippingAddress()->getCity())         $customer_city = trim($order->getShippingAddress()->getCity());
                    if($order->getShippingAddress()->getPostcode())     $customer_postcode = trim(strtoupper($order->getShippingAddress()->getPostcode()));
                    if($order->getShippingAddress()->getRegion())         $customer_region = trim($order->getShippingAddress()->getRegion());
                    if($order->getShippingAddress()->getRegionCode())     $customer_region_code = trim($order->getShippingAddress()->getRegionCode());
                    if($order->getShippingAddress()->getSuffix())         $customer_suffix = trim($order->getShippingAddress()->getSuffix());
                    if(Mage::app()->getLocale()->getCountryTranslation($order->getShippingAddress()->getCountryId()))
                    {
                        $customer_country = trim(Mage::app()->getLocale()->getCountryTranslation($order->getShippingAddress()->getCountryId()));
                    }
                }

                $address_format_set = str_replace(array("\n",'<br />','<br/>',"\r"),'',$address_format);

                $addy                 = array();
                $if_contents         = array();
                $addy['company']     		= $customer_company;
                $addy['name']      = $customer_name;
                $addy['customer_firstname'] = $customer_firstname;
                $addy['customer_lastname']  = $customer_lastname;
                $addy['customer_name_content'] = $customer_name_content;
                $addy['name']         = trim(preg_replace('~^'.$addy['company'].'~i','',$addy['name']));
                $addy['city']         = $customer_city;
                $addy['postcode']     = $customer_postcode;
                $addy['region_full'] = $customer_region;
                $addy['region_code']= $customer_region_code;
                if($customer_region_code != '')
                {
                    $addy['region']    = $customer_region_code;
                }
                else
                {
                    $addy['region']    = $customer_region;
                }
                $addy['suffix']     = $customer_suffix;
                $addy['country']     = $customer_country;
                $addy['street'] = '';
                if($address_countryskip != '')
                {
                    if($address_countryskip == 'usa' || $address_countryskip == 'united states' || $address_countryskip == 'united states of america')
                    {
                        $address_countryskip = array('usa','united states of america','united states');
                    }
                    $addy['country'] = str_ireplace($address_countryskip,'',$addy['country']);
                }

                if($has_shipping_address !== false)
                {
                    $i = 0;
                    while($i < 10)
                    {
                        if($order->getShippingAddress()->getStreet($i) && !is_array($order->getShippingAddress()->getStreet($i)))
                        {
                            if(isset($addy['street'])) $addy['street'] .= "";
                            $value = $order->getShippingAddress()->getStreet($i);

                            // wordwrap characters
                            $value = wordwrap($value, $max_chars, "\n", false);
                            $token = strtok($value, "\n");
                            while ($token != false)
                            {
                                if(trim(str_replace(',','',$token)) != '')
                                {
                                    $addy['street'] .= trim($token)." ";
                                }
                                $token = strtok(" ");
                            }
                        }
                        $i ++;
                    }
                }

                $address_format_set = str_replace(array("\n",'<br />','<br/>',"\r"),'',$address_format);

                foreach($addy as $key =>$value)
                {
                    $value = trim($value);
                    $value = preg_replace('~,$~','',$value);
                    $value = str_replace(',,',',',$value);

                    if($value != '' && !is_array($value))
                    {
                        preg_match('~\{if '.$key.'\}(.*)\{\/if '.$key.'\}~ims',$address_format_set,$if_contents);

                        if(isset($if_contents[1]))
                        {
                            $if_contents[1] = str_replace('{'.$key.'}',$value,$if_contents[1]);
                        }
                        else $if_contents[1] = '';

                        $address_format_set = preg_replace('~\{if '.$key.'\}(.*)\{/if '.$key.'\}~ims',$if_contents[1],$address_format_set);
                        $address_format_set = str_replace('{'.$key.'}',$value,$address_format_set);
                    }
                    else
                    {
                        $address_format_set = preg_replace('~\{if '.$key.'\}(.*)\{/if '.$key.'\}~i','',$address_format_set);
                        $address_format_set = str_replace('{'.$key.'}','',$address_format_set);
                    }
                }
                $address_format_set     = trim(str_replace(array('||','|'),"\n",trim($address_format_set)));
                $address_format_set     = str_replace("\n\n","\n",$address_format_set);
                $shippingAddressArray     = explode("\n",$address_format_set);

                $count                     = (count($shippingAddressArray)-1);
                $shipping_line_count     = $count;
                $show_this_shipping_line = array();

                $ship_i = 0;
                foreach($shippingAddressArray as $key =>$value)
                {
                    $skip         = 0;
                    $line_addon    = 0;
                    $line_bold     = 0;
                    $value = trim($value);
                    $value = preg_replace('~^,$~','',$value);
                    $value = str_replace(',,',',',$value);
                    $value = str_ireplace(array('{if street}','{street}','{/if street}','{if city}','{city}','{/if city}'),'',$value);
                    if($value != '') {$show_this_shipping_line[$ship_i] = $value;$ship_i ++;}
                }

                foreach($show_this_shipping_line as $i =>$value)
                {
                    $page->drawText($value, $padded_left, $this->y, 'UTF-8');
                    $this->y -= ($font_size_body*$line_spacing);
                }

                $this->y -= 50;

                // custom message
                if(isset($message))
                {

        /*
                    [order_id] : replaced with Order ID
                  - [order_date] : replaced with the order date
                  - [customer_name] : replaced with Customer Name
                  - [grey]*text here is grey and on forced new line*[/grey]

                            */
                    $message_pre = str_replace(array('[order_id]','[order_date]','[customer_name_content]'),array($order_number_display,$order_date,$customer_name_content),$message);
                    preg_match('~\[grey\](.*)\[\/grey\]~i',$message_pre,$message_pre_split);

                    $message = str_replace($message_pre_split[0],'',$message_pre);

                    if(strlen($message) > $max_chars)
                    {
                        $message_array = array();
                        $message_wrapped = wordwrap($message, $max_chars, "\n", false);

                        $token = strtok($message_wrapped, "\n");
                        while ($token != false)
                        {
                            $page->drawText(trim($token), $padded_left, $this->y, 'UTF-8');
                            $this->y-=($font_size_body*$line_spacing);
                            $token = strtok("\n");
                        }

                        unset($message_wrapped);
                    }
                    else
                    {
                        $page->drawText($message, $padded_left, $this->y, 'UTF-8');
                    }

                    if($message_pre_split[1] != '')
                    {
                        $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_grey);

                        $page->drawText($message_pre_split[1], $padded_left, $this->y, 'UTF-8');

                        $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                    }
                }
                $page_count    = 1;
            }

            $this->_afterGetPdf();
            return $pdf;
        }

    /***********************************************
        * Shifter Template - START
    ************************************************/
    public function getPdf2($orders=array(), $from_shipment = 'order')
    {
        $this->_beforeGetPdf();
        $this->_initRenderer('invoices');
        $pdf = new Zend_Pdf();
        $this->_setPdf($pdf);
        $style = new Zend_Pdf_Style();
                
        /* Page Sizes */
        //const SIZE_A4                = '595:842:'; //820
        //const SIZE_LETTER            = '612:792:'; //770
            
        $page_top = 395;$padded_right = 573;$padded_left = 20;
        
        $page_size = $this->_getConfig('page_size', 'a4', false,'general');
        
        if($page_size == 'letter') 
        {
            $page = $pdf->newPage(Zend_Pdf_Page::SIZE_LETTER);
            $page_top = 770;$padded_right = 587;$padded_left = 20; //562 usable
        }
        elseif($page_size == 'a4') 
        {
            $page = $pdf->newPage(Zend_Pdf_Page::SIZE_A4);
            $page_top = 820;$padded_right = 570;$padded_left = 20;// 540 usable
        }
        elseif($page_size == 'a5landscape') 
        {
            $page = $pdf->newPage('596:421');                    
            $page_top = 395;$padded_right = 573;$padded_left = 20;
        }
        
        $pdf->pages[] = $page;
        
        $first_page_yn             = 'y';

        foreach ($orders as $orderSingle) 
        {
            $wonder = 'wonder';
            
            if($first_page_yn == 'n') $page = $this->newPage();
            else $first_page_yn = 'n';
            $this->y = $page->getHeight();
            
            $order = Mage::getModel('sales/order')->load($orderSingle);        
            $order_id  = $order->getRealOrderId();
    
            $store_id = $order->getStore()->getId();

            $this->_beforeGetPdf();
            $this->_initRenderer('invoices');

            $pdf = new Zend_Pdf();
            $this->_setPdf($pdf);
            $style = new Zend_Pdf_Style();
            $this->_setFontBold($page, 10);
            
            $page_size = $this->_getConfig('page_size', 'a4', false,'general',$store_id);

            if($page_size == 'letter') 
            {
                $page = $pdf->newPage(Zend_Pdf_Page::SIZE_LETTER);
                $page_top = 770;$padded_right = 587;
            }
            elseif($page_size == 'a4')
            {
                $page = $pdf->newPage(Zend_Pdf_Page::SIZE_A4);
                $page_top = 820;$padded_right = 570;
            }
            elseif($page_size == 'a5landscape') 
            {
                $page = $pdf->newPage('596:421');                    
                $page_top = 395;$padded_right = 573;
            }
            
            $pdf->pages[] = $page;           
              
            /***********************************************************
            * CONFIGURATIONS
            ***********************************************************/

            // all y values must be positive, all x positive
            // bottom left is 0,0

            ## DEFAULT VALUES
            $columnYNudgeDefault        = 570;
            $barcodeXYDefault           = '450,800';
            $orderDateXYDefault         = '390,755';
            $orderIdXYDefault           = '390,730';
            $customerIdXYDefault        = '390,705';
            $customerNameXYDefault      = '130,648'; 
            $addressXYDefault           = '130,633';  
            $orderIdFooterXYDefault     = '106,76';
            $customerIdFooterXYDefault  = '106,47';            

            $cutoff_noDefault           = 10;
            $skuXDefault                = 90;
            $qtyXDefault                = 40;
            $productXDefault            = 230;
            $colorXDefault              = 400;
            $sizeXDefault               = 450;
            $priceXDefault              = 505; 

            $columnYNudge           = $this->_getConfig('pack_column', $columnYNudgeDefault,false,$wonder,$store_id);
            $showBarCode            = $this->_getConfig('pickpack_packbarcode', 0, false,$wonder,$store_id);

            $barcodeXY              = explode(",", $this->_getConfig('pack_barcode', $barcodeXYDefault));               
            $orderDateXY            = explode(",", $this->_getConfig('pack_order', $orderDateXYDefault));
            $customerIdXY           = explode(",", $this->_getConfig('pack_cid', $customerIdXYDefault));
            $orderIdXY              = explode(",", $this->_getConfig('pack_oid', $orderIdXYDefault));                        

            $color_attribute_name     = trim($this->_getConfig('color_attribute_name', 'color',false,$wonder,$store_id));
            $size_attribute_name     = trim($this->_getConfig('size_attribute_name', 'size',false,$wonder,$store_id));

            $customerNameXY         = explode(",", $this->_getConfig('pack_customer', $customerNameXYDefault,false,$wonder,$store_id));
            $addressXY                 = explode(",", $this->_getConfig('pack_customeraddress', $addressXYDefault,false,$wonder,$store_id));

            $customerIdFooterXY     =  explode(",", $this->_getConfig('footer_customer_id', $customerIdFooterXYDefault,false,$wonder,$store_id));
            $orderIdFooterXY        =  explode(",", $this->_getConfig('footer_order_id', $orderIdFooterXYDefault));      

            $cutoff_no              = $this->_getConfig('pack_noofitems', 10, false,$wonder,$store_id);
            $font_size_overall       = $this->_getConfig('pickpack_fontsizeoverall', 9, false,$wonder,$store_id);
            $font_size_productline   = $this->_getConfig('pickpack_fontsizeproductline', 9, false,$wonder,$store_id);
            
            $shelving_real_title         = $this->_getConfig('shelving_real_title', 'shelf', false,$wonder,$store_id);
                    
            $font_family_body = $this->_getConfig('font_family_body', 'helvetica', false,'general',$store_id);
            $font_style_body = $this->_getConfig('font_style_body', 'regular', false,'general',$store_id);
            $font_size_body = $this->_getConfig('font_size_body', 10, false,'general',$store_id);
            $font_color_body = $this->_getConfig('font_color_body', 'Black', false,'general',$store_id);

            $non_standard_characters     = $this->_getConfig('non_standard_characters', 0, false,'general',$store_id);
            
            $shipment_details_yn    = $this->_getConfig('shipment_details_yn', 0, false,$wonder,$store_id);

            $skuX                   = $this->_getConfig('pack_sku', $skuXDefault, false,$wonder,$store_id);
            $qtyX                   = $this->_getConfig('pack_qty', $qtyXDefault, false,$wonder,$store_id);
            $productX               = $this->_getConfig('pack_product', $productXDefault, false,$wonder,$store_id);
            $colorX                 = $this->_getConfig('pack_color', $colorXDefault, false,$wonder,$store_id);
            $sizeX                  = $this->_getConfig('pack_size', $sizeXDefault, false,$wonder,$store_id);
            $priceX                 = $this->_getConfig('pack_price', $priceXDefault, false,$wonder,$store_id);            

            $this->y                = $page->getHeight();

            /***********************************************************
            * CONFIGURATIONS
            ***********************************************************/

            $page->setFillColor(new Zend_Pdf_Color_GrayScale(0));
            $this->_setFontRegular($page, $font_size_overall);         

            # BARCODE
            if(1 == $showBarCode)
            {
                $barcodeString = $this->convertToBarcodeString($order->getRealOrderId());
                $page->setFont(Zend_Pdf_Font::fontWithPath(dirname(__FILE__)  . '/' . 'Code128bWin.ttf'), 16);  
                $page->drawText($barcodeString, $barcodeXY[0], $barcodeXY[1], 'CP1252');
            }            
            if($shipment_details_yn == 1)
            {
                // $shipping_method = '';
                $shipping_method = clean_method($order->getShippingDescription(),'shipping');
                
                $this->_setFont($page, $font_style_body, ($font_size_productline-2), $font_family_body, $non_standard_characters, $font_color_body);
                $page->drawText(Mage::helper('sales')->__('Post').': '.$shipping_method, $barcodeXY[0], ($barcodeXY[1]-6), 'UTF-8');
            }
            
            $page->setFillColor(new Zend_Pdf_Color_GrayScale(0));
            $this->_setFontRegular($page, $font_size_overall);
            
            # HEADER 
            if(Mage::helper('core')->formatDate($order->getCreatedAtStoreDate())) $order_date = Mage::helper('core')->formatDate($order->getCreatedAtStoreDate(), 'medium', false);
            $page->drawText($order_date, $orderDateXY[0], $orderDateXY[1], 'UTF-8');
            $page->drawText($order->getRealOrderId(), $orderIdXY[0], $orderIdXY[1], 'UTF-8');
            $page->drawText($order->getCustomerId(), $customerIdXY[0], $customerIdXY[1] , 'UTF-8');

            # NAME/DELIVERY
            $page->drawText($order->getCustomerName(), $customerNameXY[0], $customerNameXY[1], 'UTF-8');
            $shippingAddress = $this->_formatAddress($order->getShippingAddress()->format('pdf'));        
            $page->drawText(str_replace('|',' ',implode(', ',$shippingAddress)), $addressXY[0], $addressXY[1], 'UTF-8');

            # FOOTER
            $page->drawText($order->getRealOrderId(), $orderIdFooterXY[0], $orderIdFooterXY[1], 'UTF-8');           
            $page->drawText($order->getCustomerId(), $customerIdFooterXY[0], $customerIdFooterXY[1] , 'UTF-8');

            # ITEMS
            $this->y         = $columnYNudge;  
            $this->_itemsY   = $this->y;  
          
            $itemsCollection =  $order->getAllVisibleItems();
            $total_items     = count($itemsCollection);

            $page->setFillColor(new Zend_Pdf_Color_GrayScale(0));
            $this->_setFontRegular($page, $font_size_productline);          
            
            $counter = 1; 
            foreach ($itemsCollection as $item)
            {
                           
                $size = '';
                $color = ''; 
                $size_id = '';
                $color_id = '';
                $color_attribute_id = '';
                $size_attribute_id = '';

                $options = $item->getProductOptions();

                if(Mage::getModel('eav/entity_attribute')->loadByCode('catalog_product', $color_attribute_name)->getAttributeId())
                {
                    $color_attribute_id = Mage::getModel('eav/entity_attribute')->loadByCode('catalog_product', $color_attribute_name)->getAttributeId();//272
                }

                if(Mage::getModel('eav/entity_attribute')->loadByCode('catalog_product', $size_attribute_name)->getAttributeId())
                {
                    $size_attribute_id = Mage::getModel('eav/entity_attribute')->loadByCode('catalog_product', $size_attribute_name)->getAttributeId();//525
                }


                $qty = $item->getIsQtyDecimal() ? $item->getQtyOrdered() : (int) $item->getQtyOrdered();

                if($item->getProductType() == Mage_Catalog_Model_Product_Type::TYPE_CONFIGURABLE) 
                {
                    $sku = $item->getProductOptionByCode('simple_sku');
                    if(isset($options['info_buyRequest']['super_attribute'][$size_attribute_id])) $size_id  = $options['info_buyRequest']['super_attribute'][$size_attribute_id]; #size
                    if(isset($options['info_buyRequest']['super_attribute'][$color_attribute_id])) $color_id = $options['info_buyRequest']['super_attribute'][$color_attribute_id]; #color     

                    $sizeCollection = Mage::getResourceModel('eav/entity_attribute_option_collection')                
                    ->setStoreFilter(0)                   
                    ->setAttributeFilter($size_attribute_id)                    
                    ->load(); 

                    foreach($sizeCollection as $_size)
                    {                        
                        if($_size->getOptionId() == $size_id)
                        {
                            $size = $_size->getValue();
                            break;
                        }
                    }                    

                    $colorCollection = Mage::getResourceModel('eav/entity_attribute_option_collection')                
                    ->setStoreFilter(0)                   
                    ->setAttributeFilter($color_attribute_id)                    
                    ->load();         

                    foreach($colorCollection as $_color)
                    {                        
                        if($_color->getOptionId() == $color_id)
                        {
                            $color = $_color->getValue();
                            break;
                        }
                    }
                } 
                else 
                {
                    // simple product
                    // sku works, others not
                    $sku = $item->getSku();
                    if($item->getAttributeText($color_attribute_name)) $color = $item->getAttributeText($color_attribute_name);
                    if($item->getAttributeText($size_attribute_name)) $size = $item->getAttributeText($size_attribute_name);

                    if(!isset($color) && Mage::getModel('catalog/product')->load($item->getProductId())->getAttributeText($color_attribute_name)) $color = Mage::getModel('catalog/product')->load($item->getProductId())->getAttributeText($color_attribute_name);
                    if(!isset($size) && Mage::getModel('catalog/product')->load($item->getProductId())->getAttributeText($size_attribute_name)) $size = Mage::getModel('catalog/product')->load($item->getProductId())->getAttributeText($size_attribute_name);

                    if(!isset($color) && $item->getColor) $color = $item->getColor;
                    if(!isset($size) && $item->getSize) $size = $item->getSize;                
                }
            
                if($from_shipment == 'shipment')
                {
                    $qty_string = 's:'.(int)$item->getQtyShipped() . ' / o:'.$qty;
                }
                else
                {
                    $qty_string = $qty;
                }
       
                $page->drawText($qty_string, $qtyX, $this->y , 'UTF-8');
                $page->drawText($sku, $skuX, $this->y , 'UTF-8');
                $page->drawText($item->getName(), $productX, $this->y , 'UTF-8');
                $page->drawText($color, $colorX, $this->y , 'UTF-8');
                $page->drawText($size, $sizeX, $this->y , 'UTF-8');                    

                $price = $qty * $item->getPriceInclTax();

                $page->drawText(number_format($price, 2, '.', ','), $priceX, $this->y , 'UTF-8');
                $this->y -= 15;

                if(($counter % $cutoff_no) == 0 && $counter != $total_items)
                {
                    $page = $this->newPage2();
                }

                $counter++;
            }

            /***********************************************
            * Shifter Template - END
            ************************************************/
            $this->_afterGetPdf();
        }
    return $pdf;
    }


   /***********************************************
    * Default Template - START
    ************************************************/

    public function getPdfDefault($orders=array(), $from_shipment = 'order', $invoice_or_pack = 'pack')
    {
        $wonder = 'wonder';
        if($invoice_or_pack == 'invoice') $wonder = 'wonder_invoice';
    
		$total_price_taxed	= 0;
		$storeId 			= Mage::app()->getStore()->getId();

		$sku_supplier_item_action = array();
		$sku_supplier_item_action_master = array();
		$config_first_run = true;
		$countstore=0;

		$split_supplier_yn_default     = 0;
		$supplier_attribute_default = 'supplier';
		$supplier_options_default     = 'filter';
		$supplier_login_default        = '';
		$tickbox_default            = 'no'; //no, pick, pickpack
		$supplier_ubermaster        = array();

		$split_supplier_yn_temp     = $this->_getConfig('pickpack_split_supplier_yn', $split_supplier_yn_default, false,'general');
		$split_supplier_options     = $this->_getConfig('pickpack_split_supplier_options', 'no', false,'general');
		$split_supplier_yn = 'no';
		if($split_supplier_yn_temp == 1)
		{
			$split_supplier_yn         = $split_supplier_options;
		}
		// this means only picklists should be separated
		if($split_supplier_yn == 'pick') $split_supplier_yn = 'no';

		$supplier_attribute         = $this->_getConfig('pickpack_supplier_attribute', $supplier_attribute_default, false,'general');
		$supplier_options             = $this->_getConfig('pickpack_supplier_options', $supplier_options_default, false,'general');
      
          foreach ($orders as $orderSingle) 
          {
              $order             = Mage::getModel('sales/order')->load($orderSingle);        
              $order_id          = $order->getRealOrderId();
              $order_storeId     = $order->getStore()->getId();

              if(($storeId != $order_storeId) || ($config_first_run === true))
              {
                  $get_store = $order->getStore();
                  $config_first_run = false;
                  $storeId = $order_storeId;
      
                        /***********************************************************
                          * CONFIGURATIONS
                          ***********************************************************/

                          // all y values must be positive, all x positive
                          // bottom left is 0,0

                          $page_size = $this->_getConfig('page_size', 'a4', false,'general',$order_storeId);

                          if($page_size == 'letter') 
                          {
                              $page_top = 770;$padded_right = 587;$padded_left = 20;

                              $columnYNudgeDefault        = 720;
                              $barcodeXYDefault           = '465,755';
                              $title2XYDefault               = '465,733';
                              $orderDateXYDefault         = '160,695';
                              $orderIdXYDefault           = '30,695';
                              $customerIdXYDefault        = '390,655';
                              $addressXYDefault           = '40,645';  
                              $addressFooterXYDefault     = '50,110';
                              $addressFooterXYDefault_xtra = '325,175';
                              $returnAddressFooterXYDefault = '320,90';
                              $customerNameXYDefault        = '0,0';

                              $giftMessageXYDefault        = '0,90';
                              $notesXYDefault                = '25,90';
                              $packedByXYDefault            = '520,20';
                              $return_logo_XYDefault        = '320,40';
                          }
                          elseif($page_size == 'a4') 
                          {
                              $page_top = 820;$padded_right = 570;$padded_left = 20;

                              $columnYNudgeDefault        = 720;
                              $barcodeXYDefault           = '465,805';
                              $title2XYDefault               = '465,783';
                              $orderDateXYDefault         = '160,745';
                              $orderIdXYDefault           = '30,745';
                              $customerIdXYDefault        = '390,705';
                              $addressXYDefault           = '40,695';  
                              $addressFooterXYDefault     = '50,140';
                              $addressFooterXYDefault_xtra = '325,205';
                              $returnAddressFooterXYDefault = '320,120';

                              $customerNameXYDefault        = '0,0';

                              $giftMessageXYDefault        = '0,140';
                              $notesXYDefault                = '25,140';
                              $packedByXYDefault            = '520,20';
                              $return_logo_XYDefault        = '320,70';//'320,140'; (minus the image size [180x120] from return address coords)
                          }
                          elseif($page_size == 'a5landscape') 
                          {
                              //$page_top = 395;$padded_right = 573;
                              /*
                              Letter        612x792 587x770 (-25 -22)
                              A4             595x842 570x820 (-25 -22)
                              A5             420x595 395x573 
                              A5(L)        595x420 573x395 
                              */
                              $page_top = 395;$padded_right = 573;$padded_left = 20;

                              $columnYNudgeDefault        = 720;
                              $barcodeXYDefault           = '465,379';//-425
                              $title2XYDefault               = '465,358';
                              $orderDateXYDefault         = '160,320';
                              $orderIdXYDefault           = '30,320';
                              $customerIdXYDefault        = '390,280';
                              $addressXYDefault           = '40,270';  
                              $addressFooterXYDefault     = '50,100';
                              $addressFooterXYDefault_xtra = '325,165';
                              $returnAddressFooterXYDefault = '320,80';
                              $customerNameXYDefault        = '0,0';
                              $giftMessageXYDefault        = '0,80';
                              $notesXYDefault                = '25,80';
                              $packedByXYDefault            = '520,20';
                              $return_logo_XYDefault        = '320,70';//'320,140'; (minus the image size [180x120] from return address coords)
                          }

                          ## DEFAULT VALUES
                          $cutoff_noDefault           = 20;
                          $subheader_start            = 0;
                      
                          $boldLastAddressLineYNDefault = 'Y';
                          $fontColorGrey                = 0.6;
                          $fontColorReturnAddressFooter = 0.2;
                          $boxBkgColorDefault            = 0.7;

                          $red_bkg_color             = new Zend_Pdf_Color_Html('lightCoral');
                          $grey_bkg_color            = new Zend_Pdf_Color_GrayScale(0.7);
                          $dk_grey_bkg_color        = new Zend_Pdf_Color_GrayScale(0.3);//darkCyan
                          $dk_cyan_bkg_color         = new Zend_Pdf_Color_Html('darkCyan');//darkOliveGreen
                          $dk_og_bkg_color         = new Zend_Pdf_Color_Html('darkOliveGreen');//darkOliveGreen
                          $black_color             = new Zend_Pdf_Color_Rgb(0,0,0);
                          $red_color             = new Zend_Pdf_Color_Html('darkRed');
                          $grey_color             = new Zend_Pdf_Color_GrayScale(0.3);
                          $greyout_color             = new Zend_Pdf_Color_GrayScale(0.6);
                          $white_color             = new Zend_Pdf_Color_GrayScale(1);

                          $split_supplier_yn_default     = 0;
                          $supplier_attribute_default = 'supplier';
                          $supplier_options_default     = 'filter';
                          $supplier_login_default        = '';
                          $tickbox_default            = 'no'; //no, pick, pickpack
                          $supplier_ubermaster        = array();
                          $order_id_master            = array();
                          $magik_product_str 			= array();

                          $split_supplier_yn_temp     = $this->_getConfig('pickpack_split_supplier_yn', $split_supplier_yn_default, false,'general',$order->getStore()->getId());
                          $split_supplier_options     = $this->_getConfig('pickpack_split_supplier_options', 'no', false,'general',$order->getStore()->getId());
                          $split_supplier_yn = 'no';
                          if($split_supplier_yn_temp == 1)
                          {
                              $split_supplier_yn         = $split_supplier_options;
                          }
                          // this means only picklists should be separated
                          if($split_supplier_yn == 'pick') $split_supplier_yn = 'no';

              if($split_supplier_yn != 'no')
              {
                          $supplier_attribute         = $this->_getConfig('pickpack_supplier_attribute', $supplier_attribute_default, false,'general',$order->getStore()->getId());
                          $supplier_options             = $this->_getConfig('pickpack_supplier_options', $supplier_options_default, false,'general',$order->getStore()->getId());
              }
              
              $item_count = 0;
              $total_item_count = 0;
              
              $itemsCollection =  $order->getAllVisibleItems();        
              foreach ($itemsCollection as $item)
              {        
                  $total_item_count += $item->getIsQtyDecimal() ? $item->getQtyOrdered() : (int) $item->getQtyOrdered();
                  if($item->getProductType() == Mage_Catalog_Model_Product_Type::TYPE_CONFIGURABLE) 
                  {
                      $sku = $item->getProductOptionByCode('simple_sku');
                      $product_id = Mage::getModel('catalog/product')->getIdBySku($sku);
                  } 
                  else 
                  {
                      $sku = $item->getSku();
                      $product_id = $item->getProductId(); // get it's ID    
                  }    
                                      
                  $sku_productid[$sku] = $product_id;

                  $shelving_real_attribute     = $this->_getConfig('shelving_real', 'shelf', false,$wonder,$order->getStore()->getId());
                  $shelving_attribute         = $this->_getConfig('shelving', '', false,$wonder,$order->getStore()->getId());            

                  $product = Mage::getModel('catalog/product')->loadByAttribute('sku', $sku, array('cost',$shelving_attribute,$shelving_real_attribute,'name','simple_sku','qty'));            
                  //if(Mage::getModel('cataloginventory/stock_item')->loadByProduct($product_id)->getQty()) $stock = round(Mage::getModel('cataloginventory/stock_item')->loadByProduct($product_id)->getQty());
              
                  $supplier = '';
                  $sku_supplier_item_action_master[$order_id] = 'keep';
                  $loop_supplier = 0;
          
                  if($split_supplier_yn == 'pickpack')
                  {
                      $sku_supplier_item_action_master[$order_id] = 'hide';
                      if(Mage::getModel('catalog/product')->load($product_id))
                      {
                          $_newProduct = Mage::getModel('catalog/product')->load($product_id);  
                          if($_newProduct->getData($supplier_attribute)) $supplier = $_newProduct->getData($supplier_attribute);
                      }
                      elseif($product->getData($supplier_attribute))
                      {
                           $supplier = $product->getData($supplier_attribute);
                      }
                      if(Mage::getModel('catalog/product')->load($product_id)->getAttributeText($supplier_attribute))
                      {
                          $supplier = Mage::getModel('catalog/product')->load($product_id)->getAttributeText($supplier_attribute);
                      }
                      elseif($product[$supplier_attribute]) $supplier = $product[$supplier_attribute];
                      if(is_array($supplier)) $supplier = implode(',',$supplier);
                      if(!$supplier) $supplier = '~Not Set~';    
                      $supplier = trim(strtoupper($supplier));
                      if(isset($sku_supplier[$sku]) && $sku_supplier[$sku] != $supplier) $sku_supplier[$sku] .= ','.$supplier;
                      else $sku_supplier[$sku] = $supplier;
                      $sku_supplier[$sku] = preg_replace('~,$~','',$sku_supplier[$sku]);
                      if(!isset($supplier_master[$supplier]))
                      {
                          $supplier_master[$supplier] = $supplier;
                          $supplier_ubermaster[] = $supplier;
                      }
              
                      if(isset($order_id_master[$order_id])) $order_id_master[$order_id] .= ','.$supplier;
                      else $order_id_master[$order_id] = $supplier;

                      $sku_supplier_item_action[$supplier][$sku] = 'keep';
                      // if set to filter and a name and this is the name, then print
                      if($supplier_options == 'filter' && isset($supplier_login) && ($sku_supplier[$sku] == strtoupper($supplier_login)) )//grey //split
                      {
                          $sku_supplier_item_action[$supplier][$sku] = 'keep';
                      }
                      elseif($supplier_options == 'filter' && isset($supplier_login) && ($supplier_login != '') && ($sku_supplier[$sku] != strtoupper($supplier_login)) )//grey //split
                      {
                          $sku_supplier_item_action[$supplier][$sku] = 'hide';
                      }
                      elseif($supplier_options == 'grey' && isset($supplier_login) && ($sku_supplier[$sku] == strtoupper($supplier_login)) )//grey //split
                      {
                          $sku_supplier_item_action[$supplier][$sku] = 'keep';
                      }
                      elseif($supplier_options == 'grey' && isset($supplier_login) && $supplier_login != '' && ($sku_supplier[$sku] != strtoupper($supplier_login)) )//grey //split
                      {
                          $sku_supplier_item_action[$supplier][$sku] = 'keepGrey';
                      }
                      elseif($supplier_options == 'grey' && (!isset($supplier_login) || $supplier_login == '') && ($sku_supplier[$sku] != strtoupper($supplier) ) )
                      {
                          $sku_supplier_item_action[$supplier][$sku] = 'keepGrey';
                      }
                      elseif($supplier_options == 'filter' && (!isset($supplier_login) || $supplier_login == '') && ($sku_supplier[$sku] != strtoupper($supplier) ) )
                      {
                          $sku_supplier_item_action[$supplier][$sku] = 'hide';
                      }
                      elseif($supplier_options == 'grey' && (!isset($supplier_login) || $supplier_login == '') && ($sku_supplier[$sku] == strtoupper($supplier) ) )
                      {
                          $sku_supplier_item_action[$supplier][$sku] = 'keep';
                      }
                      elseif($supplier_options == 'filter' && ($supplier_login == '') && ($sku_supplier[$sku] == strtoupper($supplier) ) )
                      {
                          $sku_supplier_item_action[$supplier][$sku] = 'keep';
                      }
                      elseif($supplier_options == 'grey') $sku_supplier_item_action[$supplier][$sku] = 'keepGrey';
                      elseif($supplier_options == 'filter') $sku_supplier_item_action[$supplier][$sku] = 'hide';
                  
                  
                      if($split_supplier_yn == 'no') $sku_supplier_item_action[$supplier][$sku] = 'keep';
              
                      if(($sku_supplier_item_action_master[$order_id] != 'keep') && ($sku_supplier_item_action_master[$order_id] != 'keepGrey') && (($sku_supplier_item_action[$supplier][$sku] == 'keepGrey') || ($sku_supplier_item_action[$supplier][$sku] == 'keep'))) $sku_supplier_item_action_master[$order_id] = 'keep';
                      $loop_supplier = 1;
                  }
              }
          }
      }

          if(($split_supplier_yn != 'no' && $sku_supplier_item_action_master[$order_id] == 'keep') || ($split_supplier_yn == 'no'))
          {
              $this->_beforeGetPdf();
              $this->_initRenderer('invoices');
              $pdf = new Zend_Pdf();
              $this->_setPdf($pdf);
              $style = new Zend_Pdf_Style();
              
              /*
              Letter        612x792 587x770 (-25 -22)
              A4             595x842 570x820 (-25 -22)
              A5             420x595 395x573 
              A5(L)        595x420 573x395 
              */
          
              if($page_size == 'letter') 
              {
                  $page = $pdf->newPage(Zend_Pdf_Page::SIZE_LETTER);
                  $page_top = 770;$padded_right = 587;
              }
              elseif($page_size == 'a4') 
              {
                  $page = $pdf->newPage(Zend_Pdf_Page::SIZE_A4);
                  $page_top = 820;$padded_right = 570;
              }
              elseif($page_size == 'a5landscape') 
              {
                  $page = $pdf->newPage('596:421');                    
                  $page_top = 395;$padded_right = 573;
              }
              
              $pdf->pages[] = $page;
              $this->y = $page_top;//$page->getHeight();
          }
          
          $s = 0;                
          $first_page_yn             = 'y';
          $page_count                = 1;
          $shelving_attribute        = '';
          $subtotal_order            = array();
          
          do
          {
              if($split_supplier_yn != 'no') $supplier = $supplier_ubermaster[$s];
              
              foreach ($orders as $orderSingle) 
              {
                  $order                 = Mage::getModel('sales/order')->load($orderSingle);        
                  $order_id              = $order->getRealOrderId();                        
                  $store_id             = $order->getStore()->getId();
                  $itemsCollection     = $order->getAllVisibleItems();
                  
                  //
                  /**
                  config inputs    
                  */
                  $second_page_start            = $this->_getConfig('second_page_start', 'top', false,'general',$store_id); // top or asfirst 
              
                  $trim_names_yn                = $this->_getConfig('trim_names_yn', 1, false,'general',$store_id); //0,1,linebreak
                  $prices_yn                    = $this->_getConfig('prices_yn', 0, false,$wonder,$store_id);
                  $prices_hideforgift_yn        = $this->_getConfig('prices_hideforgift_yn', 0, false,$wonder,$store_id);
                  $tax_yn                       = $this->_getConfig('tax_yn', 'no', false,$wonder,$store_id);
                  $tax_col_yn                 = 0;
                  $tax_bands_yn				= 0;
                  
                  if($tax_yn == 'yesboth' || $tax_yn == 'yescol') $tax_col_yn = 1;
                  if($prices_yn == 0) $tax_yn = 'no';
                  if($tax_yn == 'no') 
                  {
                      $tax_col_yn = 0;
                      $subtotal_order = explode(',',$this->_getConfig('subtotal_order_no', '10,20,40', false,$wonder,$store_id));
                      /*
                          subtotal_order[0]Subtotal   
                          [1]Discounts    
                          [2]Tax     
                          [3]Shipping
                      */
                      $subtotal_order[3] = 0;
                      if(isset($subtotal_order[2])) $subtotal_order[3] = $subtotal_order[2];
                      $subtotal_order[2] = 0;
                  }
                  
                  if($tax_yn == 'yessubtotal') 
                  {
                      $tax_bands_yn 			= $this->_getConfig('tax_bands_yn_subtotal', 1, false,$wonder,$store_id);
                      $subtotal_order 		= explode(',',$this->_getConfig('subtotal_order_yessubtotal', '10,20,30,40', false,$wonder,$store_id));
                  }                        
                  elseif($tax_yn == 'yesboth') 
                  {
                      $tax_bands_yn 			= $this->_getConfig('tax_bands_yn', 1, false,$wonder,$store_id);
                      $subtotal_order 		= explode(',',$this->_getConfig('subtotal_order_yesboth', '10,20,30,40', false,$wonder,$store_id)); 
                  }
				elseif($tax_yn == 'noboth') 
                  {
                      $tax_bands_yn 			= $this->_getConfig('tax_bands_yn', 1, false,$wonder,$store_id);
                      $subtotal_order 		= explode(',',$this->_getConfig('subtotal_order_noboth', '10,20,30,40', false,$wonder,$store_id));
                  }
                  elseif($tax_yn == 'yescol') 
                  {
                      $subtotal_order 		= explode(',',$this->_getConfig('subtotal_order_yescol', '10,20,40', false,$wonder,$store_id));
                      $subtotal_order[3] 		= $subtotal_order[2];
                      $subtotal_order[2] 		= 0;
                  }
                
                  $tax_label                  = trim($this->_getConfig('tax_label', '', false,$wonder,$store_id));
                  $discount_line_or_subtotal  = $this->_getConfig('discount_line_or_subtotal', '', false,$wonder,$store_id);
              
                  $date_format                = $this->_getConfig('date_format', 'M. j, Y', false,'general',$store_id);

                  $doubleline_yn              = $this->_getConfig('doubleline_yn', 0, false,$wonder,$store_id);
                  
                  $shelving_real_yn           = $this->_getConfig('shelving_real_yn', 0, false,$wonder,$store_id);
                  $shelving_real_attribute    = trim($this->_getConfig('shelving_real', '', false,$wonder,$store_id));
                  if($shelving_real_attribute == '') $shelving_real_yn = 0;
                  $shelving_real_title        = trim($this->_getConfig('shelving_real_title', '', false,$wonder,$store_id));
                  $shelving_real_title        = str_ireplace(array('blank',"'"),'',$shelving_real_title);
                   $sku_title                 = $this->_getConfig('sku_title', '', false,$wonder,$store_id);
                   $sku_barcode_title         = $this->_getConfig('sku_barcode_title', '', false,$wonder,$store_id);
                   $product_stock_qty_title   = $this->_getConfig('product_stock_qty_title', '', false,$wonder,$store_id);
                   $items_title               = $this->_getConfig('items_title', '', false,$wonder,$store_id);

                   $order_or_invoice          = $this->_getConfig('orderorinvoice', 'order', false,$wonder,$store_id);
                   $order_or_invoice_date     = $this->_getConfig('orderorinvoicedate', 'order', false,$wonder,$store_id);

                   $beta_boxes_yn             = $this->_getConfig('beta_boxes_yn', 0, false,$wonder,$store_id);
                   $beta_box_1_yn             = $this->_getConfig('beta_box_1_yn', 0, false,$wonder,$store_id);
                   $beta_box_2_yn             = $this->_getConfig('beta_box_2_yn', 0, false,$wonder,$store_id);
                   $beta_box_3_yn             = $this->_getConfig('beta_box_3_yn', 0, false,$wonder,$store_id);
                  if($beta_boxes_yn == 0)
                  {
                      $beta_box_1_yn          = 0;
                       $beta_box_2_yn         = 0;
                       $beta_box_3_yn			= 0;
                  }
                  
$product_images_yn          = $this->_getConfig('product_images_yn', 0, false,$wonder,$store_id);
$product_images_source     	= $this->_getConfig('product_images_source', 'thumbnail', false,$wonder,$store_id);

$product_sku_yn            	= $this->_getConfig('product_sku_yn', 1, false,$wonder,$store_id);
$product_sku_simple_configurable = 'simple';
                  if($product_sku_yn == 'configurable') 
                  {
                      $product_sku_yn         = 1;
                      $product_sku_simple_configurable = 'configurable';
                  }
                   $product_sku_barcode_yn	= $this->_getConfig('product_sku_barcode_yn', 1, false,$wonder,$store_id);
                   $product_stock_qty_yn	= $this->_getConfig('product_stock_qty_yn', 0, false,$wonder,$store_id);
          
				$custom_title_yn = $this->_getConfig('pickpack_title_yn', 0, false,$wonder,$store_id);
				$invoice_title = trim($this->_getConfig('pickpack_title', '', false,$wonder,$store_id));
				$invoice_title_2_yn = $this->_getConfig('pickpack_title_2_yn', 0, false,$wonder,$store_id);
               
                  //473/978
                  // = 269 / 556pt wide image
                  $show_top_logo_yn           = $this->_getConfig('pickpack_packlogo', 0, false,$wonder,$store_id); 
                  $logo_position              = $this->_getConfig('pickpack_logo_position', 'left', false,$wonder,$store_id); 
                    
                  $show_shipping_logo_yn      = $this->_getConfig('pickpack_returnlogo_shipping', '', false,$wonder,$store_id);            
                  $shipping_logo_XY           = explode(",", $this->_getConfig('pickpack_nudgelogo_shipping', '40,50',true,$wonder,$store_id));            
                  
                  $page_template              = $this->_getConfig('page_template', 0, false,$wonder,$store_id);

                  $shipping_billing_title_position = $this->_getConfig('shipping_billing_title_position', 'above', false,$wonder,$store_id);
                  $title_date_xpos            = trim($this->_getConfig('title_date_xpos', 'auto', false,$wonder,$store_id));
                  $custom_message_image_line_yn = 0;//$this->_getConfig('custom_message_image_line_yn', 0, false,$wonder,$store_id);
                  $page_pad                   = explode(',', trim($this->_getConfig('page_pad', '0,0',false,$wonder,$store_id)));               
                  $fill_product_header_yn     = $this->_getConfig('fill_product_header_yn', 1,false,$wonder,$store_id);               
                  $title_invert_color         = $this->_getConfig('title_invert_color', 0, false,$wonder,$store_id);
              
                  $mailer_padding             = array(0,0,0);
                  
                  if($page_template == 'tech') 
                  {
                      $title_invert_color     = $this->_getConfig('title_invert_color_tech', 1, false,$wonder,$store_id);     
                      $page_pad               = explode(',', trim($this->_getConfig('page_pad_tech', '0,0',false,$wonder,$store_id))); 
                      $fill_product_header_yn = $this->_getConfig('fill_product_header_yn_tech', 0,false,$wonder,$store_id);
                  }
                  elseif($page_template == 'bringup') 
                  {
                      $title_invert_color		= $this->_getConfig('title_invert_color_bringup', 1, false,$wonder,$store_id);     
                      $page_pad               = explode(',', trim($this->_getConfig('page_pad_bringup', '0,0',false,$wonder,$store_id))); 
                      $fill_product_header_yn = $this->_getConfig('fill_product_header_yn_bringup', 0,false,$wonder,$store_id);
                      $logo_position          = 'right';
                      $mailer_padding         = explode(',', trim($this->_getConfig('mailer_padding_bringup', '0,0,0',false,$wonder,$store_id))); 
                  }
                  elseif($page_template == 'mailer') 
                  {
                      $title_invert_color     = $this->_getConfig('title_invert_color_mailer', 1, false,$wonder,$store_id);     
                      $page_pad               = explode(',', trim($this->_getConfig('page_pad_mailer', '0,0',false,$wonder,$store_id))); 
                      $fill_product_header_yn = $this->_getConfig('fill_product_header_yn_mailer', 0,false,$wonder,$store_id);
                      $mailer_padding         = explode(',', trim($this->_getConfig('mailer_padding', '0,0,0',false,$wonder,$store_id))); 
                  }
                  else
                  {
                      $custom_message_image_line_yn = 0;
                  }
                  $page_pad_leftright = $page_pad[0];
                  $page_pad_topbottom = $page_pad[1];
                  
                  if($page_size == 'letter') 
                  {
                      // 792 x 612
                      $page_top 		= (770-$page_pad_topbottom);
                      $padded_right 	= (594-$page_pad_leftright);
                      $padded_left 	= (20+$page_pad_leftright); //562 usable
                  }
                  elseif($page_size == 'a4') 
                  {
                      // 595 pt x 842 pt
                      $page_top 		= (820-$page_pad_topbottom);
                      $padded_right 	= (577-$page_pad_leftright);
                      $padded_left 	= (20+$page_pad_leftright);
                  }
                  elseif($page_size == 'a5landscape') 
                  {
                      // 420 pt x 595 pt (flipped)
                      $page_top 		= (395-$page_pad_topbottom);
                      $padded_right 	= (577-$page_pad_leftright);
                      $padded_left 	= (20+$page_pad_leftright);
                  }
                  
                  if($custom_title_yn == 0) 
                  {
                      if($invoice_or_pack == 'pack') $invoice_title = 'Packing Sheet';
                      elseif($invoice_or_pack == 'invoice') $invoice_title = 'Invoice    ';
                      $order_or_invoice     	= 'order';
                      $invoice_title_2_yn 	= 0;
                      $title_date_xpos 		= 'auto';
                      $order_or_invoice_date 	= 'order';
                  }
                                          
                  if($page_template == 'tech') 
                  {
                      $custom_title_yn 		= 1;
                      $shipping_billing_title_position = 'beside';                            
                      if($title_date_xpos == 'auto' || $title_date_xpos < 100) $title_date_xpos = 350;
                  }
                  
                  $invoice_title_2            = trim($this->_getConfig('pickpack_title_2', '', false,$wonder,$store_id));
                  if($invoice_title_2_yn == 0) $invoice_title_2 = '';
                  $title2XY                   = explode(",", $this->_getConfig('pickpack_nudge_title', $title2XYDefault,true,$wonder,$store_id));               
                  
                   $non_standard_characters   = $this->_getConfig('non_standard_characters', 0, false,'general',$store_id);
                  
                  
                  $first_item_title_shift     = 0;
                  if($prices_yn != '0')
                  { 
                      $first_item_title_shift = -13;
                  }
                  
                  $gift_message_yn        = $this->_getConfig('gift_message_yn', 'yesunder', false,$wonder,$store_id);
                  if($gift_message_yn != 'no' || $prices_hideforgift_yn == 1)
                  { 
                      $gift_message_item 	= Mage::getModel('giftmessage/message');
                      $gift_message_id 	= $order->getGiftMessageId();
                      
                      if(!is_null($gift_message_id)) 
                      {
                          // hide prices if set to hide prices on gift order
                          if($prices_hideforgift_yn == 1) $prices_yn = 0;
                      }
                  }

                  $giftWrap_info = array();
                  $giftWrap_info['wrapping_paper'] = NULL;
                  $giftWrap_info['message'] = NULL;
                  
                  if(isInstalled('Xmage_GiftWrap') || isInstalled('Magestore_Giftwrap'))
                  {	
	if(isInstalled('Magestore_Giftwrap'))
	{
		$giftWrapInfos 		= Mage::getModel('giftwrap/giftcard')
							->getCollection()
							->addFieldToFilter('store_id','0')
							;
		foreach($giftWrapInfos as $info)
		{
			$giftWrap_info['message'] .= $info->getData('message');
			$giftWrap_info['wrapping_paper'] .= str_ireplace(array('.jpg','.jpeg','.gif','.png'),'',$info->getData('image'));
		}
		/*
			[giftcard_id] => 1
		            [status] => 1
		            [name] => Test Gift Card
		            [image] => Test gift image.png
		            [price] => 1.5000
		            [store_id] => 0
		            [message] => 
		            [character] => 200
		            [option_id] => 1
		            [default_name] => 1
		            [default_price] => 1
		            [default_image] => 1
		            [default_sort_order] => 1
		            [default_message] => 1
		            [default_status] => 1
		            [default_character] => 1
		*/				
	}
	elseif(isInstalled('Xmage_GiftWrap') && (Mage::getModel('giftwrap/order')))
                      {
                          /*
                              ["entity_id"]=>"2"
                              ["order_id"]=>"181"
                              ["message"]=>"happy birthday"
                              ["items"]=>"981"
                              ["fee"]=>"0"
                              ["giftbox_image"]=>"xmage_giftwrap/Screen shot 2011-09-06 at 2.33.42 PM.png"
                              ["giftcard_image"]=>"xmage_giftwrap/gift_card/giftwrap2.jpg"
                              ["giftcard_html"]=>"<div style="position: relative;"><p>Test content</p><div id="gift-textbox" class="drsElement drsMoveHandle" style="visibility: visible;position: absolute;width:100px; height:100px; top:10px; left:10px;"><div id="gift-content">happy birthday</div></div></div>"
                          */
                        // zzzz  
		$orderId 		= $order->getId();
                          $giftWrapInfos 	= Mage::getModel('giftwrap/order')->getCollection()->addFieldToFilter('order_id',$orderId);//
		foreach($giftWrapInfos as $info)
		{
			$giftWrap_info['message'] .= $info->getData('message');
			if(isset($giftWrap_info['wrapping_paper'])) $giftWrap_info['wrapping_paper'] .= ' | ';
			$giftWrap_info['wrapping_paper'] .= trim(str_ireplace(array('xmage_giftwrap/','.jpg','.jpeg','.gif','.png'),'',$info->getData('giftbox_image')));
		}
	}
	
	unset($giftWrapInfos);
	if(trim($giftWrap_info['wrapping_paper']) != '' && $prices_hideforgift_yn == 1) $prices_yn = 0;
                  }
                  
                  $giftMessageXY              	= explode(",", $this->_getConfig('gift_message_nudge', $giftMessageXYDefault,true,$wonder,$store_id));               

                  $notes_yn_pre                	= $this->_getConfig('notes_yn_pre', '0', false,$wonder,$store_id);
                  $notes_yn                    	= $this->_getConfig('notes_yn', 'yesemail', false,$wonder,$store_id);
                  if($notes_yn_pre == 0) $notes_yn = 'no';
                  $notes_filter                	= trim(strtolower($this->_getConfig('notes_filter', '', false,$wonder,$store_id)));
                  // replace single or double quotes and ensure that they must match:
$notes_filter = preg_replace('/^([\'"])(.*)\\1$/', '\\2', $notes_filter);
$notes_filter_options        	= $this->_getConfig('notes_filter_options', '', false,$wonder,$store_id);
                  if($notes_filter_options != 'yestext') $notes_filter = '';
                  $notesXY                     	= explode(",", $this->_getConfig('notes_nudge', $notesXYDefault,true,$wonder,$store_id));               

                  $packed_by_yn                	= $this->_getConfig('packed_by_yn', 0, false,$wonder,$store_id);
                  $packedByXY                  	= explode(",", $this->_getConfig('packed_by_nudge', $packedByXYDefault,true,$wonder,$store_id));               
                  
                  $product_qty_upsize_yn        	= $this->_getConfig('product_qty_upsize_yn', 0, false,$wonder,$store_id);
                  $product_qty_underlined     	= 0;
                  $product_qty_red     			= 0;
                  if($product_qty_upsize_yn == 'u' || $product_qty_upsize_yn == 'c') 
                  {
                      if($product_qty_upsize_yn == 'c') $product_qty_red = 1;
                      $product_qty_upsize_yn 		= 1;
                      $product_qty_underlined 	= 1;
                  }
                  $boldLastAddressLineYN        	= $boldLastAddressLineYNDefault;
                   $font_size_returnaddresstop 	= 8;
                  $font_size_titles             	= 14;
                  $boxBkgColor                	= $boxBkgColorDefault;
                  
                  $font_style_shipping_billing_title = $this->_getConfig('font_style_shipping_billing_title', 'bold', false,'general',$store_id);
                  $font_family_header         	= $this->_getConfig('font_family_header', 'helvetica', false,'general',$store_id);
                  $font_style_header             	= $this->_getConfig('font_style_header', 'regular', false,'general',$store_id);
                  $font_size_header             	= $this->_getConfig('font_size_header', 16, false,'general',$store_id);
                  $font_color_header             	= trim($this->_getConfig('font_color_header', 'darkOliveGreen', false,'general',$store_id));

                  $font_family_subtitles         	= $this->_getConfig('font_family_subtitles', 'helvetica', false,'general',$store_id);
                  $font_style_subtitles         	= $this->_getConfig('font_style_subtitles', 'regular', false,'general',$store_id);
                  $font_size_subtitles         	= $this->_getConfig('font_size_subtitles', 15, false,'general',$store_id);
                  $font_color_subtitles         	= trim($this->_getConfig('font_color_subtitles', '#222222', false,'general',$store_id));
                  $background_color_subtitles 	= trim($this->_getConfig('background_color_subtitles', '#5BA638', false,'general',$store_id));
                  $background_color_subtitles_zend = new Zend_Pdf_Color_Html($background_color_subtitles);
                  if($font_family_subtitles == 'custom')
                  {
                      $font_filename     			= $this->_getConfig('font_custom_subtitles', '', false,'general',$store_id);
                      $sub_folder         		= 'custom_font';
                      $option_group         		= 'general';
                      if($font_filename)
                      {
                          $font_path = Mage::getStoreConfig('system/filesystem/media', $store_id) . '/moogento/pickpack/'.$sub_folder.'/' . $font_filename;
                          if (is_file($font_path)) 
                          {
                              // gonna pass the font file path through the style attribute
                              $font_style_subtitles   = $font_path;
                          }
                          else $font_family_subtitles = 'helvetica';
                      }
                  }
                  else $font_custom_subtitles    	= '';
                  
                  $font_family_company         	= $this->_getConfig('font_family_company', 'helvetica', false,'general',$store_id);
                  $font_style_company         	= $this->_getConfig('font_style_company', 'regular', false,'general',$store_id);
                  $font_size_company             	= $this->_getConfig('font_size_company', 8, false,'general',$store_id);
                  $font_color_company         	= trim($this->_getConfig('font_color_company', '#222222', false,'general',$store_id));
                  if($font_family_company == 'custom')
                  {
                      $font_filename     			= $this->_getConfig('font_custom_company', '', false,'general',$store_id);
                      $sub_folder         		= 'custom_font';
                      $option_group         		= 'general';
                      if($font_filename)
                      {
                          $font_path = Mage::getStoreConfig('system/filesystem/media', $store_id) . '/moogento/pickpack/'.$sub_folder.'/' . $font_filename;
                          if (is_file($font_path)) 
                          {
                              // gonna pass the font file path through the style attribute
                              $font_style_company = $font_path;
                          }
                          else $font_family_company = 'helvetica';
                      }
                  }
                  else $font_custom_company    	= '';    

                  $font_family_message         	= $this->_getConfig('font_family_message', 'helvetica', false,'general',$store_id);
                  $font_style_message         	= $this->_getConfig('font_style_message', 'italic', false,'general',$store_id);
                  $font_size_message             	= $this->_getConfig('font_size_message', 10, false,'general',$store_id);
                  $font_color_message         	= trim($this->_getConfig('font_color_message', '#222222', false,'general',$store_id));
                  $background_color_message     	= trim($this->_getConfig('background_color_message', '#5BA638', false,'general',$store_id));
                  $background_color_message_zend 	= new Zend_Pdf_Color_Html($background_color_message);
                  
				$font_family_comments         	= $this->_getConfig('font_family_comments', 'helvetica', false,'general',$store_id);
                  $font_style_comments         	= $this->_getConfig('font_style_comments', 'regular', false,'general',$store_id);
                  $font_size_comments             	= $this->_getConfig('font_size_comments', 9, false,'general',$store_id);
                  $font_color_comments         	= trim($this->_getConfig('font_color_comments', '#222222', false,'general',$store_id));
                  $background_color_comments_pre     	= trim($this->_getConfig('background_color_comments', 'skyblue', false,'general',$store_id));
                  $background_color_comments 	= new Zend_Pdf_Color_Html($background_color_comments_pre);

                  $font_family_gift_message     	= $this->_getConfig('font_family_gift_message', 'helvetica', false,'general',$store_id);
                  $font_style_gift_message     	= $this->_getConfig('font_style_gift_message', 'italic', false,'general',$store_id);
                  $font_size_gift_message     	= $this->_getConfig('font_size_gift_message', 12, false,'general',$store_id);
                  $font_color_gift_message     	= trim($this->_getConfig('font_color_gift_message', '#222222', false,'general',$store_id));
                  $background_color_gift_message 	= trim($this->_getConfig('background_color_gift_message', '#5BA638', false,'general',$store_id));
                  $background_color_gift_message_zend = new Zend_Pdf_Color_Html(''.$background_color_gift_message.'');

                  $font_family_body             	= $this->_getConfig('font_family_body', 'helvetica', false,'general',$store_id);
                  $font_style_body             	= $this->_getConfig('font_style_body', 'regular', false,'general',$store_id);
                  $font_size_body             	= $this->_getConfig('font_size_body', 10, false,'general',$store_id);
                  $font_color_body             	= trim($this->_getConfig('font_color_body', 'Black', false,'general',$store_id));

                  $barcode_type        = $this->_getConfig('font_family_barcode', 'code128', false,'general',$store_id);

				// for width calculations, assuming helvetica...
				$font_helvetica       = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);

				switch ($barcode_type) 
				{
					case 'code128':
					$font_family_barcode 	= 'Code128bWin.ttf';
					break;

					case 'code39':
					$font_family_barcode 	= 'CODE39.ttf';								
					break;	

					case 'code39x':
					$font_family_barcode 	= 'CODE39X.ttf';
					break;

					default:
					$font_family_barcode 	= 'Code128bWin.ttf';
					break;
				}

                  $font_size_options            	= $this->_getConfig('font_size_options', 8, false,'general',$store_id);
              
                  if($non_standard_characters == 'msgothic')
                  {
                      $font_family_body 			= 'msgothic';
                      $font_family_header 		= 'msgothic';
                      $font_family_gift_message 	= 'msgothic';
                      $font_family_message 		= 'msgothic';
                      $font_family_comments 		= 'msgothic';
                      $font_family_company 		= 'msgothic';
                      $font_family_subtitles 		= 'msgothic';
                      $non_standard_characters 	= 1;
                  }
                  elseif($non_standard_characters == 'tahoma')
                  {
                      $font_family_body 			= 'tahoma';
                      $font_family_header 		= 'tahoma';
                      $font_family_gift_message 	= 'tahoma';
                       $font_family_comments 		= 'tahoma';
                     $font_family_message 		= 'tahoma';
                      $font_family_company 		= 'tahoma';
                      $font_family_subtitles 		= 'tahoma';
                      $non_standard_characters 	= 1;
                  }
                  elseif($non_standard_characters == 'garuda')
                  {
                      $font_family_body 			= 'garuda';
                      $font_family_header 		= 'garuda';
                      $font_family_gift_message 	= 'garuda';
                       $font_family_comments 		= 'garuda';
                     $font_family_message 		= 'garuda';
                      $font_family_company 		= 'garuda';
                      $font_family_subtitles 		= 'garuda';
                      $non_standard_characters 	= 1;
                  }
                  elseif($non_standard_characters == 'sawasdee')
                  {
                      $font_family_body 			= 'sawasdee';
                      $font_family_header 		= 'sawasdee';
                      $font_family_gift_message 	= 'sawasdee';
                       $font_family_comments 		= 'sawasdee';
                     $font_family_message 		= 'sawasdee';
                      $font_family_company 		= 'sawasdee';
                      $font_family_subtitles 		= 'sawasdee';
                      $non_standard_characters 	= 1;
                  }
                  elseif($non_standard_characters == 'kinnari')
                  {
                      $font_family_body 			= 'kinnari';
                      $font_family_header 		= 'kinnari';
                      $font_family_gift_message 	= 'kinnari';
                      $font_family_comments 		= 'kinnari';
                      $font_family_message 		= 'kinnari';
                      $font_family_company 		= 'kinnari';
                      $font_family_subtitles 		= 'kinnari';
                      $non_standard_characters 	= 1;
                  }
                  elseif($non_standard_characters == 'purisa')
                  {
                      $font_family_body 			= 'purisa';
                      $font_family_header 		= 'purisa';
                      $font_family_gift_message 	= 'purisa';
                      $font_family_comments 		= 'purisa';
                      $font_family_message 		= 'purisa';
                      $font_family_company 		= 'purisa';
                      $font_family_subtitles 		= 'purisa';
                      $non_standard_characters 	= 1;
                  }
              
                  $background_color_product_temp 		= trim($this->_getConfig('background_color_product', '#FFFFFF', false,'general',$store_id));
                  $background_color_product     		= new Zend_Pdf_Color_Html($background_color_product_temp);

                  $background_color_vert_product_temp	= '#FFFFFF';
                  $background_color_vert_product     	= new Zend_Pdf_Color_Html($background_color_vert_product_temp);
                  
                  $product_images_line_nudge          = trim($this->_getConfig('product_images_line_nudge', 0, false,$wonder,$store_id));
                  if($product_images_line_nudge  > 0) $product_images_line_nudge  = -abs($product_images_line_nudge);
                  if($product_images_yn == 0) $product_images_line_nudge = 0;
                  $product_images_border_color_temp   = strtoupper(trim($this->_getConfig('product_images_border_color', '#FFFFFF', false,$wonder,$store_id)));
                  $product_images_border_color        = new Zend_Pdf_Color_Html($product_images_border_color_temp);
                  $product_images_maxdimensions       = explode(',', str_ireplace('null','',$this->_getConfig('product_images_maxdimensions', '50,',false,$wonder,$store_id)));               
                  if($product_images_maxdimensions[0] == '' || $product_images_maxdimensions[1] == '')
                  {
                      if($product_images_maxdimensions[0] == '') $product_images_maxdimensions[0] = NULL;
                      if($product_images_maxdimensions[1] == '') $product_images_maxdimensions[1] = NULL;
                      if($product_images_maxdimensions[0] == NULL && $product_images_maxdimensions[1] == NULL) $product_images_maxdimensions[0] = 50;
                  }
                  
                  $font_color_header_zend     = new Zend_Pdf_Color_Html($font_color_header);    
                  $font_color_subtitles_zend  = new Zend_Pdf_Color_Html($font_color_subtitles);    
                  $font_color_body_zend       = new Zend_Pdf_Color_Html($font_color_body);

                  $shelving_yn                = $this->_getConfig('shelving_yn', 0, false,$wonder,$store_id);
                  $shelving_attribute         = trim($this->_getConfig('shelving', '', false,$wonder,$store_id));            
                  if($shelving_attribute == '' || $shelving_real_yn == 0) $shelving_yn = 0;
                  if($shelving_yn == 0) $shelving_attribute = null;
                  $shelving_title             = $this->_getConfig('shelving_title', '', false,$wonder,$store_id);
                  $shelving_title             = trim(str_ireplace(array('blank',"'"),'',$shelving_title));

                  $shelving_2_yn              = $this->_getConfig('shelving_2_yn', 0, false,$wonder,$store_id);
                  $shelving_2_attribute       = trim($this->_getConfig('shelving_2', '', false,$wonder,$store_id));
                  if($shelving_2_attribute == '' || $shelving_real_yn == 0) $shelving_2_yn = 0;
                  $shelving_2_title           = $this->_getConfig('shelving_2_title', '', false,$wonder,$store_id);
                  $shelving_2_title           = trim(str_ireplace(array('blank',"'"),'',$shelving_2_title));

                  // test for addresses
                  $has_shipping_address 	= false;
                  $has_billing_address 	= false;
                  foreach ($order->getAddressesCollection() as $address) 
                  {
                          if ($address->getAddressType() == 'shipping' && !$address->isDeleted()) {
                              $has_shipping_address = true;
                          }
                          elseif ($address->getAddressType() == 'billing' && !$address->isDeleted()) {
                              $has_billing_address = true;
                          }
                  }
                  
                  $shipment_details_yn                = $this->_getConfig('shipment_details_yn', 0, false,$wonder,$store_id);
                  $shipment_details_boxes_yn          = $this->_getConfig('shipment_details_boxes_yn', 0, false,$wonder,$store_id);
                  $shipment_details_boxes_weightsplit	= $this->_getConfig('shipment_details_boxes_weightsplit', 20, false,$wonder,$store_id);

                  $shipment_details_weight    		= $this->_getConfig('shipment_details_weight', 0, false,$wonder,$store_id);
                  $shipment_details_weight_unit 		= $this->_getConfig('shipment_details_weight_unit', 'kg', false,$wonder,$store_id);
                  
                  $shipment_details_carrier    		= $this->_getConfig('shipment_details_carrier', 0, false,$wonder,$store_id);
                  if($shipment_details_carrier == 'filtered_by_pallet')
                  {
                      $shipment_details_pallet_weight = trim($this->_getConfig('shipment_details_pallet_weight', 500, false,$wonder,$store_id));
                  }
                  else $shipment_details_pallet_weight = 0;
                  $shipment_details_payment    		= $this->_getConfig('shipment_details_payment', 0, false,$wonder,$store_id);
                  $shipment_details_purchase_order 	= $this->_getConfig('shipment_details_purchase_order', 0, false,$wonder,$store_id);
                  if($shipment_details_payment == 0) $shipment_details_purchase_order = 0;
                  $shipment_details_custgroup			= $this->_getConfig('shipment_details_custgroup', 0, false,$wonder,$store_id);
                  $shipment_details_customer_id		= $this->_getConfig('shipment_details_customer_id', 0, false,$wonder,$store_id);
                  $shipment_details_count        		= $this->_getConfig('shipment_details_count', 0, false,$wonder,$store_id);
                  $customer_group_filter         		= $this->_getConfig('shipment_details_custgroup_filter', 0, false,$wonder,$store_id);
                  $customer_group_filter         		= trim(strtolower($customer_group_filter));
                  $shipment_details_custom_attribute_yn    	= $this->_getConfig('shipment_details_custom_attribute_yn', 0, false,$wonder,$store_id);
                  $shipment_details_custom_attribute        	= trim($this->_getConfig('shipment_details_custom_attribute', '', false,$wonder,$store_id));
                  if($shipment_details_custom_attribute == '') $shipment_details_custom_attribute_yn = 0;
                  $shipment_details_custom_attribute_2_yn    	= $this->_getConfig('shipment_details_custom_attribute_2_yn', 0, false,$wonder,$store_id);
                  $shipment_details_custom_attribute_2    	= trim($this->_getConfig('shipment_details_custom_attribute_2', '', false,$wonder,$store_id));
                  if($shipment_details_custom_attribute_2 == '') $shipment_details_custom_attribute_2_yn = 0;
                  if($shipment_details_custom_attribute_yn == 0)
                  {
                      $shipment_details_custom_attribute      = '';
                      $shipment_details_custom_attribute_2_yn	= 0;
                      $shipment_details_custom_attribute_2    = '';
                  }
                  if($shipment_details_custom_attribute_2_yn == 0)
                  {
                      $shipment_details_custom_attribute_2    = '';
                  }
                  $shipment_details_deadline_yn    = $this->_getConfig('shipment_details_deadline_yn', 0, false,$wonder,$store_id);
                  $shipment_details_deadline_text  = trim($this->_getConfig('shipment_details_deadline_text', '', false,$wonder,$store_id));
                  $shipment_details_deadline_days  = trim($this->_getConfig('shipment_details_deadline_days', 0, false,$wonder,$store_id));
                  if($shipment_details_deadline_yn == 0)
                  {
                      $shipment_details_deadline_text = '';
                      $shipment_details_deadline_days = 0;
                  }

                  $configurable_names         = $this->_getConfig('pack_configname', 'simple', false,$wonder,$store_id); //col/sku
                  $columnYNudge               = $columnYNudgeDefault;
                  $showBarCode                = $this->_getConfig('pickpack_packbarcode', 0, false,$wonder,$store_id); 
                  $shipaddress_packbarcode_yn = $this->_getConfig('shipaddress_packbarcode_yn', 0, false,$wonder,$store_id); 
                  $shipaddress_title          = $this->_getConfig('shipaddress_title', '', false,$wonder,$store_id); 
      
                  $barcodeXY                  = explode(',', $barcodeXYDefault);               
                  $orderDateXY                = explode(',', $orderDateXYDefault);
                  $orderIdXY                  = explode(',', $orderIdXYDefault);  
                  $addressXY                  = explode(",", $addressXYDefault);
                  $addressFooterXY            = explode(",", $this->_getConfig('pickpack_shipaddress', $addressFooterXYDefault,true,$wonder,$store_id));
                  $addressFooterXY_xtra       = explode(",", $this->_getConfig('pickpack_shipaddress_xtra', $addressFooterXYDefault_xtra,true,$wonder,$store_id));
                  $font_size_shipaddress_xtra = $this->_getConfig('pickpack_shipfont_xtra', 8, false,$wonder,$store_id);
                  $flat_address_margin_rt_xtra = $this->_getConfig('flat_address_margin_rt_xtra', 0, true,$wonder,$store_id);

            
                  $orderIdXY[1] 				= ($page_top - 5 - 41 - 32);
                if($background_color_subtitles == '#FFFFFF') 
                  {
                      $orderIdXY[0] -= 11;
                      $orderIdXY[1] += 11;
                      $addressXY[0] -= 15;
                      $addressXY[1] += 10;
                  }
                  $datebar_start_y 			= $orderIdXY[1];
                      
					$shipping_title             = trim($this->_getConfig('shipping_title', '', false,$wonder,$store_id));
					$product_options_title      = trim($this->_getConfig('product_options_title', '', false,$wonder,$store_id));      
					$images_title               = trim($this->_getConfig('images_title', '', false,$wonder,$store_id));  
					$qty_title                  = trim($this->_getConfig('qty_title', '', false,$wonder,$store_id));            
					$price_title                = trim($this->_getConfig('price_title', '', false,$wonder,$store_id));            
					$tax_title                  = trim($this->_getConfig('tax_title', '', false,$wonder,$store_id));            
					$total_title                = trim($this->_getConfig('total_title', '', false,$wonder,$store_id));            

                   if($tax_yn == 'yesboth') 
                  {
                       $tax_title             = trim($this->_getConfig('tax_title_both', '', false,$wonder,$store_id));            
                      $tax_label              = trim($this->_getConfig('tax_label_both', '', false,$wonder,$store_id));
                  }
                  elseif($tax_yn == 'yessubtotal') 
                  {
                      $tax_label              = trim($this->_getConfig('tax_label_subtotal', '', false,$wonder,$store_id));
                  }
                  
                  $product_options_yn         = $this->_getConfig('product_options_yn', 'no',false,$wonder,$store_id);            
                  $billing_details_yn         = $this->_getConfig('billing_details_yn', 0, false,$wonder,$store_id);  
                  $shipping_details_yn        = $this->_getConfig('shipping_details_yn', 1, false,$wonder,$store_id);  
                  $billing_tax_details_yn		= $this->_getConfig('billing_tax_details_yn', '',false,$wonder,$store_id);  
                  $billing_details_position 	= $this->_getConfig('billing_details_position', 0,false,$wonder,$store_id); 
                  $billing_title              = trim($this->_getConfig('billing_title', '', false,$wonder,$store_id));

                  if($shipping_details_yn    == 0) $shipping_title = null;
                  if($has_billing_address === false) $billing_details_yn = 0;
                  if($billing_details_yn == 0) 
                  {
                      $billing_tax_details_yn = 0;
                      $billing_details_position = 0;
                      $billing_title = '';
                  }
                  // if billing address set to yes, shipping set to no, and billing address set to be right-side, show on left
                  if(($billing_details_yn == 1) && ($shipping_details_yn    == 0)) $billing_details_position = 1;
                  if(($billing_details_yn == 0) && ($shipping_details_yn    == 1)) $billing_details_position = 0;
                  
                  if(($page_template != 'tech') && ($shipping_billing_title_position == 'beside') && ($title_date_xpos < 100) && ($billing_details_yn == 1))
	{
	$title_date_xpos = 350;
}
                  

                  $cutoff_no          = $cutoff_noDefault;
                  

                  $taxEachX           = 0;
                  
                  if($prices_yn == 1 && $tax_col_yn == 1)
                  {
					$tickboxX       = $this->_getConfig('pricesT_tickboxX', 27, false,$wonder,$store_id);
					$skuX           = $this->_getConfig('pricesT_skuX', 10, false,$wonder,$store_id);
					$sku_barcodeX   = $this->_getConfig('pricesT_barcodeX', 10, false,$wonder,$store_id);
					$sku_barcodeX   = $this->_getConfig('pricesT_barcodeX', 10, false,$wonder,$store_id); 
					$productX       = $this->_getConfig('pricesT_productX', 10, false,$wonder,$store_id);
					$stockqtyX      = $this->_getConfig('pricesT_stockqtyX', 10, false,$wonder,$store_id);
					$shelfX         = $this->_getConfig('pricesT_shelfX', 10, false,$wonder,$store_id);
					$shelf2X        = $this->_getConfig('pricesT_shelf2X', 10, false,$wonder,$store_id);
					$shelf3X        = $this->_getConfig('pricesT_shelf2X', 10, false,$wonder,$store_id);
					$optionsX       = $this->_getConfig('pricesT_optionsX', 0, false,$wonder,$store_id);
					$qtyX           = $this->_getConfig('pricesT_qty_priceX', 10, false,$wonder,$store_id);
					$imagesX        = $this->_getConfig('pricesT_images_priceX', 50, false,$wonder,$store_id);
					$priceX         = $this->_getConfig('pricesT_priceX', 10,false,$wonder,$store_id);
					if($tax_yn == 'yesboth') $taxEachX = $this->_getConfig('pricesT_item_taxX_both', 0,false,$wonder,$store_id);
					else  $taxEachX = $this->_getConfig('pricesT_item_taxX', 0,false,$wonder,$store_id);
					$priceEachX     = $this->_getConfig('pricesT_item_priceX', 10,false,$wonder,$store_id);
                  }
                  elseif($prices_yn == 1)
                  {
	$tickboxX       = $this->_getConfig('pricesY_tickboxX', 27, false,$wonder,$store_id);
	$skuX           = $this->_getConfig('pricesY_skuX', 10, false,$wonder,$store_id);
	$sku_barcodeX   = $this->_getConfig('pricesY_barcodeX', 10, false,$wonder,$store_id);
	$stockqtyX   = $this->_getConfig('pricesY_stockqtyX', 10, false,$wonder,$store_id);
	$productX       = $this->_getConfig('pricesY_productX', 10, false,$wonder,$store_id);
	$shelfX         = $this->_getConfig('pricesY_shelfX', 10, false,$wonder,$store_id);
	$shelf2X        = $this->_getConfig('pricesY_shelf2X', 10, false,$wonder,$store_id);
	$shelf3X        = $this->_getConfig('pricesY_shelf3X', 10, false,$wonder,$store_id);
	$optionsX       = $this->_getConfig('pricesY_optionsX', 0, false,$wonder,$store_id);
	$qtyX           = $this->_getConfig('pricesY_qty_priceX', 50, false,$wonder,$store_id);
	$imagesX        = $this->_getConfig('pricesY_images_priceX', 10, false,$wonder,$store_id);
	$priceX         = $this->_getConfig('pricesY_priceX', 10,false,$wonder,$store_id);
	$taxEachX       = $this->_getConfig('pricesT_item_taxX', 0,false,$wonder,$store_id);
	$priceEachX     = $this->_getConfig('pricesY_item_priceX', 10,false,$wonder,$store_id);
                  }
                  else
                  {
	$tickboxX       = $this->_getConfig('pricesN_tickboxX', 27, false,$wonder,$store_id);
	$skuX           = $this->_getConfig('pricesN_skuX', 10, false,$wonder,$store_id);
	$sku_barcodeX	= $this->_getConfig('pricesN_barcodeX', 10, false,$wonder,$store_id);
	$stockqtyX		= $this->_getConfig('pricesN_stockqtyX', 10, false,$wonder,$store_id);
	$productX       = $this->_getConfig('pricesN_productX', 10, false,$wonder,$store_id);
	$shelfX         = $this->_getConfig('pricesN_shelfX', 10, false,$wonder,$store_id);
	$shelf2X        = $this->_getConfig('pricesN_shelf2X', 10, false,$wonder,$store_id);
	$shelf3X        = $this->_getConfig('pricesN_shelf3X', 10, false,$wonder,$store_id);
	$optionsX       = $this->_getConfig('pricesN_optionsX', 0, false,$wonder,$store_id);
	$qtyX           = $this->_getConfig('pricesN_qty_priceX', 10, false,$wonder,$store_id);
	$imagesX        = $this->_getConfig('pricesN_images_priceX', 50, false,$wonder,$store_id);
	$priceX         = $this->_getConfig('pricesY_priceX', 10,false,'wonder');
	$taxEachX       = $this->_getConfig('pricesT_item_taxX', 0,false,$wonder,$store_id);
                  }
                  
                  $columns_xpos_array = array();
                  $columns_xpos_array['tickboxX'] = $tickboxX;
if($product_sku_yn == 1) 			$columns_xpos_array['skuX'] = $skuX;
if($product_sku_barcode_yn == 1) 	$columns_xpos_array['sku_barcodeX'] = $sku_barcodeX;
$columns_xpos_array['stockqtyX'] = $stockqtyX;
$columns_xpos_array['productX'] = $productX;
if($shelving_real_yn == 1) 			$columns_xpos_array['shelfX'] = $shelfX;
if($shelving_yn == 1) 				$columns_xpos_array['shelf2X'] = $shelf2X;
if($shelving_2_yn == 1) 			$columns_xpos_array['shelf3X'] = $shelf3X;
$columns_xpos_array['optionsX'] = $optionsX;
$columns_xpos_array['qtyX'] = $qtyX;
if($product_images_yn == 1) 		$columns_xpos_array['imagesX'] = $imagesX;
if($prices_yn == 1) 				$columns_xpos_array['priceX'] = $priceX;
if($tax_col_yn == 1) 				$columns_xpos_array['taxEachX'] = $taxEachX;

asort($columns_xpos_array);


                  $orderdetailsX                 = 304;
                  if($shipping_billing_title_position == 'beside' && $title_date_xpos != 'auto') $orderdetailsX = $title_date_xpos;
      
                  $userId                     = Mage::getSingleton('admin/session')->getUser() ? Mage::getSingleton('admin/session')->getUser()->getId(): 0;
                  $user                       = ($userId !== 0) ? Mage::getModel('admin/user')->load($userId): '';
                  $username                   = (!empty($user['username'])) ? $user['username']:'';

                  $supplier_login_pre         = $this->_getConfig('pickpack_supplier_login', '', false,'general',$store_id);
                  $supplier_login_pre         = str_replace(array("\n",','),';',$supplier_login_pre);
                  $supplier_login_pre         = explode(';',$supplier_login_pre);

                  foreach($supplier_login_pre as $key => $value)
                  {
                      $supplier_login_single = explode(':',$value);
                      if(preg_match('~'.$username.'~i',$supplier_login_single[0])) 
                      {
                          if(isset($supplier_login_single[1]) && $supplier_login_single[1] != 'all') $supplier_login = trim($supplier_login_single[1]);
                          else $supplier_login = '';
                      }
                  }

                  $tickbox                     	= $this->_getConfig('pickpack_tickbox', $tickbox_default, false,'general',$store_id);
                  $override_address_format_yn 	= 1;
                  $customer_email_yn             	= $this->_getConfig('customer_email_yn', 0,false,'general',$store_id);
                  $customer_phone_yn             	= $this->_getConfig('customer_phone_yn', 0,false,'general',$store_id);
                  $address_format             	= $this->_getConfig('address_format', '', false,'general',$store_id); //col/sku
                  $address_countryskip          	= trim(strtolower($this->_getConfig('address_countryskip', 0,false,'general',$store_id)));              
                  $bottom_shipping_address_yn 	= $this->_getConfig('pickpack_bottom_shipping_address_yn', 0,false,$wonder,$store_id);              
                  $bottom_shipping_address_yn_xtra 	= $this->_getConfig('pickpack_bottom_shipping_address_yn_xtra', 0,false,$wonder,$store_id);              
                  $bottom_shipping_address_id_yn 	= $this->_getConfig('pickpack_bottom_shipping_address_id_yn', 1,false,$wonder,$store_id);              
                  $return_address_yn            	= $this->_getConfig('pickpack_return_address_yn', 0,false,$wonder,$store_id);              
                  if($page_size == 'a5landscape')
                  {         
                      $bottom_shipping_address_yn = 0;
                      $return_address_yn 			= 0;
                  }
                  if($return_address_yn == 0) 
{
	$show_return_logo_yn = '0';
}
                  if($bottom_shipping_address_yn == 0) 
                  {
                      $shipaddress_packbarcode_yn 	= 0;
                      $shipaddress_title             	= '';
                      $show_shipping_logo_yn        	= 0;
	$bottom_shipping_address_id_yn	= 0;
                  }
                  
                  if($return_address_yn == 'yesgroup')
                  {
                      $return_address_group1      = $this->_getConfig('pickpack_return_address_group1', '',false,$wonder,$store_id);
                      $return_address_group2      = $this->_getConfig('pickpack_return_address_group2', '',false,$wonder,$store_id);
                      $return_address_group3      = $this->_getConfig('pickpack_return_address_group3', '',false,$wonder,$store_id);
                      $return_address             = $this->_getConfig('pickpack_return_address_group_default', '',false,$wonder,$store_id);
                  
                      $font_size_returnaddress    = $this->_getConfig('pickpack_returnfont_group', 9, false,$wonder,$store_id);
                      $font_size_shipaddress      = $this->_getConfig('pickpack_shipfont_group', 15, false,$wonder,$store_id);
                      $show_return_logo_yn        = $this->_getConfig('pickpack_returnlogo_group', '', false,$wonder,$store_id);            
                      $returnAddressFooterXY      = explode(",", $this->_getConfig('pickpack_returnaddress_group', $returnAddressFooterXYDefault,true,$wonder,$store_id));
                      $return_logo_XY           	= explode(",", $this->_getConfig('pickpack_nudgelogo_group', $return_logo_XYDefault,true,$wonder,$store_id));                            
                  }
                  else
                  {
                      $return_address				= $this->_getConfig('pickpack_return_address', '',false,$wonder,$store_id);    
                      $return_address_group1      = '';
                      $return_address_group2      = '';
                      $return_address_group3      = '';
                      
                      $font_size_returnaddress	= $this->_getConfig('pickpack_returnfont', 9, false,$wonder,$store_id);
                      $font_size_shipaddress      = $this->_getConfig('pickpack_shipfont', 15, false,$wonder,$store_id);
                      $show_return_logo_yn        = $this->_getConfig('pickpack_returnlogo', '', false,$wonder,$store_id);            
                      $returnAddressFooterXY      = explode(",", $this->_getConfig('pickpack_returnaddress', $returnAddressFooterXYDefault,true,$wonder,$store_id));
                      $return_logo_XY            	= explode(",", $this->_getConfig('pickpack_nudgelogo', $return_logo_XYDefault,true,$wonder,$store_id));            
                  }
                  
                  $company_address_yn            = $this->_getConfig('pickpack_company_address_yn', 0,false,$wonder,$store_id);          

                  if($company_address_yn == 'yesgroup')
                  {
                      $company_address_group1        = $this->_getConfig('pickpack_company_address_group1', '',false,$wonder,$store_id);
                      $company_address_group2        = $this->_getConfig('pickpack_company_address_group2', '',false,$wonder,$store_id);
                      $company_address_group3        = $this->_getConfig('pickpack_company_address_group3', '',false,$wonder,$store_id);
                      $company_address               = $this->_getConfig('pickpack_company_address_group_default', '',false,$wonder,$store_id);
                  }
                  else
                  {
                      $company_address            = $this->_getConfig('pickpack_company_address', '',false,$wonder,$store_id);
                      $company_address_group1     = '';
                      $company_address_group2     = '';
                      $company_address_group3     = '';
                  }

                  $logo_maxdimensions             = explode(',','269,41');                                       
                  if($logo_position == 'fullwidth') 
                  {
                      $company_address_yn 	= 0;
                      $logo_maxdimensions    	= explode(',','556,41');               
                  }

                  if($logo_maxdimensions[0] == '' || $logo_maxdimensions[1] == '')
                  {
                      if($logo_maxdimensions[0] == '') $logo_maxdimensions[0] = NULL;
                      if($logo_maxdimensions[1] == '') $logo_maxdimensions[1] = NULL;
                      if($logo_maxdimensions[0] == NULL && $logo_maxdimensions[1] == NULL) $logo_maxdimensions[0] = 269;
                  }
                  
                  $float_top_address_yn        = 0;
                  if($logo_position == 'right')
                  {
                      $pickpack_company_address_logoright = $this->_getConfig('pickpack_company_address_logoright', '',false,$wonder,$store_id);
                      //$company_address        			= $pickpack_company_address_logoright;
                      if($page_template == 'bringup')
	{
		$float_top_address_yn = $this->_getConfig('float_top_address_yn', 0,false,$wonder,$store_id);
	}
                  }
                  else 
                  {
                      $pickpack_company_address_logoright = '';
                      $float_top_address_yn    			= 0;
                  }

if($company_address_yn === 0) $company_address = '';

                  if(($float_top_address_yn == 0) && ($page_template == 'bringup')) $mailer_padding = array(0,0,0);
                  
                  $page_1_products_y_cutoff    	= $this->_getConfig('page_1_products_y_cutoff', 0,false,$wonder,$store_id);
                  
                  $capitalize_label_yn        	= $this->_getConfig('capitalize_label_yn', 0,false,'general',$store_id);   // o,usonly,1           
                  $message_yn                    	= $this->_getConfig('custom_message_yn', '', false,$wonder,$store_id);
                  $custom_message_image_locked_yn = $this->_getConfig('custom_message_image_locked_yn', 0, false,$wonder,$store_id);
                  $custom_message_image_nudge 	= explode(',',trim($this->_getConfig('custom_message_image_nudge', '0,0', false,$wonder,$store_id)));

                  if($message_yn != 'yesimage') 
{
	$custom_message_image_locked_yn = 0;                        
	$custom_message_image_nudge = null;
}
                    $message_filter             = trim($this->_getConfig('custom_message_filter', '', false,$wonder,$store_id));
                    $message                    = trim($this->_getConfig('custom_message', '', false,$wonder,$store_id));
                    $custom_message_position    = array();
                  if($message_yn == 'yesbox') 
                  {
                      $message 					= trim($this->_getConfig('custom_message_yesbox', '', false,$wonder,$store_id));
                      $custom_message_position 	= explode(',',trim($this->_getConfig('custom_message_position', '300,200', false,$wonder,$store_id)));
                  }
                  $messageA               = trim($this->_getConfig('custom_messageA', '', false,$wonder,$store_id));
                    $messageB             = trim($this->_getConfig('custom_messageB', '', false,$wonder,$store_id));
                  if($message_yn == 'yes2') $message = $messageA;
                  if($message_yn == 'no' || $message_yn == 'yesimage')
                  {
                      $message 	= null; 
	$messageA 	= null; 
	$messageB 	= null;
                  }

                  $sort_packing_yn		= $this->_getConfig('sort_packing_yn', 1,false,'general',$store_id);               
                  $sort_packing           = $this->_getConfig('sort_packing', 'sku',false,'general',$store_id);               
                  $sortorder_packing      = $this->_getConfig('sort_packing_order', 'ascending',false,'general',$store_id);  
                  $sort_packing_attribute = null;
                  if($sort_packing == 'attribute')
                  {
                      $sort_packing_attribute        = trim($this->_getConfig('sort_packing_attribute', '',false,'general',$store_id));  
                      if($sort_packing_attribute != '') $sort_packing = $sort_packing_attribute;
                      else $sort_packing = 'sku';
                  }
                  if($sort_packing_yn == 0) $sortorder_packing = 'none';
                  
                  /**
                  end config    
                  */
                  //
              
                  if((isset($sku_supplier_item_action_master[$order_id]) && $sku_supplier_item_action_master[$order_id] == 'keep') || ($split_supplier_yn == 'no'))
                  {
                      if($first_page_yn == 'n') 
                      {
                          $page = $this->newPage();
                      }
                      else $first_page_yn = 'n';
                      
                      if(($logo_position == 'left') && ($page_size == 'letter'))
                      {
                          $x1 = $padded_left;
                          $y1 = ($page_top - 5 - $logo_maxdimensions[1]);
                          $x2 = ($padded_left + $logo_maxdimensions[0]);
                          $y2 = ($page_top - 5);
                      }
                      elseif(($logo_position == 'left') && ($page_size == 'a4'))
                      {
                          $x1 = $padded_left;
                          $y1 = ($page_top - 5 - $logo_maxdimensions[1]);
                          $x2 = ($padded_left + $logo_maxdimensions[0]);
                          $y2 = ($page_top - 5);
                      }
                      elseif(($logo_position == 'right') && ($page_size == 'letter'))
                      {
                          $x1 = ($padded_right - $logo_maxdimensions[0]);
                          $y1 = ($page_top - 5 - $logo_maxdimensions[1]);
                          $x2 = $padded_right;
                          $y2 = ($page_top - 5);
                      }
                      elseif(($logo_position == 'right') && ($page_size == 'a4'))
                      {
                          $x1 = ($padded_right - 289);
                          $y1 = ($page_top - 5 - $logo_maxdimensions[1]);
                          $x2 = $padded_right;
                          $y2 = ($page_top - 5);
                      }
                      elseif($logo_position == 'fullwidth')
                      {
                          $x1 = $padded_left;
                          $y1 = ($page_top - 5 - $logo_maxdimensions[1]);//784; 41?
                          $x2 = ($padded_left + $logo_maxdimensions[0]);
                          $y2 = ($page_top - 5);//825;
                      }
                      
                      # BARCODE
                      if(1 == $showBarCode){

		$barcode_font_size = 14;
		$barcode_fontsize_shiftleft = 0;
		if($barcode_type !== 'code128')
		{
			$barcode_font_size += 12;
			$barcode_fontsize_shiftleft += 75;
		}
		$long_barcode_shiftup = 0;
		$barcodeString_pre = $order->getRealOrderId();
                          $barcodeString = $this->convertToBarcodeString($barcodeString_pre,$barcode_type);
		$barcode_width_multiplier = 1.35;
		if(strlen($barcodeString_pre) > 11) 
		{
			if($barcode_type !== 'code128') $barcode_fontsize_shiftleft += 32;
			$barcode_width_multiplier = 1.19;
			$long_barcode_shiftup = 20;
			$barcode_fontsize_shiftleft += (((16-($barcode_font_size))*11)*1);
		}
		else
		{
			$barcode_fontsize_shiftleft += ((16-$barcode_font_size)*7);
		}	
		
                          $barcodeWidth = (($barcode_width_multiplier*$this->parseString($order_id,Zend_Pdf_Font::fontWithPath(dirname(__FILE__)  . '/' . $font_family_barcode), $barcode_font_size))-3+$barcode_fontsize_shiftleft);
                         
		$page->setFillColor($black_color);
                          $this->_setFontBold($page, 10);
                          //$barcodeString = $this->convertToBarcodeString($order->getRealOrderId());
		$page->setFont(Zend_Pdf_Font::fontWithPath(dirname(__FILE__)  . '/' . $font_family_barcode), $barcode_font_size); 
                          $page->drawText($barcodeString, ($padded_right-$barcodeWidth), ($y2-20+$long_barcode_shiftup), 'CP1252');
                          $page->setFillColor($black_color);
                          $this->_setFontRegular($page, $font_size_body);
                      }     
          
	if($invoice_title_2_yn == 1 && $invoice_title_2 != '')
                      {
                          $this->_setFont($page, $font_style_subtitles, $font_size_subtitles, $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                          $page->drawText($invoice_title_2, $title2XY[0], $title2XY[1], 'UTF-8');
                      }
          
                      $store = null;
                      if ($order->getStoreId()) {$store=$order->getStoreId();}
                      
                      if($show_top_logo_yn == 1)
                      {
                          $sub_folder 	= 'logo_pack';
                          $option_group 	= 'wonder';

                          if($wonder != 'wonder')
                          {
                              $sub_folder 	= 'logo_invoice';
                              $option_group 	= 'wonder_invoice';
                          }
                          
                          // header logo
                             if($beta_boxes_yn == 0) 
                          {
                              $sub_folder 	= 'logo_pack';
                              $option_group 	= 'wonder';

                              if($wonder != 'wonder')
                              {
                                  $sub_folder 	= 'logo_invoice';
                                  $option_group 	= 'wonder_invoice';
                              }
                              
                              
                              $packlogo_filename = Mage::getStoreConfig('pickpack_options/'.$option_group.'/pack_logo', $store);
                              if($packlogo_filename)
                              {
                                  $packlogo_path = Mage::getBaseDir('media') . '/moogento/pickpack/'.$sub_folder.'/' . $packlogo_filename;    
                                  
                                  if (is_file($packlogo_path)) 
                                  {    
                                      $img_width     		= $logo_maxdimensions[0];
                                      $img_height 		= $logo_maxdimensions[1];

                                      $imageObj 			= new Varien_Image($packlogo_path);
                                      $orig_img_width 	= $imageObj->getOriginalWidth();
                                      $orig_img_height 	= $imageObj->getOriginalHeight();
                          
                                      // image width = fixed
                                      if($orig_img_width > $logo_maxdimensions[0])
                                      {
                                          $img_height 	= ceil(($logo_maxdimensions[0]/$orig_img_width)*$orig_img_height);
                                          $img_width 		= $logo_maxdimensions[0];
                                      }
                              
                                      // $x1         		= $imagesX;
                                      $y1         		= ($y2 - $img_height);
                                      $x2         		= ($x1 + $img_width);
                                      // $y2         		= ($this->y + 5);
                                      $datebar_start_y = ($y1 - 30);
                                      
                                      if($datebar_start_y < $orderIdXY[1]) $orderIdXY[1] = $datebar_start_y;
                                  
                                      $packlogo = Zend_Pdf_Image::imageWithPath($packlogo_path);            
                                      $page->drawImage($packlogo, $x1, $y1, $x2, $y2);
                                      unset($packlogo);
                                      unset($packlogo_filename);
                                      unset($packlogo_path);
                                  }
                              }
                              
                             }
                          elseif($beta_boxes_yn == 1)
                          {
                              // 171 x 41
                              $sub_folder = 'beta_box_logo_pack';
                              $option_group = 'wonder';

                              if($wonder != 'wonder')
                              {
                                  $sub_folder = 'beta_box_logo_invoice';
                                  $option_group = 'wonder_invoice';
                              }
                              
                              $packlogo_filename = Mage::getStoreConfig('pickpack_options/'.$option_group.'/beta_box_logo', $store);
                              if($packlogo_filename)
                              {
                                  $packlogo_path = Mage::getBaseDir('media') . '/moogento/pickpack/'.$sub_folder.'/' . $packlogo_filename;
                                  
                                  if (is_file($packlogo_path)) 
                                  {    
                                      $packlogo = Zend_Pdf_Image::imageWithPath($packlogo_path);        
                                      $page->drawImage($packlogo, 158, $y1, 299, $y2);
                                  }
                              }    
                              unset($packlogo_filename);
                              unset($packlogo);
                              unset($packlogo_path);
                          }
                      }
                      
                      // draw box behind order ID#
                      if(strtoupper($background_color_subtitles) != '#FFFFFF')
                      {
                          $page->setFillColor($background_color_subtitles_zend);            
                          $page->setLineColor($background_color_subtitles_zend);
                          $page->setLineWidth(0.5);
                          if($page_template == 'tech') $page->drawRoundedRectangle($padded_left,($orderIdXY[1]-($font_size_subtitles/2)-2), $padded_right, ($orderIdXY[1]+$font_size_subtitles+2+2),array(6,6,0,0));        
                          elseif($fill_product_header_yn == 1)
						   {
								$page->drawRectangle($padded_left, ceil($orderIdXY[1]-($font_size_subtitles/2)), $padded_right, ceil($orderIdXY[1]+$font_size_subtitles+2));
							}
							else
							{
								$page->drawRectangle($padded_left, ceil($orderIdXY[1]-($font_size_subtitles/2)-3), $padded_right, ceil($orderIdXY[1]-($font_size_subtitles/2)-3));
							}
		
                      }

                      // header                            
                      $order_date = '';
                      if($order_or_invoice_date == 'order')
                      {
							if(($from_shipment != 'invoice') && ($order->getCreatedAtStoreDate()))
							{
								//date_format
								$order_date = 'n/a';
								$dated 				= $order->getCreatedAtStoreDate();
								$dated_timestamp 	= strtotime($dated);
								
								if($dated != '') // eg Packing Sheet from Invoices page = no date
								{
									$dated_timestamp 	= strtotime($dated);
									//$order_date 		= date($date_format,$dated_timestamp);
									if($dated_timestamp != false) 
									{
										$order_date = Mage::getModel('core/date')->date($date_format, $dated_timestamp);
									}
									else
									{
										$locale_timestamp = Mage::getModel('core/date')->timestamp(strtotime($order->getCreatedAt()));
										if($locale_timestamp != false) $order_date = Mage::getModel('core/date')->date($date_format, $locale_timestamp);
									}
								}								
							}
                      }
                      elseif($order_or_invoice_date == 'invoice')
                      {
                          if($order->getCreatedAtStoreDate())
                          {
                              $_invoices = $order->getInvoiceCollection();
								foreach($_invoices as $_invoice)
								{
									$invoiceIncrementId = $_invoice->getIncrementId();
									$invoice 			= Mage::getModel('sales/order_invoice')->loadByIncrementId($invoiceIncrementId);
									$dated 				= $invoice->getCreatedAt();
									if($dated != '') // eg Packing Sheet from Invoices page = no date
									{
										$dated_timestamp 	= strtotime($dated);
										$order_date 		= date($date_format,$dated_timestamp);
									}
									break;
								}
		                    
                          }
                      }
                      elseif($order_or_invoice_date == 'today')
                      {
                          $order_date = date($date_format, Mage::getModel('core/date')->timestamp(time()));
                      }
                          
                      // get shipping date
                      /*
                                  $ship_date_temp = Mage::getModel('sales/order')->loadByIncrementId($order_id);
                                  $shipdate = strtotime($ship_date_temp['updated_at']);
                                  $shipdateplus10 = ($shipdate+(60*60*24*10));                            
                                  $order_number_display = '#'.$order->getRealOrderId() . '  '.date('j M Y',$shipdate).'  :  '.date('j M Y',$shipdateplus10);
                      */
                      
                      $invoice_number_display = '';
                      $order_number_display     = '';
                      
                      foreach ($order->getInvoiceCollection() as $_tmpInvoice) 
                      {
                          if($_tmpInvoice->getIncrementId()) 
                          {
                              if($invoice_number_display != '') $invoice_number_display .= ',';
                              $invoice_number_display .= $_tmpInvoice->getIncrementId();
                          }
                          break;
                      }

                      if($order_or_invoice == 'order') $order_number_display = $order->getRealOrderId();
                      elseif($order_or_invoice == 'invoice' && $invoice_number_display != '') 
                      {
                          $order_number_display = $invoice_number_display;
                      }
                      
                      $this->_setFont($page, $font_style_subtitles, $font_size_subtitles, $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                      $orderIdXY[1] -= $mailer_padding[1];
                      
                      if($split_supplier_yn == 'pickpack')
                      {
                          $order_date .= '      Supplier: '.$supplier;
                           $title_date_xpos -= 50;
                      }
                      
                      $date_y = null;
                      if($title_date_xpos == 'auto' && $page_template != 'mailer')
                      {
                          $order_number_display .= '   '.$order_date;
                      }
                      elseif($page_template != 'mailer')
                      {
                          $page->drawText($order_date, $title_date_xpos, $orderIdXY[1], 'UTF-8');
                          $date_y = $orderIdXY[1];
                      }
                      
                      if($page_template == 'mailer')
                      {
                          $orderIdXY[1] += ($font_size_company*2);
                          $orderIdXY[0] = $padded_left;
                          $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles*1.4), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                      }
                      
                      if($invoice_title != '')
                      {
                          // If small logo, make sure Invoice Title/Date start below height of raised address (if address has been brought up)
                          if($float_top_address_yn == 1 && (($has_billing_address == 1) || ($has_shipping_address == 1)) && ($orderIdXY[1] > ($page_top - ($font_size_body * 15)))) $orderIdXY[1] = ($page_top - ($font_size_body * 15));
                          
                          $title_start_X = $orderIdXY[0];
                          $date_y = $orderIdXY[1];
                          
                          if($page_template == 'tech') $title_start_X = ($padded_left + ((strlen($shipping_title))*$font_size_subtitles*0.5));
                      
                          if($title_invert_color != 1)
                          {
                              $order_number_display = $invoice_title.'  '.$order_number_display;
                              $page->drawText($order_number_display, $title_start_X , $orderIdXY[1], 'UTF-8');
                          }
                          elseif($title_invert_color == 1)
                          {
                              $this->_setFont($page, $font_style_subtitles, $font_size_subtitles, $font_family_subtitles, $non_standard_characters, '#FFFFFF');
                              $page->drawText($invoice_title, $title_start_X, $orderIdXY[1], 'UTF-8');
                              $this->_setFont($page, $font_style_subtitles, $font_size_subtitles, $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                              $page->drawText($order_number_display, ($title_start_X +(($font_size_subtitles/2) * strlen($invoice_title))), $orderIdXY[1], 'UTF-8');
                          }
                      }
                      else $page->drawText($order_number_display, $orderIdXY[0], $orderIdXY[1], 'UTF-8');
                      
                      // if the 2nd page needs to be below the header (preprinted forms)
                      $items_header_top_firstpage = $orderIdXY[1];

	// HEADER STORE ADDRESS
                      $this->y = $y2-($font_size_company*0.5);
                      if( ($company_address_yn == 1) || ($company_address_yn == 'yesgroup') || ($return_address_yn == 1) || ($return_address_yn == 'yesgroup') )
                      {
		if(isInstalled('Moogento_ShipEasy') && is_object($order->getShippingAddress()) && $order->getShippingAddress()->getCountryId())
		{
			$customer_country = trim(Mage::app()->getLocale()->getCountryTranslation($order->getShippingAddress()->getCountryId()));
                          
			$us_array = array('usa','u.s.a.','united states','united states of america');
			$eu_array = array('uk','united kingdom','england','great britain','belgium','bulgaria','czech republic','denmark','germany','estonia','ireland','greece','spain','france','italy','cyprus','latvia','lithuania','luxembourg','hungary','malta','netherlands','austria','poland','portugal','romania','slovenia','slovakia','finland','sweden');
			$non_eu_array = array('albania','andorra','armenia','azerbaijan','belarus','bosnia and herzegovina','georgia','liechtenstein','moldova','monaco','norway','russia','san marino','serbia','switzerland','ukraine','vatican','vatican city state' );
			
                          	if(in_array(strtolower($customer_country),$eu_array)) 
                           {
                               if($company_address_yn == 'yesgroup')	$company_address 	= $company_address_group2; //EU
                               if($return_address_yn == 'yesgroup') 	$return_address 	= $return_address_group2; //EU
                           }
                           elseif(in_array(strtolower($customer_country),$non_eu_array)) 
                           {
                               if($company_address_yn == 'yesgroup') 	$company_address 	= $company_address_group2; // non_eu
                               if($return_address_yn == 'yesgroup')	$return_address 	= $return_address_group2; // non_eu
                           }
                           elseif(in_array(strtolower($customer_country),$us_array)) 
                           {
                               if($company_address_yn == 'yesgroup') 	$company_address 	= $company_address_group1; // USA
                               if($return_address_yn == 'yesgroup')	$return_address 	= $return_address_group1; // USA
                           }
                           elseif(stripos('australia',$customer_country) !== FALSE) 
                           {
                               if($company_address_yn == 'yesgroup') 	$company_address 	= $company_address_group3; //AUS
                               if($return_address_yn == 'yesgroup')	$return_address 	= $return_address_group3; //AUS
                           }
		}

                          if( ($company_address != '') && (($company_address_yn == 1) || ($company_address_yn == 'yesgroup')) )
                          {
                              // store-specific
                              $this->_setFont($page, $font_style_company, $font_size_company, $font_family_company, $non_standard_characters, $font_color_company);

                              $line_height = 1;
                              $company_x = 320;
                              $company_vert_line = true;
                          
                              if(($page_template == 'mailer') || ($logo_position == 'right'))
                              {
                                  $company_x = $padded_left;
                                  $company_vert_line = false;
                              }
              
                              foreach(explode("\n", $company_address) as $value)
                              {
                                  if($value!=='')
                                  {
                                      $page->drawText(trim(strip_tags($value)), $company_x, ($this->y-$line_height-1), 'UTF-8');
                                  }
                                  $line_height = ($line_height + $font_size_company);
                              }
                          
                              $address_top_y = null;
                              if($float_top_address_yn == 1) $float_top_address_y = ($this->y - ($line_height-($font_size_body * 2.5)));//float_top_address_yn
                              if($company_vert_line === true && (strtoupper($background_color_subtitles) != '#FFFFFF') && $logo_position == 'left')
                              {
                                  $page->setFillColor($background_color_subtitles_zend);            
                                  $page->setLineColor($background_color_subtitles_zend);
                                  $page->setLineWidth(0.5);            
                                  $page->drawRectangle(304, $y1, 316, $y2);
                                  //or:
                                  /*
                                      $company_line_height = ($line_height-$fontsize_returnaddresstop+2);
                                      if($company_line_height < 36) $company_line_height = 36;
                                      $page->drawRectangle(304, ($page_top-$company_line_height), 316, ($page_top+6));
                                  */
                              }
                              $this->_setFont($page, $font_style_subtitles, $font_size_subtitles, $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                          }
                      }
                      else $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
	// end
	
	
                      $customer_email     	= '';                        
                      $shipping_taxvat     	= '';
                      $customer_phone     	= '';
                      $customer_fax         	= '';
                      $customer_company		= '';
                      $customer_name         	= '';
                      $customer_firstname    	= '';
                      $customer_lastname     	= '';
                      $customer_name         	= '';
                      $customer_city         	= '';
                      $customer_postcode     	= '';
                      $customer_region     	= '';
                      $customer_region_code 	= '';
                      $customer_prefix     	= '';
                      $customer_suffix     	= '';
                      $customer_country     	= '';
                      $customer_street1     	= '';
                      $customer_street2     	= '';
                      $customer_street3     	= '';
                      $customer_street4     	= '';
                      $customer_street5     	= '';
                      $billing_taxvat     	= '';

                      if($has_shipping_address !== false) 
                      {
                          if($order->getShippingAddress()->getFax())          $customer_fax = trim($order->getShippingAddress()->getFax());
                          if($order->getShippingAddress()->getTelephone())    $customer_phone = trim($order->getShippingAddress()->getTelephone());
                          if($order->getShippingAddress()->getCompany())      $customer_company = trim($order->getShippingAddress()->getCompany());
                          if($order->getShippingAddress()->getName())         $customer_name = trim($order->getShippingAddress()->getName());
		if($order->getShippingAddress()->getFirstname())	$customer_firstname = trim($order->getShippingAddress()->getFirstname());
		if($order->getShippingAddress()->getLastname())     $customer_lastname = trim($order->getShippingAddress()->getLastname());
                          if($order->getShippingAddress()->getCity())         $customer_city = trim($order->getShippingAddress()->getCity());
                          if($order->getShippingAddress()->getPostcode())     $customer_postcode = trim(strtoupper($order->getShippingAddress()->getPostcode()));
                          if($order->getShippingAddress()->getRegion())       $customer_region = trim($order->getShippingAddress()->getRegion());
                          if($order->getShippingAddress()->getRegionCode())   $customer_region_code = trim($order->getShippingAddress()->getRegionCode());
                          if($order->getShippingAddress()->getPrefix())       $customer_prefix = trim($order->getShippingAddress()->getPrefix());
                          if($order->getShippingAddress()->getSuffix())       $customer_suffix = trim($order->getShippingAddress()->getSuffix());
                          if($order->getShippingAddress()->getStreet1())      $customer_street1 = trim($order->getShippingAddress()->getStreet1());
                          if($order->getShippingAddress()->getStreet2())      $customer_street2 = trim($order->getShippingAddress()->getStreet2());
                          if($order->getShippingAddress()->getStreet3())      $customer_street3 = trim($order->getShippingAddress()->getStreet3());
                          if($order->getShippingAddress()->getStreet4())      $customer_street4 = trim($order->getShippingAddress()->getStreet4());
                          if($order->getShippingAddress()->getStreet5())      $customer_street5 = trim($order->getShippingAddress()->getStreet5());
                          
                          if(Mage::app()->getLocale()->getCountryTranslation($order->getShippingAddress()->getCountryId())) 
                          {
                              $customer_country = trim(Mage::app()->getLocale()->getCountryTranslation($order->getShippingAddress()->getCountryId()));
                          }
                      }
                      if($order->getCustomerEmail()) $customer_email = trim($order->getCustomerEmail());
                      
                      // beta_box 1 (billing_address != shipping_address)
                      if($beta_box_1_yn == 1)
                      {
                          if( ($has_billing_address === true) && ($has_shipping_address === true) && ($order->getShippingAddress()->getRegionCode().$order->getShippingAddress()->getPostcode().$order->getShippingAddress()->getName().$order->getShippingAddress()->getCity() != $order->getBillingAddress()->getRegionCode().$order->getBillingAddress()->getPostcode().$order->getBillingAddress()->getName().$order->getBillingAddress()->getCity()) )
                          {
                              $filename_folder 	= 'beta_box_1_image';
                              $sub_folder 		= 'beta_box_1_pack';
                              $option_group 		= 'wonder';

                              if($wonder != 'wonder')
                              {
                                  $sub_folder 	= 'beta_box_1_invoice';
                                  $option_group 	= 'wonder_invoice';
                              }
                          }
                          else
                          {
                              $filename_folder 	= 'beta_box_blank_image';
                              $sub_folder 		= 'beta_box_blank_pack';
                              $option_group 		= 'wonder';

                              if($wonder != 'wonder')
                              {
                                  $sub_folder 	= 'beta_box_blank_invoice';
                                  $option_group 	= 'wonder_invoice';
                              }
                          }
                      
                          $packlogo_filename = Mage::getStoreConfig('pickpack_options/'.$option_group.'/'.$filename_folder, $store);
                          if($packlogo_filename)
                          {
                              $packlogo_path = Mage::getBaseDir('media') . '/moogento/pickpack/'.$sub_folder.'/' . $packlogo_filename;
                              
                              if (is_file($packlogo_path)) 
                              {    
                                  $packlogo = Zend_Pdf_Image::imageWithPath($packlogo_path);            
                                  $page->drawImage($packlogo, 20, $y1, 61, $y2);
                              }
                          }    
                          unset($packlogo_filename);
                          unset($packlogo);
                          unset($packlogo_path);
                      }

                      $billing_email         	= '';
                      $billing_phone         	= '';
                      $billing_company     	= '';
                      $billing_name         	= '';
                      $billing_firstname		= '';
                      $billing_lastname       = '';
                      $billing_city         	= '';
                      $billing_postcode     	= '';
                      $billing_region     	= '';
                      $billing_region_code 	= '';
                      $billing_prefix     	= '';
                      $billing_suffix     	= '';
                      $billing_country     	= '';
                      $billing_street1    	= '';
                      $billing_street2    	= '';
                      $billing_street3    	= '';
                      $billing_street4    	= '';
                      $billing_street5    	= '';
                      
                      if($billing_details_yn == 1)
                      {
                          if($billing_tax_details_yn == 1)
                          {
                              $customer = Mage::getModel('customer/customer')->load($order->getData('customer_id'));
                              if($customer->getData('taxvat')) $billing_taxvat = $tax_title.' : '.trim($customer->getData('taxvat'));
                          }
                          
                          if($order->getBillingAddress()->getTelephone()) 	$billing_phone = trim($order->getBillingAddress()->getTelephone());
                          if($order->getBillingAddress()->getCompany())     	$billing_company = trim($order->getBillingAddress()->getCompany());
                          if($order->getBillingAddress()->getName())			$billing_name = trim($order->getBillingAddress()->getName());
		if($order->getBillingAddress()->getFirstname())		$billing_firstname = trim($order->getBillingAddress()->getFirstname());
		if($order->getBillingAddress()->getLastname())     	$billinglastname = trim($order->getBillingAddress()->getLastname());
                          if($order->getBillingAddress()->getCity())         	$billing_city = trim($order->getBillingAddress()->getCity());
                          if($order->getBillingAddress()->getPostcode())     	$billing_postcode = trim(strtoupper($order->getBillingAddress()->getPostcode()));
                          if($order->getBillingAddress()->getRegion())     	$billing_region = trim($order->getBillingAddress()->getRegion());
                          if($order->getBillingAddress()->getRegionCode()) 	$billing_region_code = trim($order->getBillingAddress()->getRegionCode());
                          if($order->getBillingAddress()->getPrefix())     	$billing_prefix = trim($order->getBillingAddress()->getPrefix());
                          if($order->getBillingAddress()->getSuffix())     	$billing_suffix = trim($order->getBillingAddress()->getSuffix());
                          if($order->getBillingAddress()->getStreet1())     	$billing_street1 = trim($order->getBillingAddress()->getStreet1());
                          if($order->getBillingAddress()->getStreet2())     	$billing_street2 = trim($order->getBillingAddress()->getStreet2());
                          if($order->getBillingAddress()->getStreet3())     	$billing_street3 = trim($order->getBillingAddress()->getStreet3());
                          if($order->getBillingAddress()->getStreet4())     	$billing_street4 = trim($order->getBillingAddress()->getStreet4());
                          if($order->getBillingAddress()->getStreet5())     	$billing_street5 = trim($order->getBillingAddress()->getStreet5());
                          if(Mage::app()->getLocale()->getCountryTranslation($order->getBillingAddress()->getCountryId())) 
                          {
                              $billing_country = trim(Mage::app()->getLocale()->getCountryTranslation($order->getBillingAddress()->getCountryId()));
                          }
                          
                          $billing_address    = array();
                          $if_contents     = array();
                          $billing_address['street']       	= '';
                          $billing_address['street1']        	= $billing_street1;
                          $billing_address['street2']        	= $billing_street2;
                          $billing_address['street3']        	= $billing_street3;
                          $billing_address['street4']        	= $billing_street4;
                          $billing_address['street5']        	= $billing_street5;
                          $billing_address['company']			= $billing_company;
                          $billing_address['name']         	= $billing_name;
                          $billing_address['name']         	= trim(preg_replace('~^'.$billing_address['company'].'~i','',$billing_address['name']));
                          $billing_address['city']         	= $billing_city;
                          $billing_address['postcode']     	= $billing_postcode;
                          $billing_address['region_full'] 	= $billing_region;
                          $billing_address['region_code'] 	= $billing_region_code;
                          if($billing_region_code != '') 
                          {
                              $billing_address['region']    	= $billing_region_code;
                          }
                          else
                          {
                              $billing_address['region']    	= $billing_region;
                          }
                          $billing_address['prefix']     		= $billing_prefix;
                          $billing_address['suffix']     		= $billing_suffix;
                          $billing_address['country']     	= $billing_country;
                          if($address_countryskip != '') 
                          {
                              if($address_countryskip == 'usa' || $address_countryskip == 'united states' || $address_countryskip == 'united states of america')
                              {
                                  $address_countryskip = array('usa','united states of america','united states');
                              }
                              $billing_address['country'] = str_ireplace($address_countryskip,'',$billing_address['country']);
                          }                
                          $i = 0;
                          while($i < 10)
                          {
                              if($order->getBillingAddress()->getStreet($i) && !is_array($order->getBillingAddress()->getStreet($i)))
                              {
                                  $value 		= trim($order->getBillingAddress()->getStreet($i));
                                  $max_chars 	= 20;
                                  $font_temp 	= Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
                                  $font_size_compare = ($font_size_body*0.8);
                                  $line_width = $this->parseString('1234567890',$font_temp,$font_size_compare); // bigger = left
                                  $char_width = $line_width/10;
                                  $max_chars 	= round(($orderdetailsX-160)/$char_width);
                                  // wordwrap characters
                                  $value = wordwrap($value, $max_chars, "\n", false);
                                  $token = strtok($value, "\n");
                                  while ($token != false) 
                                  {
                                      if(trim(str_replace(',','',$token)) != '')
                                      {
                                          $billing_address['street'] .= trim($token)."\n";
                                      }
                                      $token = strtok("\n");
                                  }
                              }
                              $i ++;
                          }
                      
                          $address_format_set = str_replace(array("\n",'<br />','<br/>',"\r"),'',$address_format);

                          foreach($billing_address as $key =>$value)
                          {                                    
                              $value = trim($value);
                              $value = str_replace(array(',,',', ,',', ,'),',',$value);
                              $value = preg_replace('~,$~','',$value);
                              $value = trim(preg_replace('~\-$~','',$value));
                              
                              if($value != '' && !is_array($value))
                              {        
                                  preg_match('~{if '.$key.'}(.*){\/if '.$key.'}~ims',$address_format_set,$if_contents);
                                  
                                  if(isset($if_contents[1])) 
                                  {
                                      $if_contents[1] = str_replace('{'.$key.'}',$value,$if_contents[1]);
                                  }
                                  else $if_contents[1] = '';
                                  
                                  $address_format_set = preg_replace('~\{if '.$key.'\}(.*)\{/if '.$key.'\}~ims',$if_contents[1],$address_format_set);
                                  $address_format_set = str_replace('{'.$key.'}',$value,$address_format_set);
                              }
                              else
                              {
                                  $address_format_set = preg_replace('~\{if '.$key.'\}(.*)\{/if '.$key.'\}~i','',$address_format_set);    
                                  $address_format_set = str_replace('{'.$key.'}','',$address_format_set);
                              }    
                          }
                          // add VAT# if set to yes and if there's something there
                          if($billing_tax_details_yn == 1 && $billing_taxvat != '') $address_format_set = '||||'.$billing_taxvat;                                
                          $address_format_set    			= trim(str_replace(array('||','|'),"\n",trim($address_format_set)));                                
                          $address_format_set     		= str_replace("\n\n","\n",$address_format_set);
                          
                          $billingAddressArray     		= explode("\n",$address_format_set);
                          $billing_line_count     		= (count($billingAddressArray)-1);
                      }
                      // end billing address

                      $shipping_address                 	= array();
                      $if_contents         				= array();
                      $shipping_address['company']     	= $customer_company;
                      $shipping_address['name']         	= $customer_name;
                      $shipping_address['name']         	= trim(preg_replace('~^'.$shipping_address['company'].'~i','',$shipping_address['name']));
                      $shipping_address['city']         	= $customer_city;
                      $shipping_address['postcode']     	= $customer_postcode;
                      $shipping_address['region_full'] 	= $customer_region;
                      $shipping_address['region_code']	= $customer_region_code;
                      if($customer_region_code != '') 
                      {
                          $shipping_address['region']    = $customer_region_code;
                      }
                      else
                      {
                          $shipping_address['region']    = $customer_region;
                      }
                      $shipping_address['prefix']     	= $customer_prefix;
                      $shipping_address['suffix']     	= $customer_suffix;
                      $shipping_address['country']     	= $customer_country;
                      $shipping_address['street'] 		= '';
                      $shipping_address['street1']    	= $customer_street1;
                      $shipping_address['street2']    	= $customer_street2;
                      $shipping_address['street3']    	= $customer_street3;
                      $shipping_address['street4']    	= $customer_street4;
                      $shipping_address['street5']    	= $customer_street5;
                      if($address_countryskip != '') 
                      {
                          if($address_countryskip == 'usa' || $address_countryskip == 'united states' || $address_countryskip == 'united states of america')
                          {
                              $address_countryskip = array('usa','united states of america','united states');
                          }
                          $shipping_address['country'] = str_ireplace($address_countryskip,'',$shipping_address['country']);
                      }
                      
                      if($has_shipping_address !== false) 
                      {
                          $i = 0;
                          while($i < 10)
                          {
                              if($order->getShippingAddress()->getStreet($i) && !is_array($order->getShippingAddress()->getStreet($i)))
                              {
                                  $value = trim($order->getShippingAddress()->getStreet($i));

                                  $max_chars = 20;
                                  $font_temp = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
                                  $font_size_compare = ($font_size_body*0.8);
                                  $line_width = $this->parseString('1234567890',$font_temp,$font_size_compare); // bigger = left
                                  $char_width = $line_width/10;
                                  $max_chars = round(($orderdetailsX-160)/$char_width);
                                  // wordwrap characters
                                  $value = wordwrap($value, $max_chars, "\n", false);
                                  $token = strtok($value, "\n");
                                  while ($token !== false) 
                                  {
                                      if(trim(str_replace(',','',$token)) != '')
                                      {
                                          $shipping_address['street'] .= trim($token)."\n";
                                      }
                                      $token = strtok("\n");
                                  }                                    
                              }
                              $i ++;
                          }
                      }
                                              
                      $address_format_set = str_replace(array("\n",'<br />','<br/>',"\r"),'',$address_format);

                      foreach($shipping_address as $key =>$value)
                      {                                    
                          $value = trim($value);
                          $value = str_replace(array(',,',', ,',', ,'),',',$value);
                          $value = trim(preg_replace('~\-$~','',$value));                                
                          
                          if($value != '' && !is_array($value))
                          {        
                              preg_match('~\{if '.$key.'\}(.*)\{\/if '.$key.'\}~ims',$address_format_set,$if_contents);
                              
                              if(isset($if_contents[1])) 
                              {
                                  $if_contents[1] = str_replace('{'.$key.'}',$value,$if_contents[1]);
                              }
                              else $if_contents[1] = '';
                              
                              $address_format_set = preg_replace('~\{if '.$key.'\}(.*)\{/if '.$key.'\}~ims',$if_contents[1],$address_format_set);
                              $address_format_set = str_replace('{'.$key.'}',$value,$address_format_set);
                          }
                          else
                          {
                              $address_format_set = preg_replace('~\{if '.$key.'\}(.*)\{/if '.$key.'\}~i','',$address_format_set);    
                              $address_format_set = str_replace('{'.$key.'}','',$address_format_set);
                          }    
                      }
                      $address_format_set     = trim(str_replace(array('||','|'),"\n",trim($address_format_set)));
                      $address_format_set     = str_replace("\n\n","\n",$address_format_set);
                      $shippingAddressArray     = explode("\n",$address_format_set);

                      $count                     = (count($shippingAddressArray));    
                      $shipping_line_count     = $count;
                      if(isset($billing_line_count) && $billing_line_count > $shipping_line_count) 
                      {
                          $shipping_line_count = $billing_line_count;
                      }
                      
                      $address_left_x     = $addressXY[0];
                      if($float_top_address_yn == 0) $address_right_x    = $orderdetailsX;
                      $email_X             = $address_left_x;
                  
                      if($billing_details_position == 1)
                      {
                          $address_left_x     = $orderdetailsX;
                          $address_right_x    = $addressXY[0];
                      }
                      $address_top_y = ($orderIdXY[1]-($font_size_subtitles*2));//($addressXY[1]+20);

	                  if($shipping_title == '' && ($billing_details_yn == 0 || $billing_title == '')) 
	                  {
	                      $address_top_y -= 10;
	                  }


                      $address_title_left_x = $address_left_x;
                      $address_title_right_x = $address_right_x;

                      if($shipping_billing_title_position == 'beside') 
                      {
                          $address_left_x     = ($padded_left + ((strlen($shipping_title))*$font_size_subtitles*0.5));
                          $address_title_left_x = $padded_left;
                          if($page_template == '0') $address_title_left_x = $orderIdXY[0];
                      
                          $address_right_x    = $orderdetailsX;
                          $address_title_right_x = ($address_right_x-((strlen($billing_title))*$font_size_subtitles*0.5));
                      
                          if($page_template == 'tech')
                          { 
                              $address_top_y = ($page_top-110);
                          }
                          else $address_left_x += 10;
                          
                          $email_X             = $address_left_x;
                          
                          if($billing_details_position == 1)
                          {
                              $address_left_x     = $orderdetailsX;
                              $address_title_left_x = ($address_left_x-((strlen($shipping_title))*$font_size_subtitles*0.5));
                              
                              if($float_top_address_yn == 0) $address_right_x    = ($padded_left + ((strlen($billing_title))*$font_size_subtitles*0.5));
                              $address_title_right_x = $padded_left;
                              if($page_template == '0') $address_title_right_x = $orderIdXY[0];
                          }
                      }
                          
                      $this->_setFont($page, $font_style_shipping_billing_title,  ($font_size_body+1), $font_family_body, $non_standard_characters, $font_color_body);
                      
                      if($page_template == 'tech') 
                      {
                          $this->_setFont($page, $font_style_subtitles, $font_size_subtitles, $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                      }
                      elseif($page_template == 'mailer' || $page_template == 'bringup')
                      {
                          $address_top_y -= $mailer_padding[0];
                          $address_left_x += $mailer_padding[2];
                      }
                          
                      if($shipping_title == '' && ($billing_details_yn == 0 || $billing_title == '') && ($float_top_address_yn == 0)) 
                      {
                          $address_top_y = ($address_top_y + ($font_size_body+2));
                      }
                      elseif($float_top_address_yn == 1)
                      {
                          $address_top_y = $float_top_address_y;
                          $address_title_right_x = $padded_left;
                          $address_right_x = $padded_left;
                          
                          if($page_template == 'bringup')
                          {
                              $address_top_y -= $mailer_padding[0];
                              $address_left_x += $mailer_padding[2];
                              $address_right_x += $mailer_padding[2];
                              $address_title_left_x += $mailer_padding[2];
                              $address_title_right_x += $mailer_padding[2];
                              $email_X += $mailer_padding[2]-($font_size_body/2);
                          }
                      }
                      else
                      {
                      	// nudge down top addresses
                      	$address_top_y -= $font_size_body;
                      }

                      if($shipping_title != '') 
                      {
                          $page->drawText($shipping_title, $address_title_left_x, $address_top_y, 'UTF-8');
                      }
                      
                      if($billing_details_yn == 1 && $billing_title != '' && ($has_billing_address === true))
                      {
                          $page->drawText($billing_title, $address_title_right_x, $address_top_y, 'UTF-8');
                      }
                      
                      $this->_setFont($page, $font_style_body, ($font_size_body+1), $font_family_body, $non_standard_characters, $font_color_body);
                      
                      $line_height         = 0;
                      $addressLine         = '';                           
                      $line_height_top     = (1.07*($font_size_body+2));
                      $line_height_bottom = (1.05*$font_size_shipaddress);
                      $i_space             = -0.5;
                      if($shipping_billing_title_position == 'beside')  {$i_space = -1;}
                      $show_this_billing_line = array();
                      $show_this_shipping_line = array();
                      
                      $ship_i = 0;
                      $bill_i = 0;
                      foreach($shippingAddressArray as $key =>$value)
                      {
                          $skip         = 0;
                          $line_addon    = 0;
                          $line_bold     = 0;
                          $value = trim($value);
                          $value = preg_replace('~^,$~','',$value);
                          $value = str_replace(',,',',',$value);
                          $value = str_ireplace(array('{if street}','{street}','{/if street}','{if street1}','{street1}','{/if street1}','{if street2}','{street2}','{/if street2}','{if street3}','{street3}','{/if street3}','{if street4}','{street4}','{/if street4}','{if street5}','{street5}','{/if street5}','{if city}','{city}','{/if city}'),'',$value);
                          if($value != '') {$show_this_shipping_line[$ship_i] = $value;$ship_i ++;}
                      }
                          
                      if(($billing_details_yn == 1) && ($has_billing_address === true))
                      {
                          foreach($billingAddressArray as $key =>$value)
                          {
                              $value = trim($value);
                              $value = preg_replace('~^,$~','',$value);
                              $value = str_replace(',,',',',$value);
                              $value = str_ireplace(array('{if street}','{street}','{/if street}','{if street1}','{street1}','{/if street1}','{if street2}','{street2}','{/if street2}','{if street3}','{street3}','{/if street3}','{if street4}','{street4}','{/if street4}','{if street5}','{street5}','{/if street5}','{if city}','{city}','{/if city}'),'',$value);
                              if($value != '') {$show_this_billing_line[$bill_i] = $value;$bill_i ++;}
                          }
                      }
      
                      $packlogo_filename = null;
                      $packlogo_path = null;
                      $bottom_image_width = null;
                      $bottom_image_height = null;
                      
                         // footer return address logo
                      if($show_return_logo_yn == 1)
                      {
                          $sub_folder = 'bottom_return_address_logo_pack';
                          $option_group = 'wonder';

                          if($wonder != 'wonder')
                          {
                              $sub_folder = 'bottom_return_address_logo_invoice';
                              $option_group = 'wonder_invoice';
                          }
                          
                          if($return_address_yn == 'yesgroup')
                          {
                              $image = Mage::getStoreConfig('pickpack_options/'.$option_group.'/pickpack_logo_group', $order->getStore()->getId());
                          }
                          else $image = Mage::getStoreConfig('pickpack_options/'.$option_group.'/pickpack_logo', $order->getStore()->getId());
                      
                  
                          if ($image) 
                          {
                              
                              $filename = Mage::getBaseDir('media') . '/moogento/pickpack/'.$sub_folder.'/' . $image;
                          
                              if (is_file($filename)) 
                              {
                                  $image = Zend_Pdf_Image::imageWithPath($filename);
                                  $page->drawImage($image, $return_logo_XY[0], $return_logo_XY[1], ($return_logo_XY[0]+180), ($return_logo_XY[1]+120));
                              }
                          }
                      }

                      // custom message
                      // working out bottom image dimensions
                      if($message_yn == 'yesimage' && $custom_message_image_locked_yn == 1)
                      {
                          $this->y -= 40;
                          
                          // 2250 x 417  (540 x 100)
                          // Dimensions 540pt(A4)|562pt(US Letter) x 100pt @ 300dpi : non-interlaced .png
                          if($invoice_or_pack == 'invoice') $packlogo_filename = $this->_getConfig('custom_message_image', null, false, $wonder, $store_id);
                          else $packlogo_filename = $this->_getConfig('custom_message_image_pack', null, false, $wonder, $store_id);

                          if($packlogo_filename)
                          {
                              $sub_folder = 'message_pack';
                              $option_group = 'wonder';

                              if($wonder != 'wonder')
                              {
                                  $sub_folder = 'message_invoice';
                                  $option_group = 'wonder_invoice';
                              }
                              
                              if($packlogo_filename)
                              {
                                  $packlogo_path = Mage::getBaseDir('media') . '/moogento/pickpack/'.$sub_folder.'/' . $packlogo_filename;
                                  
                                  // changing url link of image into directory link
                                  $dirImg = Mage::getBaseDir().str_replace("/",DS,strstr($packlogo_path,'/media'));
                                  $imageObj = new Varien_Image($dirImg);
                                  $bottom_image_width = ceil($imageObj->getOriginalWidth() / 4.17);
                                  $bottom_image_height = ceil($imageObj->getOriginalHeight() / 4.17);
                              }
                          
                              if($this->y < (20+$bottom_image_height) )
                              {
                                  if($page_count == 1 && $return_address_yn == 0)
                                  {
                                      $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                                      $page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($font_size_subtitles * 2), 'UTF-8');
                                  }
                                  $page = $this->newPage();
                                  $page_count ++;
                                  $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                                  if($second_page_start == 'asfirst') $this->y = $items_header_top_firstpage;
                                  else $this->y = $page_top;

                                  $page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y), 'UTF-8');
                                  $this->y = ($this->y - ($font_size_subtitles*2));

                                  $items_y_start = $this->y;
                                  $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                              }        

                              $bottom_image_x1 = 20;
                              $bottom_image_x2 = (($bottom_image_width)+20);
                              $bottom_image_y1 = ($this->y-($bottom_image_height));
                              $bottom_image_y2 = $this->y;

                              if($custom_message_image_locked_yn == 1)
                              {
                                  $bottom_image_y2 = (10 + $bottom_image_height);
                                  $bottom_image_y1 = 10;

				$bottom_image_x1 += $custom_message_image_nudge[0];
                               $bottom_image_x2 += $custom_message_image_nudge[0];
                               $bottom_image_y1 += $custom_message_image_nudge[1];
                               $bottom_image_y2 += $custom_message_image_nudge[1];

                                  if($page_template == 'tech' && $custom_message_image_line_yn == 1 && strtoupper($background_color_subtitles) != '#FFFFFF') 
                                  {
                                      $page->setFillColor($background_color_subtitles_zend);            
                                      $page->setLineColor($background_color_subtitles_zend);    
                                      $page->setLineWidth(0.5);                
                                      $page->drawLine(($padded_left),($bottom_image_y2 + ($font_size_subtitles/2)), $padded_right, ($bottom_image_y2 + ($font_size_subtitles/2)));
                                  }
                              }

                              if (is_file($packlogo_path)) 
                              {    
                                  $packlogo = Zend_Pdf_Image::imageWithPath($packlogo_path);            
                                  $page->drawImage($packlogo, $bottom_image_x1, $bottom_image_y1, $bottom_image_x2, $bottom_image_y2);
                              }
                          }
                      }
                      elseif($message != null)
                      {
                          
                          $line_count = 0;
                          if($message_yn == 'yesbox')
                          {
                              $this->y = $custom_message_position[1];
                              
                              $maxWidthPage = ($padded_right + 20 - $custom_message_position[0] - 20);
                              $font_temp = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
                              $font_size_compare = ($font_size_options);
                              $line_width = $this->parseString('1234567890',$font_temp,$font_size_compare); // bigger = left
                              $char_width = $line_width/10;
                              $max_chars = round($maxWidthPage/$char_width);
                              
                              if(strlen($message) > $max_chars)
                              {
                                  $chunks = explode("\n",wordwrap($message, $max_chars, "\n"));
                              }
                              else $chunks = explode("\n",$message);
                              $line_count = count($chunks);
                              
                              $custom_message_box_left = ($custom_message_position[0] - 10);
                          }
                          else
                          {
                              $custom_message_box_left = $padded_left;
                              
                              // shift up message box
                              if(isset($has_shown_product_image) && $has_shown_product_image == 1) $this->y += ($img_height/2);
                              $message_array = explode("\n", $message);
                              $line_count = count($message_array);
                              $this->y -= (($font_size_subtitles-4)/2);                                    
                          }
                          
                          if(strtoupper($background_color_message) != '#FFFFFF' && $message_yn != 'yes')
                          {
                              $page->setFillColor($background_color_message_zend);            
                              $page->setLineColor($background_color_message_zend);            
                              $page->setLineWidth(0.5);                                                
                              $page->drawRectangle($custom_message_box_left, ($this->y-($line_count*($font_size_message+2))-10), $padded_right, ($this->y+11-10));
                          }
                          
                          $this->_setFont($page, $font_style_message, $font_size_message, $font_family_message, $non_standard_characters, $font_color_message);

                          if($message_yn == 'yesbox')
                          {
                              if(isset($chunks) && is_array($chunks))
                              {
                                  foreach($chunks as $key => $chunk)
                                  {
                                      $chunk_display = '';
                                      if(trim($chunk != '')) 
                                      {
                                          $this->y -= ($font_size_message + 2);                                                                                                
                                          $page->drawText($chunk, ($custom_message_position[0]), $this->y , 'UTF-8');
                                      }
                                  }

                                  unset($chunks);
                              }
                          }
                          elseif($message_yn != 'yes')
                          {
                              
                              foreach ($message_array as $value)
                              {
                                  if($non_standard_characters == 0) 
                                  {
                                      $font_temp = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
                                  }
                                  else
                                  {                                                
                                      $font_temp = Zend_Pdf_Font::fontWithPath(dirname(__FILE__)  . '/' . 'arial.ttf');  
                                  }
                                  $line_width = ceil($this->parseString($value,$font_temp,($font_size_message*0.96)));//*0.77)); // bigger = left

                                  $left_margin = ceil((($padded_right-$line_width)/2));
                                  if($left_margin < 0) $left_margin = 0;

                                  if($line_width == 0) // some issue with non-standard fonts
                                  {
                                      $left_margin = 25;
                                  }

                                  if(isset($value) && isset($left_margin) && ($this->y > 9)) $page->drawText($value,$left_margin, $this->y, 'UTF-8');
                                  $this->y -= ($font_size_message + 2);
                                  if($this->y < 10) $this->y = 10;
                              }
                          }
                      }
                      
                      if($shipaddress_packbarcode_yn == 1)
                      {
                          $barcode_font_size = 16;
							$left_down = 0;
		
							if($barcode_type !== 'code128')
							{
								$barcode_font_size += 12;
								$left_down = 12;
							}
		
                          $barcodeString = $this->convertToBarcodeString($order_id,$barcode_type);
                          $barcodeWidth = 1.35*$this->parseString($order_id,Zend_Pdf_Font::fontWithPath(dirname(__FILE__)  . '/' . $font_family_barcode), $barcode_font_size);
                          $page->setFillColor($white_color);
                          $page->setLineColor($white_color);
                          $page->drawRectangle(($addressFooterXY[0] - 5), ($addressFooterXY[1]+($barcode_font_size) - 5), ($addressFooterXY[0] + $barcodeWidth + 5), ($addressFooterXY[1] + ($barcode_font_size*2.4)) );
                          $page->setFillColor(new Zend_Pdf_Color_RGB(0, 0, 0));
		$page->setFont(Zend_Pdf_Font::fontWithPath(dirname(__FILE__)  . '/' . $font_family_barcode), $barcode_font_size); 
                          $page->drawText($barcodeString, ($addressFooterXY[0]-$left_down), ($addressFooterXY[1] + $barcode_font_size + 5-($left_down/2)), 'CP1252');
                          $page->setFillColor($white_color);
                          $page->drawRectangle(($addressFooterXY[0] - 7), ($addressFooterXY[1]+($barcode_font_size)-($left_down/4)), ($addressFooterXY[0] + $barcodeWidth + 5), ($addressFooterXY[1] + ($barcode_font_size*1.6) - ($left_down)) );
                      }
                      
                      if($shipaddress_title != '')
                      {
                          if($page_template != 'tech') 
                          {
                              $this->_setFont($page, $font_style_body, ($font_size_body+0.5), $font_family_body, $non_standard_characters, $font_color_body);
                          }
                          else
                          {
                              $this->_setFont($page, $font_style_body, ($font_size_body-0.5), $font_family_body, $non_standard_characters, $font_color_body);    
                          }
                          $page->drawText($shipaddress_title, ($address_right_x+10), ($addressFooterXY[1]-4), 'UTF-8');    
                          $i_space ++;                    
                          $shipping_line_count ++;        
                      }
                      
                      // footer shipping address logo
                      if(($bottom_shipping_address_yn == 1) && ($show_shipping_logo_yn == 1))
                      {
                          $sub_folder = 'bottom_shipping_address_logo_pack';
                          $option_group = 'wonder';
                          if($wonder != 'wonder')
                          {
                              $sub_folder = 'bottom_shipping_address_logo_invoice';
                              $option_group = 'wonder_invoice';
                          }
                          $image = Mage::getStoreConfig('pickpack_options/'.$option_group.'/pickpack_logo_shipping', $order->getStore()->getId());                        
                          if ($image) 
                          {
			$filename = Mage::getBaseDir('media') . '/moogento/pickpack/'.$sub_folder.'/' . $image;                
                              if (is_file($filename)) 
                              {
                                  $image = Zend_Pdf_Image::imageWithPath($filename);
                                  $page->drawImage($image, $shipping_logo_XY[0], $shipping_logo_XY[1], ($shipping_logo_XY[0]+225), ($shipping_logo_XY[1]+120));
                              }
                          }
                      }
      					
      				  $shipping_address_flat = ''; // for flat address
                      $max_y_custom_message = 20;
                      if(isset($bottom_billing_address_yn) && ($bottom_shipping_address_yn == 1 || $bottom_billing_address_yn == 1)) $max_y_custom_message = $addressFooterXY[1];                            
      
                      foreach($show_this_shipping_line as $i =>$value)
                      {
	                      
                          if($i == ($shipping_line_count-1)) 
                          {
                              $line_bold = 1;
                              $value = preg_replace('~,$~','',$value);
                          }
                          
                         if($bottom_shipping_address_yn_xtra == 1) 
                         {
                         	if($shipping_address_flat != '') $shipping_address_flat .= ', ';
                         	$shipping_address_flat .= $value;
                         }

                          $i_space = ($i_space+1);
                  
                          if($page_template != 'tech') 
                          {
                              $this->_setFont($page, $font_style_body, ($font_size_body+1), $font_family_body, $non_standard_characters, $font_color_body);
                          }
                          else
                          {
                              $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);    
                          }
                      
                          if($shipping_billing_title_position != 'beside')  
                          {
                              if($shipping_details_yn == 1) 
                              {
                                  $page->drawText($value, $address_left_x, (($address_top_y-$font_size_body)-($line_height_top*$i_space)-$line_addon), 'UTF-8');
                              }
                              
                              if(isset($show_this_billing_line[$i])) $page->drawText($show_this_billing_line[$i], $address_right_x, (($address_top_y-$font_size_body)-($line_height_top*$i_space)-$line_addon), 'UTF-8');
                          }
                          else
                          {
                              if($shipping_details_yn == 1) 
                              {
                                  $page->drawText($value, $address_left_x, ($address_top_y-($line_height_top*$i_space)-$line_addon), 'UTF-8');
                              }
                              
                              if(isset($show_this_billing_line[$i])) $page->drawText($show_this_billing_line[$i], $address_right_x, ($address_top_y-($line_height_top*$i_space)-$line_addon), 'UTF-8');
                          }
                          
                          $font_size_adjust = 0;
                          
                          
                          if($bottom_shipping_address_yn == 1) 
                          {
                              if(($capitalize_label_yn == 1) || (($capitalize_label_yn == 'usonly') && (strtolower($customer_country) == 'united states')))
                              {
                                  $value = trim(strtoupper($value));
                                  // remove line-end commas for USPS
                                  if(strtolower($customer_country) == 'united states') $value = preg_replace('~,$~','',$value);
                                  $font_size_adjust = 2;
                              }
                              
                              if($line_bold == 1) 
                              {
                                  $this->_setFont($page, 'bold', ($font_size_shipaddress+2-$font_size_adjust), $font_family_body, $non_standard_characters, $font_color_body);
                                  $line_addon = ($font_size_shipaddress*0.1);
                              }
                              else $this->_setFont($page, $font_style_body, ($font_size_shipaddress-$font_size_adjust), $font_family_body, $non_standard_characters, $font_color_body);
                              
                              $bottom_shipping_address_pos = array();
                              $bottom_shipping_address_pos['x'] = $addressFooterXY[0];
                              $bottom_shipping_address_pos['y'] = ($addressFooterXY[1]-($line_height_bottom*$i_space)-$line_addon);
                              $bottom_shipping_address_pos = preg_replace('~[^.0-9]~','', $bottom_shipping_address_pos);

							if(trim($bottom_shipping_address_pos['x']) == '') $bottom_shipping_address_pos['x'] = 0;
							if(trim($bottom_shipping_address_pos['y']) == '') $bottom_shipping_address_pos['y'] = 0;

                              $page->drawText($value, $bottom_shipping_address_pos['x'], $bottom_shipping_address_pos['y'], 'UTF-8');
                          }
                      }
									
					if(($bottom_shipping_address_yn_xtra == 1) && ($shipping_address_flat != ''))
					{		
						$return_to_this_y = $this->y;
						$this->y = $addressFooterXY_xtra[1];
						$shipping_address_flat = trim(str_replace(',,',',',$shipping_address_flat));
						$max_flat_shipping_address_width = ($padded_right - $flat_address_margin_rt_xtra - $addressFooterXY_xtra[0]);
						$max_flat_shipping_address_characters = stringBreak($shipping_address_flat, $max_flat_shipping_address_width, $font_size_shipaddress_xtra);
						$shipping_address_flat_wrapped = wordwrap($shipping_address_flat, $max_flat_shipping_address_characters, "\n", false);
						$this->y -= ($font_size_shipaddress_xtra + 2);
						$line_count = 0;
						$token = strtok($shipping_address_flat_wrapped, "\n");
						$number_lines = (1+substr_count($shipping_address_flat_wrapped, "\n"));
						$this->_setFont($page, 'regular', ($font_size_shipaddress_xtra), $font_family_body, $non_standard_characters, $font_color_body);
						while ($token != false) 
						{
						  $page->drawText(trim($token), $addressFooterXY_xtra[0], $this->y);
						  $this->y -= $font_size_shipaddress_xtra;
						  $token = strtok("\n");
						  $line_count ++;
						}
						unset($token);
						unset($line_count);
						unset($shipping_address_flat);
						$this->y = $return_to_this_y;
						// zzz
					}

                      $tel_email_y 					= ceil($address_top_y - ((($shipping_line_count+1) * $font_size_body)+($font_size_body*3)));                      
                      $subheader_start 				= ($address_top_y-($line_height_top*($i_space+1))-$line_addon);         
                      $billing_shipping_details_y 	= null;
                      $top_phone_Y 					= 0;
                      $top_phone_Y 					= ceil($addressXY[1]-($line_height_top*($i_space+1))-$line_addon);
                      $bottom_tel_email_y 			= ceil($addressFooterXY[1] - (($shipping_line_count+1) * $font_size_shipaddress));
                      
                      if($customer_phone_yn != 'no' && $customer_phone != '')
                      {
                          $i_space += 2;
                          $value = Mage::helper('sales')->__('T:').' '.$customer_phone;
                          $line_addon=($font_size_body*0.5);
                          $this->_setFont($page, $font_style_body, ($font_size_body), $font_family_body, $non_standard_characters, $font_color_body);
              
                          $top_phone_Y = $tel_email_y;
                          
                          if($customer_phone_yn != 'yeslabel' && ($shipping_details_yn == 1)) 
                          {
                              if($page_template == 'tech')
                              {
                                  $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles), $font_family_subtitles, $non_standard_characters, '#BBBBBB');
                                  $page->drawText(Mage::helper('sales')->__('T:'), $email_X, ($top_phone_Y), 'UTF-8');
                                  $this->_setFont($page, $font_style_body, ($font_size_body), $font_family_body, $non_standard_characters, '#BBBBBB');
                                  $page->drawText($customer_phone, ($email_X+$font_size_subtitles), ($top_phone_Y), 'UTF-8');
                              }
                              else
                              {
                                  $page->drawText($value, $email_X, ($top_phone_Y), 'UTF-8');
                                  if($customer_fax != '')
                                  {
                                      $fax_value = Mage::helper('sales')->__('F:').' '.$customer_fax;
                                      $page->drawText($fax_value, $email_X, ($top_phone_Y-$font_size_body), 'UTF-8');
                                  }
                              }
                              
                              $subheader_start = ($top_phone_Y - ($font_size_body *2));
                          }
                          
                          if($bottom_shipping_address_yn == 1 && $customer_phone_yn != 'yesdetails') 
                          {
                              $this->_setFont($page, 'regular', ($font_size_shipaddress-4), $font_family_body, $non_standard_characters, '#444444');
                              $page->drawText($value, $addressFooterXY[0], $bottom_tel_email_y, 'UTF-8');
                          }
                          
                          $subheader_start -= ($subheader_start - $top_phone_Y);
                          $this->y = $top_phone_Y - ($font_size_body*0.5);
                          $tel_email_y = $top_phone_Y - ($font_size_body);
                          if($customer_fax != null) $tel_email_y = $top_phone_Y - ($font_size_body*2);
                          $bottom_tel_email_y = $bottom_tel_email_y - ($font_size_body*1.2);
                      }
                      
                      if($customer_email_yn != 'no' && $customer_email != '')
                      {
                          $value = 'E: '.$customer_email;
                          
                          $this->_setFont($page, $font_style_body, ($font_size_body), $font_family_body, $non_standard_characters, $font_color_body);
              
                          $top_email_Y = $tel_email_y;
                          if($page_template == 'tech') $top_email_Y = ($tel_email_y - 3);
                                              
                          $bottom_email_Y = $bottom_tel_email_y;
                          
                          if($customer_email_yn != 'yeslabel' && ($shipping_details_yn == 1)) 
                          {
                              if($page_template == 'tech')
                              {
                                  $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles), $font_family_subtitles, $non_standard_characters, '#BBBBBB');
                                  $page->drawText(Mage::helper('sales')->__('E:'), $email_X, ($top_email_Y), 'UTF-8');
                                  $this->_setFont($page, $font_style_body, ($font_size_body), $font_family_body, $non_standard_characters, '#BBBBBB');
                                  $page->drawText($customer_email, ($email_X+$font_size_subtitles), ($top_email_Y), 'UTF-8');
                              }
                              else
                              {
                                  $page->drawText($value, $email_X, ($top_email_Y), 'UTF-8');
                              }
                              
                              $subheader_start = ($top_email_Y - ($font_size_body *1.6));
                              
                          }
                          
                          if($bottom_shipping_address_yn == 1 && $customer_email_yn != 'yesdetails') 
                          {
                              $this->_setFont($page, 'regular', ($font_size_shipaddress-4), $font_family_body, $non_standard_characters, '#444444');
                              $page->drawText($value, $addressFooterXY[0], $bottom_email_Y, 'UTF-8');
                          }
                          
                          // $subheader_start -= ($subheader_start - $top_email_Y);
                          $this->y = $top_email_Y - ($font_size_body*0.5);
                      }
                      
                      $shipping_method_raw = '';
                      $shipping_method = '';
                      
                      if($has_shipping_address !== false && ( ($shipment_details_yn == 1) || ($beta_box_2_yn == 1) || $page_template == 'mailer') )
                      {                                
                          $shipping_method_raw = $order->getShippingDescription();
                          $shipping_method = clean_method($shipping_method_raw,'shipping');        
                      }
                      
                                  
                      if($shipment_details_yn == 1)    
                      {
                          if($float_top_address_yn == 1) 
                          {
                              if(isset($date_y) && $date_y > 0) $shipment_details_y = ($date_y);
                              else $shipment_details_y = ($subheader_start-($font_size_body*2));
                              $orderdetailsX += 80;
                          }
                          elseif(($billing_details_yn == 1) && ($has_billing_address === true) && ($shipping_details_yn == 1))  $shipment_details_y = $top_phone_Y;
                          else 
                          {
                              $shipment_details_y = ($address_top_y-$line_height_top);
                              // if billing/shipping title, move up a line to be in line with the title
                              if(($shipping_billing_title_position != 'beside') && ((($billing_details_yn == 1) && ($has_billing_address === true) && ($billing_title != '')) || (($shipping_details_yn == 1) && ($shipping_title != '')))) $shipment_details_y += $line_height_top;
                          }
                          
                          
                                                        $paymentInfo = '';
                          $payment_test = '';
                          if($shipment_details_payment == 1)
                          {
                      		// $paymentInfo     = $order->getPayment()->getMethodInstance()->getTitle();
                          	// $paymentInfo     = Mage::helper('payment')->getInfoBlock($order->getPayment())->setIsSecureMode(true)->toHtml();
	      	$paymentInfo = Mage::helper('payment')->getInfoBlock($order->getPayment())->setIsSecureMode(true)->toPdf();
                          	$payment_test     = clean_method($paymentInfo,'payment');
		}
		
                          $customer_group = '';
                          $customer_group = ucwords(strtolower(Mage::getModel('customer/group')->load((int)$order->getCustomerGroupId())->getCode()));
                          $customer_id    = trim($order->getCustomerId());
                          $line_height     = 0;

                          $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                          
                          $items_count = 0;
                          if($shipment_details_count == 1)
                          {
                          	 // $items_count = $total_item_count;
                              //$items_count = $order['total_item_count'];
								$items_count = ceil($order->getTotalQtyOrdered());
                              if(!$items_count || ($items_count == 0))
                              {
                                  // v3.1.2.4
                                  $items_count = count($order->getAllVisibleItems());
                              }
                              $page->drawText(Mage::helper('pickpack')->__('Item count').' : ', $orderdetailsX, ($shipment_details_y-$line_height), 'UTF-8');
                              $page->drawText($items_count, ($orderdetailsX+80), ($shipment_details_y-$line_height), 'UTF-8');
                              $line_height = ($line_height+(1.15*$font_size_body));
                          }

                          $total_shipping_weight = 0;
                          $total_shipping_weight = round($order['weight'],2);
                          if($shipment_details_weight == 1)
                          {
                              $page->drawText(Mage::helper('sales')->__('Weight').' :', $orderdetailsX, ($shipment_details_y-$line_height), 'UTF-8');
                              $page->drawText($total_shipping_weight.' '.$shipment_details_weight_unit, ($orderdetailsX+80), ($shipment_details_y-$line_height), 'UTF-8');
                              $line_height = ($line_height+(1.15*$font_size_body));
                          }
                          
                          if($shipment_details_boxes_yn == 1)
                          {
                              $rounded_weight = ($total_shipping_weight/30);
                              $rounded_weight = ceil($rounded_weight);
                              $page->drawText(Mage::helper('sales')->__('Boxes').' : ', $orderdetailsX, ($shipment_details_y-$line_height), 'UTF-8');
                              $page->drawText($rounded_weight, ($orderdetailsX+80), ($shipment_details_y-$line_height), 'UTF-8');
                              $line_height = ($line_height+(1.15*$font_size_body));
                          }


                          $maxWidthPage         = ($padded_right - ($orderdetailsX+80));
                          $font_temp             = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
                          $font_size_compare     = ($font_size_body);
                          $line_width         = $this->parseString('1234567890',$font_temp,$font_size_compare); // bigger = left
                          $char_width         = $line_width/10;
                          $max_chars             = round($maxWidthPage/$char_width);
                          $invert_X_plus        = 0;
                              
                              
                          if($shipment_details_carrier != '0')    
                          {
                              
                              if($page_template == 'tech') 
                              {
                                  $this->_setFont($page, $font_style_subtitles, $font_size_subtitles, $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                                  $page->drawText(Mage::helper('sales')->__('Shipping Method').':', $orderdetailsX, ($shipment_details_y-$line_height), 'UTF-8');
                                  $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                                  $invert_X_plus = 16;
                              }
                              else $page->drawText(Mage::helper('sales')->__('Shipping').' :', $orderdetailsX, ($shipment_details_y-$line_height), 'UTF-8');

                              if(($shipment_details_carrier == 'filtered_by_pallet') && ($shipment_details_pallet_weight < $total_shipping_weight) )
                              {
                                  $page->drawText(Mage::helper('sales')->__('SHIP BY PALLET'), ($orderdetailsX+80+$invert_X_plus), ($shipment_details_y-$line_height), 'UTF-8');
                                  $line_height = ($line_height+(1.15*$font_size_body));
                              }
                              elseif($shipping_method != '')
                              {
                                  if(strlen($shipping_method) > $max_chars)
                                  {
                                      $shipping_display = mb_wordwrap_array($shipping_method,$max_chars);
                                      foreach($shipping_display as $value)
                                      {
                                          $page->drawText(trim($value), ($orderdetailsX+80+$invert_X_plus), ($shipment_details_y-$line_height), 'UTF-8');
                                          $line_height += $font_size_body;
                                      }
                                      unset($value);
                                  }
                                  else 
                                  {
                                      $page->drawText($shipping_method, ($orderdetailsX+80+$invert_X_plus), ($shipment_details_y-$line_height), 'UTF-8');
                                      $line_height = ($line_height+(1.15*$font_size_body));
                                  }
                              }
                          }
                          
                          $purchase_test = 0;
                          
                          if($shipment_details_payment == 1)    
                          {
                              if($shipment_details_purchase_order == 1)
                              {
                                  if(stripos($payment_test, 'purchase order') !== false)
                                  {
                                      $purchase_test = trim(str_ireplace(array('Purchase order',':','  '), array('','',' '),$payment_test));
                                      $payment_test = 'Purchase Order';
                                      if(strlen($purchase_test) < 1) $shipment_details_purchase_order = 0;
                                  }
                                  else $shipment_details_purchase_order = 0;
                              }
                              
                              if($page_template == 'tech') 
                              {
                                  $this->_setFont($page, $font_style_subtitles, $font_size_subtitles, $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                                  $page->drawText(Mage::helper('sales')->__('Payment Method').':', ($orderdetailsX-0.5), ($shipment_details_y-$line_height), 'UTF-8');
                                  $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                                  $invert_X_plus = 16;
                              }
                              else $page->drawText(Mage::helper('sales')->__('Payment').' :', $orderdetailsX, ($shipment_details_y-$line_height), 'UTF-8');
                                                                  
                              if(strlen($payment_test) > $max_chars)
                              {
                                  $payment_display = mb_wordwrap_array($payment_test,$max_chars);
                                  foreach($payment_display as $value)
                                  {
                                      $page->drawText(trim($value), ($orderdetailsX+80+$invert_X_plus), ($shipment_details_y-$line_height), 'UTF-8');
                                      $line_height += $font_size_body;                                        
                                  }
                                  unset($value);
                                  unset($payment_display);
                              }
                              else 
                              {
                                  $page->drawText($payment_test, ($orderdetailsX+80+$invert_X_plus), ($shipment_details_y-$line_height), 'UTF-8');
                                  $line_height = ($line_height+(1.15*$font_size_body));
                              }
                          }
                          
                          if($shipment_details_purchase_order == 1)    
                          {
                              if($page_template == 'tech') 
                              {
                                  $this->_setFont($page, $font_style_subtitles, $font_size_subtitles, $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                                  $page->drawText('                        '.Mage::helper('sales')->__('PO #:'), ($orderdetailsX+1.15), ($shipment_details_y-$line_height), 'UTF-8');
                                  $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                                  $invert_X_plus = 16;
                              }
                              else $page->drawText(Mage::helper('sales')->__('Purchase Order').'# :', $orderdetailsX, ($shipment_details_y-$line_height), 'UTF-8');
                                                                  
                              if(strlen($purchase_test) > $max_chars)
                              {
                                  $payment_display = mb_wordwrap_array($purchase_test,$max_chars);
                                  foreach($payment_display as $value)
                                  {
                                      $page->drawText(trim(str_replace(array('#',' '),'',$value)), ($orderdetailsX+80+$invert_X_plus), ($shipment_details_y-$line_height), 'UTF-8');
                                      $line_height += $font_size_body;                                        
                                  }
                                  unset($value);
                                  unset($purchase_test);
                                  unset($payment_display);
                              }
                              else 
                              {
                                  $page->drawText(trim(str_replace(array('#',' '),'',$purchase_test)), ($orderdetailsX+80+$invert_X_plus), ($shipment_details_y-$line_height), 'UTF-8');
                                  $line_height = ($line_height+(1.15*$font_size_body));
                              }
                          }

                          if($shipment_details_custgroup == 1 && $customer_group != '')    
                          {
                              $customer_group_filtered         = $customer_group;
                              $customer_group_filter_array     = array();
                              $customer_group_filter_array     = explode(',',$customer_group_filter);
                              foreach($customer_group_filter_array as $customer_group_filter_single)
                              {
                                  $customer_group_filtered = trim(str_ireplace(trim($customer_group_filter_single),'',$customer_group_filtered));
                              }

                              if($customer_group_filtered != '')
                              {
                                  $page->drawText(Mage::helper('sales')->__('Customer group').' :', $orderdetailsX, ($shipment_details_y-$line_height), 'UTF-8');
                                  $page->drawText($customer_group, ($orderdetailsX+80), ($shipment_details_y-$line_height), 'UTF-8');
                                  $line_height = ($line_height+(1.15*$font_size_body));
                              }                                    
                          }

                          if($shipment_details_customer_id == 1 && $customer_id != '')
                          {
                                  $page->drawText(Mage::helper('sales')->__('Customer ID').' :', $orderdetailsX, ($shipment_details_y-$line_height), 'UTF-8');
                                  $page->drawText($customer_id, ($orderdetailsX+80), ($shipment_details_y-$line_height), 'UTF-8');
                                  $line_height = ($line_height+(1.15*$font_size_body));
                          }
                          
                          if($shipment_details_custom_attribute_yn == 1 && $shipment_details_custom_attribute != '' && Mage::getModel('amorderattr/attribute'))
                          {
                              unset($shipment_custom_attribute_label);
                              unset($shipment_custom_attribute);
                              $shipment_custom_attribute_label     = array();
                              $shipment_custom_attribute             = array();
                              $collection = Mage::getModel('eav/entity_attribute')->getCollection();
                              $collection->addFieldToFilter('is_visible_on_front', 1);
                              $collection->addFieldToFilter('entity_type_id', Mage::getModel('eav/entity')->setType('order')->getTypeId());
                              $attributes = $collection->load();
                              $orderAttributes = Mage::getModel('amorderattr/attribute')->load($order->getId(), 'order_id');

                              if ($attributes->getSize())
                              {
                                  foreach ($attributes as $attribute)
                                  {
                                      $currentStore     = $order->getStoreId();
                                      $storeIds         = explode(',', $attribute->getData('store_ids'));
                                      if (!in_array($currentStore, $storeIds) && !in_array(0, $storeIds))
                                      {
                                          continue;
                                      }

                                      $value_a = '';
                                      switch ($attribute->getFrontendInput())
                                      {
                                          case 'select':
                                              $options_a = $attribute->getSource()->getAllOptions(true, true);

                                              foreach ($options_a as $option_a)
                                              {
                                                  if ($option_a['value'] == $orderAttributes->getData($attribute->getAttributeCode()))
                                                  {
                                                      $value_a = $option_a['label'];
                                                      break;
                                                  }
                                              }
                                              break;
                                          default:
                                              $value_a = $orderAttributes->getData($attribute->getAttributeCode());
                                              break;
                                      }
                                      
                                      if(!isset($shipment_custom_attribute_label[$attribute->getAttributeCode()]))
                                      {
                                          $shipment_custom_attribute_label[$attribute->getAttributeCode()] = trim(str_replace(array(':','Ship Order When','Information'),array('','Ship Order','Info'),$attribute->getFrontendLabel()));
                                      }
                                      
                                      $shipment_custom_attribute[$attribute->getAttributeCode()] = $value_a;
                                  }
                              }
                          
                              if(isset($shipment_custom_attribute_label[$shipment_details_custom_attribute]) && $shipment_custom_attribute[$shipment_details_custom_attribute] != '') 
                              {
                                  $display_cust_attr_label_1     = $shipment_custom_attribute_label[$shipment_details_custom_attribute];
                                  $display_cust_attr_1         = $shipment_custom_attribute[$shipment_details_custom_attribute];
                              
                                  $page->drawText($display_cust_attr_label_1.' :', $orderdetailsX, ($shipment_details_y-$line_height), 'UTF-8');
                                  $page->drawText($display_cust_attr_1, ($orderdetailsX+80), ($shipment_details_y-$line_height), 'UTF-8');
                                  $line_height = ($line_height+(1.15*$font_size_body));
                              }
                          }
                  
                          if($shipment_details_custom_attribute_2_yn == 1 && $shipment_details_custom_attribute_2 != '')
                          {
                              if(isset($shipment_custom_attribute_label[$shipment_details_custom_attribute_2]) && $shipment_custom_attribute[$shipment_details_custom_attribute_2] != '') 
                              {
                                  $display_cust_attr_label_2     = $shipment_custom_attribute_label[$shipment_details_custom_attribute_2];
                                  $display_cust_attr_2         = $shipment_custom_attribute[$shipment_details_custom_attribute_2];
                              
                                  $page->drawText($display_cust_attr_label_2.' :', $orderdetailsX, ($shipment_details_y-$line_height), 'UTF-8');
                                  $page->drawText($display_cust_attr_2, ($orderdetailsX+80), ($shipment_details_y-$line_height), 'UTF-8');
                                  $line_height = ($line_height+(1.15*$font_size_body));
                              }
                          }
                          
                          /*
                              $shipment_details_deadline_yn    = $this->_getConfig('shipment_details_deadline_yn', 0, false,$wonder,$store_id);
                              $shipment_details_deadline_text    = trim($this->_getConfig('shipment_details_deadline_text', '', false,$wonder,$store_id));
                              $shipment_details_deadline_days
                          */
                          
                          if($shipment_details_deadline_yn == 1)
                          {
                              $deadline_date = date($date_format, Mage::getModel('core/date')->timestamp((time()+(60*60*24*$shipment_details_deadline_days))));
                              
                              $page->drawText($shipment_details_deadline_text.' :', $orderdetailsX, ($shipment_details_y-$line_height), 'UTF-8');
                              $page->drawText($deadline_date, ($orderdetailsX+80), ($shipment_details_y-$line_height), 'UTF-8');
                              $line_height = ($line_height+(1.15*$font_size_body));
                          }
                                                          
                          if($message_yn == 'yes2')
                          {
                              if(preg_match('~'.$message_filter.'~i',$customer_group)) $message = $messageB;
                          }
                          
                          // if(isset($billing_shipping_details_y) && $billing_shipping_details_y != null) 
                          if($shipment_details_yn == 1) {                                
                              $line_height = ($line_height-(2*$font_size_body));                                            
                              if($subheader_start > ($shipment_details_y-$line_height)) $subheader_start = ceil($shipment_details_y-($line_height));
                              
                          }
                      }
                      
                      // if(($billing_details_yn == 0) && ($shipping_details_yn == 0) && ($shipment_details_yn == 0))
                      //                         {
                      //                             if($subheader_start > ($orderIdXY[1] + $font_size_subtitles)) $subheader_start = ($orderIdXY[1] + $font_size_subtitles);
                      //                         }
                      if(($billing_details_yn == 0) && ($shipping_details_yn == 0) && ($shipment_details_yn == 0))
                      {
                          if($subheader_start > ($orderIdXY[1] + $font_size_subtitles)) $subheader_start = ($orderIdXY[1] + $font_size_subtitles);
                          else{$subheader_start = ($orderIdXY[1]);}
                      }

                      // beta_box 2 (shipping method)
                      if($beta_box_2_yn == 1)
                      {
                          $box2_shown = false;
          
                          $beta_box_2store_matchtext            = trim(strtolower($this->_getConfig('beta_box_2store_matchtext', '', false,$wonder,$store_id)));
                          $beta_box_2express_matchtext        = trim(strtolower($this->_getConfig('beta_box_2express_matchtext', '', false,$wonder,$store_id)));
                          $beta_box_2priorint_matchtext        = trim(strtolower($this->_getConfig('beta_box_2priorint_matchtext', '', false,$wonder,$store_id)));
                          $beta_box_2standint_neg_matchtext    = trim(strtolower($this->_getConfig('beta_box_2standint_neg_matchtext', '', false,$wonder,$store_id)));
                     
                          $haystack = '';
                          $haystack = preg_replace("/[^a-z0-9\s]/", '', strtolower($shipping_method_raw));
      
                          if(strpos($haystack, $beta_box_2store_matchtext) !== false)
                          {
                              $filename_folder = 'beta_box_2store_image';
                              $sub_folder = 'beta_box_2store_pack';
                              $option_group = 'wonder';

                              if($wonder != 'wonder')
                              {
                                  $sub_folder = 'beta_box_2store_invoice';
                                  $option_group = 'wonder_invoice';
                              }    
                              $box2_shown = true;
                          }
                          elseif(strpos($haystack, $beta_box_2express_matchtext) !== false)
                          {
                              $filename_folder = 'beta_box_2express_image';
                              $sub_folder = 'beta_box_2express_pack';
                              $option_group = 'wonder';

                              if($wonder != 'wonder')
                              {
                                  $sub_folder = 'beta_box_2express_invoice';
                                  $option_group = 'wonder_invoice';
                              }    
                              $box2_shown = true;
                          }
                          elseif(strpos($haystack, $beta_box_2priorint_matchtext) !== false)
                          {
                              $filename_folder = 'beta_box_2priorint_image';
                              $sub_folder = 'beta_box_2priorint_pack';
                              $option_group = 'wonder';

                              if($wonder != 'wonder')
                              {
                                  $sub_folder = 'beta_box_2priorint_invoice';
                                  $option_group = 'wonder_invoice';
                              }
                              $box2_shown = true;
                          }
                          elseif($beta_box_2standint_neg_matchtext != '')
                          {                    
                              if(!isset($customer_country) && Mage::app()->getLocale()->getCountryTranslation($order->getShippingAddress()->getCountryId())) 
                              {
                                  $customer_country = trim(Mage::app()->getLocale()->getCountryTranslation($order->getShippingAddress()->getCountryId()));
                              }
                              
                              if( $customer_country ) 
                              { 
                                  $haystack = strtolower( $customer_country ); 
                           
                                  $neg_array = array();
                                  $neg_array = explode('|',$beta_box_2standint_neg_matchtext);
                                  
                                  $found_country = false;
                              
                                  foreach($neg_array as $key => $value)
                                  {
                                      if(strpos($value, $haystack) !== false)
                                      {
                                          $found_country = true;
                                      }
                                  }
                                  
                                  if($found_country === false)
                                  {
                                      $filename_folder = 'beta_box_2standint_image';
                                      $sub_folder = 'beta_box_2standint_pack';
                                      $option_group = 'wonder';

                                      if($wonder != 'wonder')
                                      {
                                          $sub_folder = 'beta_box_2standint_invoice';
                                          $option_group = 'wonder_invoice';
                                      }
                              
                                      $box2_shown = true;    
                                  }
                              }
                          }

                          if($box2_shown === false)
                          {
                              $filename_folder = 'beta_box_blank_image';
                              $sub_folder = 'beta_box_blank_pack';
                              $option_group = 'wonder';

                              if($wonder != 'wonder')
                              {
                                  $sub_folder = 'beta_box_blank_invoice';
                                  $option_group = 'wonder_invoice';
                              }
                          }

                          $packlogo_filename = Mage::getStoreConfig('pickpack_options/'.$option_group.'/'.$filename_folder, $store);
                          if($packlogo_filename)
                          {
                              // $packlogo_path = Mage::getStoreConfig('system/filesystem/media', $store) . '/moogento/pickpack/'.$sub_folder.'/' . $packlogo_filename;
                              $packlogo_path = Mage::getBaseDir('media') . '/moogento/pickpack/'.$sub_folder.'/' . $packlogo_filename;
                              if (is_file($packlogo_path)) 
                              {    
                                  $packlogo = Zend_Pdf_Image::imageWithPath($packlogo_path);            
                                  $page->drawImage($packlogo, 66, $y1, 107, $y2);
                              }
                          }    
                          unset($packlogo_filename);
                          unset($packlogo);
                          unset($packlogo_path);
                      }
                      
                      $order_notes_X = $padded_left;
                      if($page_template != 1) $order_notes_X = $orderIdXY[0];
                      
                      /* Add Order Notes*/    
                      if($notes_yn == 'yesemail')
                      {                                 
                          /*
                              [entity_id] => 17
                                                          [parent_id] => 8
                                                          [is_customer_notified] => 0
                                                          [is_visible_on_front] => 1
                                                          [comment] => New note two ('visible on frontend')
                                                          [status] => pending
                                                          [created_at] => 2011-02-08 01:21:55
                                                          [store_id] => 1
                          */
                          

                          if($order->getStatusHistoryCollection(true))
                          {
                              $notes = $order->getStatusHistoryCollection(true);
                              $note_line = array();
                              $note_comment_count = 0;
                              
                              $i = 0;
                              foreach ($notes as $_item)
                              {
                                  $_item['comment'] = clean_method($_item['comment']);
                                  
                                  if($notes_filter_options == 'yestext' && (stripos($_item['comment'], $notes_filter) !== false))
				{
					$_item['comment'] = '';
				}
		
				if($_item['comment'] != '' && (($notes_filter_options == 'yesfrontend' && $_item['is_visible_on_front'] == 1) 
				|| ($notes_filter_options == 'no' 
				|| $notes_filter_options == 'yestext')))
				{
                                      $_item['created_at']         = date('m/d/y',strtotime($_item['created_at']));
                                      $_item['comment']             = $_item['created_at'].' : '.$_item['comment'];
                                      $_item['comment']             = wordwrap($_item['comment'], 114, "\n", false);
                                      $note_line[$i]['date']         = $_item['created_at'];
                                      $note_line[$i]['comment']     = $_item['comment'];
                                      if($note_line[$i]['comment'] != '') $note_comment_count = 1;
                                      $note_line[$i]['is_visible_on_front'] = $_item['is_visible_on_front'];
                                      $i ++;
                                  }
                              }
                              
                                  
                              if($note_comment_count > 0)
                              {
                                  $character_breakpoint            = 50;
                                  $test_name            = 'abcdefghij';//10
                                  $font_temp             = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
                                  $test_name_length     = round($this->parseString($test_name,$font_temp,($font_size_body)));
                                  $pt_per_char             = ($test_name_length/10);
                                  $max_name_length         = $padded_right;
                                  $character_breakpoint             = round(($max_name_length/$pt_per_char)-25);
                                  // $this->y -= ($font_size_body + 4);
                                  // $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-1), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                                  $this->_setFont($page, 'bold', ($font_size_body), $font_family_body, $non_standard_characters, $font_color_body);
                              
                                  $this->y = $subheader_start;
                                  $this->y -= ($font_size_body*2);
                                  
                                  $page->drawText(Mage::helper('sales')->__('Order Notes'), ($order_notes_X), $this->y);
                                  $this->y -= ($font_size_body*1);
                                  $this->_setFont($page, $font_style_body, ($font_size_body-1), $font_family_body, $non_standard_characters, $font_color_body);

                                  sksort($note_line, 'date', true);

                                  $i = 0;
                                  $line_count = 0;
                                  while(isset($note_line[$i]['date']))
                                  {
                                      $note_line[$i]['comment']             = wordwrap($note_line[$i]['comment'], $character_breakpoint, "\n", false);
                                      
                                      $token = strtok($note_line[$i]['comment'], "\n");
                                      while ($token != false) 
                                      {
                                          $page->drawText(trim($token), ($order_notes_X), $this->y);
                                          $this->y-=($font_size_body-1);//10
                                          $token = strtok("\n");
                                          $line_count ++;
                                      }        
                                      $order_notes_was_set = true;
                                      $i ++;                    
                                  }
                              
                                  $subheader_start -= ($font_size_body * ($line_count+2));                                    
                              }
                              unset($note_line);
                              unset($_item);
                          }
                      }
                  
                      $customer_comments_shown = false;
                      $customer_comments = null;
                      $customer_comments_b = null;
                      
                      if($order->getOnestepcheckoutCustomercomment() != '')
                      {
                          $customer_comments .= trim(strip_tags(str_replace(array('<br/>','<br />'),' ',$order->getOnestepcheckoutCustomercomment())));
                  
                      }
                      elseif($order->getData('gomage_checkout_customer_comment'))
                      {
                          $customer_comments .= trim(strip_tags(str_replace(array('<br/>','<br />'),' ',$order->getData('gomage_checkout_customer_comment'))));
                      }
	elseif ($order->getHCheckoutcomment()) 
	{
		$customer_comments .= Mage::helper('sales')->__('This is a message from the customer : ') . $order->getHCheckoutcomment();
	}
	
	if(isInstalled('Aitoc_Aitcheckoutfields'))
	{
		$data_label = '';
		$filter_by_code = 'delivery'; // <<< enter attribute code to use here
		$code = array();
		$data = array();
		$code = Mage::getModel('aitcheckoutfields/aitcheckoutfields')->getInvoiceCustomData($order->getId() , null , true); 
		if(is_array($code))
		{
			foreach($code as $data)
            {
				if(($data['value'] != '') && ($data['code'] == $filter_by_code))
				{
					if($data['label'] != '') $data_label = $data['label'].' : ';
					$customer_comments .= $data_label.trim(strip_tags(str_replace(array('<br/>','<br />'),' ',$data['value'])));
					break;
				}
			}
		}
		// $headTitle = Mage::getStoreConfig('aitcheckoutfields/common_settings/aitcheckoutfields_additionalblock_label');
	}
	
	if(isInstalled('Spletnisistemi_OrderComment'))
	{
		if($order->getSpletnisistemiOrdercomment() != '')
		{
			$customer_comments .= trim(strip_tags(str_replace(array('<br/>','<br />'),' ',$order->getSpletnisistemiOrdercomment())));
		}
	}

	if($order->getBiebersdorfCustomerordercomment())
	{
	  $customer_comments_b = trim(strip_tags(str_replace(array('<br/>','<br />'),' ',$order->getBiebersdorfCustomerordercomment())));
	}
  
	if(strlen($customer_comments) > 0)
	{
		$subheader_start -= $font_size_body;
		$this->y = $subheader_start;

		$max_comment_length = ($padded_right - $order_notes_X);
		$max_comment_characters = stringBreak($customer_comments, $max_comment_length, $font_size_body);
		$customer_comments_wrapped     = wordwrap($customer_comments, $max_comment_characters, "\n", false);
		$this->y -= ($font_size_body + 4);


		$line_count = 0;
		$token = strtok($customer_comments_wrapped, "\n");
		$number_lines = substr_count($customer_comments_wrapped, "\n");

		if(($background_color_comments_pre != '') && ($background_color_comments_pre != '#FFFFFF'))
		{
			//$this->y -= ($font_size_comments*1.5);									
			$page->setFillColor($background_color_comments);			
			$page->setLineColor($background_color_comments);	
			$page->setLineWidth(0.5);				
			$page->drawRectangle(20, ($this->y-(($font_size_comments/2)+(($number_lines+1)*$font_size_comments))), $padded_right, ($this->y+$font_size_comments+2));
		}

		$this->_setFont($page, 'bold', ($font_size_comments), $font_family_comments, $non_standard_characters, $font_color_comments);
		$page->drawText(Mage::helper('pickpack')->__('Customer Comments'), ($order_notes_X), $this->y);
		$this->y -= ($font_size_comments);
		$this->_setFont($page, $font_style_comments, ($font_size_comments-1), $font_family_comments, $non_standard_characters, $font_color_comments);

		while ($token != false) 
		{
		  $page->drawText(trim($token), $order_notes_X, $this->y);
		  $this->y -= $font_size_comments;
		  $token = strtok("\n");
		  $line_count ++;
		}
		$customer_comments_shown = true;
		$subheader_start -= (($font_size_comments) * ($line_count+2));                                    
	}
                      
                      if(strlen($customer_comments_b) > 0)
                      {
                          $customer_comments_b_wrapped     = wordwrap($customer_comments_b, 114, "\n", false);
                          $this->y -= ($font_size_body + 4);
                          if($customer_comments_shown === false)
                          {
                              $this->_setFont($page, $font_style_comments, ($font_size_comments), $font_family_comments, $non_standard_characters, $font_color_comments);
                              $page->drawText(Mage::helper('pickpack')->__('Customer Comments'), ($order_notes_X), $this->y);
                              $this->y -= ($font_size_comments);
                          }
                          $this->_setFont($page, $font_style_comments, ($font_size_comments-1), $font_family_comments, $non_standard_characters, $font_color_comments);

                          $line_count = 0;
                          $token = strtok($customer_comments_b_wrapped, "\n");
                          while ($token != false) 
                          {
                              $page->drawText(trim($token), ($order_notes_X), $this->y);
                              $this->y-=$font_size_comments;
                              $token = strtok("\n");
                              $line_count ++;
                          }
                          $customer_comments_shown = true;
                          $subheader_start -= (($font_size_comments) * ($line_count+2));                                    
                      }
                      
                      // beta_box 3 (customer commented)
                      if($beta_box_3_yn == 1)
                      {
                          if($customer_comments_shown === true)
                          {
                              $filename_folder = 'beta_box_3_image';
                              $sub_folder = 'beta_box_3_pack';
                              $option_group = 'wonder';

                              if($wonder != 'wonder')
                              {
                                  $sub_folder = 'beta_box_3_invoice';
                                  $option_group = 'wonder_invoice';
                              }
                          }
                          else
                          {
                              $filename_folder = 'beta_box_blank_image';
                              $sub_folder = 'beta_box_blank_pack';
                              $option_group = 'wonder';

                              if($wonder != 'wonder')
                              {
                                  $sub_folder = 'beta_box_blank_invoice';
                                  $option_group = 'wonder_invoice';
                              }
                          }

                          $packlogo_filename = Mage::getStoreConfig('pickpack_options/'.$option_group.'/'.$filename_folder, $store);
                          if($packlogo_filename)
                          {
                              // $packlogo_path = Mage::getStoreConfig('system/filesystem/media', $store) . '/moogento/pickpack/'.$sub_folder.'/' . $packlogo_filename;
                              $packlogo_path = Mage::getBaseDir('media') . '/moogento/pickpack/'.$sub_folder.'/' . $packlogo_filename;
                              if (is_file($packlogo_path)) 
                              {    
                                  // 1 : 20, 61
                                  // 2: 66, 107
                                  // 3: 112, 153
                                  // logo: 158
                                  $packlogo = Zend_Pdf_Image::imageWithPath($packlogo_path);            
                                  $page->drawImage($packlogo, 112, $y1, 153, $y2);
                              }
                          }    
                          unset($packlogo_filename);
                          unset($packlogo);
                          unset($packlogo_path);
                      }
                  
                      $shipping_address_header_lines = (count($shippingAddressArray) + 1);
                      $this->_setFont($page, $font_style_subtitles, ($font_size_shipaddress-3), $font_family_subtitles, $non_standard_characters, '#444444');
                      if($bottom_shipping_address_id_yn == 1) $page->drawText('#'.$order->getRealOrderId(), $addressFooterXY[0], ($addressFooterXY[1]+($font_size_shipaddress)), 'UTF-8');           
                                                  
                      $line_height     = 0;
                      $item_prev         = '';
                      $i                 = 0;
                      $stop_address     = FALSE;
                      
                      $page->setFillColor($black_color);

                      // footer return address logo
                   /*   if($show_return_logo_yn == 1)
                      {
                          $sub_folder = 'bottom_return_address_logo_pack';
                          $option_group = 'wonder';

                          if($wonder != 'wonder')
                          {
                              $sub_folder = 'bottom_return_address_logo_invoice';
                              $option_group = 'wonder_invoice';
                          }
                          
                          if($return_address_yn == 'yesgroup')
                          {
                              $image = Mage::getStoreConfig('pickpack_options/'.$option_group.'/pickpack_logo_group', $order->getStore()->getId());
                          }
                          else $image = Mage::getStoreConfig('pickpack_options/'.$option_group.'/pickpack_logo', $order->getStore()->getId());
                      
                  
                          if ($image) 
                          {
                              
                              $filename = Mage::getBaseDir('media') . '/moogento/pickpack/'.$sub_folder.'/' . $image;
                          
                              if (is_file($filename)) 
                              {
                                  $image = Zend_Pdf_Image::imageWithPath($filename);
                                  $page->drawImage($image, $return_logo_XY[0], $return_logo_XY[1], ($return_logo_XY[0]+180), ($return_logo_XY[1]+120));
                              }
                          }
                      }
*/
                      if(($return_address_yn == 1 || $return_address_yn == 'yesgroup') && isset($return_address))
                      {
                          $return_address_lines        = explode("\n", $return_address);
                          $i = 1;
                          
                          $page->setFillColor(new Zend_Pdf_Color_Rgb($fontColorReturnAddressFooter,$fontColorReturnAddressFooter,$fontColorReturnAddressFooter));       
                          if(preg_match('~^From~i',$return_address))
                          {
                              $return_address_title_fontsize = -2;
                              if($font_size_returnaddress > 10) $return_address_title_fontsize = 2;
                              $this->_setFontRegular($page, ($font_size_returnaddress-$return_address_title_fontsize));  
                              
                              $page->drawText($return_address_lines[0], $returnAddressFooterXY[0], $returnAddressFooterXY[1], 'UTF-8');
                              $i = 0;
                          }

                          $this->_setFont($page, $font_style_body, $font_size_returnaddress, $font_family_body, $non_standard_characters, $font_color_body);
                          
                          $line_height = 20;
                          
		$bottom_return_address_pos = array();
		$bottom_return_address_pos['x'] = $returnAddressFooterXY[0];
		$bottom_return_address_pos['y'] = $returnAddressFooterXY[1];
		$bottom_return_address_pos = preg_replace('~[^.0-9]~','', $bottom_return_address_pos);
		if(trim($bottom_return_address_pos['x']) == '') $bottom_return_address_pos['x'] = 0;
		if(trim($bottom_return_address_pos['y']) == '') $bottom_return_address_pos['y'] = 0;
	
                          foreach ($return_address_lines as $value)
                          {
                              if ($value!=='' && $i > 0)
                              {
				$bottom_return_address_pos['y'] = ($returnAddressFooterXY[1]-$line_height);
                                  $page->drawText(trim(strip_tags($value)), $bottom_return_address_pos['x'], $bottom_return_address_pos['y'], 'UTF-8');    
                                  $line_height = ($line_height + ($font_size_returnaddress+1));
                              }
                              $i ++;
                          }
                      }
          
                      $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                  
                      if($page_template == 'mailer')
                      {
                          $subheader_start -= $mailer_padding[1];
                          $page->drawText($order_date, $padded_left, ($subheader_start-($font_size_body*2)), 'UTF-8');
                          $page->drawText(Mage::helper('sales')->__('Shipping Method').': '.$shipping_method, $padded_left, ($subheader_start-($font_size_body*3.2)), 'UTF-8');
                      }
                                  
                      if(strtoupper($background_color_subtitles) != '#FFFFFF')
                      {
                          $page->setFillColor($background_color_subtitles_zend);            
                          $page->setLineColor($background_color_subtitles_zend);    
                          $page->setLineWidth(0.5);                
                      }
                      else $subheader_start -= ($font_size_subtitles*2);
                      
                      // set the y pos of the first bar, according to height of logo image
                      if($subheader_start > $datebar_start_y) $subheader_start = $datebar_start_y;
                      
                      if($fill_product_header_yn == 0)
                      {
                          $this->y = ($subheader_start-($font_size_body*4));
                          if(strtoupper($background_color_subtitles) != '#FFFFFF')
                          {
                              $page->drawLine($padded_left, ($this->y-($font_size_subtitles/2)-2), ($padded_right), ($this->y-($font_size_subtitles/2)-2));
                              $page->drawLine($padded_left, ($this->y+$font_size_subtitles+2+2), ($padded_right), ($this->y+$font_size_subtitles+2+2));
                          }
                      }
                      else
                      {
                          $this->y = ($subheader_start-($font_size_body*2));
                          if(strtoupper($background_color_subtitles) != '#FFFFFF')
                          {
                              $page->drawRectangle($padded_left, ($this->y-($font_size_subtitles/2)), $padded_right, ($this->y+$font_size_subtitles+2));
                          }
                      }
                      
                      $this->_setFont($page, $font_style_subtitles, $font_size_subtitles, $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                      
                      if($from_shipment == 'shipment'){
                          $productXInc = 25;
                      }else{
                          $productXInc = 0;
                      }
                      
                      $first_item_title_shift_sku     = 0;
                      $first_item_title_shift_items     = 0;
                      
	if(($qtyX > 50) && ($tickbox == 'pickpack'))
                      {
                          if($productX < $skuX) $first_item_title_shift_items = $first_item_title_shift;
                          elseif($skuX < $productX) $first_item_title_shift_sku = $first_item_title_shift;
                      }

                      if($product_images_yn == 1)
                      {
                          $page->drawText(Mage::helper('sales')->__($images_title), $imagesX, $this->y, 'UTF-8');
                      }
                      $page->drawText(Mage::helper('sales')->__($qty_title), $qtyX, $this->y, 'UTF-8');
                      $page->drawText(Mage::helper('sales')->__($items_title), ($productX+$productXInc+$first_item_title_shift_items), $this->y, 'UTF-8');
                      if($product_sku_yn == 1) $page->drawText(Mage::helper('sales')->__($sku_title), ($skuX+$first_item_title_shift_sku), $this->y, 'UTF-8');
                  
                      if($product_sku_barcode_yn == 1) $page->drawText(Mage::helper('sales')->__($sku_barcode_title), ($sku_barcodeX-1), $this->y, 'UTF-8');
                     
                      if($product_stock_qty_yn == 1) 
                      {
                      	$page->drawText(Mage::helper('sales')->__($product_stock_qty_title), ($stockqtyX), $this->y, 'UTF-8');
                      }

                      if($product_options_yn == 'yescol')
                      {
                          $page->drawText(Mage::helper('sales')->__($product_options_title), ($optionsX), $this->y, 'UTF-8');
                      }
                      
                      if($shelving_real_yn == 1)
                      {
                          $page->drawText(Mage::helper('sales')->__($shelving_real_title), ($shelfX), $this->y, 'UTF-8');
                      }
                      
                      if($shelving_yn == 1)
                      {
                          $page->drawText(Mage::helper('sales')->__($shelving_title), ($shelf2X), $this->y, 'UTF-8');
                      }
                      
                      if($shelving_2_yn == 1)
                      {
                          $page->drawText(Mage::helper('sales')->__($shelving_2_title), ($shelf3X), $this->y, 'UTF-8');
                      }
                      
                      if($prices_yn != '0') 
                      {
                          $page->drawText(Mage::helper('sales')->__($price_title), $priceEachX, $this->y, 'UTF-8');
                          $page->drawText(Mage::helper('sales')->__($total_title), $priceX, $this->y, 'UTF-8');
                      }
                      
                      if($tax_col_yn == 1) 
                      {
                          $page->drawText(Mage::helper('sales')->__($tax_title), $taxEachX, $this->y, 'UTF-8');
                      }
                      
                      $this->y = ($this->y - 28);
                      
                      if(strtoupper($background_color_subtitles) == '#FFFFFF') $this->y += 10;
                      
                      $items_y_start = $this->y;
                      
                      // number of lines of products to show
                      $cutoff_no = round((($this->y - ($addressFooterXY[1]-30))/15));
                      
                      // if no bottom labels, can show more products
                      if(($bottom_shipping_address_yn == 0) && ($return_address_yn == 0) ) $cutoff_no = round(($this->y - 30)/15);
                     
                       $counter             = 1;   
                      $total_items        = count($itemsCollection);
                      $total_qty             = 0;
                      $total_price         = 0;
                      $total_price_ex_vat = 0;
                      $total_weight        = 0;
                      $total_price_taxed    = 0;
                      $total_price_ex_vat = 0;
                      $price_unit_taxed    = 0;
                      $price_unit_tax        = 0;
                      $price_discount_unrounded = 0;
                      $max_name_length     = 0;
                      
                      $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                  
                                              //$nextColX = 0;
                      $nextColX = $padded_right;
                      if(($skuX > $productX) && ($product_sku_yn == 1)) $nextColX = $skuX;
                      elseif(($qtyX > $skuX) && ($product_sku_yn == 1)) $nextColX = $qtyX;
                      elseif( (($productX > $skuX) && ($product_sku_yn == 1)) && ($shelving_yn == 0) && ($shelving_2_yn == 0) && ($shelving_real_yn == 0) && ($prices_yn == 0)) $nextColX = $padded_right;
                      
                      if(($shelving_real_yn == 1) && ($shelfX > $productX) && ($shelfX < $qtyX)) $nextColX = $shelfX;
                      
                  	$next_col_to_product_x = getPrevNext($columns_xpos_array,'productX','next');
                      $max_name_length         = ($next_col_to_product_x - $productX);
// echo 'next_col_to_product_x:'.$next_col_to_product_x.' $productX:'.$productX;
// print_r($columns_xpos_array);
// exit;
                      $name_overflows_at_position = 0;
                      if($trim_names_yn == 0 || $trim_names_yn == 'linebreak') 
                      {
                          $name_overflows_at_position = $max_name_length;
                      }
                   
                      $custom_options_output  = '';        
                      $bundle_options_output  = array();
                      $bundle_options_part    = '';
                      $product_build          = array();
                      $product_build_item     = array();
                      $subtotal_addon			= array();
                   
                      $coun = 1;
                      
                      foreach ($itemsCollection as $itemId => $item)
                      {
                          $custom_options_output = '';
                          $Magikfee = 0;

                          if($item->getProductType() == Mage_Catalog_Model_Product_Type::TYPE_CONFIGURABLE) 
                          {
                              // any products actually go thru here?
                              $sku         = trim($item->getProductOptionByCode('simple_sku'));
                              $product_id = Mage::getModel('catalog/product')->getIdBySku($sku);
                          } 
                          else 
                          {
                              $sku         = trim($item->getSku());
                              $product_id = $item->getProductId(); // get it's ID            
                          }    
                          
                          // unique item id
                          $product_build_item[]         = $sku.'-'.$coun;    
                          $product_build[$sku.'-'.$coun]['sku'] = $sku;
                          $product_sku                 = $sku;
                          $sku                         = $sku.'-'.$coun;
                          $product_build[$sku]['sku'] = $product_sku;
                          
                          if($product_sku_simple_configurable == 'configurable')
                          {
                              // get parent sku
                              $simpleProductSku = $product_sku;
                              $_product_temp = Mage::getModel('catalog/product');
                              $simpleProductId = $_product_temp->getIdBySku( $simpleProductSku );
                              $_product_temp->load($simpleProductId);
                              if ($_product_temp->getId()) {
                                  
                                  $objConfigurableProduct = Mage::getModel('catalog/product_type_configurable');
                                  $arrConfigurableProductIds = $objConfigurableProduct->getParentIdsByChild($simpleProductId);
                                  if(is_array($arrConfigurableProductIds))
                                  {
                                      $sku_temp = '';
                                      $sku_comma = '';
                                      foreach($arrConfigurableProductIds as $key => $productId_temp)
                                      {
                                          $product_temp = '';
                                          $product_temp = Mage::getModel('catalog/product')->load($productId_temp);     
                                          $sku_temp .= $sku_comma.$product_temp->getSku();
                                          $sku_comma = ', ';
                                      }
                                      if($sku_temp != '') $product_build[$sku]['sku'] = $sku_temp;
                                  }
                              }
                          }
                          
                          $product_build[$sku]['product_id'] = $product_id;
                          $sku_productid[$product_sku]= $product_id;
              
                  
                          $product = Mage::getModel('catalog/product')->loadByAttribute('sku', $product_sku, array('cost',$shelving_attribute,$shelving_real_attribute,'name','simple_sku','qty'));            
                          //if(Mage::getModel('cataloginventory/stock_item')->loadByProduct($product_id)->getQty()) $stock = round(Mage::getModel('cataloginventory/stock_item')->loadByProduct($product_id)->getQty());
                          
                          if(!isset($supplier)) $supplier = '~Not Set~';    
                          if(!isset($sku_supplier_item_action[$supplier][$product_sku]))
                          {
                              if($supplier_options == 'filter') $sku_supplier_item_action[$supplier][$product_sku] = 'hide';
                              elseif($supplier_options == 'grey') $sku_supplier_item_action[$supplier][$product_sku] = 'keepGrey';
                              if($split_supplier_yn == 'no') $sku_supplier_item_action[$supplier][$product_sku] = 'keep';
                          }
                          
                          $options = $item->getProductOptions();            
                      
                          $category_label = '';
                          $shelving         = '';
                          $shelving_real     = '';
                          
                          if($sku_supplier_item_action[$supplier][$product_sku] != 'hide')
                          {
                                  $qty = $item->getIsQtyDecimal() ? $item->getQtyOrdered() : (int) $item->getQtyOrdered();
                              
                              $sku_print         = $product_build[$sku]['sku'];
                          
                              $product         = Mage::getModel('catalog/product')->load($product_id);
                              # Get product's category collection object
                              $catCollection     = $product->getCategoryCollection();
                              # export this collection to array so we could iterate on it's elements
                              $categs         = $catCollection->exportToArray();
                              $categsToLinks     = array();
                              # Get categories names
                              foreach($categs as $cat)
                              {
                                  $categsToLinks [] = Mage::getModel('catalog/category')->load($cat['entity_id'])->getName();
                              }
                              foreach($categsToLinks as $ind=>$cat)
                              {
                                  if($category_label != '') $category_label = $category_label.', '.$cat;
                                  else $category_label = $cat;
                              }
                              $product_build[$sku]['%category%'] = $category_label;
                              unset($category_label);

                              $product_build[$sku]['shelving'] = '';
                              if($shelving_yn == 1 && $shelving_attribute != '')
                              {
                                  $attributeName = $shelving_attribute;
                              
                                  if($attributeName == '%category%')
                                  {
                                      $product_build[$sku]['shelving'] = $product_build[$sku]['%category%'];//$category_label;
                                  }
                                  elseif(Mage::getModel('catalog/product')->load($product_id)->getData($shelving_attribute))
                                  {
                                      $attributeValue = Mage::getModel('catalog/product')->load($product_id)->getData($attributeName);
                                      $product         = Mage::getModel('catalog/product');
                                      $collection     = Mage::getResourceModel('eav/entity_attribute_collection')
                                      ->setEntityTypeFilter($product->getResource()->getTypeId())
                                      ->addFieldToFilter('attribute_code', $attributeName);
                                      $attribute         = $collection->getFirstItem()->setEntity($product->getResource());
                                      $attributeOptions = $attribute->getSource()->getAllOptions(false);
                                      
                                      if(!empty($attributeOptions))
                                      {                        
                                          $result = search($attributeOptions,'value',$attributeValue);
                                          if(isset($result[0]['label'])) 
                                          {
                                              if($trim_names_yn == 'linebreak')
                                              {
                                                  $product_build[$sku]['shelving'] = str_replace(array('<br/>','<br />'),"\n",$result[0]['label']);
                                                  $product_build[$sku]['shelving'] = strip_tags($product_build[$sku]['shelving']);
                                              }
                                              else $product_build[$sku]['shelving'] = preg_replace('/[^a-zA-Z0-9\s\.\-]/', '', $result[0]['label']);
                                          }
                                      }
                                      else 
                                      {
                                          if($trim_names_yn == 'linebreak')
                                          {
                                              $product_build[$sku]['shelving'] = str_replace(array('<br/>','<br />'),"\n",$attributeValue);
                                              $product_build[$sku]['shelving'] = strip_tags($product_build[$sku]['shelving']);
                                          }
                                          else $product_build[$sku]['shelving'] = preg_replace('/[^a-zA-Z0-9\s\.\-]/', '', $attributeValue);
                                      }
                                  }
                              }
                                      
                              $product_build[$sku]['shelving2'] = '';
                              if($shelving_2_yn == 1 && $shelving_2_attribute != '')
                              {
                                  $attributeName = $shelving_2_attribute;
                                  if($attributeName == '%category%')
                                  {
                                      $product_build[$sku]['shelving2'] = $product_build[$sku]['%category%'];//$category_label;                                            
                                  }
                                  elseif(Mage::getModel('catalog/product')->load($product_id)->getData($attributeName))
                                  {
                                      $attributeValue = Mage::getModel('catalog/product')->load($product_id)->getData($attributeName);
                                      $product         = Mage::getModel('catalog/product');
                                      $collection     = Mage::getResourceModel('eav/entity_attribute_collection')
                                      ->setEntityTypeFilter($product->getResource()->getTypeId())
                                      ->addFieldToFilter('attribute_code', $attributeName);
                                      $attribute         = $collection->getFirstItem()->setEntity($product->getResource());
                                      $attributeOptions = $attribute->getSource()->getAllOptions(false);
                                      
                                      if(!empty($attributeOptions))
                                      {                        
                                          $result = search($attributeOptions,'value',$attributeValue);
                                          if(isset($result[0]['label'])) 
                                          {
                                              if($trim_names_yn == 'linebreak')
                                              {
                                                  $product_build[$sku]['shelving2'] = $result[0]['label'];
                                              }
                                              else $product_build[$sku]['shelving2'] = preg_replace('/[^a-zA-Z0-9\s\.\-]/', '', $result[0]['label']);
                                          }
                                      }
                                      else 
                                      {
                                          $product_build[$sku]['shelving2'] = preg_replace('/[^a-zA-Z0-9\s\.\-]/', '', $attributeValue);
                                      }
                                  }
                              }
                              
                              
                              if($sort_packing != 'none' && $sort_packing != '')
                              {
                                  $product_build[$sku][$sort_packing] = '';
                                  $attributeName = $sort_packing;

                                  if($attributeName == 'Mcategory')
                                  {
                                      $product_build[$sku][$sort_packing] = $product_build[$sku]['%category%'];//$category_label;
                                  }
                                  elseif($sort_packing == 'sku')
                                  {
                                 	 $product_build[$sku][$sort_packing] = $sku;
                                  }
                                  else
                                  {
                                      $product = Mage::getModel('catalog/product');
                                  
                                      if(Mage::getModel('catalog/product')->load($product_id)->getData($attributeName))
                                      {
                                          $attributeValue = Mage::getModel('catalog/product')->load($product_id)->getData($attributeName);
                                          $collection     = Mage::getResourceModel('eav/entity_attribute_collection')
                                          ->setEntityTypeFilter($product->getResource()->getTypeId())
                                          ->addFieldToFilter('attribute_code', $attributeName);
                                          $attribute         = $collection->getFirstItem()->setEntity($product->getResource());
                                          $attributeOptions = $attribute->getSource()->getAllOptions(false);
                                          if(!empty($attributeOptions))
                                          {                        
                                              $result = search($attributeOptions,'value',$attributeValue);
                                              if(isset($result[0]['label'])) 
                                              {
                                                  if($trim_names_yn == 'linebreak')
                                                  {
                                                      $product_build[$sku][$sort_packing] = $result[0]['label'];
                                                  }
                                                  else $product_build[$sku][$sort_packing] = preg_replace('/[^a-zA-Z0-9\s\.\-]/', '', $result[0]['label']);
                                              }
                                          }
                                          else 
                                          {
                                              if($trim_names_yn == 'linebreak')
                                              {
                                                  $product_build[$sku][$sort_packing] = $attributeValue;
                                              }
                                              else $product_build[$sku][$sort_packing] = preg_replace('/[^a-zA-Z0-9\s\.\-]/', '', $attributeValue);
                                          }
                                      }
                                  }
                                  unset($attributeName);
                                  unset($attribute);
                                  unset($attributeOptions);
                                  unset($result);
                              }


                              
                              $product_build[$sku]['shelving_real'] = '';
                              if($shelving_real_yn == 1 && $shelving_real_attribute != '')
                              {
                                  $attributeName = $shelving_real_attribute;                                    
                                  if($attributeName == '%category%')
                                  {
                                      $product_build[$sku]['shelving_real'] = $product_build[$sku]['%category%'];//$category_label;
                                  }
                                  elseif(Mage::getModel('catalog/product')->load($product_id)->getData($attributeName))
                                  {
                                      $attributeValue = Mage::getModel('catalog/product')->load($product_id)->getData($attributeName);
                                      $product         = Mage::getModel('catalog/product');
                                      $collection     = Mage::getResourceModel('eav/entity_attribute_collection')
                                      ->setEntityTypeFilter($product->getResource()->getTypeId())
                                      ->addFieldToFilter('attribute_code', $attributeName);
                                      $attribute         = $collection->getFirstItem()->setEntity($product->getResource());
                                      $attributeOptions = $attribute->getSource()->getAllOptions(false);
                                      if(!empty($attributeOptions))
                                      {                        
                                          $result = search($attributeOptions,'value',$attributeValue);
                                          if(isset($result[0]['label'])) 
                                          {
                                              if($trim_names_yn == 'linebreak')
                                              {
                                                  $product_build[$sku]['shelving_real'] = $result[0]['label'];
                                              }
                                              else $product_build[$sku]['shelving_real'] = preg_replace('/[^a-zA-Z0-9\s\.\-]/', '', $result[0]['label']);
                                          }
                                      }
                                      else 
                                      {
                                          if($trim_names_yn == 'linebreak')
                                          {
                                              $product_build[$sku]['shelving_real'] = $attributeValue;
                                          }
                                          else $product_build[$sku]['shelving_real'] = preg_replace('/[^a-zA-Z0-9\s\.\-]/', '', $attributeValue);
                                      }
                                  }
                              }
          
                                                      
                              if(isset($options['options']) && $product_options_yn != 'no')
                              {
                                  //this maybe works better:
                                  //if(is_array($options['attributes_info']))

                                  if(is_array($options['options']))
                                  {
                                      $i = 0;
                                      if(isset($options['options'][$i])) $continue = 1;
                                      else $continue = 0;
                                      
                                      while($continue == 1)
                                      {
                                          if(trim($options['options'][$i]['label'].$options['options'][$i]['value']) != '')
                                          {
                                              if($i > 0) $custom_options_output .= ' ';
                                              
                                              if($product_options_yn == 'yescol')
                                              {
                                                  $custom_options_output .= htmlspecialchars_decode($options['options'][$i]['value']);
                                              }
                                              else 
                                              {
                                                  $custom_options_output .= htmlspecialchars_decode('[ '.$options['options'][$i]['label'].' : '.$options['options'][$i]['value'].' ]');
                                              }
                                          }
                                          $i ++;
                                          if(isset($options['options'][$i])) $continue = 1;
                                          else $continue = 0;
                                      }
                                  }
                              }
                              
                              if(isset($options['bundle_options']))
                              {
                                  if(is_array($options['bundle_options']))
                                  {
                                      $bundle_options_sku = 'SKU : '.$sku_print;
                                      $sku_print = Mage::helper('sales')->__('(Bundle)');
                                      $bundle_sku_test = $sku;
                                  }
                              }
                          
							// Catch product-specific fees from MagikFees
							if(Mage::helper('core')->isModuleEnabled('Magik_Magikfees')===TRUE)
							{
								$farr=unserialize($item->getPaymentFee());
								foreach($farr as $fkey=>$fval) 
								{
									$Magikfee+=$fval[0];
								} 
								if ($Magikfee!=0)
								{

									if ($Magikfee!='')
									{ 
										$subtotal_addon['magikfee'] += $Magikfee;
										$magik_product_str[$itemId] = implode("\n",array_values(array_filter(unserialize($item->getPaymentStr()))));
									}      
								}
							}
			 
                              $name = '';
                               $product_stock_qty = 0;
                               
                              if(Mage::getModel('catalog/product')->load($product_id) && $configurable_names == 'simple')
                              {
                                  $_newProduct = Mage::getModel('catalog/product')->setStoreId($storeId)->load($product_id);  
                                  if($_newProduct->getData('name')) $name = trim($_newProduct->getData('name'));
                                  if($name == '') $name = trim($item->getName());
                                  if($product_stock_qty_yn == 1) $product_stock_qty = (int)Mage::getModel('cataloginventory/stock_item')->loadByProduct($_newProduct)->getQty();
                              }
                              else
                              {
                              	$name = trim($item->getName());
                              	if($product_stock_qty_yn == 1) $product_stock_qty = (int)Mage::getModel('cataloginventory/stock_item')->loadByProduct($product)->getQty();
							  }
							  $product_build[$sku]['product_stock_qty'] = $product_stock_qty; 
                                                  
                              if($from_shipment == 'shipment'){
                                  $qty_string = 's:'.(int)$item->getQtyShipped() . ' / o:'.$qty;
                                  $price_qty = (int)$item->getQtyShipped();
                                  $productXInc = 25;
                              }else{
                                  $qty_string = $qty;
                                  $price_qty = $qty;
                                  $productXInc = 0;
                              }                                                             
                              
                              $display_name = '';
                              $name_length = 0;

                              $test_name    = $name;//'abcdefghij';//10
                              switch ($font_family_body) {
                                  case 'helvetica':
                                      $font_temp = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
                                  break;
                                      
                                  case 'times':
                                      $font_temp = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_TIMES);
                                  break;
                                          
                                  case 'courier':
                                      $font_temp = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_COURIER);
                                  break;
                                  
                                  default:
                                      $font_temp = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
                                  break;
                              }
                              
                             /*
                              $test_name_length     = round($this->parseString($test_name,$font_temp,($font_size_body)));//*0.77)); // bigger = left                                    
                              $pt_per_char_name     = ($test_name_length/strlen($test_name));
                              $character_breakpoint_name     = round($max_name_length/$pt_per_char_name);
                             */
                              /*
                              if($trim_names_yn == 0 || $trim_names_yn == 'linebreak') 
			{
				$max_name_length = ($padded_right - ($productX+$productXInc) - 27);
				$character_breakpoint_name   = stringBreak($name, $max_name_length, $font_size_body, $font_helvetica);
			}
			else
			{
			*/
				$character_breakpoint_name = stringBreak($name, $max_name_length, $font_size_body, $font_helvetica);
			//}
			
// echo '$name:'.$name.', $max_name_length:'.$max_name_length.', $font_size_body:'.$font_size_body;
// echo '<br />$character_breakpoint_name:'.$character_breakpoint_name;
// exit;			
	
                              $new_line_after_name = false;
                              if((strlen($name) > $character_breakpoint_name) && $trim_names_yn != 'linebreak')
                              {
                                  $display_name     = substr($name, 0, $character_breakpoint_name).'…';
                              }
                              else $display_name     = $name;
                          
                              if($trim_names_yn == 'linebreak') 
                              {
                                  $display_name_b     = $name;
                                  $character_breakpoint_name_b     = round($name_overflows_at_position/$pt_per_char)+2;
                                  if(strlen($name) > $character_breakpoint_name_b)
                                  {
                                      $new_line_after_name = true;  
                                  }
                              }
                              
                          
                                  // strlen($name) > $character_breakpoint_name_b):17 > 20
                              $product_build[$sku]['display_name']     = $display_name;
                              $product_build[$sku]['qty_string']         = $qty_string;
                              $product_build[$sku]['sku_print']         = $sku_print;

                              $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                              
                              if($prices_yn != '0')
			{
				$item_discount = 0;
				$item_discount_label = '';
				if($discount_line_or_subtotal == 'line')
				{
					$item_discount = $item->getDiscountAmount();
				}
				if (((float)$item->getDiscountAmount()) != 0) 
				{
					if(empty($item_discount_label) || $item_discount_label == Mage::helper('sales')->__('Discount'))
					{
						if($order->getDiscountDescription())
						{
							$item_discount_label = $order->getDiscountDescription();
						}
						
						if($order->getCouponCode() && strtolower(trim($item_discount_label)) != strtolower(trim($order->getCouponCode())))
	                	{
							$item_discount_label = $order->getCouponCode();
						}
						
						$item_discount_label = Mage::helper('sales')->__('Discount').' ('.$order->getCouponCode().')';
					}
				}
				
				// $price_unit_unrounded = $item->getPriceInclTax();
				
				//	qty		unit-price		unit-tax		combined-subtotal
				//	1		10				5				10		<< this would have tax added in combined subtotal
				//	1		10				5				15
					
				// price_unit = price for one item
				$price_unit_unrounded 		= ($item->getPrice()-$item_discount);
			
				if ($item->getPriceInclTax()) 
				{
					$price_unit_plus_tax_unrounded = ($item->getPriceInclTax()-$item_discount);
				}
				else
				{
					// v.1.3.2.4
					$qty = ($item->getQty() ? $item->getQty() : ($item->getQtyOrdered() ? $item->getQtyOrdered() : 1));
					$price = (floatval($qty)) ? ($item->getRowTotal() + $item->getTaxAmount())/$qty : 0;
					$price_unit_plus_tax_unrounded = ($price-$item_discount);
				}
				
				if($price_unit_plus_tax_unrounded < $price_unit_unrounded)
				{
					// some bug, but taxed !< untaxed, so...
					$price_unit_unrounded = $price_unit_plus_tax_unrounded;
				}
			
				$price_discount_unrounded	= ($price_discount_unrounded + $item->getDiscountAmount());				
				$price_unrounded 			= ($price_qty * ($price_unit_unrounded + $Magikfee));
				$price_plus_tax_unrounded 	= ($price_qty * ($price_unit_plus_tax_unrounded + $Magikfee));
				$price_unit 				= number_format($price_unit_unrounded, 2, '.', ',');
				$price_unit_plus_tax 		= number_format($price_unit_plus_tax_unrounded, 2, '.', ',');
				$price_plus_tax 			= number_format($price_plus_tax_unrounded, 2, '.', ',');
				$price 						= number_format($price_unrounded, 2, '.', ',');																				
				$price_ex_vat_unrounded 	= ($price_qty * ($item->getPrice() + $Magikfee));
				$price_ex_vat 				= number_format($price_ex_vat_unrounded, 2, '.', ',');
				
				$tax_percent_temp			= 0;
				$price_unit_tax 			= 0;
				$price_unit_taxed 			= 0;
				$tax_percents				= array();
				reset($tax_percents);
				
				$tax_percent_temp 			= trim($item->getTaxPercent()); 
				if($tax_percent_temp > 0)
				{
					$tax_percent_temp 			= number_format($tax_percent_temp,2,'.',''); 
				}
				elseif($tax_percent_temp != 0) $tax_percent_temp = Mage::helper('sales')->__('Other');

				if($tax_percent_temp != 0)
				{
					$price_unit_tax 			= (($price_unit_plus_tax_unrounded - $item->getPrice()) * $price_qty);
					$price_unit_taxed 			= number_format(($price_unit_plus_tax_unrounded-$price_unit_unrounded), 2, '.', ',');
				}

				if($tax_percent_temp > 0)
				{
					$tax_percent_temp = preg_replace('~\.0(.*)$~','',$tax_percent_temp);
					$tax_percent_temp = preg_replace('~\.1(.*)$~','',$tax_percent_temp);
					if(!isset($tax_percents[$tax_percent_temp])) $tax_percents[$tax_percent_temp] = $price_unit_tax;
					else $tax_percents[$tax_percent_temp] = ($price_unit_tax + $tax_percents[$tax_percent_temp]);
				}
				
				$product_build[$sku]['tax_each'] 			= $order->formatPriceTxt($price_unit_taxed);
				$product_build[$sku]['price_each'] 			= $order->formatPriceTxt($price_unit);
				$product_build[$sku]['price_each_plus_tax'] = $order->formatPriceTxt($price_unit_plus_tax); // single item price		
				$product_build[$sku]['price_each_no_tax'] 	= $order->formatPriceTxt($price_unit-$price_unit_taxed);
				$product_build[$sku]['price'] 				= $order->formatPriceTxt($price);
				$product_build[$sku]['price_plus_tax'] 		= $order->formatPriceTxt($price_plus_tax); //total item price

				$total_qty 			= ($total_qty + $price_qty);
				$total_price		= ($total_price + $price_unrounded);
				$total_price_taxed	= ($total_price_taxed + $price_plus_tax_unrounded);
				$total_price_ex_vat = ($total_price_ex_vat + $price_ex_vat_unrounded);
			}
                          
                              if($custom_options_output != '')
                              {
                                  $custom_options_title = '';
                                  $product_build[$sku]['custom_options_title_output'] = strip_tags($custom_options_title.$custom_options_output);
                              }
                                                                  
                              if(isset($options['bundle_options']) && is_array($options['bundle_options']))
                              {
                                  $product_build[$sku]['bundle_options_sku'] = $bundle_options_sku;    
                                  $product_build[$sku]['bundle_children'] = $item->getChildrenItems();
                                  $product_build[$sku]['bundle_qty_shipped'] = (int)$item->getQtyShipped();
                              }                           
                              
                              $product_build[$sku]['itemId'] = $itemId;
                              
                              if($shipment_details_yn == 1)
                              {
                                  $weight = ($price_qty * $item->getWeight());
                                  $total_weight = ($total_weight + $weight);
                              }
                              $this->y -= 15;
                           
                              $counter++;
                          } // end if hide
                          
                          unset($options);
                          $coun ++;
                      }  // end items loop
                  
                      // sort items and loop
                      if($sort_packing != 'none')
                      {
                          $sortorder_packing_bool = false;
                          if($sortorder_packing == 'ascending') $sortorder_packing_bool = true;
                          sksort($product_build,$sort_packing,$sortorder_packing_bool);
                          sksort($product_build_item,$sort_packing,$sortorder_packing_bool);
                      }
                  
                      
                      if($background_color_subtitles == '#FFFFFF') $this->y += $font_size_body*1;
                      
                      $product_count = 0;
                      $min_product_y = 0;
	$options_y_counter = 0;
                      $page_count        = 1;

                      $this->y = $items_y_start;

//zzz
                      foreach($product_build as $key => $product_build_value)
                      {

                          // min-product-y (eg for fixed page base space)
                          $min_product_y = 60;
                          if($page_count == 1)
                          {
                              if($bottom_shipping_address_yn == 1 || $return_address_yn == 1)
                              {
                                  $min_product_y = ($addressFooterXY[1]+($font_size_shipaddress*2));
                                  if($shipaddress_packbarcode_yn == 1) $min_product_y += 20;
                              }
                              if($page_1_products_y_cutoff > $min_product_y) $min_product_y = $page_1_products_y_cutoff;
                          }
                      
                          $product_count ++;
                          
                          $sku = $product_build_value['sku'];
                          $itemId = $product_build_value['itemId']; //slightly backwards way of doing this, shuld prob list items by itemId not sku

                          // if(isset($line_next_product)) $this->y = ($line_next_product-($font_size_body/2));
                          
                          // check for item list overflow
                          if($this->y < $min_product_y)
                          {
                              if($page_count == 1 && $return_address_yn == 0 && $bottom_shipping_address_yn == 0)
                              {
                                  $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                                  $page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($font_size_subtitles * 2), 'UTF-8');
                              }
                              else
                              {
                                  $min_product_y = 60;
                                  if($shipaddress_packbarcode_yn == 1) $min_product_y += 20;
                              }
                              $page = $this->newPage();
                              $page_count ++;
                              $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                              
                              if($second_page_start == 'asfirst') $this->y = $items_header_top_firstpage;
                              else $this->y = $page_top;
                              
                              $page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y), 'UTF-8');
                              $this->y = ($this->y - ($font_size_subtitles*2));
                              
                              if(strtoupper($background_color_subtitles) != '#FFFFFF')
                              {
                                  $page->setFillColor($background_color_subtitles_zend);            
                                  $page->setLineColor($background_color_subtitles_zend);    
                                  $page->setLineWidth(0.5);
                                  if($fill_product_header_yn == 0)
                                  {
                                      $page->drawLine($padded_left, ($this->y-($font_size_subtitles/2)-2), ($padded_right), ($this->y-($font_size_subtitles/2)-2));
                                      $page->drawLine($padded_left, ($this->y+$font_size_subtitles+2+2), ($padded_right), ($this->y+$font_size_subtitles+2+2));
                                  }
                                  else
                                  {
                                      $page->drawRectangle($padded_left, ($this->y-($font_size_subtitles/2)), $padded_right, ($this->y+$font_size_subtitles+2));
                                  }
                              }
                              
                              $this->_setFont($page, $font_style_subtitles, $font_size_subtitles, $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                              $page->drawText(Mage::helper('sales')->__($qty_title), $qtyX, $this->y, 'UTF-8');
                              $page->drawText(Mage::helper('sales')->__($items_title), ($productX+$productXInc+$first_item_title_shift), $this->y, 'UTF-8');
                              if($product_sku_yn == 1) $page->drawText(Mage::helper('sales')->__($sku_title), $skuX, $this->y, 'UTF-8');
                              if($product_sku_barcode_yn == 1) $page->drawText(Mage::helper('sales')->__($sku_barcode_title), ($sku_barcodeX-1), $this->y, 'UTF-8');
                              
                              if($product_stock_qty_yn == 1) 
							  {
								$page->drawText(Mage::helper('sales')->__($product_stock_qty_title), ($stockqtyX), $this->y, 'UTF-8');
							  }
					  
                              if($product_options_yn == 'yescol')
                              {
                                  $page->drawText(Mage::helper('sales')->__($product_options_title), ($optionsX), $this->y, 'UTF-8');
                              }
                              
                              if($shelving_real_yn == 1)
                              {
                                  $page->drawText(Mage::helper('sales')->__('shelf'), $shelfX, $this->y, 'UTF-8');
                              }

                              if($prices_yn != '0') 
                              {
                                  $page->drawText(Mage::helper('sales')->__($price_title), $priceEachX, $this->y, 'UTF-8');
                                  $page->drawText(Mage::helper('sales')->__($total_title), $priceX, $this->y, 'UTF-8');
                              }

                              $this->y         = ($this->y - 28);
                              $items_y_start     = $this->y;
                              $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                          }                                

                          $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                          
                          // end for item list overflow
                          
                          if(isset($sku_supplier_item_action[$supplier][$sku]) && $sku_supplier_item_action[$supplier][$sku] != 'hide')
                          {
                              if($sku_supplier_item_action[$supplier][$sku] == 'keepGrey')
                              {
                                  $page->setFillColor($greyout_color);
                              }
                              elseif($tickbox == 'pickpack')
                              {
                                  $page->setLineWidth(0.5);
                                  $page->setFillColor($white_color);            
                                  $page->setLineColor($black_color);    
                                  $page->drawRectangle($tickboxX, ($this->y), ($tickboxX+7), ($this->y+7));
                                  $page->setFillColor($black_color);
                              }
                          }
                          elseif($tickbox == 'pickpack')
                          {
                              $page->setLineWidth(0.5);
                              $page->setFillColor($white_color);            
                              $page->setLineColor($black_color);    
                              $page->drawRectangle($tickboxX, ($this->y), ($tickboxX+7), ($this->y+7));
                              $page->setFillColor($black_color);
                          }
                          // }
                  
		if(!isset($max_chars))
		{
			$maxWidthPage = ($padded_right + 20)-($productX+$productXInc+$offset);
			$font_temp = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
			$font_size_compare = ($font_size_options);
			$line_width = $this->parseString('1234567890',$font_temp,$font_size_compare); // bigger = left
			$char_width = $line_width/10;
			$max_chars = round($maxWidthPage/$char_width);
		}
		
                          $page->drawText($product_build_value['display_name'], ($productX+$productXInc), $this->y , 'UTF-8');

                          // if qty col to right of name, shift down (if set to shift down)
                          if($new_line_after_name === true && (($qtyX+8) > ($productX+$productXInc))) {$this->y -= ($font_size_body+3);}
                          
                          $shelf_print = array();
                          
                          if(isset($product_build_value['shelving']) && $product_build_value['shelving'] != '')
                          {
                              $product_build_value['shelving'] = trim(str_replace(array("\r\n","\n\n"), "\n", $product_build_value['shelving']));
                              $line_y = $this->y;    
                              
                              $shelf_print = explode("\n",$product_build_value['shelving']);
                              foreach($shelf_print as $key => $value)
                              {
                                  $value = trim($value);
                                  if($value != '')
                                  {
                                      $page->drawText(Mage::helper('sales')->__($value), $shelf2X, $this->y, 'UTF-8');
                                      $this->y -= ($font_size_body);
                                  }
                              }
                              
                              if((strpos($product_build_value['shelving'], "\n") !== false) && ($doubleline_yn == 1))
                              { }
                              else {$this->y -= ($font_size_body);}
                              
                              // start next product at this point (furthest down the page we'll go)
                              $line_next_product = $this->y;                                    
                              $this->y = $line_y;                                            
                          }
                          
                          
                          if(isset($product_build_value['shelving_real']) && $product_build_value['shelving_real'] != '') $page->drawText(Mage::helper('sales')->__($product_build_value['shelving_real']), $shelfX, $this->y, 'UTF-8');
                          if(isset($product_build_value['shelving2']) && $product_build_value['shelving2'] != '') $page->drawText(Mage::helper('sales')->__($product_build_value['shelving2']), $shelf3X, $this->y, 'UTF-8');
                          
                          if($product_qty_upsize_yn == 1 && $product_build_value['qty_string'] > 1)
                          {
                              $this->_setFont($page, 'bold', ($font_size_body+1), $font_family_body, $non_standard_characters, $font_color_body);

			if($product_qty_red == 1) $this->_setFont($page, 'bold', ($font_size_body+1), $font_family_body, $non_standard_characters, 'darkRed');
                              $page->drawText($product_build_value['qty_string'], ($qtyX+8), ($this->y-1) , 'UTF-8');
                              if($product_qty_underlined == 1)
                              {
                                  $page->setLineWidth(2);
                                  $page->setLineColor($black_color);
							if($product_qty_red == 1) $page->setLineColor($red_color);
                                  $page->drawLine(($qtyX+7), ($this->y-3), ($qtyX+6+(strlen($product_build_value['qty_string'])*$font_size_body)), ($this->y-3));
                              }
                              $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                          }
                          else
                          {                                    
                              $page->drawText($product_build_value['qty_string'], ($qtyX+8), $this->y , 'UTF-8');
                          }
                      
                          // if qty col to left of name, shift down (if set to shift down) after showing qty
                          if($new_line_after_name === true && (($qtyX+8) < ($productX+$productXInc))) {$this->y -= ($font_size_body+3);}
                      
                          if($product_sku_yn == 1) $page->drawText($product_build_value['sku_print'], $skuX, $this->y , 'UTF-8');

                          if($product_stock_qty_yn == 1) 
                          {
                          	$page->drawText($product_build_value['product_stock_qty'], ($stockqtyX+15), $this->y , 'UTF-8');
                          }
                      
                          if($product_sku_barcode_yn == 1) 
                          {
                              $barcode = $product_build_value['sku_print'];
                              $barcode_font_size = 11;
                              $barcode_Y = $this->y - 4;
                              $barcodeString = $this->convertToBarcodeString($barcode,$barcode_type);
                              $barcodeWidth = 1.35*$this->parseString($barcode, Zend_Pdf_Font::fontWithPath(dirname(__FILE__)  . '/' . $font_family_barcode), $barcode_font_size);
                              $page->setFillColor($white_color);
                              $page->setLineColor($white_color);
                              $page->drawRectangle(($sku_barcodeX - 5), ($barcode_Y-2), ($sku_barcodeX + $barcodeWidth + 5), ($barcode_Y - 2 + ($barcode_font_size*1.6)) );
                              $page->setFillColor(new Zend_Pdf_Color_RGB(0, 0, 0));
                              $page->setFont(Zend_Pdf_Font::fontWithPath(dirname(__FILE__)  . '/' . $font_family_barcode), $barcode_font_size);
                              $page->drawText($barcodeString, ($sku_barcodeX), ($barcode_Y), 'CP1252');
                              $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                          }
                          
                          if($prices_yn != 0)
		{
			if($tax_yn == 'yessubtotal') $page->drawText($product_build_value['price'], $priceX, $this->y , 'UTF-8');
			else $page->drawText($product_build_value['price_plus_tax'], $priceX, $this->y , 'UTF-8');

			if($tax_yn != 'no' && $tax_yn != 'noboth')
			{
				if($tax_col_yn == 1) 
				{
					$page->drawText($product_build_value['tax_each'], $taxEachX, $this->y , 'UTF-8');
					$page->drawText($product_build_value['price_each'], $priceEachX, $this->y , 'UTF-8');
				}
				else
				{
					$page->drawText($product_build_value['price_each_plus_tax'], $priceEachX, $this->y , 'UTF-8');
				}
			}
                              elseif($tax_yn == 'no' || $tax_yn == 'noboth')
			{
					$page->drawText($product_build_value['price_each_plus_tax'], $priceEachX, $this->y , 'UTF-8');
			}
		}
                              
                          if($product_options_yn == 'yescol' && isset($product_build_value['custom_options_title_output']))
                          {
                              $page->drawText($product_build_value['custom_options_title_output'], $optionsX, $this->y, 'UTF-8');
                          }
                          elseif(($product_options_yn == 'yes' || $product_options_yn == 'yesstacked') && isset($product_build_value['custom_options_title_output']) && $product_build_value['custom_options_title_output'] != '')
                          {
                              
                              $offset = 20;
                              $this->_setFont($page, $font_style_body, ($font_size_options), $font_family_body, $non_standard_characters, $font_color_body);
                              
                              $maxWidthPage = ($padded_right + 20)-($productX+$productXInc+$offset);
                              $font_temp = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
                              $font_size_compare = ($font_size_options);
                              $line_width = $this->parseString('1234567890',$font_temp,$font_size_compare); // bigger = left
                              $char_width = $line_width/10;
                              $max_chars = round($maxWidthPage/$char_width);
                              
                              if(strlen($product_build_value['custom_options_title_output']) > $max_chars)
                              {
                                  if($product_options_yn == 'yes') $chunks = split_words($product_build_value['custom_options_title_output'], '/ /', $max_chars);
                                  elseif($product_options_yn == 'yesstacked') $chunks = explode('[',$product_build_value['custom_options_title_output']);
                              
                                  $lines = 0;
                                  foreach($chunks as $key => $chunk)
                                  {
                                      $chunk_display = '';
                                      if(trim($chunk != '')) 
                                      {
                                          $this->y -= ($font_size_options);
                                          $options_y_counter += $font_size_options;
                                          
                                          $chunk_display = str_replace('[[','[','[ '.$chunk);
                                          
                                          $page->drawText($chunk_display, ($productX+$productXInc+$offset), $this->y , 'UTF-8');
                                          $lines ++;
                                      }
                                  }

                                  unset($chunks);
                              }
                              else
                              {
                                  if($product_options_yn == 'yesstacked') 
                                  {
                                      $chunks = explode('[',$product_build_value['custom_options_title_output']);

                                      $lines = 0;
                                      
                                      foreach($chunks as $key => $chunk)
                                      {
                                          $chunk_display = '';
                                          if(trim($chunk != '')) 
                                          {
                                              $this->y -= ($font_size_options);
                                              $options_y_counter += $font_size_options;
                                              $chunk_display = str_replace('[[','[','['.$chunk);
                                              $page->drawText($chunk_display, ($productX+$productXInc+$offset) , $this->y , 'UTF-8');
                                              $lines ++;
                                          }
                                      }
                                      unset($chunks);
                                  }
                                  else
                                  {
                                      $this->y -= ($font_size_options);
                                      $options_y_counter += $font_size_options;
                                      $page->drawText($product_build_value['custom_options_title_output'], ($productX+$productXInc+$offset) , $this->y , 'UTF-8');
                                  }
                              }
                          }
                                          
		// extra fees writeup
		if(isset($magik_product_str[$itemId]) && ($magik_product_str[$itemId] != ''))
		{
			$offset = 10;
			$line_height = ($font_size_body);
			$this->y -= $line_height;

			$this->_setFont($page, $font_style_body, ($font_size_body-1), $font_family_body, $non_standard_characters, $font_color_body);
			$page->drawText($magik_product_str[$itemId], ($productX+$productXInc+$offset) , $this->y , 'UTF-8');						                    
			$this->y -= $line_height;
		}	
                                          
                          if(isset($product_build_value['bundle_options_sku']))
                          {
                              $offset             = 10;
                              $line_height         = ($font_size_body);
                              $this->y             -= $line_height;
                              $options_y_counter     += $line_height;

                              $this->_setFont($page, $font_style_body, ($font_size_body-2), $font_family_body, $non_standard_characters, $font_color_body);
                              if(($skuX < 800) && ($product_sku_yn == 1)) 
                              {
                                  $display_bundle_sku = $product_build_value['bundle_options_sku'];
	
                                  if(strlen($display_bundle_sku) > $character_breakpoint_name)
                                  {
                                      $display_bundle_sku = substr($display_bundle_sku, 0, $character_breakpoint_name).'…';
                                  }
                                  
                                  $page->drawText($display_bundle_sku, ($productX+$productXInc+3) , $this->y , 'UTF-8');                                            
                                  $this->y -= $line_height;
                                  $options_y_counter += $line_height;
                              }
                              else $offset = 0;
                              
                              $bundle_x = ($productX+$productXInc+3);
                              
                              if($qtyX > $bundle_x)
                              {
                                  $bundle_line_x2 = ( $qtyX + 15 );
                                  $bundle_options_x = ($tickboxX+3);
                                  $tickboxX_bundle = ($tickboxX+4);
                              }
                              else 
                              {
                                  $bundle_options_x = ( $qtyX - 15 );//($tickboxX+3);
                                  $bundle_line_x2 = (($tickboxX+3) + ( strlen('Bundle Options : ') * ($font_size_body-2) ));
                                  // tickbox   image    [bundle x] qty    name     code
                                  if($skuX > $productX)
                                  {
                                      $bundle_line_x2 = ($skuX - 10);
                                      $bundle_options_x = ( $qtyX - 5 );//($tickboxX+3);
                                  }
                                  $tickboxX_bundle = $bundle_options_x+1;
                              }
                              
                              $this->_setFont($page, $font_style_body, ($font_size_body-2), $font_family_body, $non_standard_characters, '#333333');
                              $page->drawText(Mage::helper('sales')->__('Bundle Options').' : ', $bundle_options_x, $this->y , 'UTF-8');                                            
                          
                              $page->setLineWidth(0.5);
                              $page->setFillColor($white_color);            
                              $page->setLineColor($greyout_color);    
                              $page->drawLine(($bundle_options_x), ($this->y-2), $bundle_line_x2, ($this->y-2));
                              $page->setFillColor($black_color);
                              $this->_setFont($page, $font_style_body, ($font_size_body-2), $font_family_body, $non_standard_characters, $font_color_body);
                              
                              if(isset($product_build_value['bundle_children']) && count($product_build_value['bundle_children']))
                              {
                                  if($sort_packing != 'none')
                                  {
                                      if($sortorder_packing == 'ascending') $sortorder_packing_bool = true;
                                      sksort($product_build_value['bundle_children'],$sort_packing,$sortorder_packing_bool);
                                  }
                                  
                                  foreach($product_build_value['bundle_children'] as $child)
                                  {
                                      if($this->y < ($min_product_y+($font_size_body)))
                                      {
                                          if($page_count == 1 && $return_address_yn == 0 && $bottom_shipping_address_yn == 0)
                                          {
                                              $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                                              $page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($font_size_subtitles * 2), 'UTF-8');
                                          }
                                          $page = $this->newPage();
                                          $page_count ++;
                                          $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);

                                          if($second_page_start == 'asfirst') $this->y = $items_header_top_firstpage;
                                          else $this->y = $page_top;

                                          $page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y), 'UTF-8');
                                          $this->y = ($this->y - ($font_size_subtitles*2));

                                          if(strtoupper($background_color_subtitles) != '#FFFFFF')
                                          {
                                              $page->setFillColor($background_color_subtitles_zend);            
                                              $page->setLineColor($background_color_subtitles_zend);    
                                              $page->setLineWidth(0.5);
                                              if($fill_product_header_yn == 0)
                                              {
                                                  $page->drawLine($padded_left, ($this->y-($font_size_subtitles/2)-2), ($padded_right), ($this->y-($font_size_subtitles/2)-2));
                                                  $page->drawLine($padded_left, ($this->y+$font_size_subtitles+2+2), ($padded_right), ($this->y+$font_size_subtitles+2+2));
                                              }
                                              else
                                              {
                                                  $page->drawRectangle($padded_left, ($this->y-($font_size_subtitles/2)), $padded_right, ($this->y+$font_size_subtitles+2));
                                              }
                                          }

                                          $this->_setFont($page, $font_style_subtitles, $font_size_subtitles, $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                                          $page->drawText(Mage::helper('sales')->__($qty_title), $qtyX, $this->y, 'UTF-8');
                                          $page->drawText(Mage::helper('sales')->__($items_title), ($productX+$productXInc+$first_item_title_shift), $this->y, 'UTF-8');
						if($product_sku_yn == 1) $page->drawText(Mage::helper('sales')->__($sku_title), $skuX, $this->y, 'UTF-8');

                                          if($product_options_yn == 'yescol')
                                          {
                                              $page->drawText(Mage::helper('sales')->__($product_options_title), ($optionsX), $this->y, 'UTF-8');
                                          }

                                          if($shelving_real_yn == 1)
                                          {
                                              $page->drawText(Mage::helper('sales')->__('shelf'), $shelfX, $this->y, 'UTF-8');
                                          }

                                          if($prices_yn != '0') 
                                          {
                                              $page->drawText(Mage::helper('sales')->__($price_title), $priceEachX, $this->y, 'UTF-8');
                                              $page->drawText(Mage::helper('sales')->__($total_title), $priceX, $this->y, 'UTF-8');
                                          }

                                          $this->y         = ($this->y - 28);
                                          $items_y_start     = $this->y;
                                          
                                          $this->_setFont($page, $font_style_body, ($font_size_body-2), $font_family_body, $non_standard_characters, '#333333');
                                          $page->drawText(Mage::helper('sales')->__('Bundle Options Cont\'d...').' : ', $bundle_options_x, $this->y , 'UTF-8');                                            

                                          $page->setLineWidth(0.5);
                                          $page->setFillColor($white_color);            
                                          $page->setLineColor($greyout_color);    
                                          $page->drawLine(($bundle_options_x), ($this->y-2), $bundle_line_x2, ($this->y-2));
                                          $page->setFillColor($black_color);
                                          $this->_setFont($page, $font_style_body, ($font_size_body-2), $font_family_body, $non_standard_characters, $font_color_body);
                                      }
                                      
                                      $product     = Mage::getModel('catalog/product')->setStoreId($storeId)->load($child->getProductId());
                                      $sku         = $child->getSku();
                                      $price         = $child->getPriceInclTax();
                                      $qty         = (int)$child->getQtyOrdered();
                                      $name         = $child->getName();
                                      
                                      $this->y -= $line_height;
                                      $options_y_counter += $line_height;
                                      
                                      $shelving_real = '';
                                      if($shelving_real_yn == 1)
                                      {
                                          if($product->getData($shelving_real_attribute))
                                          {
                                              $shelving_real = $product->getData($shelving_real_attribute);
                                          }
                                          elseif(Mage::getModel('catalog/product')->setStoreId($storeId)->load($child->getProductId())->getAttributeText($shelving_real_attribute))
                                          {
                                              $shelving_real = Mage::getModel('catalog/product')->setStoreId($storeId)->load($child->getProductId())->getAttributeText($shelving_real_attribute);
                                          }
                                          elseif($product[$shelving_real_attribute]) $shelving_real = $product[$shelving_real_attribute];
                                          if(is_array($shelving_real)) $shelving_real = implode(',',$shelving_real);
                                          $shelving_real = trim($shelving_real);
                                          $page->drawText($shelving_real, $shelfX, $this->y , 'UTF-8');
                                          unset($shelving_real);
                                      }
                                      
                                      if($from_shipment == 'shipment')
                                      {
                                          $qty_string = 's:'.$product_build[$sku]['bundle_qty_shipped'] . ' / o:'.$qty;
                                          $price_qty = $product_build[$sku]['bundle_qty_shipped'];
                                          $productXInc = 25;
                                      }
                                      else
                                      {
                                          $qty_string = $qty;
                                          $price_qty = $qty;
                                          $productXInc = 0;
                                      }
      
                                      $display_name = '';
                                      $name_length = 0;
                                      if(strlen($name) > ($character_breakpoint_name+2))
                                      {
                                          $display_name = substr(htmlspecialchars_decode($name), 0, ($character_breakpoint_name)).'…';
                                      }
                                      else $display_name = htmlspecialchars_decode($name);
                                  
					if($product_sku_yn == 1) $page->drawText($sku, $skuX, $this->y , 'UTF-8');
                                      $page->drawText($qty_string, ($qtyX+8), $this->y , 'UTF-8');
                                      if($prices_yn != '0')
                                      {
                                          $bundle_options_part_price_total = ($price_qty * $price);
                                          $bundle_price_display = $order->formatPriceTxt($price);
                                          $bundle_price_total_display = $order->formatPriceTxt($bundle_options_part_price_total);
                                          
                                          if($price > 0) $page->drawText('('.$bundle_price_display.')', $priceEachX, $this->y , 'UTF-8');
                                          if($bundle_options_part_price_total > 0) $page->drawText('('.$bundle_price_total_display.')', $priceX, $this->y , 'UTF-8');
                                      }

                                      $page->drawText($display_name, ($productX+$productXInc+2) , $this->y , 'UTF-8');                                
                                      unset($bundle_options_output);

                                      if($tickbox == 'pickpack')
                                      {
                                          $box_x = ($productX+$productXInc+$offset);
                                          $page->setLineWidth(0.5);
                                          $page->setFillColor($white_color);            
                                          $page->setLineColor($black_color);    
                                          $page->drawRectangle(($tickboxX_bundle), ($this->y), ($tickboxX_bundle+6), ($this->y+6));                                                
                                          $page->setFillColor($black_color);
                                      }
                                  }
                              }
                          }

		/**
		images start	
		*/
        $has_shown_product_image    = 0;
        $options_y_counter          = 0;
        $img_width                  = 0;
        $img_height                 = 0;
        $resize_x                   = null;
        $resize_y                   = null;
		$has_real_image_set			= null;
		$image_product_id			= null;
		$parent_ids					= array();
		$imagePaths					= array();
		$product_images_source_res	= $product_images_source;
		if($product_images_source == 'gallery') $product_images_source_res = 'image';

		if($product_images_yn == 1 && $sku_productid[$product_sku] != '')
		{
			$product_id = $product_build_value['product_id'];
			if ($image_product = Mage::getModel('catalog/product')->load($product_id)) 
			{
				$image_path = $image_product->getImage();
				$image_parent_sku = $image_product->getSku();
				$has_real_image_set = ($image_path != null && $image_path != "no_selection" && $image_path != '');
				$image_product_id = $product_id;

				if( ($has_real_image_set !== true) && (is_object($image_product)) && ($image_product->isConfigurable() === false) ) // if is child (not parent)
				{
					$parent_ids = Mage::getModel('catalog/product_type_configurable')->getParentIdsByChild($product_id);
					if(is_array($parent_ids))
					{
						foreach($parent_ids as $key => $parent_id)
						{
							if ($image_product = Mage::getModel('catalog/product')->load($parent_id)) 
							{
								$image_path = $image_product->getImage();
								$image_parent_sku = $image_product->getSku();
								$image_product_id = $parent_id;
								$has_real_image_set = ($image_path != null 
								&& $image_path != "no_selection" 
								&& $image_path != ''
								&& (strpos($image_path,'placeholder') === false));
							}
						}
					}
				}

                if(@Mage::helper('catalog/image')->init($image_product, $product_images_source_res))
                {
                    $img_width     	= $product_images_maxdimensions[0];
                    $img_height 	= $product_images_maxdimensions[1];

                    $orig_img_width	= Mage::helper('catalog/image')->init($image_product, $product_images_source_res)->getOriginalWidth();
                    $orig_img_height= Mage::helper('catalog/image')->init($image_product, $product_images_source_res)->getOriginalHeigh(); // getOriginalHeigh() = spell mistake
                    if($orig_img_width != $orig_img_height)
                    {
                        if($orig_img_width > $orig_img_height)
                        {
                            $img_height = ceil(($orig_img_height/$orig_img_width)*$product_images_maxdimensions[1]);
                        }
                        elseif($orig_img_height > $orig_img_width)
                        {
                            $img_width = ceil(($orig_img_width/$orig_img_height)*$product_images_maxdimensions[0]);
                        }
                    }

                    $x1         = $imagesX;
                    $y1         = ($this->y - $img_height + 5 + 3 -15);
                    $x2         = ($imagesX + $img_width);
                    $y2         = ($this->y + 5 + 3 -15);

                    if(is_integer($img_width)) $resize_x = ($img_width*4);
                    if(is_integer($img_height)) $resize_y = ($img_height*4);

                    $image_placeholder_height = ($y2-$y1);

                    // product_images_source = $thumbnail, small_image, image, gallery
					if($product_images_source == 'gallery')
					{
						$gallery = Mage::getModel('catalog/product')->load($image_product_id)->getMediaGalleryImages();
						// can get posiiton here

						$image_urls = array();
						foreach ($gallery as $image ) 
						{
						    $imagePath_temp = Mage::helper('catalog/image')->init($image_product, 'image', $image->getFile())
							->constrainOnly(TRUE)
                                        ->keepAspectRatio(TRUE)
                                        ->keepFrame(FALSE)
                                        ->resize($resize_x, $resize_y)
                                        ->__toString();
					
							if(strpos($imagePath_temp,'placeholder') === false) $imagePaths[] = $imagePath_temp;
						}
					}
					else
					{          
						$imagePath_temp = Mage::helper('catalog/image')->init($image_product, $product_images_source_res)
						->constrainOnly(TRUE)
						->keepAspectRatio(TRUE)
						->keepFrame(FALSE)
						->resize($resize_x, $resize_y)
						->__toString();
					
						if(strpos($imagePath_temp,'placeholder') === false) $imagePaths[] = $imagePath_temp;
					}

					$imagePath = '';
					$image_x_addon		= 0;
					$image_x_addon_2 	= 0;
					$count = 1;
					foreach($imagePaths as $imagePath)
					{
						$image_x_addon += ($count*($img_width + 10)); // shift the 2nd image over
						$image_x_addon_2 += (($count-1)*($img_width + 10)); // shift the 2nd image over
						$count ++;

						if(($this->y - $img_height + 5 + 3 -15) < (20+($font_size_subtitles*2)))
						{
							if($page_count == 1 && $return_address_yn == 0 && $bottom_shipping_address_yn == 0)
							{
								$this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
								$page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($font_size_subtitles * 2), 'UTF-8');
							}
							$page = $this->newPage();
							$page_count ++;
							$this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);

							if($second_page_start == 'asfirst') $this->y = $items_header_top_firstpage;
							else $this->y = $page_top;

							$page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y), 'UTF-8');
							$this->y = ($this->y - ($font_size_subtitles*2));

							if(strtoupper($background_color_subtitles) != '#FFFFFF')
							{
								$page->setFillColor($background_color_subtitles_zend);            
								$page->setLineColor($background_color_subtitles_zend);    
								$page->setLineWidth(0.5);
								if($fill_product_header_yn == 0)
								{
									$page->drawLine($padded_left, ($this->y-($font_size_subtitles/2)-2), ($padded_right), ($this->y-($font_size_subtitles/2)-2));
									$page->drawLine($padded_left, ($this->y+$font_size_subtitles+2+2), ($padded_right), ($this->y+$font_size_subtitles+2+2));
								}
								else
								{
									$page->drawRectangle($padded_left, ($this->y-($font_size_subtitles/2)), $padded_right, ($this->y+$font_size_subtitles+2));
								}
							}

							$this->_setFont($page, $font_style_subtitles, $font_size_subtitles, $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
							$page->drawText(Mage::helper('sales')->__($qty_title), $qtyX, $this->y, 'UTF-8');
							$page->drawText(Mage::helper('sales')->__($items_title), ($productX+$productXInc+$first_item_title_shift), $this->y, 'UTF-8');
							$page->drawText(Mage::helper('sales')->__($sku_title), $skuX, $this->y, 'UTF-8');

							if($product_options_yn == 'yescol')
							{
								$page->drawText(Mage::helper('sales')->__($product_options_title), ($optionsX), $this->y, 'UTF-8');
							}

							if($shelving_real_yn == 1)
							{
								$page->drawText(Mage::helper('sales')->__('shelf'), $shelfX, $this->y, 'UTF-8');
							}

							if($prices_yn != '0') 
							{
								$page->drawText(Mage::helper('sales')->__($price_title), $priceEachX, $this->y, 'UTF-8');
								$page->drawText(Mage::helper('sales')->__($total_title), $priceX, $this->y, 'UTF-8');
							}

							$this->_setFont($page, $font_style_body, ($font_size_body-2), $font_family_body, $non_standard_characters, $font_color_body);
							$x1         = ($imagesX);
							$y1         = ($this->y - $img_height + 5 + 3 -15);
							$x2         = ($imagesX + $img_width);
							$y2         = ($this->y + 5 + 3 -15);
						}
						if($product_images_border_color_temp != '#FFFFFF')
                        {        
                            $page->setLineWidth(0.5);
                            $page->setFillColor($product_images_border_color);            
                            $page->setLineColor($product_images_border_color);    
                            $page->drawRectangle(($x1 - 2 + $image_x_addon_2), ($y1 - 2-$font_size_body-5), ($x2 + 2 + $image_x_addon_2), ($y2 + 2-$font_size_body-5));
                            $page->setFillColor($black_color);
                        }

                        // $imageLocation     = str_replace(array('/media','media','//'),array('','','/'),Mage::getBaseDir('media')).'/'.substr($imagePath,strlen( str_replace('/index.php','',Mage::getBaseUrl()) ));
				
						$media_path 		= Mage::getBaseDir('media');
						// = /chroot/home/account/example.com/html/media

						$image_url 			= $imagePath;
						// = http://lghttp.20020.nexcesscdn.net/8098AB/eternity/media/extendware/ewminify/media/inline/6/36/636139/image-name.JPG

						$image_url_after_media_path_with_media = strstr($image_url, '/media/'); //preg_replace('§^.*[media]§i','',$image_url);
						// = /media/extendware/ewminify/media/inline/6/36/636139/image-name.JPG

						$image_url_after_media_path = strstr_after($image_url, '/media/'); //preg_replace('§^.*[media]§i','',$image_url);
						// = extendware/ewminify/media/inline/6/36/636139/image-name.JPG

						$final_image_path = $media_path . '/' . $image_url_after_media_path;
						// = /chroot/home/account/example.com/html/media/extendware/ewminify/media/inline/6/36/636139/image-name.JPG

						$image             = Zend_Pdf_Image::imageWithPath($final_image_path);
						$page->drawImage($image, $x1+$image_x_addon_2, $y1-$font_size_body-5, $x2+$image_x_addon_2, $y2-$font_size_body-5);
						$has_shown_product_image = 1;
					}								
				}
			 
			}

			$this->y -= 15;
            if($product_images_line_nudge != 0 && !isset($product_build_value['bundle_options_sku'])) 
			{
				$this->y = ($this->y + $product_images_line_nudge);
			}
            unset($product_id);
        }
		/**
		images end	
		*/
		      

                          if(isset($line_next_product)) $this->y = ($line_next_product+($font_size_body));
                          $this->y += ($font_size_body);
                          if($has_shown_product_image == 1 && ($options_y_counter < $img_height)) 
                          {
                              $border_addon = 4;
                              if($product_images_border_color_temp != '#FFFFFF') $border_addon += 4;
                              $this->y = ($this->y - ($image_placeholder_height + $options_y_counter + abs($product_images_line_nudge) + $border_addon));
                          }
                          else 
                          {
                              $this->y = ($this->y - $options_y_counter);
                          }
                          
                          //
                          // draw vert lines

                          if($background_color_vert_product_temp != '#FFFFFF')
                          {        
							if($has_shown_product_image == 1)
							{
								// if($image_height != 0 && $product_images_yn == 1) $this->y -= $image_height;
								if($product_images_line_nudge != 0) $vert = ($product_images_line_nudge * -1);
                              	$this->y -= ($font_size_body + 5);
							}
                              else
                              {
                                  $vert = ($font_size_body*1.5);
                              }

                              $top_y = $this->y;
                              // extend top
                              if($product_count == 1) 
                              {
                                  $top_y += ($font_size_body*1.5);
                                  $vert = ($vert * 2);
                              }
                              
                              //if(($doubleline_yn == 1) || ($new_line_after_name === true)) $vert = ($vert*2);

                              $page->setLineWidth(0.5);
                              $page->setFillColor($background_color_product);            
                              $page->setLineColor($background_color_product);    
                              $page->drawLine($padded_left, ($top_y), $padded_left, ($top_y - $vert));
                              $page->drawLine($padded_right, ($top_y), $padded_right, ($top_y - $vert));

                              $vert_x_nudge = 5;

                              if($product_images_yn == 1)
                              {
                                  $page->drawLine(($imagesX-$vert_x_nudge), ($top_y), ($imagesX-$vert_x_nudge), ($top_y - $vert));
                              }
                              $page->drawLine(($qtyX-$vert_x_nudge), ($top_y), ($qtyX-$vert_x_nudge), ($top_y - $vert));

                              $page->drawLine((($productX+$productXInc+$first_item_title_shift_items)-$vert_x_nudge), ($top_y), (($productX+$productXInc+$first_item_title_shift_items)-$vert_x_nudge), ($top_y - $vert));

                              if($product_sku_yn == 1) $page->drawLine(($skuX-$vert_x_nudge), ($top_y), ($skuX-$vert_x_nudge), ($top_y - $vert));

                              if($product_options_yn == 'yescol')
                              {
                                  $page->drawLine(($optionsX-$vert_x_nudge), ($top_y), ($optionsX-$vert_x_nudge), ($top_y - $vert));
                              }

                              if($shelving_real_yn == 1)
                              {
                                  $page->drawLine(($shelfX-$vert_x_nudge), ($top_y), ($shelfX-$vert_x_nudge), ($top_y - $vert));
                              }

                              if($shelving_yn == 1)
                              {
                                  $page->drawLine(($shelf2X-$vert_x_nudge), ($top_y), ($shelf2X-$vert_x_nudge), ($top_y - $vert));
                              }

                              if($shelving_2_yn == 1)
                              {
                                  $page->drawLine(($shelf3X-$vert_x_nudge), ($top_y), ($shelf3X-$vert_x_nudge), ($top_y - $vert));
                              }

                              if($prices_yn != '0') 
                              {
                                  $page->drawLine(($priceEachX-$vert_x_nudge), ($top_y), ($priceEachX-$vert_x_nudge), ($top_y - $vert));
                                  $page->drawLine(($priceX-$vert_x_nudge), ($top_y), ($priceX-$vert_x_nudge), ($top_y - $vert));
                              }

                              if($tax_col_yn == 1) 
                              {
                                  $page->drawLine(($taxEachX-$vert_x_nudge), ($top_y), ($taxEachX-$vert_x_nudge), ($top_y - $vert));
                              }

                              $page->setFillColor($black_color);
                          }
                          //
                          
                          if($background_color_product_temp != '#FFFFFF')
                          {
                              if($has_shown_product_image == 1)
                              {
                                  // if($image_height != 0 && $product_images_yn == 1) $this->y -= $image_height;
                                  if($product_images_line_nudge != 0) $this->y = $this->y + ($product_images_line_nudge * -1);
                              }
                              else
                              {
                                  $this->y -= ($font_size_body*1.5);
                              }
                              $page->setLineWidth(0.5);
                              $page->setFillColor($background_color_product);            
                              $page->setLineColor($background_color_product);    
                              $page->drawLine($padded_left, ($this->y+1), $padded_right, ($this->y+1));
                                                                              
                              $page->setFillColor($black_color);
                              $this->y -= (($font_size_body));
                          }
                          else $this->y -= ($font_size_body*2);
                          // else $this->y -= 15;
                          
                          if($doubleline_yn == 1) $this->y -= 15;
                      }
                      unset($product_build);
                      unset($product_build_value);
                      unset($sku);
                      // end sorted items output loop


// custom message image, if 'under products = yes'
                      $packlogo_filename = null;
                      $packlogo_path = null;
                      $bottom_image_width = null;
                      $bottom_image_height = null;

                      // custom message
                      // working out bottom image dimensions
                      if($message_yn == 'yesimage' && $custom_message_image_locked_yn == 0)
                      {
                          $this->y -= 40;
                          $max_y_custom_message += 40;
                          // 2250 x 417  (540 x 100)
                          // Dimensions 540pt(A4)|562pt(US Letter) x 100pt @ 300dpi : non-interlaced .png
                          if($invoice_or_pack == 'invoice') $packlogo_filename = $this->_getConfig('custom_message_image', null, false, $wonder, $store_id);
                          else $packlogo_filename = $this->_getConfig('custom_message_image_pack', null, false, $wonder, $store_id);

                          if($packlogo_filename)
                          {
                              $sub_folder = 'message_pack';
                              $option_group = 'wonder';

                              if($wonder != 'wonder')
                              {
                                  $sub_folder = 'message_invoice';
                                  $option_group = 'wonder_invoice';
                              }
                              
                              if($packlogo_filename)
                              {
                                  // $packlogo_path = Mage::getStoreConfig('system/filesystem/media', $store) . '/moogento/pickpack/'.$sub_folder.'/' . $packlogo_filename;
                                  $packlogo_path = Mage::getBaseDir('media') . '/moogento/pickpack/'.$sub_folder.'/' . $packlogo_filename;
                                  // changing url link of image into directory link
                                  $dirImg = Mage::getBaseDir().str_replace("/",DS,strstr($packlogo_path,'/media'));
                                  $imageObj = new Varien_Image($dirImg);
                                  $bottom_image_width = ceil($imageObj->getOriginalWidth() / 4.17);
                                  $bottom_image_height = ceil($imageObj->getOriginalHeight() / 4.17);
                              }
                          
                              if($this->y < ($max_y_custom_message +$bottom_image_height) )
                              {
                                  if($page_count == 1 && $return_address_yn == 0)
                                  {
                                      $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                                      $page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($font_size_subtitles * 2), 'UTF-8');
                                  }
                                  $page = $this->newPage();
                                  $page_count ++;
                                  $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                                  if($second_page_start == 'asfirst') $this->y = $items_header_top_firstpage;
                                  else $this->y = $page_top;

                                  $page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y), 'UTF-8');
                                  $this->y = ($this->y - ($font_size_subtitles*2));

                                  $items_y_start = $this->y;
                                  $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                              }        

                              $bottom_image_x1 = 20;
                              $bottom_image_x2 = (($bottom_image_width)+20);
                              $bottom_image_y1 = ($this->y-($bottom_image_height));
                              $bottom_image_y2 = $this->y;


                              if($custom_message_image_locked_yn == 1)
                              {
                                  $bottom_image_y2 = (10 + $bottom_image_height);
                                  $bottom_image_y1 = 10;


                                  if($page_template == 'tech' && $custom_message_image_line_yn == 1 && strtoupper($background_color_subtitles) != '#FFFFFF') 
                                  {
                                      $page->setFillColor($background_color_subtitles_zend);            
                                      $page->setLineColor($background_color_subtitles_zend);    
                                      $page->setLineWidth(0.5);                
                                      $page->drawLine(($padded_left),($bottom_image_y2 + ($font_size_subtitles/2)), $padded_right, ($bottom_image_y2 + ($font_size_subtitles/2)));
                                  }
                              }

                              if (is_file($packlogo_path)) 
                              {    
                                  $packlogo = Zend_Pdf_Image::imageWithPath($packlogo_path);            
                                  $page->drawImage($packlogo, $bottom_image_x1, $bottom_image_y1, $bottom_image_x2, $bottom_image_y2);
                              }
                          }
                      }
                      
                      
                      if($prices_yn != 0)
                      {    
                          if($page_template != 'tech')
                          {
                              $this->y -=5;
                              
                              if(strtoupper($background_color_subtitles) != '#FFFFFF')
                              {    
                                  $page->setFillColor($background_color_subtitles_zend);            
                                  $page->setLineColor($background_color_subtitles_zend);    
                                  $page->setLineWidth(0.5);                
                                  $page->drawLine($padded_left, ($this->y), $padded_right, ($this->y));
                              }
                          }
                          else $this->y -=15;
                          
                          if($background_color_subtitles != '#FFFFFF') $this->y -=20;
                          else $this->y -=10;
                          
                          // take account of extra tax line in subtotal
                          if($prices_yn == 1 && ($tax_yn == 'yessubtotal' || $tax_yn == 'yesboth')) $min_product_y += ($font_size_subtitles+2);
                      
                          if($this->y < $min_product_y)
                          {                                    
                              if($page_count == 1 && $return_address_yn == 0 && $bottom_shipping_address_yn == 0)
                              {
                                  $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                                  $page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($font_size_subtitles * 2), 'UTF-8');
                              }
                              $page = $this->newPage();
                              $page_count ++;
                              $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                              if($second_page_start == 'asfirst') $this->y = $items_header_top_firstpage;
                              else $this->y = $page_top;
                              $page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y), 'UTF-8');
                              $this->y = ($this->y - ($font_size_subtitles*2) - 5);
                              if(strtoupper($background_color_subtitles) != '#FFFFFF')
                              {        
                                  $page->setFillColor($background_color_subtitles_zend);            
                                  $page->setLineColor($background_color_subtitles_zend);    
                                  $page->setLineWidth(0.5);                
                                  $page->drawLine($padded_left, ($this->y), $padded_right, ($this->y));
                              }
                              $this->y         = ($this->y - 28);
                              $items_y_start     = $this->y;
                          }
                          $priceTextX = 410;
                          if($page_template == 'tech') $priceTextX = 350;
                      
                          $totals         = array();
                          $shipping_cost     = 0;
                          $tax_amount     = 0;
                          
                          /*
                          [shipping_plus_tax] => 21.6500
                          [shipping_ex_tax] => 20.0000
                          
                              [surcharge]         => 0
                              [surcharge_label]     =>
                              [sub_total]         => 619.9600
                              [taxamount]         => 13.2000
                              [shipping_base]     => 20.0000
                              --------------------------------
                              [grand_total]         => 653.1600
                          
                              subtotal_order[0]Subtotal   
                              [1]Discounts    
                              [2]Tax     
                              [3]Shipping
                          */

                  	 	/**
                       extra charges    
                       */
		if(@$order->getMultifees() && ($order->getMultifees() > 0))
		{
			$mage_surcharge_position = 90;
			$totals[$mage_surcharge_position]['key']     = 'mage_surcharge';
                           $totals[$mage_surcharge_position]['text']    = Mage::helper('multifees')->__('Additional Fees');
                           $totals[$mage_surcharge_position]['value']   = $order->getMultifees();
		}        
		                 
                          /**
                          surcharge    
                          */
                          $totals_xtra['surcharge']		= null;
                          $totals_xtra['surcharge_label']	= null;
                          // fooman surcharge
      // if(@$order->getBaseFoomanSurchargeAmount() &&$order->getBaseFoomanSurchargeAmount()>0)             $totals_xtra['surcharge'] += $order->getBaseFoomanSurchargeAmount();
      if(@$order->getFoomanSurchargeAmount() && $order->getFoomanSurchargeAmount()>0)                 $totals_xtra['surcharge'] += $order->getFoomanSurchargeAmount();
      // if(@$order->getBaseFoomanSurchargeTaxAmount() && $order->getBaseFoomanSurchargeTaxAmount()>0)     $totals_xtra['surcharge'] += $order->getBaseFoomanSurchargeTaxAmount();
      if(@$order->getFoomanSurchargeTaxAmount() && $order->getFoomanSurchargeTaxAmount()>0)             $totals_xtra['surcharge'] += $order->getFoomanSurchargeTaxAmount();
      if(@$order->getFoomanSurchargeDescription() && trim($order->getFoomanSurchargeDescription()) != '') $totals_xtra['surcharge_label'] = $order->getFoomanSurchargeDescription();
                          if($totals_xtra['surcharge'] > 0)
                          {
                              $surcharge_position = ($subtotal_order[0] + 1);
                              $totals[$surcharge_position]['key']     = 'surcharge';
                              $totals[$surcharge_position]['text']     = Mage::helper('sales')->__('Surcharge');
                              $totals[$surcharge_position]['value']     = $totals_xtra['surcharge'];
                              
                              if($totals_xtra['surcharge_label'] != null) $totals[$surcharge_position]['text'] = $totals_xtra['surcharge_label'];
                          }
                              
                          /**
                          shipping    
                          */
                          $totals_xtra['shipping_ex_tax']         = $order->getShippingAmount();
                          $totals_xtra['shipping_plus_tax']       = $order->getShippingInclTax();
                          $totals_xtra['shipping_tax']			= ($totals_xtra['shipping_plus_tax']-$totals_xtra['shipping_ex_tax']);
                          $totals[$subtotal_order[3]]['key']      = 'shipping_base';
                          $totals[$subtotal_order[3]]['text']     = Mage::helper('sales')->__('Shipping');
                          $totals[$subtotal_order[3]]['value']    = $order->getShippingAmount();

                          /**
                          sub total    
                          */
                          $totals[$subtotal_order[0]]['key']          = 'sub_total';
                          $totals[$subtotal_order[0]]['text']         = Mage::helper('sales')->__('Subtotal');
                          $totals[$subtotal_order[0]]['value']        = $order->getSubtotal();
                          
                          if(isset($subtotal_addon['magikfee']) && $subtotal_addon['magikfee'] != '')
                          {
                          	$totals[$subtotal_order[0]]['value'] += $subtotal_addon['magikfee'];
                          }
                      
                          /**
                          tax total    
                          */    
                          if($tax_yn == 'no' || $tax_yn == 'yescol')
                          {
                              $totals[$subtotal_order[0]]['value'] += $order->getTaxAmount();
                          }
                          else
                          {
                              if($tax_bands_yn == 0)
                              {
                                  $totals[$subtotal_order[2]]['key']         = 'taxamount';
                                  $totals[$subtotal_order[2]]['text']     = $tax_label;//'Tax';
                                  $totals[$subtotal_order[2]]['value']     = $order->getTaxAmount();
				if($tax_yn == 'yesboth' || $tax_yn == 'noboth') 
                                  {
                                      $totals[$subtotal_order[2]]['text']     = $tax_label .' Incl.';
                                      // add tax to subtotal if already shown tax in product line
                                      $totals[$subtotal_order[0]]['value'] += $order->getTaxAmount();
                                  }
				if($totals[$subtotal_order[2]]['value'] < 0.01)
				{
					$totals[$subtotal_order[2]] = null;
				}
                              }
                              else
                              {
                                  // Subtotal[0]   Discounts[1]    Tax [2]    Shipping[3]
                                  if($tax_yn == 'yesboth') 
                                  {
                                      // add tax to subtotal if already shown tax in product line
/**
Option to add shipping tax to tax subtotal needed?	
*/
					// $amount = $order->getGrandTotal() - $order->getShippingAmount() - $order->getShippingTaxAmount();
                                      // $totals[$subtotal_order[0]]['value'] += $order->getTaxAmount();
					$totals[$subtotal_order[0]]['value'] += ($order->getTaxAmount()-$order->getShippingTaxAmount());
					
					// add shpping tax to shipping subtotal - MAY NEED SEPARATE OPTION
					$totals[$subtotal_order[3]]['value'] += $order->getShippingTaxAmount();
					
                                      $tax_label = $tax_label .' Incl.';
                                  }

                                  $counted_tax_amount = 0;
                                  foreach($tax_percents as $tax_percent => $tax_percent_amount)
                                  {
                                  
                                      // 20%
                                      // 20.07%
                                      // 20.10%
                                      // -> should all be 20%
                                      // if(!isset($rounded_tax[round($tax_percent,0)])) $rounded_tax[round($tax_percent,0)] = $tax_percent_amount;
                                      // else $rounded_tax[round($tax_percent,0)] = ($rounded_tax[round($tax_percent,0)] + $tax_percent_amount);                        
                                      if($tax_percent_amount > 0)
                                      {
                                          $tax_percent = number_format($tax_percent,2,'.',''); //trim(preg_replace('~\.00(.*)$~','',$tax_percent));
                                          $tax_percent = preg_replace('~\.0(.*)$~','',$tax_percent);
                                          $tax_percent = preg_replace('~\.1(.*)$~','',$tax_percent);
                                          
                                          // $rounded_tax_key = round($tax_percent,0);
                                          
                                          // if(isset($rounded_tax[$rounded_tax_key])) $rounded_tax[$rounded_tax_key] += $tax_percent_amount;
                                          //                                                 else $rounded_tax[$rounded_tax_key] = $tax_percent_amount;
                                          $counted_tax_amount += $tax_percent_amount;
                                      }
                                  }
                              
                                  $full_tax_amount = $order->getTaxAmount();
                                  $maybe_shipping_tax = ($full_tax_amount - $counted_tax_amount);
                                  if($maybe_shipping_tax > 0)
                                  {
                                      //$shipping_tax_percent = number_format((($maybe_shipping_tax/$order->getBaseShippingAmount()) * 100),2,'.',''); 
                                      $shipping_tax_percent = number_format((($maybe_shipping_tax/$order->getShippingAmount()) * 100),2,'.',''); 
                                      $shipping_tax_percent = preg_replace('~\.0(.*)$~','',$shipping_tax_percent);
                                      $shipping_tax_percent = preg_replace('~\.1(.*)$~','',$shipping_tax_percent);
                                      //trim(preg_replace('~\.00(.*)$~','',round(( ($maybe_shipping_tax/$order->getBaseShippingAmount()) * 100))));
                                      if($shipping_tax_percent > 0)
                                      {
                                          if(isset($tax_percents[$shipping_tax_percent])) $tax_percents[$shipping_tax_percent] += $maybe_shipping_tax;
                                          else $tax_percents[$shipping_tax_percent] = $maybe_shipping_tax;
                                          // could check for rounded tax there
                                      }
                                  }

                                  $tax_position = $subtotal_order[2];
                                  $tax_position_count = 0;
                                  foreach($tax_percents as $tax_percent => $tax_percent_amount)
                                  {    
                                      if($tax_percent_amount > 0)
                                      {
										if(stripos($tax_label,'moms') === false) $tax_text = $tax_label.' @ '.$tax_percent.'%';
										else $tax_text = $tax_label.' '.$tax_percent.'%';
                                          
						$tax_key_pos = ($tax_position+($tax_position_count*1));
                                          $totals[$tax_key_pos]['key']     = 'taxamount';
                                          $totals[$tax_key_pos]['text']     = $tax_text;//'Tax';
                                          $totals[$tax_key_pos]['value']    = $tax_percent_amount;
                                  
                                          $tax_position_count ++;
                                      }
                                  }
                              }
                          }
		if(isset($totals[$subtotal_order[2]]['value']))
		{
			if($totals[$subtotal_order[2]]['value'] < 0.01)
			{
				$totals[$subtotal_order[2]] = null; // don't show tax if value is 0
			}
		}
		else $totals[$subtotal_order[2]] = null;
		
                         /**
                          refunds    
                          */
		$total_refunded = $order->getTotalRefunded();
		/*
		$total_refunded = ($order->getDiscountRefunded() 
			+ $order->getShippingRefunded() 
			+ $order->getShippingTaxRefunded()
			+ $order->getSubtotalRefunded()
			+ ($order->getTaxRefunded() - $order->getShippingTaxRefunded()));*/
		if($total_refunded > 0)
                          {
                              $totals[95]['key']  = 'refunds'; // put in same order as discounts
                              $totals[95]['text'] = Mage::helper('sales')->__('Refunds');
                              $totals[95]['value']= ($total_refunded*-1);                                    
                          }
                          
                          /**
                          discounts    
                          */
                          if($price_discount_unrounded > 0 && ($discount_line_or_subtotal == 'subtotal') )
                          {
                              $totals[$subtotal_order[1]]['key']  = 'discount';
                              $totals[$subtotal_order[1]]['text'] = $item_discount_label;
                              $totals[$subtotal_order[1]]['value']= ($price_discount_unrounded*-1);                                    
                          }
                          
                          /**
                          grand total    
                          */
                          // $totals[100]['grand_total']             = $order->getGrandTotal();
                          $totals[100]['key']                     = 'grand_total';
                          $totals[100]['text']                    = Mage::helper('sales')->__('Grand Total');
		$totals[100]['value'] 					= ($order->getGrandTotal()-$total_refunded);
                  
                          ksort($totals);

// Subtotal[0]   Discounts[1]    Tax [2]    Shipping[3]
                          $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);

                          // if($page_template != 'tech') $this->y -= ($font_size_body);
                     
                          $subtotal_count = 0;
                          foreach($totals as $key => $value)
                          {
                              // $totals[$key]['key']     = 'grand_total';
                              // $totals[$key]['text']     = 'Grand Total';
                              // $totals[$key]['value']     = 1222.21;
                              
                              /*
                                  if($background_color_vert_product_temp != '#FFFFFF')
                                  {    
                                      $vert = ($font_size_body*1.5);
                                      $top_y = ($this->y-($font_size_body*0.45));

                                      $page->setLineWidth(0.5);
                                      $page->setFillColor($background_color_product);            
                                      $page->setLineColor($background_color_product);    
                                      // $page->drawLine($padded_left, ($top_y), $padded_left, ($top_y - $vert));
                                      // $page->drawLine($padded_right, ($top_y), $padded_right, ($top_y - $vert));

                                      $vert_x_nudge = 5;

                                      // left of 'total qty' title
                                      $page->drawLine(($skuX-$vert_x_nudge), ($top_y), ($skuX-$vert_x_nudge), ($top_y + $vert));
                                      // right of 'total qty' title
                                      $page->drawLine(($productX+$productXInc+$first_item_title_shift-$vert_x_nudge), ($top_y), ($productX+$productXInc+$first_item_title_shift-$vert_x_nudge), ($top_y + $vert));
                                      // left of total qty Number
                                      $page->drawLine(($qtyX-$vert_x_nudge), ($top_y), ($qtyX-$vert_x_nudge), ($top_y + $vert));

                                      // bottom horiz
                                      $page->drawLine(($qtyX-$vert_x_nudge), ($top_y), ($productX+$productXInc+$first_item_title_shift-$vert_x_nudge), ($top_y));
                                      $page->setFillColor($black_color);
                                  }
                                  //
                              */

                              if($value > 0)
                              {	
								// don't show zero value shipping
								if(($totals[$key]['key'] == 'shipping_base') && ($totals[$key]['value'] == '0.0000')) {continue;}
                                  
								if($page_template == 'tech' && ($totals[$key]['key'] != 'grand_total'))
                                  {
                                      // change spacing under lines, + = less space
                                      $this->y += ($font_size_subtitles/3);
                                      $page->setFillColor($background_color_subtitles_zend);            
                                      $page->setLineColor($background_color_subtitles_zend);    
                                      $page->setLineWidth(0.5);                
                                      $page->drawLine(($priceTextX-($font_size_body*5)),($this->y), $padded_right, ($this->y));
                                      $this->y -= ($font_size_subtitles*1.3);
                                      $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                                  }                
                              
                                  if($totals[$key]['key'] != 'grand_total')
                                  {
                                  
                                      $tax_incl_left_bkt     = '';
                                      $tax_incl_rt_bkt     = '';
                                  
					if($totals[$key]['key'] == 'taxamount' && ($tax_yn == 'yesboth' || $tax_yn == 'noboth'))
                                      {
                                          // $tax_incl_left_bkt = '(';
                                          //                                           $tax_incl_rt_bkt = ')';
                                      }
                                  
                                      if($page_template == 'tech') 
                                      {
                                          $this->_setFont($page, $font_style_subtitles, $font_size_subtitles, $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                                          $page->drawText($tax_incl_left_bkt.Mage::helper('sales')->__($totals[$key]['text']), $priceTextX, $this->y , 'UTF-8');
                                          $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                                      }
                                      else $page->drawText($tax_incl_left_bkt.Mage::helper('sales')->__($totals[$key]['text']), $priceTextX, $this->y , 'UTF-8');
                          
                                      $page->drawText($order->formatPriceTxt(number_format($totals[$key]['value'], 2, '.', ',')).$tax_incl_rt_bkt, $priceX, $this->y , 'UTF-8');
                                      if($page_template == 'tech') $this->y -= ($font_size_subtitles); 
                                      else $this->y -=15;
                                  }
                                  else
                                  {	
                                      if($page_template == 'tech')
                                      {
                                          $page->setFillColor($background_color_subtitles_zend);            
                                          $page->setLineColor($background_color_subtitles_zend);
                                          $page->setLineWidth(0.5);
                                          // shift down Grand Total box
                                          $this->y -= ($font_size_subtitles-($font_size_subtitles/4));
                                          $page->drawRoundedRectangle(($priceTextX-($font_size_body*5)),($this->y-($font_size_subtitles/2)-3), $padded_right, ($this->y+$font_size_subtitles+1),array(0,0,6,6));    
                                          $this->y -=2;                                        
                                      }
                                      else
                                      {    
                                          $page->drawLine(($priceTextX-($font_size_body*2)), ($this->y), $padded_right, ($this->y));
                                          if($background_color_subtitles != '#FFFFFF') $this->y -=20;
                                          else $this->y -=10;
                                      }
                                      // else
                                      //                                             {    
                                      //                                                 $this->y += $font_size_body;
                                      //                                                 
                                      //                                                 $page->drawLine(($priceTextX-($font_size_body*2)), ($this->y), $padded_right, ($this->y));
                                      //                                                 
                                      //                                                 $this->y -= ($font_size_body*1.2);
                                      //                                                 
                                      //                                                 // if($background_color_subtitles != '#FFFFFF') 
                                      //                                                 //                                             {
                                      //                                                 //                                                 $this->y -=20;
                                      //                                                 //                                             }
                                      //                                                 //                                             else $this->y -=10;
                                      //                                             }
                                  
                                      $this->_setFont($page, 'bold', $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                                      if($title_invert_color == 1)
                                      {                    
                                          $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles+1), $font_family_subtitles, $non_standard_characters, '#FFFFFF');
                                          $page->drawText(Mage::helper('sales')->__($totals[$key]['text']), $priceTextX, $this->y , 'UTF-8');
                                          $this->_setFont($page, 'bold', ($font_size_subtitles+1), $font_family_body, $non_standard_characters, $font_color_body);
                                      }
                                      else $page->drawText(Mage::helper('sales')->__($totals[$key]['text']), $priceTextX, $this->y , 'UTF-8');
                                  
                                      $page->drawText($order->formatPriceTxt(number_format($totals[$key]['value'], 2, '.', ',')), $priceX, $this->y , 'UTF-8');
                                  }
                                  $subtotal_count ++;
                              }
                          }                                                        
                      }
                          
                      $order_notes_was_set = false;
                      /* Add Order Notes*/    
                      if($notes_yn != 'no' && $notes_yn != 'yesemail')
                      { 
                          /*
                              [entity_id] => 17
                                                          [parent_id] => 8
                                                          [is_customer_notified] => 0
                                                          [is_visible_on_front] => 1
                                                          [comment] => New note two ('visible on frontend')
                                                          [status] => pending
                                                          [created_at] => 2011-02-08 01:21:55
                                                          [store_id] => 1
                          */
                          $notesX = 0;
                          
                          if($order->getStatusHistoryCollection(true))
                          {
                              $notes = $order->getStatusHistoryCollection(true);                                
                              $note_line = array();
                              $note_comment_count = 0;
                              
                              $i = 0;
                              foreach ($notes as $_item)
                              {
                                  $_item['comment'] = trim(strip_tags(str_replace(array('<br/>','<br />'),' ',$_item['comment'])));
                                  if($notes_filter_options == 'yestext' && (stripos($_item['comment'], $notes_filter) !== false))
				{
					$_item['comment'] = '';
				}
				elseif($notes_filter_options == 'yesfrontend' && $_item['is_visible_on_front'] != 1) 
				{
					$_item['comment'] = '';
				}
				
				if($_item['comment'] == '')
				{
					break;
				}

                                  $_item['created_at'] = date('m/d/y',strtotime($_item['created_at']));
                                  if(trim($_item['comment']) != '') $_item['comment'] = $_item['created_at'].' : '.$_item['comment'];
                                  
                                  if($notes_yn == 'yesbox')
                                  {
                                      $_item['comment'] = wordwrap($_item['comment'], 50, "\n", false);
                                  }
                                  
                                  $note_line[$i]['date'] = $_item['created_at'];
                                  $note_line[$i]['comment'] = $_item['comment'];
                                  
                                  if((($notes_filter_options == 'yesfrontend' && $_item['is_visible_on_front'] == 1) || $notes_filter_options == 'no' || ($notes_filter_options == 'yestext' && !preg_match('~'.$notes_filter.'~i',$_item['comment'])))  && ($_item['comment'] != ''))
                                  {
                                      if($note_line[$i]['comment'] != '') $note_comment_count = 1;
                                  }
                                  else $note_line[$i]['comment'] = '';
                                  $i ++;
                              }
                              
                              // for the bottom of gift message
                              $comments_y = $this->y;
                              
                              if($note_comment_count > 0 || ($page_template == 'tech'))
                              {
                                  $character_breakpoint            = 50;
                                  $test_name            = 'abcdefghij';//10
                                  $font_temp             = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
                                  $test_name_length     = round($this->parseString($test_name,$font_temp,($font_size_body)));
                                  $pt_per_char             = ($test_name_length/10);
                                  $max_name_length         = $padded_right;
                                  $character_breakpoint             = round(($max_name_length/$pt_per_char)-25);
                                  
                                  $this->y -= ($font_size_gift_message + 5);

                                  if($notes_yn == 'yesbox')
                                  {
                                      $this->y = $notesXY[1];
                                      $notesX = $notesXY[0];
                                  }
                                  elseif($notes_yn == 'yesunder')
                                  {
                                      $notesX = 25;    
                                      if(!$message || ($message && (strtoupper($background_color_message) == '#FFFFFF' || $background_color_message_zend == '')))
                                      {    
                                          $this->y -= 13;
                                          if($page_template == 'tech') 
                                          {
                                              $this->y -= 10;
                                          }
                                          // zzz
                                          if(strtoupper($background_color_message) != '#FFFFFF')
                                          {
                                              $page->setFillColor($background_color_message_zend);            
                                              $page->setLineColor($background_color_message_zend);            
                                              $page->setLineWidth(0.5);                
                                              $page->drawRectangle($padded_left, ($this->y + $font_size_gift_message + 10), $padded_right, ($this->y + $font_size_gift_message + 7));
                                          }
                                      }
                                  }
                                  
                                  
                                  if($page_template == 'tech')
                                  {
                                      $this->y -= ($font_size_subtitles*3);
                                      if($custom_message_image_locked_yn == 1) $this->y = ($bottom_image_height+($font_size_gift_message*5) + 10);
                                      
                                      $this->_setFont($page, $font_style_subtitles, $font_size_subtitles, $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                                      $page->drawText(Mage::helper('sales')->__('Comments'), ($padded_left + $addressXY[0]), $this->y);

                                      // for the bottom of gift message
                                      $comments_y = $this->y;
                                  }
                                  else
                                  {
                                      $this->_setFont($page, 'bold', $font_size_gift_message, $font_family_gift_message, $non_standard_characters, $font_color_gift_message);
                                      $page->drawText(Mage::helper('sales')->__('Order Notes'), ($notesX), $this->y);
                                      // for the bottom of gift message
                                      $comments_y = $this->y;
                                  }
                                  
                                  $this->y -= ($font_size_gift_message + 4);
                                  $this->_setFont($page, $font_style_gift_message, ($font_size_gift_message-1), $font_family_gift_message, $non_standard_characters, $font_color_gift_message);
                              
                                  sksort($note_line, 'date', true);

                                  $i = 0;
                                  while(isset($note_line[$i]['date']))
                                  {
                                      $note_line[$i]['comment']             = wordwrap($note_line[$i]['comment'], $character_breakpoint, "\n", false);
                                      
                                      // wordwrap characters
                                      $token = strtok($note_line[$i]['comment'], "\n");
                                      while ($token != false) 
                                      {
                                          if($page_template != 'tech') $page->drawText(trim($token), ($notesX), $this->y);
                                          else $page->drawText(trim($token), ($padded_left + $addressXY[0]), $this->y);
                                          $this->y-=10;
                                          $token = strtok("\n");
                                      }        
                                      $order_notes_was_set = true;
                                  
                                      $i ++;                    
                                  }
                              }
                          
                              unset($note_line);
                          }
                      }
                      
                      /* Add QC Message*/    
                      if($packed_by_yn == 1)
                      { 
                              $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                              $page->drawText(Mage::helper('sales')->__('Packed by: ____'), $packedByXY[0], $packedByXY[1], 'UTF-8');
                      }
                                                  
                      /* Add Gift Message*/  
                      $msg_line_count = 0;  
                      if($gift_message_yn != 'no' && (!is_null($gift_message_id) || $giftWrap_info['message'] != NULL|| $giftWrap_info['wrapping_paper'] != NULL))                
                      {
                          $gift_msg_array = array();
                          $notesX = 25;    
                          $gift_sender     = '';
                          $gift_recipient = '';
                          $gift_message     = '';
                      
                          if($gift_message_yn != 'no' && !is_null($gift_message_id))
                          {
                              // normal gift message
                              $gift_message_item->load((int)$gift_message_id);
                              $gift_sender     = $gift_message_item->getData('sender');
                              $gift_recipient = $gift_message_item->getData('recipient');
                              $gift_message     = $gift_message_item->getData('message');
                          }
                          
                          if($giftWrap_info['message'] != NULL) 
                          {
                              if($gift_message != '') $gift_message .= "\n";
                              $gift_message .= $giftWrap_info['message'];
                          }
                          
                          $to_from = '';
                          $to_from_from = '';
                          if(isset($gift_recipient) && $gift_recipient != ''){
                              if($gift_message_yn != 'yesnewpage') $to_from .= 'Message to '.$gift_recipient;
                              else $to_from .= 'To '.$gift_recipient;
                              //if(isset($gift_sender)) $to_from .= ', from '.$gift_sender.' :';
                          }
                          //elseif(isset($gift_sender) && $gift_sender != '') $to_from .= 'From '.$gift_sender.' :';
                          if(isset($gift_sender) && $gift_sender != '') $to_from_from = 'From '.$gift_sender;

                          if($gift_message_yn == 'yesbox')
                          {
                              $this->y = $giftMessageXY[1];
                              $msgX = $giftMessageXY[0];
                              $gift_message = wordwrap($gift_message, 50, "\n", false);
                          }
                          elseif($gift_message_yn == 'yesunder')
                          {
                              $msgX = 35;
                              $gift_message = wordwrap($gift_message, 115, "\n", false);
                          }
                          elseif($gift_message_yn == 'yesnewpage')
                          {
                              $msgX = 35;
                              $gift_message = wordwrap($gift_message, 115, "\n", false);
                          }
                          
                          // wordwrap characters
                          $token = strtok($gift_message, "\n");
                          // $y = 740; 
                          $msg_line_count = 2.5;
                          while ($token != false) 
                          {
                              $gift_msg_array[] = $token;
                              $msg_line_count ++;
                              $token = strtok("\n");
                          }
                      
                          if($order_notes_was_set)
                          {    
                                  // for the bottom of gift message
                              if($page_template == 'tech') 
                              {
                                  $this->y = $comments_y + ($font_size_gift_message * ($msg_line_count + 4)) + 10;
                                  $msgX = ($padded_left + $addressXY[0]);
                              }
                              elseif(strtoupper($background_color_message) != '#FFFFFF')
                              {
                                  $page->setFillColor($white_color);            
                                  $page->setLineColor($background_color_message_zend);            
                                  $page->setLineWidth(0.5);                
                                  $page->drawRectangle($padded_left, ($this->y + $font_size_gift_message + 10), $padded_right, ($this->y - ((($font_size_gift_message) * $msg_line_count) + 7)));
                              }
                          }
                          
                          if($gift_message_yn != 'yesnewpage')
                          {
                              $this->y -= 20;
                              
                              if($page_template != 'tech') 
                              {
                                  $this->_setFont($page, 'bold', ($font_size_gift_message), $font_family_gift_message, $non_standard_characters, $font_color_gift_message);
                              }
                              else
                              {
                                  $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                              }

                              $page->drawText(Mage::helper('sales')->__($to_from), ($msgX), $this->y, 'UTF-8');
                              $this->y -=($font_size_gift_message+8);
                              $this->_setFont($page, $font_style_gift_message, ($font_size_gift_message-1), $font_family_gift_message, $non_standard_characters, $font_color_gift_message);
                              foreach($gift_msg_array as $gift_msg_line)
                              {
                                  $page->drawText(trim($gift_msg_line), ($msgX), $this->y);
                                  $this->y-=($font_size_gift_message+3);
                              }
                              unset($gift_msg_array);
                              
                              if(isset($to_from_from) && ($to_from_from != ''))
                              {
								  //$this->y -=($font_size_gift_message+8);
								  if($page_template != 'tech') $this->_setFont($page, 'bold', ($font_size_gift_message), $font_family_gift_message, $non_standard_characters, $font_color_gift_message);
								  else $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
								  $page->drawText(Mage::helper('sales')->__($to_from_from), ($msgX), $this->y, 'UTF-8');
							  }                              

                              if(isset($giftWrap_info['wrapping_paper']))
                              {
                                  $wrapping_paper_text = trim($giftWrap_info['wrapping_paper']);
                                  if($wrapping_paper_text != '')
                                  {
                                      if($gift_message_yn == 'yesnewpage')
                                      {
                                          $this->y-=($font_size_gift_message+3);
                                          
                                          if(strtoupper($background_color_message) != '#FFFFFF')
                                          {    
                                              $page->setFillColor($background_color_message_zend);            
                                              $page->setLineColor($background_color_message_zend);    
                                              $page->setLineWidth(0.5);    
                                              $page->drawRectangle($padded_left, ($this->y-($font_size_gift_message/2)), $padded_right, ($this->y+$font_size_gift_message+2));
                                          }
                                          
                                          if($page_template != 'tech') 
                                          {
                                              $this->_setFont($page, 'bold', ($font_size_gift_message), $font_family_gift_message, $non_standard_characters, $font_color_gift_message);
                                          }
                                          else
                                          {
                                              $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                                          }
						$this->y -=($font_size_gift_message+2);
                                          $page->drawText(Mage::helper('sales')->__('Wrapping Paper Selected'), ($msgX), $this->y, 'UTF-8');
                                      }
                                      else 
                                      {
                                          if($page_template != 'tech') 
                                          {
                                              $this->_setFont($page, 'bold', ($font_size_gift_message), $font_family_gift_message, $non_standard_characters, $font_color_gift_message);
                                          }
                                          else
                                          {
                                              $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                                          }
						$this->y -=($font_size_gift_message+2);
                                          $page->drawText(Mage::helper('sales')->__('Wrapping Paper Selected'), ($msgX), $this->y, 'UTF-8');
                                      }
					$this->y -=($font_size_gift_message+2);
					$this->_setFont($page, 'regular', ($font_size_gift_message-1), $font_family_gift_message, $non_standard_characters, $font_color_gift_message);
                                      $page->drawText($wrapping_paper_text, ($msgX), $this->y);
                                  }
                              }                            
                          }
                      }
                           
                          
                      if($message_yn == 'yes')
                      {
                          $this->y -= ($font_size_message*1.5);
                      
                          if(!isset($custom_message_box_left)) $custom_message_box_left = $padded_left;                                
                          if(!isset($message_array)) $message_array = explode("\n", $message);
                          if(!isset($line_count)) $line_count = (count($message_array)-1);
                          
                          if(strtoupper($background_color_message) != '#FFFFFF')
                          {
                              $page->setFillColor($background_color_message_zend);            
                              $page->setLineColor($background_color_message_zend);            
                              $page->setLineWidth(0.5);                                                
                              $page->drawRectangle($custom_message_box_left, ($this->y-($line_count*($font_size_message+2))-10), $padded_right, ($this->y+11-10));
                          }
                          
                          $this->_setFont($page, $font_style_message, $font_size_message, $font_family_message, $non_standard_characters, $font_color_message);
                          $this->y -= ($font_size_message*1.25);
                          
                          foreach ($message_array as $value)
                          {
                              if($non_standard_characters == 0) 
                              {
                                  $font_temp = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
                              }
                              else
                              {                                                
                                  $font_temp = Zend_Pdf_Font::fontWithPath(dirname(__FILE__)  . '/' . 'arial.ttf');  
                              }
                              $line_width = ceil($this->parseString($value,$font_temp,($font_size_message*0.96)));//*0.77)); // bigger = left

                              $left_margin = ceil((($padded_right-$line_width)/2));
                              if($left_margin < 0) $left_margin = 0;

                              if($line_width == 0) // some issue with non-standard fonts
                              {
                                  $left_margin = 25;
                              }

                              if(isset($value) && isset($left_margin) && ($this->y > 9)) $page->drawText($value,$left_margin, $this->y, 'UTF-8');
                              $this->y -= ($font_size_message + 2);
                              if($this->y < 10) $this->y = 10;
                          }
                      }
                      
                      
                      if($gift_message_yn != 'no' && (!is_null($gift_message_id) || $giftWrap_info['message'] != NULL|| $giftWrap_info['wrapping_paper'] != NULL))                
                      {
                          if($gift_message_yn == 'yesnewpage')
                          {
                              $page = $this->newPage();
                              $page_count ++;
                              if($second_page_start == 'asfirst') $this->y = $items_header_top_firstpage;
                          
                              if(strtoupper($background_color_message) != '#FFFFFF')
                              {
                                  $page->setFillColor($background_color_message_zend);            
                                  $page->setLineColor($background_color_message_zend);    
                                  $page->setLineWidth(0.5);    
                                  $page->drawRectangle($padded_left, ($this->y-($font_size_gift_message/2)), $padded_right, ($this->y+$font_size_gift_message+2));
                              }
                              
                              $this->_setFont($page, 'bold', ($font_size_gift_message), $font_family_gift_message, $non_standard_characters, $font_color_gift_message);
                              $page->drawText(Mage::helper('sales')->__('Gift Message for Order').' #'.$order->getRealOrderId(), ($msgX), $this->y, 'UTF-8');
                              $this->y = ($this->y - 10 - $font_size_gift_message);
                          
                              foreach($gift_msg_array as $gift_msg_line)
                              {
                                  $page->drawText(trim($gift_msg_line), ($msgX), $this->y);
                                  $this->y-=($font_size_gift_message+3);
                              }
                              unset($gift_msg_array);

                              if(isset($giftWrap_info['wrapping_paper']))
                              {
                                  $wrapping_paper_text = trim($giftWrap_info['wrapping_paper']);
                                  if($wrapping_paper_text != '')
                                  {
                                      if($gift_message_yn == 'yesnewpage')
                                      {
                                          $this->y-=($font_size_gift_message+3);
                                          
                                          if(strtoupper($background_color_message) != '#FFFFFF')
                                          {
                                              $page->setLineColor($background_color_message_zend);    
                                              $page->setLineWidth(0.5);    
                                              $page->drawRectangle($padded_left, ($this->y-($font_size_gift_message/2)), $padded_right, ($this->y+$font_size_gift_message+2));
                                          }
                                          
                                          $this->_setFont($page, 'bold', ($font_size_gift_message), $font_family_gift_message, $non_standard_characters, $font_color_gift_message);
                                          $page->drawText(Mage::helper('sales')->__('Wrapping Paper Selected'), ($msgX), $this->y, 'UTF-8');
                                          $this->_setFont($page, $font_style_gift_message, ($font_size_gift_message-1), $font_family_gift_message, $non_standard_characters, $font_color_gift_message);
                                          $this->y = ($this->y - 10 - $font_size_gift_message);
                                      }
                                      else 
                                      {
                                          $this->_setFont($page, 'bold', ($font_size_gift_message), $font_family_gift_message, $non_standard_characters, $font_color_gift_message);
                                          $page->drawText(Mage::helper('sales')->__('Wrapping Paper Selected'), ($msgX), $this->y, 'UTF-8');
                                      }                                            
                                      $page->drawText($wrapping_paper_text, ($msgX), $this->y);
                                  }
				$this->y -= $font_size_subtitles;
				$this->_setFont($page, 'regular', ($font_size_gift_message-2), $font_family_gift_message, $non_standard_characters, $font_color_gift_message);
                              }
                          }
                      }
                  
                  
                      $page_count    = 1;
                      
                  }
              }
              
              if((!isset($supplier_ubermaster[($s+1)])) || ($split_supplier_yn == 'no')) 
              {
                  $loop_supplier = 0;
              }
              $s ++;
          }
          while($loop_supplier != 0);
                          
          $this->_afterGetPdf();
          return $pdf;
    }

         /***********************************************
        * Default Template - END
        ************************************************/



/**
   getPickSeparated 2222222  Template - START
    ************************************************/

public function getPickSeparated2($orders=array(), $from_shipment = 'order')
{

    if(function_exists('sksort'))
    {}
    else
    {
        function sksort(&$array, $subkey, $sort_ascending=false) 
        {

            if (count($array))
                $temp_array[key($array)] = array_shift($array);

            foreach($array as $key => $val){
                $offset = 0;
                $found = false;
                foreach($temp_array as $tmp_key => $tmp_val)
                {
                    if(!$found and strtolower($val[$subkey]) > strtolower($tmp_val[$subkey]))
                    {
                        $temp_array = array_merge(    (array)array_slice($temp_array,0,$offset),
                                                    array($key => $val),
                                                    array_slice($temp_array,$offset)
                                                  );
                        $found = true;
                    }
                    $offset++;
                }
                if(!$found) $temp_array = array_merge($temp_array, array($key => $val));
            }

            if ($sort_ascending) $array = array_reverse($temp_array);

            else $array = $temp_array;
        }
    }

    #die($from_shipment);
    $debug = 0;
    $this->_beforeGetPdf();
    $this->_initRenderer('invoices');

    $pdf = new Zend_Pdf();
    $this->_setPdf($pdf);
    $style = new Zend_Pdf_Style();

    $page_size = $this->_getConfig('page_size', 'a4', false,'general');

    if($page_size == 'letter') 
    {
        $page = $pdf->newPage(Zend_Pdf_Page::SIZE_LETTER);
        $page_top = 770;$padded_right = 587;
    }
    elseif($page_size == 'a4')
    {
        $page = $pdf->newPage(Zend_Pdf_Page::SIZE_A4);
        $page_top = 820;$padded_right = 570;
    }
    elseif($page_size == 'a5landscape') 
    {
        $page = $pdf->newPage('596:421');                    
        $page_top = 395;$padded_right = 573;
    }

    $pdf->pages[] = $page;

    $page_width = $padded_right;
    $skuX = 67;
    $qtyX = 40;
    $productX = 250;
    $font_size_overall = 15;
    $font_size_productline = 9;
    $total_quantity = 0;
    $total_cost = 0;
    $red_bkg_color             = new Zend_Pdf_Color_Html('lightCoral');
    $grey_bkg_color            = new Zend_Pdf_Color_GrayScale(0.7);
    $lt_grey_bkg_color        = new Zend_Pdf_Color_GrayScale(0.9);
    $dk_grey_bkg_color        = new Zend_Pdf_Color_GrayScale(0.3);//darkCyan
    $dk_cyan_bkg_color         = new Zend_Pdf_Color_Html('darkCyan');//darkOliveGreen
    $dk_og_bkg_color         = new Zend_Pdf_Color_Html('darkOliveGreen');//darkOliveGreen
    $white_bkg_color         = new Zend_Pdf_Color_Html('white');
    $orange_bkg_color         = new Zend_Pdf_Color_Html('Orange');
    $black_color             = new Zend_Pdf_Color_Rgb(0,0,0);
    $grey_color             = new Zend_Pdf_Color_GrayScale(0.3);
    $greyout_color             = new Zend_Pdf_Color_GrayScale(0.6);
    $white_color             = new Zend_Pdf_Color_GrayScale(1);
    $dk_green_color         = new Zend_Pdf_Color_Html('darkGreen');//darkOliveGreen


    $font_family_header_default = 'helvetica';
    $font_size_header_default = 16;
    $font_style_header_default = 'bolditalic';
    $font_color_header_default = 'darkOliveGreen';
    $font_family_subtitles_default = 'helvetica';
    $font_style_subtitles_default = 'bold';
    $font_size_subtitles_default = 15;
    $font_color_subtitles_default = 'darkOliveGreen';//'#222222';
    $background_color_subtitles_default = 'lightGrey';//'#999999';
    $font_family_body_default = 'helvetica';
    $font_size_body_default = 10;
    $font_style_body_default = 'regular';
    $font_color_body_default = 'Black';

    $font_family_header = $this->_getConfig('font_family_header', $font_family_header_default, false,'general');
    $font_style_header = $this->_getConfig('font_style_header', $font_style_header_default, false,'general');
    $font_size_header = $this->_getConfig('font_size_header', $font_size_header_default, false,'general');
    $font_color_header = trim($this->_getConfig('font_color_header', $font_color_header_default, false,'general'));
    $font_family_subtitles = $this->_getConfig('font_family_subtitles', $font_family_subtitles_default, false,'general');
    $font_style_subtitles = $this->_getConfig('font_style_subtitles', $font_style_subtitles_default, false,'general');
    $font_size_subtitles = $this->_getConfig('font_size_subtitles', $font_size_subtitles_default, false,'general');
    $font_color_subtitles = trim($this->_getConfig('font_color_subtitles', $font_color_subtitles_default, false,'general'));
    $background_color_subtitles = trim($this->_getConfig('background_color_subtitles', $background_color_subtitles_default, false,'general'));
    $font_family_body = $this->_getConfig('font_family_body', $font_family_body_default, false,'general');
    $font_style_body = $this->_getConfig('font_style_body', $font_style_body_default, false,'general');
    $font_size_body = $this->_getConfig('font_size_body', $font_size_body_default, false,'general');
    $font_color_body = trim($this->_getConfig('font_color_body', $font_color_body_default, false,'general'));
    $font_size_options            	= $this->_getConfig('font_size_options', 8, false,'general');

    $background_color_subtitles_zend = new Zend_Pdf_Color_Html($background_color_subtitles);    
    $font_color_header_zend = new Zend_Pdf_Color_Html($font_color_header);    
    $font_color_subtitles_zend = new Zend_Pdf_Color_Html($font_color_subtitles);    
    $font_color_body_zend = new Zend_Pdf_Color_Html($font_color_body);    

    $non_standard_characters     = $this->_getConfig('non_standard_characters', 0, false,'general');

	$barcode_type        = $this->_getConfig('font_family_barcode', 'code128', false,'general');
	switch ($barcode_type) 
	{
		case 'code128':
			$font_family_barcode 	= 'Code128bWin.ttf';
			break;

		case 'code39':
			$font_family_barcode 	= 'CODE39.ttf';

			break;	

		case 'code39x':
			$font_family_barcode 	= 'CODE39X.ttf';

			break;

		default:
			$font_family_barcode 	= 'Code128bWin.ttf';
			break;
	}

    $shelvingpos = $this->_getConfig('shelvingpos', 'col', false,'general'); //col/sku
    // $address_country_yn = $this->_getConfig('address_country_yn', 1, false,'general'); //col/sku
    $order_address_yn = $this->_getConfig('pickpack_order_address_yn', 0, false,'picks'); //col/sku

    $configurable_names = $this->_getConfig('pickpack_configname_separated', 'simple', false,'picks'); //col/sku
    $configurable_names_attribute = trim($this->_getConfig('pickpack_configname_attribute_separated', '', false,'picks')); //col/sku
    if($configurable_names != 'custom') $configurable_names_attribute = '';

    $barcodes = Mage::getStoreConfig('pickpack_options/picks/pickpack_pickbarcode');

    $printdates = Mage::getStoreConfig('pickpack_options/picks/pickpack_pickprint');//, $order->getStore()->getId());

    $product_id = NULL; // get it's ID
    $stock = NULL;
    $sku_stock = array();
    // pickpack_cost
    $showcost_yn_default        = 0;
    $showcount_yn_default        = 0;
    $currency_default            = 'USD';

    $shelving_yn_default        = 0;
    $shelving_attribute_default = 'shelf';
    $shelvingX_default             = 200;
    $supplier_yn_default         = 0;
    $supplier_attribute_default = 'supplier';
    $namenudgeYN_default        = 0;
    $stockcheck_yn_default         = 0;
    $stockcheck_default         = 1;
    $shipping_method_x            = 0;

    /////// from 1    
    $product_id                 = NULL; // get it's ID
    $stock                         = NULL;
    ///////// /from 1
    $split_supplier_yn_default     = 'no';
    $supplier_attribute_default = 'supplier';
    $supplier_options_default     = 'filter';
    $supplier_login_default        = '';
    $tickbox_default            = 'no'; //no, pick, pickpack

    // $split_supplier_yn             = $this->_getConfig('pickpack_split_supplier_yn', $split_supplier_yn_default, false,'general');
    $split_supplier_yn_temp     = $this->_getConfig('pickpack_split_supplier_yn', $split_supplier_yn_default, false,'general');
    $split_supplier_options     = $this->_getConfig('pickpack_split_supplier_options', 'no', false,'general');
    $split_supplier_yn = 'no';
    if($split_supplier_yn_temp == 1)
    {
        $split_supplier_yn = $split_supplier_options;
    }

    $supplier_attribute         = $this->_getConfig('pickpack_supplier_attribute', $supplier_attribute_default, false,'general');
    $supplier_options             = $this->_getConfig('pickpack_supplier_options', $supplier_options_default, false,'general');
    //$supplier_login             = $this->_getConfig('pickpack_supplier_login', $supplier_login_default, false,'general');

    $userId                     = Mage::getSingleton('admin/session')->getUser() ? Mage::getSingleton('admin/session')->getUser()->getId(): 0;
    $user                       = ($userId !== 0) ? Mage::getModel('admin/user')->load($userId): '';
    $username                   = (!empty($user['username'])) ? $user['username']:'';

    $supplier_login_pre         = $this->_getConfig('pickpack_supplier_login', '', false,'general');
    $supplier_login_pre         = str_replace(array("\n",','),';',$supplier_login_pre);
    $supplier_login_pre         = explode(';',$supplier_login_pre);

    foreach($supplier_login_pre as $key => $value)
    {
        $supplier_login_single = explode(':',$value);
        if(preg_match('~'.$username.'~i',$supplier_login_single[0])) 
        {
            if($supplier_login_single[1] != 'all') $supplier_login = trim($supplier_login_single[1]);
            else $supplier_login = '';
        }
    }

    $tickbox                     = $this->_getConfig('pickpack_tickbox', $tickbox_default, false,'general');
    $picklogo                     = $this->_getConfig('pickpack_picklogo', 0, false,'general');

    $showcount_yn         = $this->_getConfig('pickpack_count', $showcount_yn_default, false,'picks');

    $showcost_yn         = $this->_getConfig('pickpack_cost', $showcost_yn_default, false,'picks');
    $currency             = $this->_getConfig('pickpack_currency', $currency_default, false,'picks');
    $currency_symbol     = Mage::app()->getLocale()->currency($currency)->getSymbol();

    $stockcheck_yn         = $this->_getConfig('pickpack_stock_yn_separated', $stockcheck_yn_default,false,'picks');
    $stockcheck         = $this->_getConfig('pickpack_stock_separated', $stockcheck_default,false,'picks');    

    $shelving_yn         = $this->_getConfig('pickpack_shelving_yn_separated', $shelving_yn_default, false,'picks');
    $shelving_attribute = $this->_getConfig('pickpack_shelving_separated', $shelving_attribute_default, false,'picks');
    $shelvingX             = intval($this->_getConfig('shelving_nudge', $shelvingX_default, true,'general'));

    $nameyn             = $this->_getConfig('pickpack_name_yn_separated', $namenudgeYN_default, false,'picks');
    $namenudge             = intval($this->_getConfig('pickpack_namenudge_separated', 0, false,'picks'));

    $override_address_format_yn = 1;
    $address_format_default 	= '{if company}{company},|{/if company}
{if name}{name},|{/if name}
{if street}{street},|{/if street}
{if city}{city}, |{/if city}
{if postcode}{postcode}{/if postcode} {if region}{region},{/if region}|
{country}';
    $address_format         = $this->_getConfig('address_format', $address_format_default, false,'general'); //col/sku
    $address_countryskip      = $this->_getConfig('address_countryskip', 0,false,'general');              

    $shmethod = Mage::getStoreConfig('pickpack_options/picks/pickpack_shipmethod');

    $options_yn_base         = $this->_getConfig('separated_options_yn_base', 0, false,'picks'); // no, inline, newline

	$pickpack_options_filter = '';
	$pickpack_options_count_filter_attribute = 'separated_options_count_filter';
	$pickpack_options_filter_yn = 0;

    if($options_yn_base == 0) 
	{
		$options_yn = 0;
	}
	elseif($options_yn_base == 'yesstacked')
	{
		$options_yn             = $this->_getConfig('separated_options_yn_stacked', 0, false,'picks'); // no, inline, newline
		$pickpack_options_filter_yn = $this->_getConfig('separated_options_filter_yn_stacked', 0, false,'picks');
	    $pickpack_options_filter     = trim($this->_getConfig('separated_options_filter_stacked', '', false,'picks'));
		$pickpack_options_count_filter_attribute = 'separated_options_count_filter_stacked';
	}
	else
	{
		$options_yn             = $this->_getConfig('separated_options_yn', 0, false,'picks'); // no, inline, newline
	    $pickpack_options_filter_yn = $this->_getConfig('separated_options_filter_yn', 0, false,'picks');
	    $pickpack_options_filter     = trim($this->_getConfig('separated_options_filter', '', false,'picks'));
	}    


    $pickpack_options_filter_array = array();
    $pickpack_options_count_filter_array = array();

    if($pickpack_options_filter_yn == 0) $pickpack_options_filter = '';
    elseif($pickpack_options_filter == '' && $pickpack_options_filter_yn == 1) $pickpack_options_filter_yn = 0;
    elseif($pickpack_options_filter_yn == 1)
    {
        $pickpack_options_filter_array = explode(',',$pickpack_options_filter);
        foreach($pickpack_options_filter_array as $key => $value)
        {
            $pickpack_options_filter_array[$key] = trim($value);
        }
        $pickpack_options_count_filter     = $this->_getConfig($pickpack_options_count_filter_attribute, 0, false,'picks');

        if(trim($pickpack_options_count_filter) != '')
        {
            $pickpack_options_count_filter_array = explode(',',$pickpack_options_count_filter);
            foreach($pickpack_options_count_filter_array as $key => $value)
            {
                $pickpack_options_count_filter_array[$key] = trim($value);
            }
        }
    }

    $sort_packing_yn            = $this->_getConfig('sort_packing_yn', 1,false,'general');               
    $sort_packing                = $this->_getConfig('sort_packing', 'sku',false,'general');               
    $sortorder_packing            = $this->_getConfig('sort_packing_order', 'ascending',false,'general');  

    if($sort_packing == 'attribute')
    {
        $sort_packing_attribute        = trim($this->_getConfig('sort_packing_attribute', '',false,'general'));  
        if($sort_packing_attribute != '') $sort_packing = $sort_packing_attribute;
    }
    if($sort_packing_yn == 0) $sortorder_packing = 'none';

    $skuXInc = 0;

    /**
     * get store id
     */
    $storeId = Mage::app()->getStore()->getId();

    $order_id_master = array();
    $sku_order_suppliers = array();
    $sku_shelving = array();
    $sku_shipping_address = array();
    $sku_order_id_options = array();
    $sku_bundle = array();
    $product_build_item = array();
    $product_build = array();

    foreach ($orders as $orderSingle) 
    {
        $order = Mage::getModel('sales/order')->load($orderSingle);        
        $putOrderId = $order->getRealOrderId();
        $order_id  = $putOrderId;

        $has_shipping_address = false;
        $has_billing_address = false;
        // test for addresses
        foreach ($order->getAddressesCollection() as $address) 
        {
                if ($address->getAddressType() == 'shipping' && !$address->isDeleted()) {
                    $has_shipping_address = true;
                }
                elseif ($address->getAddressType() == 'billing' && !$address->isDeleted()) {
                    $has_billing_address = true;
                }
        }

        $sku_shipping_address_temp = '';
        $sku_shipping_address[$order_id] = '';
        // $sku_shipping_address[$order_id] = str_replace(array('<br />','<br/>',"\n","\p"),'',implode(',',$this->_formatAddress($order->getShippingAddress()->format('pdf')))); 
        $shippingAddressFlat = '';
        $shippingAddressArray = array();

        if($has_shipping_address === true) 
        {
            $shippingAddressFlat = implode(',',$this->_formatAddress($order->getShippingAddress()->format('pdf'))); 
        // $shippingAddressArray = explode(',',str_replace(',','~,',$shippingAddressFlat));

        // if($override_address_format_yn == 1)
        //         {
            //
            $shipping_address = array();
            $if_contents = array();
            $shipping_address['company'] = $order->getShippingAddress()->getCompany();
            $shipping_address['name'] = $order->getShippingAddress()->getName();
            $shipping_address['first_name'] = $order->getShippingAddress()->getFirstName();
            $shipping_address['last_name'] = $order->getShippingAddress()->getLastName();
            $shipping_address['telephone'] = $order->getShippingAddress()->getTelephone();
            // $shipping_address['email'] = $order->getBillingAddress()->getEmail();
            $i = 0;
            while($i < 10)
            {
                if($order->getShippingAddress()->getStreet($i) && !is_array($order->getShippingAddress()->getStreet($i)))
                {
                    if(isset($shipping_address['street'])) $shipping_address['street'] .= ", \n";
                    else $shipping_address['street'] = '';
                    $shipping_address['street'] .= $order->getShippingAddress()->getStreet($i);
                }
                $i ++;
            }
            $shipping_address['city'] = $order->getShippingAddress()->getCity();
            $shipping_address['postcode'] = $order->getShippingAddress()->getPostcode();
            $shipping_address['region'] = $order->getShippingAddress()->getRegion();
            $shipping_address['prefix'] = $order->getShippingAddress()->getPrefix();
            $shipping_address['suffix'] = $order->getShippingAddress()->getSuffix();
            $shipping_address['country'] = Mage::app()->getLocale()->getCountryTranslation($order->getShippingAddress()->getCountryId());                    
            $address_format_set = str_replace(array("\n",'<br />','<br/>',"\r"),'',$address_format);

            if(trim($address_countryskip) != '') $shipping_address['country'] = str_ireplace($address_countryskip,'',$shipping_address['country']);

            foreach($shipping_address as $key =>$value)
            {
                $value = trim($value);
                $value = preg_replace('~,$~','',$value);
                $value = str_replace(',,',',',$value);
                if($value != '' && !is_array($value))
                {
                    $pre_value = '';
                    // if($key == 'country') $pre_value = '##country##';
                    //                     elseif($key == 'telephone') $pre_value = '##telephone##';

                    preg_match('~\{if '.$key.'\}(.*)\{\/if '.$key.'\}~ims',$address_format_set,$if_contents);
                    if(isset($if_contents[1])) $if_contents[1] = str_replace('{'.$key.'}',$value,$if_contents[1]);
                    else $if_contents[1] = '';
                    $address_format_set = preg_replace('~\{if '.$key.'\}(.*)\{/if '.$key.'\}~ims',$pre_value.$if_contents[1],$address_format_set);
                    $address_format_set = str_ireplace('{'.$key.'}',$pre_value.$value,$address_format_set);
                    $address_format_set = str_ireplace('{/'.$key.'}','',$address_format_set);
                    $address_format_set = str_ireplace('{/if '.$key.'}','',$address_format_set);
                }
                else
                {
                    $address_format_set = preg_replace('~\{if '.$key.'\}(.*)\{/if '.$key.'\}~i','',$address_format_set);    
                    $address_format_set = str_ireplace('{'.$key.'}','',$address_format_set);
                    $address_format_set = str_ireplace('{/'.$key.'}','',$address_format_set);
                    $address_format_set = str_ireplace('{/if '.$key.'}','',$address_format_set);
                }    
            }

            $address_format_set = str_replace(array('||','|'),"\n",trim($address_format_set));
            $address_format_set = str_replace(array('{if city}','{if postcode}','{if region}'),'',$address_format_set);

            $shippingAddressArray = explode("\n",$address_format_set);        

            $i = 0;
            $stop_address = FALSE;
            $skip_entry = FALSE;

            foreach($shippingAddressArray as $i =>$value)
            {
                $value = trim($value);

                $skip_entry = FALSE;
                if(isset($value) && $value != '~')
                {
                    // remove fax
                    $value = preg_replace('!<(.*)$!','',$value);
                    if(preg_match('~T:~',$value))
                    {    
                        // if($show_phone_yn == 1)
                        //                 {
                            $value = str_replace('~','',$value);                            
                            $value = '[ '.$value.' ]';
                    }
                    elseif($stop_address === FALSE)
                    {
                        if(!isset($shippingAddressArray[($i+1)]) || preg_match('~T:~',$shippingAddressArray[($i+1)]))
                        {
                            // last line, lets bold it and make it a bit bigger
                            $value = str_replace('~','',$value);
                        }
                        else
                        {
                            if((!isset($shippingAddressArray[($i+2)]) || preg_match('~T:~',$shippingAddressArray[($i+2)])))
                            {
                                $value = str_replace('~','',$value);
                            }
                            else $value = str_replace('~',',',$value);
                        }
                        $page->setFillColor($black_color);
                    }
                    if($stop_address === FALSE && $skip_entry === FALSE)     $sku_shipping_address_temp .= ','.$value;
                }
                $i ++;        
            }    
            $sku_shipping_address_temp = str_replace(
                array('  ',',,','<br />','<br/>',"\n","\p",',,',',,',','),
                array(' ',',','','','','',',',',',', '),$sku_shipping_address_temp);
            $sku_shipping_address_temp = preg_replace('~, $~','',$sku_shipping_address_temp); 
            $sku_shipping_address[$order_id] = preg_replace('~^\s?,\s?~','',$sku_shipping_address_temp);  
    //
        }


        if(!isset($order_id_master[$order_id])) $order_id_master[$order_id] = 0;        

        $itemsCollection =  $order->getAllVisibleItems();//$order->getItemsCollection();
        // $total_items     = count($itemsCollection);

        $max_name_length     = 0;
        $test_name    = 'abcdefghij';//10
        $font_temp = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
        $test_name_length = round($this->parseString($test_name,$font_temp,($font_size_body)));//*0.77)); // bigger = left

        $pt_per_char = ($test_name_length/10);
        $max_name_length = (550 - $skuX);
        if(!isset($productXInc)) $productXInc = 0;
        $max_sku_length = (($productX+$productXInc) - 27 - $skuX);
        $character_breakpoint_name = round($max_name_length/$pt_per_char);
        $character_breakpoint_sku = round($max_sku_length/$pt_per_char);
        // $product_build_item = array();
        //     $product_build = array();
        $sku_category = array();

        $coun = 1;

        foreach ($itemsCollection as $item)
        {            
            if($item->getProductType() == Mage_Catalog_Model_Product_Type::TYPE_CONFIGURABLE) 
            {
                // any products actually go thru here?
                $sku = $item->getProductOptionByCode('simple_sku');
                $product_id = Mage::getModel('catalog/product')->setStoreId($storeId)->getIdBySku($sku);
            } 
            else 
            {
                $sku = $item->getSku();
                $product_id = $item->getProductId(); // get it's ID            
            }    



            #nu
            // if show options as counted groups
            if($options_yn == 1)
            {
                $full_sku = trim($item->getSku());    
                $parent_sku = preg_replace('~\-(.*)$~','',$full_sku);
                $sku = $parent_sku;
                // $product_build[$sku]['sku'] = $sku;
                //                 $product_build[$sku.'-'.$coun]['sku'] = $sku;    
                $product_build_item[] = $sku;//.'-'.$coun;    
                // $product_build[$sku]['sku'] = $sku;            
                $product_sku = $sku;
                // $sku = $sku.'-'.$coun;
                // $product_build[$sku]['sku'] = $product_sku;    
                $product_build[$order_id][$sku]['sku'] = $product_sku;

            }
            else
            {
                // unique item id
                $product_build_item[] = $sku.'-'.$coun;    
                // $product_build[$sku.'-'.$coun]['sku'] = $sku;            
                $product_sku = $sku;
                $sku = $sku.'-'.$coun;
                // $product_build[$sku]['sku'] = $product_sku;
                $product_build[$order_id][$sku]['sku'] = $product_sku;
            }

            $product = Mage::getModel('catalog/product')->setStoreId($storeId)->loadByAttribute('sku', $sku, array('cost',$shelving_attribute,'name','simple_sku','qty'));            
            if($stock = Mage::getModel('cataloginventory/stock_item')->loadByProduct($product_id)->getQty()) $stock = round($stock);//Mage::getModel('cataloginventory/stock_item')->loadByProduct($product_id)->getQty());

            $options = $item->getProductOptions();

            if(isset($options['bundle_options']) && is_array($options['bundle_options']))
            {
                $children = $item->getChildrenItems();
                if(count($children))
                {
                    foreach($children as $child)
                    {
                        $product_child = Mage::getModel('catalog/product')->setStoreId($storeId)->load($child->getProductId());
                        $sku_b = $child->getSku();
                        $price_b = $child->getPriceInclTax();
                        $qty_b = (int)$child->getQtyOrdered();
                        $name_b = $child->getName();

                        $this->y -= 10;
                        $offset = 20;

                        $shelving_real = '';
                        $shelving_real_b = '';

                        if(isset($shelving_yn) && $shelving_yn == 1)
                        {
                            if($shelving_real_b = $product_child->getData($shelving_attribute))
                            {
								//$shelving_real_b = $product_child->getData($shelving_attribute);
                            }
                            elseif($shelving_real_b = Mage::getModel('catalog/product')->setStoreId($storeId)->load($child->getProductId())->getAttributeText($shelving_attribute))
                            {
								// $shelving_real_b = Mage::getModel('catalog/product')->setStoreId($storeId)->load($child->getProductId())->getAttributeText($shelving_attribute);
                            }
                            elseif($product_child[$shelving_attribute]) 
							{
								$shelving_real_b = $product_child[$shelving_attribute];								
							}
                            else 
							{
								$shelving_real_b = '';							
							}

                            if(is_array($shelving_real)) $shelving_real_b = implode(',',$shelving_real_b);
                            if(isset($shelving_real_b)) $shelving_real_b = trim($shelving_real_b);
                        }

                         if($from_shipment == 'shipment'){
                                $qty_string_b = 's:'.(int)$item->getQtyShipped() . ' / o:'.$qty;
                                $price_qty_b = (int)$item->getQtyShipped();
                                $productXInc = 25;
                            }else{

                                $qty_string_b = $qty_b;
                                $price_qty_b = $qty_b;
                                $productXInc = 0;
                            }
                        $display_name_b = '';
                        if(strlen($name_b) > ($character_breakpoint_name+2))
                        {
                            $display_name_b = substr(htmlspecialchars_decode($name_b), 0, ($character_breakpoint_name)).'…';
                        }
                        else $display_name_b = htmlspecialchars_decode($name_b);

                        $sku_bundle[$order_id][$sku][] = $sku_b.'##'.$display_name_b.'##'.$shelving_real_b.'##'.$qty_string_b;
                    }
                }
            }
            else 
            {
                $sku_bundle[$order_id][$sku] = '';
            }


            $category_label = '';
            $product = Mage::getModel('catalog/product')->load($product_id);
            # Get product's category collection object
            $catCollection = $product->getCategoryCollection();
            # export this collection to array so we could iterate on it's elements
            $categs = $catCollection->exportToArray();
            $categsToLinks = array();
            # Get categories names
            foreach($categs as $cat)
            {
                $categsToLinks [] = Mage::getModel('catalog/category')->load($cat['entity_id'])->getName();
            }
            foreach($categsToLinks as $ind=>$cat)
            {
                if($category_label != '') $category_label = $category_label.', '.$cat;
                else $category_label = $cat;
            }
            $sku_category[$sku] = $category_label;
            unset($category_label);


            $shelving = '';
            $supplier = '';
            $extra = '';

            if($shelving_yn == 1)
            {
                if(Mage::getModel('catalog/product')->setStoreId($storeId)->load($product_id))
                {
                        $_newProduct = Mage::getModel('catalog/product')->setStoreId($storeId)->load($product_id);  
                    if($_newProduct->getData($shelving_attribute)) $shelving = $_newProduct->getData($shelving_attribute);
                }
                elseif($product->getData($shelving_attribute))
                {
                         $shelving = $product->getData($shelving_attribute);
                }
                else $shelving = '';

                if(is_array($shelving)) $shelving = implode(',',$shelving);

                if(trim($shelving) != '')
                {
                    if(Mage::getModel('catalog/product')->setStoreId($storeId)->load($product_id)->getAttributeText($shelving_attribute))
                    {
                        $shelving = Mage::getModel('catalog/product')->setStoreId($storeId)->load($product_id)->getAttributeText($shelving_attribute);
                    }
                    elseif($product[$shelving_attribute]) $shelving = $product[$shelving_attribute];
                    else $shelving = '';
                }

                if(trim($shelving) != '')
                {
                    if(isset($sku_shelving[$sku]) && trim(strtoupper($sku_shelving[$sku])) != trim(strtoupper($shelving))) $sku_shelving[$sku] .= ','.trim($shelving);
                    else $sku_shelving[$sku] = trim($shelving);
                    $sku_shelving[$sku] = preg_replace('~,$~','',$sku_shelving[$sku]);
                }
                else $sku_shelving[$sku] = '';
            }

            if($sort_packing != 'none' && $sort_packing != '')
            {
                $product_build[$order_id][$sku][$sort_packing] = '';

                $attributeName = $sort_packing;

                if($attributeName == 'Mcategory')
                {                        
                    $product_build[$order_id][$sku][$sort_packing] = $sku_category[$sku];//$product_build[$sku]['%category%'];//$category_label;                            
                }
                else
                {

                    $product = Mage::getModel('catalog/product');

                    if(Mage::getModel('catalog/product')->load($product_id)->getData($attributeName))
                    {
                        $attributeValue = Mage::getModel('catalog/product')->load($product_id)->getData($attributeName);

                        $collection = Mage::getResourceModel('eav/entity_attribute_collection')
                        ->setEntityTypeFilter($product->getResource()->getTypeId())
                        ->addFieldToFilter('attribute_code', $attributeName);

                        $attribute = $collection->getFirstItem()->setEntity($product->getResource());

                        $attributeOptions = $attribute->getSource()->getAllOptions(false);
                        if(!empty($attributeOptions))
                        {                        
                            $result = search($attributeOptions,'value',$attributeValue);

                            if(isset($result[0]['label'])) 
                            {
                                $product_build[$order_id][$sku][$sort_packing] = preg_replace('/[^a-zA-Z0-9\s\.\-]/', '', $result[0]['label']);
                            }
                        }
                        else 
                        {
                            $product_build[$order_id][$sku][$sort_packing] = preg_replace('/[^a-zA-Z0-9\s\.\-]/', '', $attributeValue);
                        }
                    }
                }
                unset($attributeName);
                unset($attribute);
                unset($attributeOptions);
                unset($result);

            }


            if($split_supplier_yn != 'no')
            {
                if(Mage::getModel('catalog/product')->setStoreId($storeId)->load($product_id))
                {
                        $_newProduct = Mage::getModel('catalog/product')->setStoreId($storeId)->load($product_id);  
                    if($_newProduct->getData($supplier_attribute)) $supplier = $_newProduct->getData(''.$supplier_attribute.'');
                }
                elseif($product->getData(''.$supplier_attribute.''))
                {
                         $supplier = $product->getData($supplier_attribute);
                }
                if(Mage::getModel('catalog/product')->setStoreId($storeId)->load($product_id)->getAttributeText($supplier_attribute))
                {
                    $supplier = Mage::getModel('catalog/product')->setStoreId($storeId)->load($product_id)->getAttributeText($supplier_attribute);
                }
                elseif($product[$supplier_attribute]) $supplier = $product[$supplier_attribute];

                if(is_array($supplier)) $supplier = implode(',',$supplier);
                if(!$supplier) $supplier = '~Not Set~';    

                $supplier = trim(strtoupper($supplier));

                if(isset($sku_supplier[$sku]) && $sku_supplier[$sku] != $supplier) $sku_supplier[$sku] .= ','.$supplier;
                else $sku_supplier[$sku] = $supplier;
                $sku_supplier[$sku] = preg_replace('~,$~','',$sku_supplier[$sku]);

                if(!isset($supplier_master[$supplier])) $supplier_master[$supplier] = $supplier;

                $order_id_master[$order_id] .= ','.$supplier;
            }


            if($shmethod == 1)
            {
                $sku_shipping_method[$order_id] = clean_method($order->getShippingDescription(),'shipping');

				if($sku_shipping_method[$order_id] != '') $sku_shipping_method[$order_id] = 'Ship: '.$sku_shipping_method[$order_id];

                $shipping_method_x = 260;
                if($barcodes == 1) $shipping_method_x = 300;//$barcodeWidth = 250;
                $max_shipping_description_length = 41;//37
                if(strlen($sku_shipping_method[$order_id]) > $max_shipping_description_length)
                {
                    $sku_shipping_method[$order_id] = trim(substr(htmlspecialchars_decode($sku_shipping_method[$order_id]), 0, ($max_shipping_description_length)).'…');
                }
                $font_temp = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
                $font_size_compare = ($font_size_subtitles - 2);
                $line_width = $this->parseString($sku_shipping_method[$order_id],$font_temp,$font_size_compare); // bigger = left

                //             
                /*
                $minXship = (240+($barcodeWidth*2));
                                $maxLineWidth = ($page_width-$minXship);

                                $font_temp = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
                                $font_size_compare = ($font_size_subtitles - 2);
                                $line_width = $this->parseString($sku_shipping_method[$order_id],$font_temp,$font_size_compare); // bigger = left

                                if($shipping_method_x == 0) $shipping_method_x = 360;
                                if(($line_width+$shipping_method_x+20)>$page_width)
                                {
                                    $shipping_method_x = ($page_width-$line_width-20);
                                }
                                if(($line_width+$shipping_method_x+20)>$page_width)
                                {
                                    $shipping_method_x = ($shipping_method_x-$line_width-20);
                                }
                                if($shipping_method_x>$minXship)
                                {
                                    $shipping_method_x = $minXship;
                                }*/

            }

            /********************************************************/
            // qty in this order of this sku
            $qty = $item->getIsQtyDecimal() ? $item->getQtyOrdered() : (int) $item->getQtyOrdered();
            $sqty = $item->getIsQtyDecimal() ? $item->getQtyShipped() : (int) $item->getQtyShipped();
            // total qty in all orders for this sku
            if(isset($sku_qty[$sku])) $sku_qty[$sku] = ($sku_qty[$sku]+$qty);
            else $sku_qty[$sku] = $qty;
            $total_quantity = $total_quantity + $qty;

            $cost= $qty*(is_object($product)?$product->getCost():0);
            $total_cost = $total_cost + $cost;

            $sku_master[$sku] = $sku;

            if(Mage::getModel('catalog/product')->setStoreId($storeId)->load($product_id) && $configurable_names == 'simple')
            {
                $_newProduct = Mage::getModel('catalog/product')->setStoreId($storeId)->load($product_id);  
                if($_newProduct->getData('name')) $sku_name[$sku] = $_newProduct->getData('name');
            }
            elseif($configurable_names == 'configurable') $sku_name[$sku] = $item->getName();
            elseif($configurable_names == 'custom' && $configurable_names_attribute != '')
            {
                $customname = '';

                if(Mage::getModel('catalog/product')->setStoreId($storeId)->load($product_id))
                {
                    $_newProduct = Mage::getModel('catalog/product')->setStoreId($storeId)->load($product_id);  
                    if($_newProduct->getData($configurable_names_attribute)) $customname = $_newProduct->getData(''.$configurable_names_attribute.'');
                }
                elseif($product->getData(''.$configurable_names_attribute.''))
                {
                    $customname = $product->getData($configurable_names_attribute);
                }
                else $customname = '';

                if(trim($customname) != '')
                {
                    if(Mage::getModel('catalog/product')->setStoreId($storeId)->load($product_id)->getAttributeText($configurable_names_attribute))
                    {
                        $customname = Mage::getModel('catalog/product')->setStoreId($storeId)->load($product_id)->getAttributeText($configurable_names_attribute);
                    }
                    elseif($product[$configurable_names_attribute]) $customname = $product[$configurable_names_attribute];
                    else $customname = '';
                }

                if(trim($customname) != '')
                {
                    if(is_array($customname)) $customname = implode(',',$customname);
                    $customname = preg_replace('~,$~','',$customname);
                }
                else $customname = '';

                 $sku_name[$sku] = $customname;
            }

            if(isset($options['options']) && is_array($options['options']))
            {
                $i = 0;
                if(isset($options['options'][$i])) $continue = 1;
                while($continue == 1)
                {
                    $options_name_temp[$i] = trim(htmlspecialchars_decode($options['options'][$i]['label'].' : '.$options['options'][$i]['value']));
                    $options_name_temp[$i] = preg_replace('~^select ~i','',$options_name_temp[$i]);
                    $options_name_temp[$i] = preg_replace('~^enter ~i','',$options_name_temp[$i]);
                    $options_name_temp[$i] = preg_replace('~^would you Like to ~i','',$options_name_temp[$i]);
                    $options_name_temp[$i] = preg_replace('~^please enter ~i','',$options_name_temp[$i]);
                    $options_name_temp[$i] = preg_replace('~^your ~i','',$options_name_temp[$i]);
                    $options_name_temp[$i] = preg_replace('~\((.*)\)~i','',$options_name_temp[$i]);

                    $i ++;
                    $continue = 0;
                    if(isset($options['options'][$i])) $continue = 1;
                }

                $i = 0;
                $continue = 0;
                $opt_count = 0;

                if(isset($options['options'][$i])) $continue = 1;


                $sku_order_id_options[$order_id][$sku] = array();

                while($continue == 1)// && isset($sku_order_id_options[$order_id][$sku]))
                {                    
                    if($i > 0) $sku_order_id_options[$order_id][$sku] .= ' ';
                    $sku_order_id_options[$order_id][$sku] .= htmlspecialchars_decode('[ '.$options['options'][$i]['label'].' : '.$options['options'][$i]['value'].' ]');

                        // if show options as a group
                        if($options_yn != 0 && $opt_count == 0 && $options_yn_base == 1)
                        {
                            $full_sku     = trim($item->getSku());    
                            $parent_sku = preg_replace('~\-(.*)$~','',$full_sku);
                            $full_sku     = preg_replace('~^'.$parent_sku.'\-~','',$full_sku);
                            $options_sku_array = array();
                            $options_sku_array = explode('-',$full_sku);
                            if(!isset($options_sku_parent[$order_id])) $options_sku_parent[$order_id] = array();
                            if(!isset($options_sku_parent[$order_id][$sku])) $options_sku_parent[$order_id][$sku] = array();

                            $opt_count = 0;
                            foreach ($options_sku_array as $k => $options_sku_single)
                            {    
                                if(!isset($options_sku_parent[$order_id][$sku][$options_sku_single])) $options_sku_parent[$order_id][$sku][$options_sku_single] = '';

                                // if(!isset($options_name_count[$options_sku_single])) $options_name_count[$options_sku_single] = 0;
                                //                                 else $options_name_count[$options_sku_single] ++;
                                if(!isset($options_name_temp[$opt_count])) $options_name_temp[$opt_count] = '';
                                $options_name[$order_id][$sku][$options_sku_single] = $options_name_temp[$opt_count];

                                if(isset($options_sku[$order_id][$options_sku_single]) && (!in_array($options_sku_single,$pickpack_options_filter_array)))
                                {
                                    $options_sku[$order_id][$options_sku_single] = ($sku_qty[$sku] + $options_sku[$order_id][$options_sku_single]);
                                    $options_sku_parent[$order_id][$sku][$options_sku_single] = ($qty + $options_sku_parent[$order_id][$sku][$options_sku_single]);
                                    // if($options_name_temp[$opt_count]) $sku_name[$options_sku_single] =  $options_name_temp[$opt_count];
                                }
                                elseif(!in_array($options_sku_single,$pickpack_options_filter_array))
                                {
                                    $options_sku[$order_id][$options_sku_single] = ($sku_qty[$sku]);
                                    $options_sku_parent[$order_id][$sku][$options_sku_single] = $qty;//($sku_qty[$sku]);
                                    // if($options_name_temp[$opt_count]) $sku_name[$options_sku_single] =  $options_name_temp[$opt_count];
                                }

                                $opt_count ++;
                            }        
                            unset($options_name_temp);    
                        }

                    // }

                    $i ++;
                    $continue = 0;
                    if(isset($options['options'][$i])) $continue = 1;
                }
            }
            unset($options_name_temp);

            $sku_stock[$sku] = $stock;

            if(isset($sku_order_id_qty[$order_id][$sku])){
                $sku_order_id_qty[$order_id][$sku] = ($sku_order_id_qty[$order_id][$sku]+$qty); 
                $sku_order_id_sqty[$order_id][$sku] = ($sku_order_id_sqty[$order_id][$sku]+$sqty); 
                $sku_order_id_sku[$order_id][$sku] = $product_sku; 

                $product_build[$order_id][$sku]['qty'] = ($sku_order_id_qty[$order_id][$sku]+$qty); 
                $product_build[$order_id][$sku]['sqty'] = ($sku_order_id_sqty[$order_id][$sku]+$sqty); 
                // $sku_order_id_sku[$order_id][$sku] = $product_sku;
            }else{
                $sku_order_id_qty[$order_id][$sku] = $qty;
                $sku_order_id_sqty[$order_id][$sku] = $sqty; 
                $sku_order_id_sku[$order_id][$sku] = $product_sku; 

                $product_build[$order_id][$sku]['qty'] = $qty; 
                $product_build[$order_id][$sku]['sqty'] = $sqty;
            } 

            if(!isset($max_qty_length)) $max_qty_length = 2;
            if(strlen($sku_order_id_qty[$order_id][$sku]) > $max_qty_length) $max_qty_length = strlen($sku_order_id_qty[$order_id][$sku]);
            if(strlen($sku_order_id_sqty[$order_id][$sku]) > $max_qty_length) $max_qty_length = strlen($sku_order_id_sqty[$order_id][$sku]);


            if($split_supplier_yn != 'no')
            {
                // if(!in_array($supplier,$sku_order_suppliers[$order_id])) $sku_order_suppliers[$order_id][] = $supplier;
                if(!isset($sku_order_suppliers[$order_id])) $sku_order_suppliers[$order_id][] = $supplier;
                elseif(!in_array($supplier,$sku_order_suppliers[$order_id])) $sku_order_suppliers[$order_id][] = $supplier;
            }
            $coun ++;

        }


    if(isset($sku_bundle[$order_id]) && is_array($sku_bundle[$order_id])) ksort($sku_bundle[$order_id]);
    }

    $processed_skus = array();

    ksort($order_id_master);
    ksort($sku_order_id_qty);
    // ksort($sku_bundle);
    ksort($sku_master);
    ksort($product_build);
    if(isset($supplier_master))    ksort($supplier_master);
    $supplier_previous         = '';
    $supplier_item_action     = '';
    $first_page_yn             = 'y';

    if($split_supplier_yn != 'no')
    {
        foreach($supplier_master as $key =>$supplier)
        {
            if( (isset($supplier_login) && ($supplier_login != '') && (strtoupper($supplier) == strtoupper($supplier_login) ) ) || !isset($supplier_login) || $supplier_login == '')
            {

                if($first_page_yn == 'n') $page = $this->newPage();
                else $first_page_yn = 'n';

                if($picklogo == 1)
                {                    
                    $packlogo = Mage::getStoreConfig('pickpack_options/wonder/pack_logo', $order->getStore()->getId());
                    if($packlogo)
                    {
                        $packlogo = Mage::getStoreConfig('system/filesystem/media', $order->getStore()->getId()) . '/moogento/pickpack/logo_pack/' . $packlogo;
                        if (is_file($packlogo)) {    
                            $packlogo = Zend_Pdf_Image::imageWithPath($packlogo);            
                            $page->drawImage($packlogo, 27, ($page_top-31), 296, ($page_top+10));
                        }
                    }
                    //770 / 820 ($page_top-5)
                    $this->_setFont($page, $font_style_header, $font_size_header, $font_family_header, $non_standard_characters, $font_color_header);    
                    $page->drawText(Mage::helper('sales')->__('Order-separated Pick List'), 325, ($page_top-5), 'UTF-8');        
                    $page->drawText(Mage::helper('sales')->__('Supplier : '.$supplier), 325, ($page_top-25), 'UTF-8');
                    $page->setFillColor($font_color_header_zend);            
                    $page->setLineColor($font_color_header_zend);
                    $page->setLineWidth(0.5);            
                    $page->drawRectangle(304, ($page_top-31), 316, ($page_top+10));

                    $this->y = 777;
                }
                else
                {
                       $this->_setFont($page, $font_style_header, ($font_size_header+2), $font_family_header, $non_standard_characters, $font_color_header);
                    $page->drawText(Mage::helper('sales')->__(Mage::helper('sales')->__('Order-separated Pick List').', '.Mage::helper('sales')->__('Supplier').' : '.$supplier), 31, ($page_top-5), 'UTF-8');
                    //$page->drawText(Mage::helper('sales')->__('Supplier : '.$supplier), 325, ($page_top-25), 'UTF-8');
                    $page->setLineColor($font_color_header_zend);
                    $page->setFillColor($font_color_header_zend);
                    $page->drawRectangle(27, ($page_top-12), $padded_right, ($page_top-11));

                    $this->y = 800;
                }

                $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);

                $sku_supplier_item_action = array();
                $sku_supplier_item_action_master = array();

                $page_count = 1;
                foreach($order_id_master as $order_id =>$value)
                {
                    // if ($this->y<40) $page = $this->newPage();
                    if ($this->y<60)
                    {
                        if($page_count == 1)
                        {
                            $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                            $page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y - 15), 'UTF-8');
                        }
                        $page = $this->newPage();
                        $page_count ++;
                        $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                        $page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y + 15), 'UTF-8');
                    }

                    $grey_title = FALSE;
                    $supplier_array = explode(',',$value);
                    $supplier_skip_order = TRUE;
                    if(in_array(strtoupper(trim($supplier)),$supplier_array)) $supplier_skip_order = FALSE;
                    elseif($supplier_options == 'grey')
                    {
                        $supplier_skip_order = FALSE;
                        $grey_title = TRUE;
                    } // hide only 'filter' settings, if 'grey' show non-fulfileld orders greyed out


                    if($supplier_skip_order == FALSE)
                    {
                        $page->setFillColor($background_color_subtitles_zend);
                        $page->setLineColor($background_color_subtitles_zend);
                        if($grey_title == TRUE)
                        {
                            $page->setFillColor($lt_grey_bkg_color);
                            $page->setLineColor($lt_grey_bkg_color);    
                        }
                        $page->drawRectangle(27, $this->y, $padded_right, ($this->y - 20));

                        $this->_setFont($page, 'bold', $font_size_subtitles, $font_family_subtitles, $non_standard_characters, $font_color_subtitles);

                        // order #
                        if($grey_title == TRUE) $page->setFillColor(new Zend_Pdf_Color_GrayScale(0.4));
                        $page->drawText(Mage::helper('sales')->__('#') .$order_id, 31, ($this->y - 15), 'UTF-8');

                        if($tickbox != 'no' && $grey_title != TRUE)
                        {
                            $page->setFillColor($white_color);            
                            $page->setLineColor($black_color);    
                            $page->drawRectangle(552, ($this->y-2), 568, ($this->y-18));
                        }

                        if($barcodes==1)
                        {
                            $barcodeString = $this->convertToBarcodeString($order_id,$barcode_type);
                            $barcodeWidth = $this->parseString($order_id,Zend_Pdf_Font::fontWithPath(dirname(__FILE__)  . '/' . $font_family_barcode), 24);
                            $page->setFillColor($white_color);
                            $page->setLineColor($white_color);
                            $page->drawRectangle(($barcodeWidth + 38), ($this->y-2), (40+$barcodeWidth+$barcodeWidth+10), ($this->y - 18));
                            $page->setFillColor($black_color);
                            if($grey_title == TRUE) $page->setFillColor(new Zend_Pdf_Color_GrayScale(0.4));
                            $page->setFont(Zend_Pdf_Font::fontWithPath(dirname(__FILE__)  . '/' . $font_family_barcode), 16);
                            $page->drawText($barcodeString, ($barcodeWidth + 50), ($this->y - 20), 'CP1252');
                        }

                        if($shmethod == 1)
                        {    
                            if($grey_title == TRUE) $page->setFillColor(new Zend_Pdf_Color_GrayScale(0.4));                        
                            $this->_setFont($page, 'bold', ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                            $page->drawText($sku_shipping_method[$order_id], $shipping_method_x, ($this->y - 15), 'UTF-8');
                        }

                        if($order_address_yn == 1)
                        {
                            $this->y -= 30;

                            if($grey_title == TRUE) $page->setFillColor(new Zend_Pdf_Color_GrayScale(0.4));
                            $this->_setFont($page, 'regular', ($font_size_subtitles-4), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);                        
                            $page->drawText($sku_shipping_address[$order_id], 60, ($this->y - 15), 'UTF-8');
                        }

                        $this->y -= 30;


                        foreach($sku_order_id_qty[$order_id] as $sku =>$qty)
                        {
                            $supplier_item_action = 'keep';
                            // if set to filter and a name and this is the name, then print
                            if($supplier_options == 'filter' && isset($supplier_login) && (strtoupper($sku_supplier[$sku]) == strtoupper($supplier_login)) )//grey //split
                            {
                                $supplier_item_action = 'keep';
                            }
                            elseif($supplier_options == 'filter' && isset($supplier_login) && ($supplier_login != '') && (strtoupper($sku_supplier[$sku]) != strtoupper($supplier_login)) )//grey //split
                            {
                                $supplier_item_action = 'hide';
                            }
                            elseif($supplier_options == 'grey' && isset($supplier_login) && (strtoupper($sku_supplier[$sku]) == strtoupper($supplier_login)) )//grey //split
                            {
                                $supplier_item_action = 'keep';
                            }
                            elseif($supplier_options == 'grey' && isset($supplier_login) && $supplier_login != '' && (strtoupper($sku_supplier[$sku]) != strtoupper($supplier_login)) )//grey //split
                            {
                                $supplier_item_action = 'keepGrey';
                            }
                            elseif($supplier_options == 'grey' && ($supplier_login == '') && (strtoupper($sku_supplier[$sku]) != strtoupper($supplier) ) )
                            {
                                $supplier_item_action = 'keepGrey';
                            }
                            elseif($supplier_options == 'filter' && ($supplier_login == '') && (strtoupper($sku_supplier[$sku]) != strtoupper($supplier) ) )
                            {
                                $supplier_item_action = 'hide';
                            }
                            elseif($supplier_options == 'grey' && ($supplier_login == '') && (strtoupper($sku_supplier[$sku]) == strtoupper($supplier) ) )
                            {
                                $supplier_item_action = 'keep';
                            }
                            elseif($supplier_options == 'filter' && ($supplier_login == '') && (strtoupper($sku_supplier[$sku]) == strtoupper($supplier) ) )
                            {
                                $supplier_item_action = 'keep';
                            }
                            elseif($supplier_options == 'grey') $supplier_item_action = 'keepGrey';
                            elseif($supplier_options == 'filter') $supplier_item_action = 'hide';

                            $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);

                            if($supplier_item_action != 'hide' && trim($supplier_item_action) != '')
                            {
                                if ($this->y<60)
                                {
                                    if($page_count == 1)
                                    {
                                        $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                                        $page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y - 15), 'UTF-8');
                                    }
                                    $page = $this->newPage();
                                    $page_count ++;
                                    $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                                    $page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y + 15), 'UTF-8');
                                }

                                // if ($this->y<15) $page = $this->newPage();
                                if($supplier_item_action == 'keepGrey')
                                {
                                    $page->setFillColor($greyout_color);
                                }
                                elseif($tickbox != 'no')
                                {
                                    $page->setFillColor($white_color);            
                                    $page->setLineColor($black_color);    
                                    $page->drawRectangle(27, ($this->y), 34, ($this->y+7));
                                    $page->setFillColor($font_color_body_zend);
                                }


                                //
                                $sku_addon = '';
                                if($shelving_yn == 1 && trim($sku_shelving[$sku]) != '') 
                                {
                                    if($shelvingpos == 'col')
                                    {
                                        $page->drawText('['.$sku_shelving[$sku].']', $shelvingX, $this->y , 'UTF-8');
                                    }
                                    else
                                    {
                                        $sku_addon = ' / ['.$sku_shelving[$sku].']';
                                    }
                                }

                                $max_qty_length_display = 0;

                                 if($from_shipment == 'shipment'){
                                    $max_qty_length_display = ((($max_qty_length+5)*($font_size_body*1.1))-57);
                                    $qty_string = 's:'.(int)$sku_order_id_sqty[$order_id][$sku] . ' / o:'.$qty; 
                                 }else{
                                     $qty_string = $qty;
                                 }                            

                                $page->drawText($qty_string, $qtyX, $this->y , 'UTF-8');
                                $page->drawText(' x  '.$sku.$sku_addon, $skuX+$max_qty_length_display, $this->y , 'UTF-8');
                                if($nameyn == 1) $page->drawText($sku_name[$sku], intval($namenudge), $this->y , 'UTF-8');
                                //

                                if(($sku_stock[$sku] < $stockcheck) && $stockcheck_yn == 1 && $supplier_item_action != 'keepGrey') 
                                {
                                    $this->_setFont($page, $font_style_body, ($font_size_body-2), $font_family_body, $non_standard_characters, $font_color_body);

                                    $this->y -= 12;
                                    $page->setFillColor($red_bkg_color);            
                                    $page->setLineColor(new Zend_Pdf_Color_Rgb(1,1,1));    
                                    $page->drawRectangle(55, ($this->y-4), $padded_right, ($this->y+10));
                                    $page->setFillColor(new Zend_Pdf_Color_GrayScale(0));                
                                    $warning = 'Stock Warning      SKU: '.$sku.'    Net Stock After All Picks : ';
                                    if(isset($sku_stock[$sku])) $warning .= $sku_stock[$sku];
                                    $page->drawText($warning, 60, $this->y , 'UTF-8');
                                    $this->y -= 4;
                                }

                                if(isset($sku_order_id_options[$order_id][$sku]) && $sku_order_id_options[$order_id][$sku] != '')
                                {
									$this_item_options = '';
                                    $this_item_options = trim(str_replace('Array[','[',$sku_order_id_options[$order_id][$sku]));
                                    $this->y -= 10;
                                    $this->_setFont($page, $font_style_body, ($font_size_options), $font_family_body, $non_standard_characters, $font_color_body);

									$maxWidthPage = ($padded_right + 20 - 80);
                                    $font_temp = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
                                    $font_size_compare = ($font_size_options);
                                    $line_width = $this->parseString('1234567890',$font_temp,$font_size_compare); // bigger = left
                                    $char_width = $line_width/10;
                                    $max_chars = round($maxWidthPage/$char_width);

                                    if(strlen($this_item_options) > $max_chars)
                                    {
                                        if($options_yn_base == '1') $chunks = split_words($this_item_options, '/ /', $max_chars);
                                        elseif($options_yn_base == 'yesstacked') $chunks = explode('[',$this_item_options);

                                        $lines = 0;
                                        foreach($chunks as $key => $chunk)
                                        {
                                            $chunk_display = '';

                                            if(trim($chunk != '')) 
                                            {
                                                $this->y -= ($font_size_options);
                                                $options_y_counter += $font_size_options;

                                                $chunk_display = str_replace('[[','[','[ '.$chunk);

                                                $page->drawText($chunk_display, 80, $this->y , 'UTF-8');
                                                $lines ++;
                                            }
                                        }

                                        unset($chunks);
                                    }
                                    else
                                    {
                                        if($options_yn_base == 'yesstacked') 
                                        {
                                            $chunks = explode('[',$this_item_options);

                                            $lines = 0;

                                            foreach($chunks as $key => $chunk)
                                            {
                                                $chunk_display = '';
                                                if(trim($chunk != '')) 
                                                {
                                                    $this->y -= ($font_size_options);
                                                    $options_y_counter += $font_size_options;
                                                    $chunk_display = str_replace('[[','[','['.$chunk);
                                                    $page->drawText($chunk_display, 80, $this->y , 'UTF-8');
                                                    $lines ++;
                                                }
                                            }
                                            unset($chunks);
                                        }
                                        else
                                        {
                                            $this->y -= ($font_size_options);
                                            $options_y_counter += $font_size_options;
                                            $page->drawText($this_item_options, 80, $this->y , 'UTF-8');
                                        }
                                    }



                                }


                                if($sku_bundle[$order_id][$sku])
                                {
                                    $offset = 10;
                                    $box_x = ($qtyX-$offset);
                                    $this->y -= 10;
                                    $this->_setFont($page, $font_style_body, ($font_size_body-2), $font_family_body, $non_standard_characters, $font_color_body);
                                    $page->drawText(Mage::helper('sales')->__('Bundle Options').' : ', $box_x , $this->y , 'UTF-8');

                                    foreach($sku_bundle[$order_id][$sku] as $key =>$value)
                                    {
                                        $sku            = '';
                                        $name            = '';
                                        $shelf            = '';
                                        $qty            = '';
                                        $sku_bundle_array = explode('##',$value);
                                        $sku             = $sku_bundle_array[0];
                                        $name             = $sku_bundle_array[1];
                                        $shelf             = $sku_bundle_array[2];
                                        $qty             = $sku_bundle_array[3];

                                        $this->_setFont($page, $font_style_body, ($font_size_body-2), $font_family_body, $non_standard_characters, $font_color_body);
                                        $this->y -= 10;
                                        $page->drawText($sku, ($skuX+$skuXInc+10) , $this->y , 'UTF-8');
                                        $page->drawText($name, intval($namenudge+10) , $this->y , 'UTF-8');
                                        $page->drawText($shelf, $shelvingX , $this->y , 'UTF-8');
                                        $page->drawText($qty.'  x', $qtyX , $this->y , 'UTF-8');

                                        if(($sku_supplier_item_action[$supplier][$sku] != 'keepGrey') && ($tickbox == 'pickpack'))
                                        {
                                            $page->setLineWidth(0.5);
                                            $page->setFillColor($white_color);            
                                            $page->setLineColor($black_color);    
                                            $page->drawRectangle($box_x, ($this->y-1), ($box_x + 7), ($this->y+6));
                                            $page->setFillColor($black_color);
                                        }
                                    }
                                }

                                $this->y -= 12;
                            }
                        }
                    } //end if in supplier_array
                }// end roll_Order
            }// end hide/grey sheets for suppliers
        }
    }
    else
    {


            if($picklogo == 1)
            {                    
                $packlogo = Mage::getStoreConfig('pickpack_options/wonder/pack_logo', $order->getStore()->getId());
                if($packlogo)
                {
                    $packlogo = Mage::getStoreConfig('system/filesystem/media', $order->getStore()->getId()) . '/moogento/pickpack/logo_pack/' . $packlogo;
                    if (is_file($packlogo)) {    
                        $packlogo = Zend_Pdf_Image::imageWithPath($packlogo);            
                        $page->drawImage($packlogo, 27, ($page_top-31), 296, ($page_top+10));
                    }
                }
                $this->_setFont($page, $font_style_header, $font_size_header, $font_family_header, $non_standard_characters, $font_color_header);    
                if($from_shipment == 'shipment')
                {
                    $page->drawText(Mage::helper('sales')->__('Shipment-separated Pick List'), 325, ($page_top-5), 'UTF-8');        
                }
                else
                {
                    $page->drawText(Mage::helper('sales')->__('Order-separated Pick List'), 325, ($page_top-5), 'UTF-8');        
                }
                // $page->drawText(Mage::helper('sales')->__('Supplier : '.$supplier), 325, 790, 'UTF-8');
                $page->setFillColor($font_color_header_zend);            
                $page->setLineColor($font_color_header_zend);
                $page->setLineWidth(0.5);            
                $page->drawRectangle(304, ($page_top-31), 316, ($page_top+10));

                $this->y = ($page_top-43);//777;
            }
            else
            {
                   $this->_setFont($page, $font_style_header, ($font_size_header+2), $font_family_header, $non_standard_characters, $font_color_header);
                if($from_shipment == 'shipment')
                {
                    $page->drawText(Mage::helper('sales')->__('Shipment-separated Pick List'), 31, ($page_top-5), 'UTF-8');
                }
                else
                {
                    $page->drawText(Mage::helper('sales')->__('Order-separated Pick List'), 31, ($page_top-5), 'UTF-8');
                }
                $page->setLineColor($font_color_header_zend);
                $page->setFillColor($font_color_header_zend);
                $page->drawRectangle(27, ($page_top-12), $padded_right, ($page_top-11));

                $this->y = ($page_top-20);//800;
            }
            $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);


            // roll_orderID
            $page_count = 1;
            // foreach($order_id_master as $order_id =>$value)
            //             {    
            foreach($product_build as $order_id => $order_build) 
            {            
                if ($this->y<60)
                {
                    if($page_count == 1)
                    {
                        $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                        $page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y - 15), 'UTF-8');
                    }
                    $page = $this->newPage();
                    $page_count ++;
                    $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                    $page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y + 15), 'UTF-8');
                }

                $page->setFillColor($background_color_subtitles_zend);
                $page->setLineColor($background_color_subtitles_zend);
                $page->drawRectangle(27, $this->y, $padded_right, ($this->y - 20));

                // order #
                $this->_setFont($page, 'bold', $font_size_subtitles, $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                $page->drawText(Mage::helper('sales')->__('#') .$order_id, 31, ($this->y - 15), 'UTF-8');

                $barcodes = Mage::getStoreConfig('pickpack_options/picks/pickpack_pickbarcode');

            //587 / 570 ($padded_right-2)
                if($tickbox != 'no')
                {
                    $page->setFillColor($white_color);            
                    $page->setLineColor($black_color);    
                    $page->drawRectangle(($padded_right-2-16), ($this->y-2), ($padded_right-2), ($this->y-18));
                    $page->setFillColor($black_color);
                }

                if($barcodes==1)
                {
                    $barcodeString = $this->convertToBarcodeString($order_id,$barcode_type);
                    $barcodeWidth = $this->parseString($order_id,Zend_Pdf_Font::fontWithPath(dirname(__FILE__)  . '/' . $font_family_barcode), 24);
                    $page->setFillColor($white_color);
                    $page->setLineColor($white_color);
                    $page->drawRectangle(($barcodeWidth + 38), ($this->y-2), (40+$barcodeWidth+$barcodeWidth+10), ($this->y - 18));
                    $page->setFillColor(new Zend_Pdf_Color_RGB(0, 0, 0));
                    $page->setFont(Zend_Pdf_Font::fontWithPath(dirname(__FILE__)  . '/' . $font_family_barcode), 16);
                    $page->drawText($barcodeString, ($barcodeWidth + 50), ($this->y - 20), 'CP1252');
                }

                if($shmethod == 1)
                {    
                    $this->_setFont($page, 'bold', ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                    $page->drawText($sku_shipping_method[$order_id], $shipping_method_x, ($this->y - 15), 'UTF-8');
                }

                if($order_address_yn == 1)
                {
                    $page->setFillColor($background_color_subtitles_zend);
                    $page->setLineColor($background_color_subtitles_zend);
                    $page->drawRectangle(27, ($this->y-31), $padded_right, ($this->y - 20));

                    // order #
                    $this->_setFont($page, 'regular', ($font_size_subtitles*0.6), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);

                    $this->y -= 28;
                    $page->drawText($sku_shipping_address[$order_id], 31, $this->y, 'UTF-8');
                    // $this->y += 5;
                    $this->y -= 16;
                }
                else $this->y -= ($font_size_body+20);

                    if($sort_packing != 'none')
                    {
                        $sortorder_packing_bool = false;
                        if($sortorder_packing == 'ascending') $sortorder_packing_bool = true;
                        sksort($order_build,$sort_packing,$sortorder_packing_bool);
                        // sksort($product_build_item,$sort_packing,$sortorder_packing_bool);
                    }

                    foreach($order_build as $sku => $value)
                    {
                        // $sku = $key;
                        $dsku = $value['sku'];
                        $qty = $value['qty'];
                        $sqty = $value['sqty'];


                        // if ($this->y<15) $page = $this->newPage();
                        if ($this->y<60)
                        {
                            if($page_count == 1)
                            {
                                $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                                $page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y - 15), 'UTF-8');
                            }
                            $page = $this->newPage();
                            $page_count ++;
                            $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                            $page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y + 15), 'UTF-8');
                        }

                        $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);

                        if($tickbox != 'no')
                        {
                            $page->setLineWidth(1);
                            $page->setFillColor($white_color);            
                            $page->setLineColor($black_color);    
                            $page->drawRectangle(27, ($this->y), (27+($font_size_body*0.65)), ($this->y+($font_size_body*0.65)));

                                    // $page->setLineWidth(0.5);
                                    //                     $page->setFillColor($white_color);            
                                    //                     $page->setLineColor($black_color);    
                                    //                     $page->drawRectangle(27, $this->y, 34, ($this->y+7));
                                    //                     $page->setFillColor($black_color);

                        }
                        $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);

                            //
                        $sku_addon = '';
                        if($shelving_yn == 1 && trim($sku_shelving[$sku]) != '') 
                        {
                            if($shelvingpos == 'col')
                            {
                                $page->drawText('['.$sku_shelving[$sku].']', $shelvingX, $this->y , 'UTF-8');
                            }
                            else
                            {
                                $sku_addon = ' / ['.$sku_shelving[$sku].']';
                            }
                        }

                        $max_qty_length_display = 0;

                        if($from_shipment == 'shipment'){
                            $max_qty_length_display = ((($max_qty_length+5)*($font_size_body*1.1))-57);
                            $qty_string = 's:'.(int)$sku_order_id_sqty[$order_id][$sku]. ' / o:'.$qty;
                        }else{
                            $qty_string = $qty;
                        }                            

                        $page->drawText($qty_string, $qtyX, $this->y , 'UTF-8');

                        $display_sku = '';
                        if(strlen($sku) > ($character_breakpoint_sku+2))
                        {
                            // $display_sku = substr(htmlspecialchars_decode($sku_order_id_sku[$order_id][$sku]), 0, ($character_breakpoint_sku)).'…';
                            $display_sku = substr(htmlspecialchars_decode($dsku), 0, ($character_breakpoint_sku)).'…';
                        }
                        // else $display_sku = htmlspecialchars_decode($sku_order_id_sku[$order_id][$sku]);
                        else $display_sku = htmlspecialchars_decode($dsku);


                        // $page->drawText(' x  '.$display_sku.$sku_addon, $skuX+$max_qty_length_display, $this->y , 'UTF-8');
                        $page->drawText($display_sku.$sku_addon, $skuX+$max_qty_length_display, $this->y , 'UTF-8');
                        if($nameyn == 1 && isset($sku_name[$sku])) $page->drawText($sku_name[$sku], intval($namenudge), $this->y , 'UTF-8');

                        if(isset($sku_stock[$sku]) && ($sku_stock[$sku] < $stockcheck) && $stockcheck_yn == 1) 
                        {
                            $this->_setFont($page, $font_style_body, ($font_size_body-2), $font_family_body, $non_standard_characters, $font_color_body);

                            $this->y -= ($font_size_body+2);
                            $page->setFillColor($red_bkg_color);            
                            $page->setLineColor(new Zend_Pdf_Color_Rgb(1,1,1));    
                            $page->drawRectangle(55, ($this->y-4), $padded_right, ($this->y+10));
                            $page->setFillColor(new Zend_Pdf_Color_GrayScale(0));                
                            $warning = 'Stock Warning      SKU: '.$sku.'    Net Stock After All Picks : '.$sku_stock[$sku];
                            $page->drawText($warning, 60, $this->y , 'UTF-8');
                            $this->y -= 4;
                        }

                        if(isset($sku_order_id_options[$order_id][$sku]) && $sku_order_id_options[$order_id][$sku] != '')
                        {
                            $this->_setFont($page, $font_style_body, $font_size_options, $font_family_body, $non_standard_characters, $font_color_body);
                            if($options_yn == 0 && $options_yn_base == 1) 
                            {
                                $this->y -= ($font_size_body);
                                $page->drawText(Mage::helper('sales')->__('Options').': '.$sku_order_id_options[$order_id][$sku], ($namenudge + 20) , $this->y , 'UTF-8');
                            }
                            elseif($options_yn_base == 'yesstacked')
                            {
/**

*/
								$this_item_options = '';
								$this_item_options = trim(str_replace('Array[','[',$sku_order_id_options[$order_id][$sku]));

								$maxWidthPage = ($padded_right + 20 - 80);
                                $font_temp = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
                                $font_size_compare = ($font_size_options);
                                $line_width = $this->parseString('1234567890',$font_temp,$font_size_compare); // bigger = left
                                $char_width = $line_width/10;
                                $max_chars = round($maxWidthPage/$char_width);

                                if(strlen($this_item_options) > $max_chars)
                                {
									if($options_yn_base == '1') 
									{
										$chunks = split_words($this_item_options, '/ /', $max_chars);
									}
                                    elseif($options_yn_base == 'yesstacked') 
									{
										$chunks = explode('[',$this_item_options);
									}

                                    $lines = 0;
                                    foreach($chunks as $key => $chunk)
                                    {
                                        $chunk_display = '';

                                        if(trim($chunk != '')) 
                                        {
                                            $this->y -= ($font_size_options);
                                            $options_y_counter += $font_size_options;

                                            $chunk_display = str_replace('[[','[','[ '.$chunk);

                                            $page->drawText($chunk_display, 80, $this->y , 'UTF-8');
                                            $lines ++;
                                        }
                                    }

                                    unset($chunks);
                                }
                                else
                                {
                                    if($options_yn_base == 'yesstacked') 
                                    {
                                        $chunks = explode('[',$this_item_options);

                                        $lines = 0;

                                        foreach($chunks as $key => $chunk)
                                        {
                                            $chunk_display = '';
                                            if(trim($chunk != '')) 
                                            {
                                                $this->y -= ($font_size_options);
                                                $options_y_counter += $font_size_options;
                                                $chunk_display = str_replace('[[','[','['.$chunk);
                                                $page->drawText($chunk_display, 80, $this->y , 'UTF-8');
                                                $lines ++;
                                            }
                                        }
                                        unset($chunks);
                                    }
                                    else
                                    {
                                        $this->y -= ($font_size_options);
                                        $options_y_counter += $font_size_options;
                                        $page->drawText($this_item_options, 80, $this->y , 'UTF-8');
                                    }
                                }
/**

*/
							}
							elseif($options_yn_base == 1)
                            {
                                ksort($options_sku_parent[$order_id][$sku]);

                                foreach($options_sku_parent[$order_id][$sku] as $options_sku => $options_qty)
                                {


                                    if(!in_array($options_sku,$pickpack_options_filter_array))
                                    {
                                        $this->y -= ($font_size_body-2);

                                        if($tickbox != 'no')
                                        {
                                            $page->setFillColor($white_color);            
                                            $page->setLineColor($black_color);    
                                            $page->setLineWidth(0.5);            
                                            $page->drawRectangle(30, ($this->y-1), 36, ($this->y+5));
                                            $page->setLineWidth(1);            
                                        }
                                        $this->_setFont($page, $font_style_body, ($font_size_body-2), $font_family_body, $non_standard_characters, $font_color_body);

                                        if(!in_array($options_sku,$pickpack_options_count_filter_array))
                                        {
                                            $page->drawText($options_qty, ($qtyX + 4) , $this->y , 'UTF-8');
                                            // $page->drawText('x [ '.$options_sku.' ]', ($skuX+$max_qty_length_display + 4) , $this->y , 'UTF-8');
                                            $page->drawText(' [ '.$options_sku.' ]', ($skuX+$max_qty_length_display + 6) , $this->y , 'UTF-8');
                                        }
                                        else
                                        {
                                            $page->drawText('   [ '.$options_sku.' ]', ($skuX+$max_qty_length_display + 6) , $this->y , 'UTF-8');
                                        }


                                        if(isset($options_name[$order_id][$sku][$options_sku]) && $nameyn == 1)
                                        {
                                            $page->drawText($options_name[$order_id][$sku][$options_sku], ($namenudge+4), $this->y , 'UTF-8');
                                        }
                                    }
                                }
                            }
                        }

                        if(isset($sku_bundle[$order_id][$sku]) && is_array($sku_bundle[$order_id][$sku]))
                        {
                            $offset = 10;
                            $box_x = ($qtyX-$offset);
                            $this->y -= ($font_size_body);
                            $this->_setFont($page, $font_style_body, ($font_size_body-2), $font_family_body, $non_standard_characters, $font_color_body);
                            $page->drawText(Mage::helper('sales')->__('Bundle Options').' : ', $box_x , $this->y , 'UTF-8');

                            foreach($sku_bundle[$order_id][$sku] as $key =>$value)
                            {
                                $sku            = '';
                                $name            = '';
                                $shelf            = '';
                                $qty            = '';
                                $sku_bundle_array = explode('##',$value);
                                $sku             = $sku_bundle_array[0];
                                $name             = $sku_bundle_array[1];
                                $shelf             = $sku_bundle_array[2];
                                $qty             = $sku_bundle_array[3];



                                $this->_setFont($page, $font_style_body, ($font_size_body-2), $font_family_body, $non_standard_characters, $font_color_body);
                                $this->y -= ($font_size_body-2);
                                $page->drawText($sku, ($skuX+$skuXInc+10) , $this->y , 'UTF-8');
                                $page->drawText($name, intval($namenudge+10) , $this->y , 'UTF-8');
                                $page->drawText($shelf, $shelvingX , $this->y , 'UTF-8');
                                // $page->drawText($qty.'  x', $qtyX , $this->y , 'UTF-8');
                                $page->drawText($qty, $qtyX , $this->y , 'UTF-8');

                                if($tickbox != 'no')
                                {
                                    $page->setFillColor($white_color);            
                                    $page->setLineColor($black_color);    
                                    $page->setLineWidth(0.5);            
                                    $page->drawRectangle(30, ($this->y-1), 36, ($this->y+5));
                                    $page->setLineWidth(1);            
                                }

                                // if(((isset($sku_supplier_item_action[$supplier][$sku]) && $sku_supplier_item_action[$supplier][$sku] != 'keepGrey')) && ($tickbox == 'pickpack'))
                                //                         {
                                //                             $page->setLineWidth(0.5);
                                //                             $page->setFillColor($white_color);            
                                //                             $page->setLineColor($black_color);    
                                //                             $page->drawRectangle($box_x, ($this->y), ($box_x + ($font_size_body-2-4)), ($this->y+($font_size_body-2-4)));
                                //                             $page->setFillColor($black_color);
                                //                         }
                            }
                        }

                    $this->y -= ($font_size_body+1);
                // }
                }// end roll_SKU

            }// end roll_Order

            $this->y -= 30;
            // $this->_setFontItalic($page,12);
            if(($showcount_yn == 1) || $showcost_yn == 1)
            {
                $page->setFillColor($white_bkg_color);            
                $page->setLineColor($orange_bkg_color);    
                $page->setLineWidth(4);    
                $page->drawRectangle(355, ($this->y-34), 568, ($this->y+10+$font_size_body));
                $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
            }

            if($showcount_yn == 1)
            {
                $page->drawText(Mage::helper('sales')->__('Total quantity').' : '.$total_quantity, 375, $this->y , 'UTF-8');
            }

            $this->y -= 20;

            if($showcost_yn == 1)
            {
                $page->drawText(Mage::helper('sales')->__('Total cost').' : '.$currency_symbol."  ".($total_cost), 375, $this->y , 'UTF-8');
            }

            if($printdates == 1)
            {
                $this->_setFontBold($page);
$page->drawText(Mage::helper('sales')->__('Printed:').'   '.date('D jS M Y G:i', Mage::getModel('core/date')->timestamp(time())), 210, 18, 'UTF-8');
            }
    }

    $this->_afterGetPdf();

    return $pdf;    
    /**
    getPickseparated2 222222222 Template - END
    *********************************************
    ************************************************/
}





 /**
   getPickCOMBINED Template - START
    ************************************************/

public function getPickCombined($orders=array(), $output='order_combined')//$shipments = array(), $from_shipment = 'order')
{
	$from_shipment 						= 'order';
	$trolleybox_yn 						= 0;
	$trolleybox_max 					= null;
	$show_orderid_with_trolleyboxid_yn 	= 0;
	$qty_yn 							= 1;
	$show_bundle_parent_yn				= 0;
	
	$config_group 						= 'messages';
	if($output == 'trolleybox')
	{
		$config_group 					= 'trolleybox_picklist';
		$trolleybox_yn 					= $this->_getConfig('trolleybox_yn', 1, false,$config_group);
		$qty_yn 						= $this->_getConfig('qty_yn', 0,false,$config_group);
		$show_orderid_with_trolleyboxid_yn = $this->_getConfig('show_orderid_with_trolleyboxid_yn', 1,false,$config_group);
		$show_bundle_parent_yn = $this->_getConfig('show_bundle_parent_yn', 0,false,$config_group);
		
		if($trolleybox_yn == 1)
		{
			$trolleybox_max = $this->_getConfig('trolleybox_max', 6, false,$config_group);
		}
	}
	$shipments = array();
    $store_id = Mage::app()->getStore()->getId();

// product_separated or order_combined
    $this->_beforeGetPdf();
    $this->_initRenderer('invoices');

    $pdf = new Zend_Pdf();
    $this->_setPdf($pdf);
    $style = new Zend_Pdf_Style();
    
    $page_size = $this->_getConfig('page_size', 'a4', false,'general');
    
	$padded_left = 20;
    if($page_size == 'letter') 
    {
        $page = $pdf->newPage(Zend_Pdf_Page::SIZE_LETTER);
        $page_top = 770;$padded_right = 587;
    }
    elseif($page_size == 'a4') 
    {
        $page = $pdf->newPage(Zend_Pdf_Page::SIZE_A4);
        $page_top = 820;$padded_right = 570;
    }
    elseif($page_size == 'a5landscape') 
    {
        $page = $pdf->newPage('596:421');                    
        $page_top = 395;$padded_right = 573;
    }
    
    $pdf->pages[] = $page;

    $qtyX                     = 40;
    $productX                 = 250;
    $font_size_overall         = 15;
    $font_size_productline     = 9;
    $total_quantity         = 0;
    $total_cost             = 0;
    $error_product_count	= 0;

    $shipping_subtotal_yn = $this->_getConfig('shipping_subtotal_yn', 0, false,$config_group);
    $total_paid_subtotal_yn = $this->_getConfig('total_paid_subtotal_yn', 0, false,$config_group);

    $red_bkg_color             = new Zend_Pdf_Color_Html('lightCoral');
    $grey_bkg_color            = new Zend_Pdf_Color_GrayScale(0.7);
    $alternate_row_color_temp = $this->_getConfig('alternate_row_color', '#DDDDDD', false,$config_group);
    $alternate_row_color    = new Zend_Pdf_Color_Html($alternate_row_color_temp);
    $dk_grey_bkg_color        = new Zend_Pdf_Color_GrayScale(0.3);
    $dk_cyan_bkg_color         = new Zend_Pdf_Color_Html('darkCyan');
    $dk_og_bkg_color         = new Zend_Pdf_Color_Html('darkOliveGreen');
    $white_bkg_color         = new Zend_Pdf_Color_Html('white');
    $orange_bkg_color         = new Zend_Pdf_Color_Html('Orange');    
    $black_color             = new Zend_Pdf_Color_Rgb(0,0,0);
    $grey_color             = new Zend_Pdf_Color_GrayScale(0.3);
    $greyout_color             = new Zend_Pdf_Color_GrayScale(0.6);
    $white_color             = new Zend_Pdf_Color_GrayScale(1);
    
    $font_family_header_default     = 'helvetica';
    $font_size_header_default         = 16;
    $font_style_header_default         = 'bolditalic';
    $font_color_header_default         = 'darkOliveGreen';
    $font_family_subtitles_default     = 'helvetica';
    $font_style_subtitles_default     = 'bold';
    $font_size_subtitles_default     = 15;
    $font_color_subtitles_default     = '#222222';
    $background_color_subtitles_default = '#999999';
    $font_family_body_default         = 'helvetica';
    $font_size_body_default         = 10;
    $font_style_body_default         = 'regular';
    $font_color_body_default         = 'Black';

    $font_family_header                 = $this->_getConfig('font_family_header', $font_family_header_default, false,'general');
    $font_style_header                     = $this->_getConfig('font_style_header', $font_style_header_default, false,'general');
    $font_size_header                     = $this->_getConfig('font_size_header', $font_size_header_default, false,'general');
    $font_color_header                     = trim($this->_getConfig('font_color_header', $font_color_header_default, false,'general'));
    $font_family_subtitles                 = $this->_getConfig('font_family_subtitles', $font_family_subtitles_default, false,'general');
    $font_style_subtitles                 = $this->_getConfig('font_style_subtitles', $font_style_subtitles_default, false,'general');
    $font_size_subtitles                 = $this->_getConfig('font_size_subtitles', $font_size_subtitles_default, false,'general');
    $font_color_subtitles                 = trim($this->_getConfig('font_color_subtitles', $font_color_subtitles_default, false,'general'));
    $background_color_subtitles         = trim($this->_getConfig('background_color_subtitles', $background_color_subtitles_default, false,'general'));
    $font_family_body                     = $this->_getConfig('font_family_body', $font_family_body_default, false,'general');
    $font_style_body                     = $this->_getConfig('font_style_body', $font_style_body_default, false,'general');
    $font_size_body                     = $this->_getConfig('font_size_body', $font_size_body_default, false,'general');
    $font_color_body                     = trim($this->_getConfig('font_color_body', $font_color_body_default, false,'general'));
    $background_color_subtitles_zend     = new Zend_Pdf_Color_Html($background_color_subtitles);    
    $font_color_header_zend             = new Zend_Pdf_Color_Html($font_color_header);    
    $font_color_subtitles_zend             = new Zend_Pdf_Color_Html($font_color_subtitles);    
    $font_color_body_zend                 = new Zend_Pdf_Color_Html($font_color_body);

    $non_standard_characters     = $this->_getConfig('non_standard_characters', 0, false,'general');

	$barcode_type        = $this->_getConfig('font_family_barcode', 'code128', false,'general',$store_id);
	switch ($barcode_type) 
	{
		case 'code128':
			$font_family_barcode 	= 'Code128bWin.ttf';
			break;

		case 'code39':
			$font_family_barcode 	= 'CODE39.ttf';
			
			break;	

		case 'code39x':
			$font_family_barcode 	= 'CODE39X.ttf';
			
			break;

		default:
			$font_family_barcode 	= 'Code128bWin.ttf';
			break;
	}
	
    $printdates                 = Mage::getStoreConfig('pickpack_options/messages/pickpack_packprint');
    $date_format                = $this->_getConfig('date_format', 'M. j, Y', false,'general');

    $shelvingpos				= $this->_getConfig('shelvingpos', 'col', false,'general'); //col/sku

    $product_images_yn						= $this->_getConfig('product_images_yn', 0, false,$config_group);
	if($product_images_yn == 1)
	{
 	   $product_images_source				= $this->_getConfig('product_images_source', 'thumbnail', false,$config_group);
	    $col_title_product_images			= explode(',',trim($this->_getConfig('col_title_product_images', ',150', false,$config_group)));
	    $product_images_border_color_temp   = strtoupper(trim($this->_getConfig('product_images_border_color', '#CCCCCC', false,$config_group)));
		$product_images_border_color        = new Zend_Pdf_Color_Html($product_images_border_color_temp);
		$product_images_maxdimensions       = explode(',',str_ireplace('null','',$this->_getConfig('product_images_maxdimensions', '50,',$config_group)));               
		if($product_images_maxdimensions[0] == '' || $product_images_maxdimensions[1] == '')
		{
		   if($product_images_maxdimensions[0] == '') $product_images_maxdimensions[0] = NULL;
		   if($product_images_maxdimensions[1] == '') $product_images_maxdimensions[1] = NULL;
		   if($product_images_maxdimensions[0] == NULL && $product_images_maxdimensions[1] == NULL) $product_images_maxdimensions[0] = 50;
		}
		$product_images_source_res			= $product_images_source;
		if($product_images_source == 'gallery') $product_images_source_res = 'image';
	}
	
	$media_path 				= Mage::getBaseDir('media');
	
    $product_id					= NULL; // get it's ID
    $stock						= NULL;
    $sku_stock					= array();
    $sku_qty					= array();
    $sku_cost					= array();
    $showcost_yn_default		= 0;
    $showcount_yn_default		= 0;
    $currency_default			= 'USD';
    
    $shelving_yn_default        = 0;
    $shelving_attribute_default = '';
    $shelvingX_default          = 200;
    $supplier_yn_default        = 0;
    $supplier_attribute_default = 'supplier';
    $stockcheck_yn_default      = 0;
    $stockcheck_default         = 1;
    
    $supplier_login_default     = '';
    $tickbox_default            = 'no';
    
    $split_supplier_yn_temp     = $this->_getConfig('pickpack_split_supplier_yn', 'no', false,'general');
    $split_supplier_options     = $this->_getConfig('pickpack_split_supplier_options', 'no', false,'general');
    $split_supplier_yn = 'no';
    if($split_supplier_yn_temp == 1)
    {
        $split_supplier_yn = $split_supplier_options;
    }

    $supplier_attribute         = $this->_getConfig('pickpack_supplier_attribute', 'supplier', false,'general');
    $supplier_options             = $this->_getConfig('pickpack_supplier_options', 'filter', false,'general');

    $userId                     = Mage::getSingleton('admin/session')->getUser() ? Mage::getSingleton('admin/session')->getUser()->getId(): 0;
    $user                       = ($userId !== 0) ? Mage::getModel('admin/user')->load($userId): '';
    $username                   = (!empty($user['username'])) ? $user['username']:'';

    $supplier_login_pre         = $this->_getConfig('pickpack_supplier_login', '', false,'general');
    $supplier_login_pre         = str_replace(array("\n",','),';',$supplier_login_pre);
    $supplier_login_pre         = explode(';',$supplier_login_pre);

    foreach($supplier_login_pre as $key => $value)
    {
        $supplier_login_single = explode(':',$value);
        if(preg_match('~'.$username.'~i',$supplier_login_single[0])) 
        {
            if($supplier_login_single[1] != 'all') $supplier_login = trim($supplier_login_single[1]);
            else $supplier_login = '';
        }
    }
    
    $sort_packing_yn            = $this->_getConfig('sort_packing_yn', 1,false,$config_group);               
    $sort_packing                = $this->_getConfig('sort_packing', 'sku',false,$config_group);               
    $sortorder_packing            = $this->_getConfig('sort_packing_order', 'ascending',false,$config_group);  
    $sort_packing_attribute        = null;
    if($sort_packing == 'attribute')
    {
        $sort_packing_attribute        = trim($this->_getConfig('sort_packing_attribute', '',false,$config_group));  
        if($sort_packing_attribute != '') $sort_packing = $sort_packing_attribute;
        else $sort_packing = 'sku';
    }
    if($sort_packing_yn == 0) $sortorder_packing = 'none';
    
    

    $tickbox                     = $this->_getConfig('pickpack_tickbox', $tickbox_default, false,'general');
    $picklogo                     = $this->_getConfig('pickpack_picklogo', 0, false,'general');

    $showcount_yn         = $this->_getConfig('pickpack_count', $showcount_yn_default, false,$config_group);
    $order_count_yn     = $this->_getConfig('order_count_yn', 1, false,$config_group);

    $showcost_yn         = $this->_getConfig('pickpack_cost', $showcost_yn_default, false,$config_group);
    $currency             = $this->_getConfig('pickpack_currency', $currency_default, false,$config_group);
    $currency_symbol     = Mage::app()->getLocale()->currency($currency)->getSymbol();
    $shipping_currency     = Mage::app()->getConfig()->getNode('default/'.Mage_Directory_Model_Currency::XML_PATH_CURRENCY_BASE);
    $shipping_currency_symbol = Mage::app()->getLocale()->currency(Mage::app()->getStore()->
     getCurrentCurrencyCode())->getSymbol();
    $stockcheck_yn         = $this->_getConfig('pickpack_showstock_yn_combined', 0, false,$config_group);
    $stockcheck         = $this->_getConfig('pickpack_stock_combined', $stockcheck_default, false,$config_group);

    $combined_sku_yn     = $this->_getConfig('combined_sku_yn', 1, false,$config_group);
    
    $shelving_yn         = $this->_getConfig('pickpack_shelving_yn', 0, false,$config_group);
    $shelving_attribute = $this->_getConfig('pickpack_shelving', '', false,$config_group);

    $extra_yn             = $this->_getConfig('pickpack_extra_yn', 0, false,$config_group);
    $extra_attribute     = $this->_getConfig('pickpack_extra', '', false,$config_group);
    
    $extra3_yn             = $this->_getConfig('pickpack_extra3_yn', 0, false,$config_group);
    $extra3_attribute     = $this->_getConfig('pickpack_extra3', '', false,$config_group);
    
    $nameyn             = $this->_getConfig('pickpack_name_yn_combined', 0, false,$config_group);

    $col_title_position_qty     = explode(',',$this->_getConfig('col_title_position_qty', '0,10', false,$config_group));
    $col_title_position_sku     = explode(',',$this->_getConfig('col_title_position_sku', '0,50', false,$config_group));
    $col_title_position_name     = explode(',',$this->_getConfig('col_title_position_name', '0,250', false,$config_group));
    $col_title_position_trolleybox = explode(',',$this->_getConfig('col_title_position_trolleybox', '0,350', false,$config_group));
    $col_title_position_stock     = explode(',',$this->_getConfig('col_title_position_stock', '0,460', false,$config_group));
    $col_title_position_attr1     = explode(',',$this->_getConfig('col_title_position_attr1', '0,380', false,$config_group));
    $col_title_position_attr2     = explode(',',$this->_getConfig('col_title_position_attr2', '0,410', false,$config_group));
    $col_title_position_attr3     = explode(',',$this->_getConfig('col_title_position_attr3', '0,300', false,$config_group));
        
    $configurable_names             = $this->_getConfig('pickpack_configname_combined', 'simple', false,$config_group); //col/sku
    $configurable_names_attribute     = trim($this->_getConfig('pickpack_configname_attribute_separated', '', false,'picks')); //col/sku
    if($configurable_names != 'custom') $configurable_names_attribute = '';
    
    $pickpack_options_filter_array = array();
    $pickpack_options_count_filter_array = array();
    
    $options_yn                 = $this->_getConfig('pickpack_options_yn', 0, false,$config_group); // no, inline, newline
    $pickpack_options_filter_yn = $this->_getConfig('pickpack_options_filter_yn', 0, false,$config_group);
    $pickpack_options_filter     = $this->_getConfig('pickpack_options_filter', 0, false,$config_group);
    if($pickpack_options_filter_yn == 0) $pickpack_options_filter = '';
    elseif(trim($pickpack_options_filter) != '')
    {
        $pickpack_options_filter_array = explode(',',$pickpack_options_filter);
        foreach($pickpack_options_filter_array as $key => $value)
        {
            $pickpack_options_filter_array[$key] = trim($value);
        }
    }
    $pickpack_options_count_filter     = $this->_getConfig('pickpack_options_count_filter', 0, false,$config_group);
    if($pickpack_options_filter_yn == 0) $pickpack_options_count_filter = '';
    elseif(trim($pickpack_options_count_filter) != '')
    {
        $pickpack_options_count_filter_array = explode(',',$pickpack_options_count_filter);
        foreach($pickpack_options_count_filter_array as $key => $value)
        {
            $pickpack_options_count_filter_array[$key] = trim($value);
        }
    }
    
    $sku_master = array();
    $process_list = array();

    if($from_shipment == 'shipment')
    {
        $process_list = $shipments;
    }
    else
    {
        $process_list = $orders;
    }
    $shipment_list = array();
    unset($shipment_list);
    
    $options_sku_array = array();
    $options_sku = array();
    unset($options_sku);
    unset($options_sku_array);
    
    $count         = 0;
    $count_all     = 0;
    $_count     = 0;
    $i             = 0;
    $total_shipping_cost = array();
    $order_count = 0;
    $productXInc = 0;
    $first_item_title_shift_sku     = 0;
    $first_item_title_shift_items     = 0;
    $total_paid = 0;
    $sku_image_paths			= array();
    $flat_item_list = array();
    $trolleybox_order_id = array();
    $sku_qty_orderid = array();
    
	foreach ($process_list as $orderSingle) 
    {        
        $order_count ++;
        
        if($from_shipment == 'shipment')
        {    
            unset($_items);
            unset($_item);
            
            $_shipment     = Mage::getModel('sales/order_shipment')->load($orderSingle);    
            $_items     = $_shipment->getAllItems();
        
            $itemsCollection = $_items;
            
            $order     = Mage::getModel('sales/order')->load($orders[$i]);    
            $order_items = $order->getAllVisibleItems();
            $shipment_list[]     = $_shipment->getIncrementId();
            $order_list[]        = $order->getRealOrderId();
            if(strlen($order->getShippingAddress()->getName()) > 20)
            {
                $name_list[] = substr(htmlspecialchars_decode($order->getShippingAddress()->getName()), 0, 20).'…';
            }
            else $name_list[]         = $order->getShippingAddress()->getName();
        }
        else
        {
            $order                 = Mage::getModel('sales/order')->load($orderSingle);    
            $itemsCollection     =  $order->getAllVisibleItems();
        }
        
        if(!isset($total_shipping_cost['shipping_ex_tax'])) $total_shipping_cost['shipping_ex_tax'] = $order->getShippingAmount();
        else $total_shipping_cost['shipping_ex_tax'] += $order->getShippingAmount();
        
        if(!isset($total_shipping_cost['shipping_plus_tax'])) $total_shipping_cost['shipping_plus_tax'] = $order->getShippingInclTax();
        else $total_shipping_cost['shipping_plus_tax']     += $order->getShippingInclTax();
        
       	$total_paid     += $order->getBaseGrandTotal();
                
        // $total_items     = count($itemsCollection);
        $product_build_item = array();
        $product_build         = array();
        $options_name_temp     = array();
        unset($options_name_temp);
        
        $coun = 1;
        
        foreach ($itemsCollection as $item)
        {   
        	$item_product_type = $item->getProductType();
        	if(!isset($item_product_type)) 
        	{
        		$error_product_count ++;
        		continue;
        	}
            if($item->getProductType() == Mage_Catalog_Model_Product_Type::TYPE_CONFIGURABLE) 
            {
                $sku = $item->getProductOptionByCode('simple_sku');
            } 
            else 
            {
                $sku = $item->getSku();
            }    
            
            if($options_yn == 'newskuparent')
            {
                $full_sku = trim($item->getSku());    
                $parent_sku = preg_replace('~\-(.*)$~','',$full_sku);
                $sku = $parent_sku;
            }
     
       		$product = Mage::getModel('catalog/product')->setStoreId($store_id)->loadByAttribute('sku', $sku, array('cost','name','simple_sku','qty', $sort_packing_attribute, $shelving_attribute, $extra_attribute, $extra3_attribute, $supplier_attribute));            
		
			if($item->getProductType() == Mage_Catalog_Model_Product_Type::TYPE_CONFIGURABLE) 
	        {
                $product_id = $product->setStoreId($store_id)->getIdBySku($sku);
            } 
            else 
            {
				// $product_id = $item->getId();
                $product_id = $item->getProductId();
            }
            
            // unique item id
            $product_build_item[] = $sku.'-'.$coun;    
            $product_build[$sku.'-'.$coun]['sku'] = $sku;            
            $product_sku = $sku;
            
            $product_build[$sku]['sku'] = $product_sku;

			/**
			images PRELOADER start	
			*/          
			//$attributes = $prod->getTypeInstance(true)->getSetAttributes($prod);

			// $gallery_data = $image_product->getData('media_gallery');
			// foreach ($gallery_data['images'] as &$image) {
			// 	var_dump($image);
			// }						
            $has_shown_product_image    = 0;

			if(($product_images_yn == 1) && !isset($sku_image_paths[$sku]['path'][0])) // ie only get sku image paths if not previously got in this combined request
			{
				$image_product = Mage::helper('catalog/product')->getProduct($product_id, null, null);

		        $options_y_counter      = 0;
		        $img_width              = 0;
		        $img_height             = 0;
		        $resize_x               = null;
		        $resize_y               = null;
				$has_real_image_set		= null;
				$parent_ids				= array();
				$imagePaths				= array();
				
				$image_path				= '';
				$image_path 			= $image_product->getImage();
				$image_parent_sku 		= $product->getSku();
				$has_real_image_set 	= (($image_path != null) && ($image_path != "no_selection") && ($image_path != ''));

                if($image_path != '')
				{
                    $sku_image_paths[$sku]['width']     = $product_images_maxdimensions[0];
                    $sku_image_paths[$sku]['height'] 	= $product_images_maxdimensions[1];

                    $orig_img_width	= Mage::helper('catalog/image')->init($image_product, $product_images_source_res)->getOriginalWidth();
                    $orig_img_height= Mage::helper('catalog/image')->init($image_product, $product_images_source_res)->getOriginalHeigh(); // getOriginalHeigh() = spell mistake
                    if($orig_img_width != $orig_img_height)
                    {
                        if($orig_img_width > $orig_img_height)
                        {
                            $sku_image_paths[$sku]['height'] = ceil(($orig_img_height/$orig_img_width)*$product_images_maxdimensions[1]);
                        }
                        elseif($orig_img_height > $orig_img_width)
                        {
                            $sku_image_paths[$sku]['width'] = ceil(($orig_img_width/$orig_img_height)*$product_images_maxdimensions[0]);
                        }
                    }

                    if(is_integer($sku_image_paths[$sku]['width'])) $resize_x = ($sku_image_paths[$sku]['width']*4);
                    if(is_integer($sku_image_paths[$sku]['height'])) $resize_y = ($sku_image_paths[$sku]['height']*4);

                    // product_images_source = $thumbnail, small_image, image, gallery
					if($product_images_source == 'gallery')
					{
						//$gallery = Mage::getModel('catalog/product')->load($image_product_id)->getMediaGalleryImages();
						$gallery = $image_product->getMediaGalleryImages();

						foreach ($gallery as $image) 
						{
						    $imagePath_temp = Mage::helper('catalog/image')->init($image_product, 'image', $image->getFile())
								->constrainOnly(TRUE)
                                      ->keepAspectRatio(TRUE)
                                      ->keepFrame(FALSE)
                                      ->resize($resize_x, $resize_y)
                                      ->__toString();

							if(strpos($imagePath_temp,'placeholder') === false) $imagePaths[] = $imagePath_temp;
						}
					}
					else
					{          
						$imagePath_temp = Mage::helper('catalog/image')->init($image_product, $product_images_source_res)
							->constrainOnly(TRUE)
							->keepAspectRatio(TRUE)
							->keepFrame(FALSE)
							->resize($resize_x, $resize_y)
							->__toString();

						if(strpos($imagePath_temp,'placeholder') === false) $imagePaths[] = $imagePath_temp;
					}
					
					// $imageLocation     = str_replace(array('/media','media','//'),array('','','/'),Mage::getBaseDir('media')).'/'.substr($imagePath,strlen( str_replace('/index.php','',Mage::getBaseUrl()) ));
					//$media_path 		= Mage::getBaseDir('media');
					$imagePath = '';
					
					foreach($imagePaths as $imagePath)
					{
						$image_url 			= $imagePath;
						// = http://lghttp.20020.nexcesscdn.net/8098AB/example/media/extendware/ewminify/media/inline/6/36/636139/image-name.JPG

						$image_url_after_media_path_with_media = strstr($image_url, '/media/'); //preg_replace('§^.*[media]§i','',$image_url);
						// = /media/extendware/ewminify/media/inline/6/36/636139/image-name.JPG

						$image_url_after_media_path = strstr_after($image_url, '/media/'); //preg_replace('§^.*[media]§i','',$image_url);
						// = extendware/ewminify/media/inline/6/36/636139/image-name.JPG

						$final_image_path = $media_path . '/' . $image_url_after_media_path;
						// = /chroot/home/account/example.com/html/media/extendware/ewminify/media/inline/6/36/636139/image-name.JPG
					
						$sku_image_paths[$sku]['path'][] = $final_image_path;
					}
				}
			}			
			/**
			images PRELOADER end	
			*/
  
			$shelving = '';
			$supplier = '';
// echo '$product_id:'.$product_id.' $store_id:'.$store_id;
// exit;		
// 			if(is_object($product)) $_newProduct = $product->setStoreId($store_id)->load($product_id);  
   
			if($sort_packing_attribute != null)
			{
			   $sort_packing_value = '';

				if(is_object($product))
				{
					if($sort_packing_value = $product->getData($sort_packing_attribute)){}
					elseif($sort_packing_value = $product->getAttributeText($sort_packing_attribute)){}
					elseif($sort_packing_value = $product[$sort_packing_attribute]){}
				}
				
				if($sort_packing_value == '')
				{
					$sort_packing_value = Mage::getResourceModel('catalog/product')->getAttributeRawValue($product_id, $sort_packing_attribute, $store_id);
				}
				
				if(is_array($sort_packing_value)) 
				{
					$sort_packing_value = implode(',',$sort_packing_value);
					$sort_packing_value = preg_replace('~^,~','',$sort_packing_value);
				}
				$sort_packing_value = trim($sort_packing_value);
				$sku_master[$sku]['sort'] = $sort_packing_value;
				unset($sort_packing_value);
				

				// if($sort_packing_value == '')
				// 			{
				// 				if($product->getAttributeText($sort_packing_attribute))
				// 			   	{
				// 			        //$sort_packing_value = $product->setStoreId($store_id)->load($product_id)->getAttributeText($sort_packing_attribute);
				// 			        $sort_packing_value = $product->getAttributeText($sort_packing_attribute);
				// 			    }
				// 			    elseif($product[$sort_packing_attribute]) $sort_packing_value = $product[$sort_packing_attribute];
				// 			}
			

			   //if($product)//($product->setStoreId($store_id)->load($product_id))
			   //{
			     //  $_newProduct = $product->setStoreId($store_id)->load($product_id);  
			       // if($_newProduct->getData($sort_packing_attribute)) $sort_packing_value = $_newProduct->getData($sort_packing_attribute);
			   //}
			   // elseif($product->getData($sort_packing_attribute))
			   //                 {
			   //                          $sort_packing_value = $product->getData($sort_packing_attribute);
			   //                 }

			   //if($product->setStoreId($store_id)->load($product_id)->getAttributeText($sort_packing_attribute))

			
			}
			//elseif($sort_packing == 'sku') $sku_master[$sku]['sort'] = $sku;
			
			if($shelving_yn == 1)
			{ 
				$shelving_var = '';

				if(is_object($product))
				{
					if($shelving_var = $product->getData($shelving_attribute)){}
					elseif($shelving_var = $product->getAttributeText($shelving_attribute)){}
					elseif($shelving_var = $product[$shelving_attribute]){}
				}

				if($shelving_var == '')
				{
					$shelving_var = Mage::getResourceModel('catalog/product')->getAttributeRawValue($product_id, $shelving_attribute, $store_id);
				}

				if(is_array($shelving_var)) 
				{
					$shelving_var = implode(',',$shelving_var);
					$shelving_var = preg_replace('~^,~','',$shelving_var);
				}
				$shelving_var = trim($shelving_var);
				$sku_master[$sku]['shelving'] = $shelving_var;
				$sku_shelving[$sku] = $shelving_var;
				unset($shelving_var);
				
			   // //if($product->setStoreId($store_id)->load($product_id))
			   // 			  // if($product)
			   // 			  // {
			   // 			   //    $product = $product->setStoreId($store_id)->load($product_id);  
			   // 			       if($product->getData($shelving_attribute)) $shelving = $product->getData($shelving_attribute);
			   // 			   //}
			   // 			   elseif($product->getData($shelving_attribute))
			   // 			   {
			   // 			            $shelving = $product->getData($shelving_attribute);
			   // 			   }
			   //if($product->setStoreId($store_id)->load($product_id)->getAttributeText($shelving_attribute))
			   // if($product->getAttributeText($shelving_attribute))
			   // 			   {
			   // 			       //$shelving = $product->setStoreId($store_id)->load($product_id)->getAttributeText($shelving_attribute);
			   // 			       $shelving = $product->getAttributeText($shelving_attribute);
			   // 			   }
			   // 			   elseif($product[$shelving_attribute]) $shelving = $product[$shelving_attribute];
			   // 
			   // 			   if(is_array($shelving)) 
			   // 			   {
			   // 			       $shelving = implode(',',$shelving);
			   // 			       $shelving = preg_replace('~^,~','',$shelving);
			   // 			   }
			   // 
			   // 			   $shelving = trim($shelving);
			   // 
			   // 			   if($shelving != '')
			   // 			   {
			   // 			       if(isset($sku_shelving[$sku]) && strtoupper($sku_shelving[$sku]) != strtoupper($shelving)) $sku_shelving[$sku] .= ','.$shelving;
			   // 			       else $sku_shelving[$sku] = $shelving;
			   // 			       $sku_shelving[$sku] = preg_replace('~,$~','',$sku_shelving[$sku]);
			   // 			       unset($shelving);
			   // 			   }
			}    
 
			if($extra_yn == 1)
			{ 
			
				$extra_var = '';

				if(is_object($product))
				{
					if($extra_var = $product->getData($extra_attribute)){}
					elseif($extra_var = $product->getAttributeText($extra_attribute)){}
					elseif($extra_var = $product[$extra_attribute]){}
				}

				if($extra_var == '')
				{
					$extra_var = Mage::getResourceModel('catalog/product')->getAttributeRawValue($product_id, $extra_attribute, $store_id);
				}

				if(is_array($extra_var)) 
				{
					$extra_var = implode(',',$extra_var);
					$extra_var = preg_replace('~^,~','',$extra_var);
				}
				$extra_var = trim($extra_var);
				$sku_master[$sku]['extra'] = $extra_var;
				$sku_extra[$sku] = $extra_var;
				unset($extra_var);
				
				
					// 	   //if($product->setStoreId($store_id)->load($product_id))
					//    //{
					//     //   $product = $product->setStoreId($store_id)->load($product_id);  
					//        if($product->getData($extra_attribute)) $extra = $product->getData($extra_attribute);
					//    //}
					//    elseif($product->getData($extra_attribute))
					//    {
					//             $extra = $product->getData($extra_attribute);
					//    }
					// 
					//    //if($product->setStoreId($store_id)->load($product_id)->getAttributeText($extra_attribute))
					//    if($product->getAttributeText($extra_attribute))
					//    {
					//        //$extra = $product->setStoreId($store_id)->load($product_id)->getAttributeText($extra_attribute);
					//        $extra = $product->getAttributeText($extra_attribute);
					//    }
					//    elseif($product[$extra_attribute]) $extra = $product[$extra_attribute];
					// 
					//    if(isset($extra) && is_array($extra)) 
					//    {
					//        $extra = implode(',',$extra);
					//        $extra = preg_replace('~^,~','',$extra);
					//    }
					// elseif(!isset($extra)) 
					// {
					// $extra = '';
					// }
					// 
					//    $extra = trim($extra);
					// 
					//    if($extra != '')
					//    {
					//        if(isset($sku_extra[$sku]) && strtoupper($sku_extra[$sku]) != strtoupper($extra)) $sku_extra[$sku] .= ','.$extra;
					//        else $sku_extra[$sku] = $extra;
					//        $sku_extra[$sku] = preg_replace('~,$~','',$sku_extra[$sku]);
					//        unset($extra);
					//    }
			}

		if($extra3_yn == 1)
			{ 
			
				$extra3_var = '';

				if(is_object($product))
				{
					if($extra3_var = $product->getData($extra3_attribute)){}
					elseif($extra3_var = $product->getAttributeText($extra3_attribute)){}
					elseif($extra3_var = $product[$extra3_attribute]){}
				}

				if($extra3_var == '')
				{
					$extra3_var = Mage::getResourceModel('catalog/product')->getAttributeRawValue($product_id, $extra3_attribute, $store_id);
				}

				if(is_array($extra3_var)) 
				{
					$extra3_var = implode(',',$extra3_var);
					$extra3_var = preg_replace('~^,~','',$extra3_var);
				}
				$extra3_var = trim($extra3_var);
				$sku_master[$sku]['extra3'] = $extra3_var;
				$sku_extra3[$sku] = $extra3_var;
				unset($extra3_var);
			
			   // //if($product->setStoreId($store_id)->load($product_id))
			   // 			   //{
			   // 			    //   $product = $product->setStoreId($store_id)->load($product_id);  
			   // 			       if($product->getData($extra3_attribute)) $extra3 = $product->getData($extra3_attribute);
			   // 			   //}
			   // 			   elseif($product->getData($extra3_attribute))
			   // 			   {
			   // 			            $extra3 = $product->getData($extra3_attribute);
			   // 			   }
			   // 			   //if($product->setStoreId($store_id)->load($product_id)->getAttributeText($extra3_attribute))
			   // 			   if($product->getAttributeText($extra3_attribute))
			   // 			   {
			   // 			       //$extra3 = $product->setStoreId($store_id)->load($product_id)->getAttributeText($extra3_attribute);
			   // 			       $extra3 = $product->getAttributeText($extra3_attribute);
			   // 			   }
			   // 			   elseif($product[$extra3_attribute]) $extra3 = $product[$extra3_attribute];
			   // 
			   // 			   if(is_array($extra3)) 
			   // 			   {
			   // 			       $extra3 = implode(',',$extra3);
			   // 			       $extra3 = preg_replace('~^,~','',$extra3);
			   // 			   }
			   // 
			   // 			   $extra3 = trim($extra3);
			   // 
			   // 			   if($extra3 != '')
			   // 			   {
			   // 			       if(isset($sku_extra3[$sku]) && strtoupper($sku_extra3[$sku]) != strtoupper($extra3)) $sku_extra3[$sku] .= ','.$extra3;
			   // 			       else $sku_extra3[$sku] = $extra3;
			   // 			       $sku_extra3[$sku] = preg_replace('~,$~','',$sku_extra3[$sku]);
			   // 			       unset($extra3);
			   // 			   }
			}

			if($split_supplier_yn != 'no')
			{
				$supplier_var = '';

				if(is_object($product))
				{
					if($supplier_var = $product->getData($supplier_attribute)){}
					elseif($supplier_var = $product->getAttributeText($supplier_attribute)){}
					elseif($supplier_var = $product[$supplier_attribute]){}
				}

				if($supplier_var == '')
				{
					$supplier_var = Mage::getResourceModel('catalog/product')->getAttributeRawValue($product_id, $supplier_attribute, $store_id);
				}

				if(is_array($supplier_var)) 
				{
					$supplier_var = implode(',',$supplier_var);
					$supplier_var = preg_replace('~^,~','',$supplier_var);
				}
				$supplier = trim($supplier_var);
			
				
			   // //if($product->setStoreId($store_id)->load($product_id))
			   // 			   //{
			   // 			    //       $product = $product->setStoreId($store_id)->load($product_id);  
			   // 			       if($product->getData($supplier_attribute)) $supplier = $product->getData($supplier_attribute);
			   // 			   //}
			   // 			   elseif($product->getData($supplier_attribute))
			   // 			   {
			   // 			            $supplier = $product->getData($supplier_attribute);
			   // 			   }
			   // 
			   // 			   //if($product->setStoreId($store_id)->load($product_id)->getAttributeText($supplier_attribute))
			   // 			   if($product->getAttributeText($supplier_attribute))
			   // 			   {
			   // 			      // $supplier = $product->setStoreId($store_id)->load($product_id)->getAttributeText($supplier_attribute);
			   // 			       $supplier = $product->getAttributeText($supplier_attribute);
			   // 			   }
			   // 			   elseif($product[$supplier_attribute]) $supplier = $product[$supplier_attribute];
			   // 
			   // 			   if(is_array($supplier)) 
			   // 			   {
			   // 			       $supplier = implode(',',$supplier);
			   // 			       $supplier = preg_replace('~^,~','',$supplier);
			   // 			   }    

			   if(!$supplier) $supplier = '~Not Set~';    

			   $supplier = strtoupper($supplier);

				$sku_master[$sku]['supplier'] = $supplier;
				$sku_supplier[$sku] = $supplier;
				unset($supplier_var);
				
			   if(isset($sku_supplier[$sku]) && $sku_supplier[$sku] != $supplier) $sku_supplier[$sku] .= ','.$supplier;
			   else $sku_supplier[$sku] = $supplier;
			   $sku_supplier[$sku] = preg_replace('~,$~','',$sku_supplier[$sku]);

			   if(!isset($supplier_master[$supplier])) $supplier_master[$supplier] = $supplier;

			   if(isset($order_id))
			   {
			       if(!isset($order_id_master[$order_id])) $order_id_master[$order_id] = $supplier;
			       else $order_id_master[$order_id] .= ','.$supplier;
			   }
				
				unset($supplier);
			}
        
            // qty in this order of this sku
            $sqty = 0;
            if($from_shipment == 'shipment')
            {
                $qty = (int) $item->getOrderItem()->getQtyShipped();
                $sqty = $item->getIsQtyDecimal() ? $item->getQty() : (int) $item->getQty();//$item->getQty();
                
                $qty_shipped_now = (int) $item->getQty();
                $qty_shipped_total = (int) $item->getOrderItem()->getQtyShipped();
                $qty_ordered = (int) $order_items[($coun-1)]['qty_ordered'];
                
                $count = ($count + $qty_shipped_now);
                $count_all = ($count_all + $qty_shipped_total);
                $tqty = $qty_shipped_total;
                $sqty = $qty_shipped_now;
                $qty = $qty_ordered;
            }
            else
            {
                $qty = $item->getIsQtyDecimal() ? $item->getQtyOrdered() : (int) $item->getQtyOrdered();
            }
            
    		if(!isset($order_id)) $order_id = $order->getRealOrderId();
           $sku_qty_orderid[$sku][$order_id] = $qty;

            // total qty in all orders for this sku
            if(isset($sku_qty[$sku])){
              $sku_qty[$sku] = ($sku_qty[$sku]+$qty);
              $sku_sqty[$sku] = ($sku_sqty[$sku]+$sqty);
              if(isset($tqty)) $sku_tqty[$sku] = ($sku_tqty[$sku]+$tqty);
                else $sku_tqty[$sku] = 0;
              $sku_sku[$sku] = $product_sku;
            }else{
             $sku_qty[$sku] = $qty;
             $sku_sqty[$sku] = $sqty;
             if(isset($tqty)) $sku_tqty[$sku] = $tqty;
                else $sku_tqty[$sku] = 0;
             $sku_sku[$sku] = $product_sku;
            } 
            
            
            
            if(!isset($max_qty_length)) $max_qty_length = 2;
            if(strlen($sku_qty[$sku]) > $max_qty_length) $max_qty_length = strlen($sku_qty[$sku]);
            if(strlen($sku_sqty[$sku]) > $max_qty_length) $max_qty_length = strlen($sku_sqty[$sku]);
            
            $options = $item->getProductOptions();
          
            if(isset($options['options']) && is_array($options['options']))
            {
                $j = 0;
                $continue = 0;
                if(isset($options['options'][$j])) $continue = 1;
                
                while($continue == 1)
                {
                    if(!isset($sku_order_id_options[$sku])) $sku_order_id_options[$sku] = '';
                    if($j > 0) $sku_order_id_options[$sku] .= ' ';
                    if($options_yn == 'inline' || $options_yn == 'newline') $sku_order_id_options[$sku] .= htmlspecialchars_decode('[ '.$options['options'][$j]['label'].' : '.$options['options'][$j]['value'].' ]');
                    
                    if($options_yn == 'newsku' || $options_yn == 'newskuparent') $options_name_temp[] = str_replace('[[','[',htmlspecialchars_decode('[ '.$options['options'][$j]['label'].' : '.$options['options'][$j]['value'].' ]'));
                    
                    $sku_order_id_options[$sku] = str_replace('[[','[',$sku_order_id_options[$sku]);
                     
                    $j ++;
                    $continue = 0;
                    if(isset($options['options'][$j])) $continue = 1;
                }

                if($options_yn == 'newsku' || $options_yn == 'newskuparent')
                {
                    $full_sku     = trim($item->getSku());    
                    $parent_sku = preg_replace('~\-(.*)$~','',$full_sku);
                    $full_sku     = preg_replace('~^'.$parent_sku.'\-~','',$full_sku);
                        
                    $options_sku_array = explode('-',$full_sku);

                    $opt_count = 0;
                    foreach ($options_sku_array as $k => $options_sku_single)
                    {                
                        if(isset($options_sku[$options_sku_single]) && (!in_array($options_sku_single,$pickpack_options_filter_array)))
                        {
                            $options_sku[$options_sku_single] = ($sku_qty[$sku] + $options_sku[$options_sku_single]);
                            $options_sku_parent[$sku][$options_sku_single] = ($qty + $options_sku_parent[$sku][$options_sku_single]);
                            if($options_name_temp[$opt_count]) $sku_name[$options_sku_single] =  $options_name_temp[$opt_count];
                        }
                        elseif(!in_array($options_sku_single,$pickpack_options_filter_array))
                        {
                            $options_sku[$options_sku_single] = ($sku_qty[$sku]);
                            $options_sku_parent[$sku][$options_sku_single] = $qty;//($sku_qty[$sku]);
                            if($options_name_temp[$opt_count]) $sku_name[$options_sku_single] =  $options_name_temp[$opt_count];
                        }
                        $opt_count ++;
                    }        
                    unset($options_name_temp);    
                }
            }

            $sku_cost[$sku]     = (is_object($product)?$product->getCost():0);
            $sku_master[$sku]['sku']     = $sku;      

            if(is_object($product) && isset($configurable_names) && ($configurable_names == 'simple'))
            {
                $_newProduct = $product->setStoreId($store_id)->load($product_id);  
                if($_newProduct->getData('name')) $sku_name[$sku] = $_newProduct->getData('name');
            }
            elseif(isset($configurable_names) && $configurable_names == 'configurable') 
			{
				$sku_name[$sku] = $item->getName();				
			}
            elseif(isset($configurable_names) && $configurable_names == 'custom' && $configurable_names_attribute != '')
            {
                $customname = '';
                
                if($product->setStoreId($store_id)->load($product_id))
                {
                    $_newProduct = $product->setStoreId($store_id)->load($product_id);  
                    if($_newProduct->getData($configurable_names_attribute)) $customname = $_newProduct->getData(''.$configurable_names_attribute.'');
                }
                elseif($product->getData(''.$configurable_names_attribute.''))
                {
                    $customname = $product->getData($configurable_names_attribute);
                }
                else $customname = '';

                if(trim($customname) != '')
                {
                    if($product->setStoreId($store_id)->load($product_id)->getAttributeText($configurable_names_attribute))
                    {
                        $customname = $product->setStoreId($store_id)->load($product_id)->getAttributeText($configurable_names_attribute);
                    }
                    elseif($product[$configurable_names_attribute]) $customname = $product[$configurable_names_attribute];
                    else $customname = '';
                }

                if(trim($customname) != '')
                {
                    if(is_array($customname)) $customname = implode(',',$customname);
                    $customname = preg_replace('~,$~','',$customname);
                }
                else $customname = '';
                
                 $sku_name[$sku] = $customname;
            }

            $sku_type[$sku] = 'normal';

            // bundle SKUs
            //$options = $item->getProductOptions();
            if(isset($options['bundle_options']) && is_array($options['bundle_options']))
            {
                $children = $item->getChildrenItems();
                if(count($children) > 0)
                {
                    foreach($children as $child)
                    {
						$child_product_id = $child->getProductId();
						
                      //$child_product = $product->setStoreId($store_id)->load($child->getProductId());
                        $sku_b = $child->getSku();
                        $price_b = $child->getPriceInclTax();
                        $qty_b = (int)$child->getQtyOrdered();
                        $name_b = $child->getName();

                        $this->y -= 10;
                        $offset = 20;

                        $shelving_real = '';
                        $shelving_real_b = '';
                        if(isset($shelving_real_yn) && $shelving_real_yn == 1)
                        {
							$shelving_real_b = Mage::getResourceModel('catalog/product')->getAttributeRawValue($child_product_id, $shelving_real_attribute, $store_id);
/*
							if($child_product->getData($shelving_real_attribute))
							{
							    $shelving_real_b = $child_product->getData($shelving_real_attribute);
							}
							elseif($child_product->setStoreId($store_id)->load($child->getProductId())->getAttributeText($shelving_real_attribute))
							{
							    $shelving_real_b = $child_product->setStoreId($store_id)->load($child->getProductId())->getAttributeText($shelving_real_attribute);
							}
							elseif($child_product[$shelving_real_attribute]) $shelving_real_b = $child_product[$shelving_real_attribute];
							else $shelving_real_b = '';*/
                            
                            if(is_array($shelving_real)) $shelving_real_b = implode(',',$shelving_real_b);
                            if(isset($shelving_real_b)) $shelving_real_b = trim($shelving_real_b);
                        }

						if($sort_packing_attribute != null)
						{
						   $sort_packing_value = '';

							// if(is_object($product))
							// 						{
							// 							if($sort_packing_value = $product->getData($sort_packing_attribute)){}
							// 							elseif($sort_packing_value = $product->getAttributeText($sort_packing_attribute)){}
							// 							elseif($sort_packing_value = $product[$sort_packing_attribute]){}
							// 						}
						
							if($sort_packing_value == '')
							{
								$sort_packing_value = Mage::getResourceModel('catalog/product')->getAttributeRawValue($child_product_id, $sort_packing_attribute, $store_id);
							}

							if(is_array($sort_packing_value)) 
							{
								$sort_packing_value = implode(',',$sort_packing_value);
								$sort_packing_value = preg_replace('~^,~','',$sort_packing_value);
							}
							$sort_packing_value = trim($sort_packing_value);
							//$sku_master[$sku]['sort'] = $sort_packing_value;
							// unset($sort_packing_value);
						}

                        if($from_shipment == 'shipment')
                        {
                            $qty_string_b = 's:'.(int)$item->getQtyShipped() . ' / o:'.$qty;
                            $price_qty_b = (int)$item->getQtyShipped();
                            $productXInc = 25;
                        }
                        else
                        {
                            $qty_string_b = $qty_b;
                            $price_qty_b = $qty_b;
                            $productXInc = 0;
                        }
                        
                        $display_name_b = '';
                        if(strlen($name_b) > ($character_breakpoint_name+2))
                        {
                            $display_name_b = substr(htmlspecialchars_decode($name_b), 0, ($character_breakpoint_name)).'…';
                        }
                        else $display_name_b = htmlspecialchars_decode($name_b);

                        $sku_cost[$sku_b] = (is_object($child_product)?$child_product->getCost():0);
                        $sku_master['sku'][$sku_b] = $sku_b;
                        $sku_name[$sku_b] = $name_b;
                        if($sku_qty[$sku_b] > 0) $sku_qty[$sku_b] = ($sku_qty[$sku_b] + $qty_b);
                        else $sku_qty[$sku_b] = $qty_b;
                        if($sku_sqty[$sku_b] > 0) $sku_sqty[$sku_b] = ($sku_sqty[$sku_b] + $price_qty_b);
                        else $sku_sqty[$sku_b] = $price_qty_b;
                         $sku_sku[$sku_b] = $sku_b;
                        $sku_type[$sku] = 'bundle';

						/**
						Bundled Trolley	
						*/
						if($output == 'trolleybox')
						{
							$trolleybox_this_order_id = $order->getRealOrderId();

							if(!isset($trolleybox_item_id)) $trolleybox_item_id = 0;
							else $trolleybox_item_id ++;

							if(!isset($trolleybox_order_id[$trolleybox_this_order_id])) 
							{
								$trolleybox_order_id[$trolleybox_this_order_id] = true;

								if(!isset($trolleybox_trolley_id)) $trolleybox_trolley_id = 1;

								if(!isset($trolleybox_box_id))
								{
									$trolleybox_box_id = 1;
								}	
								else
								{
									$trolleybox_box_id ++;
									if($trolleybox_box_id > $trolleybox_max)
									{
										$trolleybox_trolley_id ++;
										$trolleybox_box_id = 1;
									}
								}
							}	

							$flat_item_list[$trolleybox_item_id]['sku'] 				= $sku_b;
							$flat_item_list[$trolleybox_item_id]['name'] 				= $name_b;
							$flat_item_list[$trolleybox_item_id]['order_id'] 			= $trolleybox_this_order_id;
							$flat_item_list[$trolleybox_item_id]['trolleybox_box_id'] 	= $trolleybox_box_id;
							$flat_item_list[$trolleybox_item_id]['trolleybox_trolley_id'] = $trolleybox_trolley_id;
							$flat_item_list[$trolleybox_item_id]['sort'] 				= $sort_packing_value;
							$flat_item_list[$trolleybox_item_id]['product_type'] 		= 'bundle-child';
							if($sku_qty[$sku] > 1)
							{
								$trolleybox_qty_cycle = 1;
								while($trolleybox_qty_cycle < $qty_b)
								{
									$trolleybox_item_id ++;
									$trolleybox_qty_cycle ++;
										$flat_item_list[$trolleybox_item_id]['sku'] 				= $sku_b;
										$flat_item_list[$trolleybox_item_id]['name'] 				= $name_b;
										$flat_item_list[$trolleybox_item_id]['order_id'] 			= $trolleybox_this_order_id;
										$flat_item_list[$trolleybox_item_id]['trolleybox_box_id'] 	= $trolleybox_box_id;
										$flat_item_list[$trolleybox_item_id]['trolleybox_trolley_id'] = $trolleybox_trolley_id;
										$flat_item_list[$trolleybox_item_id]['sort'] 				= $sort_packing_value;
										$flat_item_list[$trolleybox_item_id]['product_type'] 		= 'bundle-child';
								}
								//$sku_qty[$sku] = 0;
							}
							$qty_b = 0;
							unset($sort_packing_value);
						}
						/**
						END bundled trolley	
						*/
                    }
                }
            }
		
            if($output == 'trolleybox')
    		{
    			$trolleybox_this_order_id = $order->getRealOrderId();
    			
    			
    			if(!isset($trolleybox_item_id)) $trolleybox_item_id = 0;
    			else $trolleybox_item_id ++;
    			
    			
    			if(!isset($trolleybox_order_id[$trolleybox_this_order_id])) 
    			{
	    			$trolleybox_order_id[$trolleybox_this_order_id] = true;
					
					if(!isset($trolleybox_trolley_id)) $trolleybox_trolley_id = 1;
	    			
    				if(!isset($trolleybox_box_id))
					{
						$trolleybox_box_id = 1;
					}	
   					else
   					{
   						$trolleybox_box_id ++;
   						if($trolleybox_box_id > $trolleybox_max)
						{
							$trolleybox_trolley_id ++;
							$trolleybox_box_id = 1;
						}
   					}
    			}	
    			
				$flat_item_list[$trolleybox_item_id]['sku'] 				= $sku;
				$flat_item_list[$trolleybox_item_id]['name'] 				= $sku_name[$sku];
				$flat_item_list[$trolleybox_item_id]['order_id'] 			= $trolleybox_this_order_id;
				$flat_item_list[$trolleybox_item_id]['trolleybox_box_id'] 	= $trolleybox_box_id;
				$flat_item_list[$trolleybox_item_id]['trolleybox_trolley_id'] = $trolleybox_trolley_id;
				$flat_item_list[$trolleybox_item_id]['sort'] 				= $sku_master[$sku]['sort'];
				$flat_item_list[$trolleybox_item_id]['product_type'] 		= $sku_type[$sku];
				
				if($sku_qty[$sku] > 1)
				{
					$flat_qty_cycle = 1;
					while($flat_qty_cycle < $sku_qty_orderid[$sku][$order_id])
					{
						$trolleybox_item_id ++;
						$flat_qty_cycle ++;
							$flat_item_list[$trolleybox_item_id]['sku'] 				= $sku;
							$flat_item_list[$trolleybox_item_id]['name'] 				= $sku_name[$sku];
							$flat_item_list[$trolleybox_item_id]['order_id'] 			= $trolleybox_this_order_id;
							$flat_item_list[$trolleybox_item_id]['trolleybox_box_id'] 	= $trolleybox_box_id;
							$flat_item_list[$trolleybox_item_id]['trolleybox_trolley_id'] = $trolleybox_trolley_id;
							$flat_item_list[$trolleybox_item_id]['sort'] 				= $sku_master[$sku]['sort'];
							$flat_item_list[$trolleybox_item_id]['product_type'] 		= $sku_type[$sku];
					}
					$sku_qty[$sku] = 0;
				}
			} 
            
            $coun ++;
        }
        $i ++;
    }

    if($options_yn == 'newsku')
    {
        foreach($options_sku as $sku_option_key => $sku_option_value)
        {
            $sku_master['sku'][$sku_option_key] = $sku_option_key;
            $qty = $sku_option_value;
            $sqty = $sku_option_value;

                if(isset($sku_qty[$sku_option_key]))
                {
                    $sku_qty[$sku_option_key] = ($sku_qty[$sku_option_key]+$qty);
                    $sku_sqty[$sku_option_key] = ($sku_sqty[$sku_option_key]+$sqty);
                    if(isset($tqty)) $sku_tqty[$sku_option_key] = ($sku_tqty[$sku_option_key]+$tqty);
                    else $sku_tqty[$sku_option_key] = 0;
                    $sku_sku[$sku_option_key] = $sku_option_key;
                }
                else
                {
                    $sku_qty[$sku_option_key] = $qty;
                    $sku_sqty[$sku_option_key] = $sqty;
                    if(isset($tqty)) $sku_tqty[$sku_option_key] = $tqty;
                    else $sku_tqty[$sku_option_key] = 0;
                    $sku_sku[$sku_option_key] = $sku_option_key;
                }
        }
    }

    $sortorder_packing_bool = false;
    
    $supplier_previous         = '';
    $supplier_item_action     = '';
    $first_page_yn             = 'y';
    
	if($output == 'trolleybox')
    {
    	// setup sku_master to be flat_item_list
    	$sku_master = $flat_item_list;
    }
	//     echo '<br /><br />';
	//  print_r($flat_item_list);
	// exit;
    // sort items and loop
    if(($sort_packing != 'none') && ($output != 'trolleybox'))
    {
        if($sortorder_packing == 'ascending') $sortorder_packing_bool = true;
        sksort($sku_master,'sort',$sortorder_packing_bool);
    }
    elseif(($sort_packing != 'none') && ($output == 'trolleybox'))
    {
		// first sort = trolleybox_trolley_id
		// (ie list by trolleys, then list inside by trolleyboxes (which shoule be 'sort' key))
    	
  		// Obtain a list of columns
		foreach ($sku_master as $key => $row) 
		{
			$trolley_id[$key]  = $row['trolleybox_trolley_id'];
			$sort[$key] = $row['sort'];
		}
		
		if (version_compare(phpversion(), '5.4', '>='))
		{			
		// Add $data as the last parameter, to sort by the common key
			array_multisort($trolley_id, SORT_ASC, SORT_REGULAR, $sort, SORT_ASC, SORT_NATURAL, $sku_master); // php>5.4 can use SORT_NATURAL
		}
		else 
		{
			//usort( $sku_master, function( $el1, $el2) { return strnatcmp( $el1['sort'], $el2['sort']); });
			array_multisort($trolley_id, SORT_ASC, SORT_REGULAR, $sort, SORT_ASC, SORT_REGULAR, $sku_master);
		}
		
    }
        

    if($split_supplier_yn != 'no')
    {
        foreach($supplier_master as $key =>$supplier)
        {
            if( (isset($supplier_login) && ($supplier_login != '') && (strtoupper($supplier) == strtoupper($supplier_login) ) ) || !isset($supplier_login) || $supplier_login == '')
            {
                
                // new page
                $total_quantity = 0;    
                $total_cost = 0;    
            
                if($first_page_yn == 'n') $page = $this->newPage();
                else $first_page_yn = 'n';

                $this->y = ($page_top-43);
            
                if($picklogo == 1)
                {                    
                    $packlogo = Mage::getStoreConfig('pickpack_options/wonder/pack_logo', $order->getStore()->getId());
                    if($packlogo)
                    {
                        $packlogo = Mage::getStoreConfig('system/filesystem/media', $order->getStore()->getId()) . '/moogento/pickpack/logo_pack/' . $packlogo;
                        if (is_file($packlogo)) {    
                            $packlogo = Zend_Pdf_Image::imageWithPath($packlogo);            
                            $page->drawImage($packlogo, 27, 784, 296, 825);
                        }
                    }
                    $this->_setFont($page, $font_style_header, $font_size_header, $font_family_header, $non_standard_characters, $font_color_header);    
                    
                    $picklist_title = '';
                    
                    if($output == 'trolleybox') 
                    {
                    	$picklist_title .= Mage::helper('sales')->__('Trolleybox Pick List');
                    }
                    else
                    {
						if($from_shipment == 'shipment')
						{
							$picklist_title .= Mage::helper('sales')->__('Shipment-combined Pick List');
						}
						else
						{
							$picklist_title .= Mage::helper('sales')->__('Order-combined Pick List');    
						}
					}
                    $page->drawText($picklist_title, 325, 810, 'UTF-8');        
                    
                    $page->drawText(Mage::helper('sales')->__('Supplier').' : '.$supplier, 325, 790, 'UTF-8');
                    $page->setFillColor($font_color_header_zend);            
                    $page->setLineColor($font_color_header_zend);
                    $page->setLineWidth(0.5);            
                    $page->drawRectangle(304, 784, 316, 825);
                    // $this->y -= 10;
                    $page->drawRectangle(27, $this->y, $padded_right, ($this->y - 1));
                    $this->y -= 40;
                }
                else
                {
                       $this->_setFont($page, $font_style_header, ($font_size_header+2), $font_family_header, $non_standard_characters, $font_color_header);
                    
                    if($output == 'trolleybox') 
                    {
                    	$picklist_title .= Mage::helper('sales')->__('Trolleybox Pick List');
                    }
                    else
                    {
						if($from_shipment == 'shipment')
						{
							$page->drawText(Mage::helper('sales')->__('Shipment-combined Pick List, Supplier').' : '.$supplier, 31, 810, 'UTF-8');
						}
						else
						{
							$page->drawText(Mage::helper('sales')->__('Order-combined Pick List, Supplier').' : '.$supplier, 31, 810, 'UTF-8');
						}
					}
                    $page->setLineColor($font_color_header_zend);
                    $page->setFillColor($font_color_header_zend);
                    $page->drawRectangle(27, 803, $padded_right, 804);
                }

                $processed_skus = array();
                // roll_SKU
                $page_count = 1;
                $grey_next_line = 0;
				$trolleybox_current_trolley_id = 1;
   
                foreach($sku_master as $key =>$sku)
                {                
					if(($show_bundle_parent_yn == 0) && ($sku_master[$key]['product_type'] == 'bundle')) continue;
					 
                	if(($this->y<60) || (($output == 'trolleybox') && ($sku_master[$key]['trolleybox_trolley_id'] != $trolleybox_current_trolley_id)))
                    {
                    	$trolleybox_current_trolley_id = $sku_master[$key]['trolleybox_trolley_id'];
						if($page_count == 1)
						{
							$this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
							$page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y - 15), 'UTF-8');
						}
						$page = $this->newPage();
						$page_count ++;
						$this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
						$page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y + 15), 'UTF-8');
					}
                           
                    if(!in_array($sku,$processed_skus) || ($trolleybox_yn == 1))
                    {
                        $processed_skus[] = $sku;
        
                        $supplier_item_action = 'keep';
                    
                        // if set to filter and a name and this is the name, then print
                        if($supplier_options == 'filter' && isset($supplier_login) && (strtoupper($sku_supplier[$sku]) == strtoupper($supplier_login)) )//grey //split
                        {
                            $supplier_item_action = 'keep';
                        }
                        elseif($supplier_options == 'filter' && isset($supplier_login) && ($supplier_login != '') && (strtoupper($sku_supplier[$sku]) != strtoupper($supplier_login)) )//grey //split
                        {
                            $supplier_item_action = 'hide';
                        }
                        elseif($supplier_options == 'grey' && isset($supplier_login) && (strtoupper($sku_supplier[$sku]) == strtoupper($supplier_login)) )//grey //split
                        {
                            $supplier_item_action = 'keep';
                        }
                        elseif($supplier_options == 'grey' && isset($supplier_login) && $supplier_login != '' && (strtoupper($sku_supplier[$sku]) != strtoupper($supplier_login)) )//grey //split
                        {
                            // grey/login and this product is not same supplier as login
                            $supplier_item_action = 'keepGrey';
                        }
                        elseif($supplier_options == 'grey' && ($supplier_login == '') && (strtoupper($sku_supplier[$sku]) != strtoupper($supplier) ) )
                        {
                            $supplier_item_action = 'keepGrey';
                        }
                        elseif($supplier_options == 'filter' && ($supplier_login == '') && (strtoupper($sku_supplier[$sku]) != strtoupper($supplier) ) )
                        {
                            $supplier_item_action = 'hide';
                        }
                        elseif($supplier_options == 'grey' && ($supplier_login == '') && (strtoupper($sku_supplier[$sku]) == strtoupper($supplier) ) )
                        {
                            $supplier_item_action = 'keep';
                        }
                        elseif($supplier_options == 'filter' && ($supplier_login == '') && (strtoupper($sku_supplier[$sku]) == strtoupper($supplier) ) )
                        {
                            $supplier_item_action = 'keep';
                        }
                        elseif($supplier_options == 'grey') $supplier_item_action = 'keepGrey';
                        elseif($supplier_options == 'filter') $supplier_item_action = 'hide';

						//if(($sku_type[$sku] == 'bundle') && ($show_bundle_parent_yn == 0)) $supplier_item_action = 'hide'; (don't need it)

                        if($supplier_item_action != 'hide' && $supplier_item_action != '')
                        {                        
                            if($grey_next_line == 1)
                            {
                                $page->setFillColor($alternate_row_color);            
                                $page->setLineColor($alternate_row_color);    
                                $page->drawRectangle(25, ($this->y-2), $padded_right, ($this->y+9));
                                $grey_next_line = 0;
                            }
                            else $grey_next_line = 1;
                            $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);

                            // $page->setFillColor($black_color);
                            if($supplier_item_action == 'keepGrey') 
                            {
                                $page->setFillColor($greyout_color);
                            }
                            else
                            {
                                $total_quantity = $total_quantity + $sku_qty[$sku] + $sku_qty_options[$sku];    
                                if($from_shipment == 'shipment')
                                {
                                    $total_cost = $total_cost + ($sku_qty[$sku] * $sku_cost[$sku]);    
                                }
                                else
                                {
                                    $total_cost = $total_cost + ($sku_sqty[$sku] * $sku_cost[$sku]);    
                                }
                            
                                if($tickbox != 'no')
                                {
                                    $page->setFillColor($white_color);            
                                    $page->setLineColor($black_color);    
                                    if($sku_type[$sku] != 'bundle') $page->drawRectangle(27, ($this->y), 34, ($this->y+7));
                                    else $page->drawCircle(27, ($this->y), 7);
                                    $page->setFillColor($font_color_body_zend);
                                }
                            }
        
                            $max_qty_length_display = 0;
                        
                            if($from_shipment == 'shipment'){
                                $max_qty_length_display = ((($max_qty_length+5)*($font_size_body*1.1)*1.35)-57);
                                $qty_string = 's:'.(int)$sku_sqty[$sku] . ' / ts:'.$sku_tqty[$sku]. ' / o:'.$sku_qty[$sku];
                            }else{
                                $qty_string = $sku_qty[$sku];
                                $max_qty_length_display = (($max_qty_length-1)*$font_size_body);
                            }

                            $sku_addon = '';
                            if($shelving_yn == 1 && $sku_shelving[$sku]) 
                            {
	//
                                if($shelvingpos == 'col')
                                {
                                    $page->drawText('['.$sku_shelving[$sku].']', $col_title_position_attr1[1], $this->y , 'UTF-8');
                                }
                                else
                                {
                                    $sku_addon = ' / ['.$sku_shelving[$sku].']';
                                }
                            }
                        
                        	$x_string = '';
                            if($qty_yn == 1) 
                            {
                            	$page->drawText($qty_string, $qtyX, $this->y , 'UTF-8');
                            	$x_string = ' x   ';
                            }
                            $page->drawText($x_string.$sku.$sku_addon, ($col_title_position_sku[1]+$max_qty_length_display), $this->y , 'UTF-8');
                            if($extra_yn == 1)    $page->drawText($sku_extra[$sku], $col_title_position_attr2[1], $this->y , 'UTF-8');
                            if($extra3_yn == 1)    $page->drawText($sku_extra3[$sku], $col_title_position_attr3[1], $this->y , 'UTF-8');
                            if($nameyn == 1)    $page->drawText($sku_name[$sku], intval($col_title_position_name[1]), $this->y , 'UTF-8');
                        
                            if(($stockcheck_yn == 1) && ($supplier_item_action != 'keepGrey') )
                            {
								if(Mage::getModel('cataloginventory/stock_item')->loadByProduct($product_id)->getQty()) 
								{
									$stock = round(Mage::getModel('cataloginventory/stock_item')->loadByProduct($product_id)->getQty());
								}
								$sku_stock[$sku] = $stock;
								if($sku_stock[$sku] < $stockcheck)
								{
                               	 	$this->_setFont($page, $font_style_body, ($font_size_body-2), $font_family_body, $non_standard_characters, $font_color_body);
                            
	                                $this->y -= 12;
	                                $page->setFillColor($red_bkg_color);            
	                                $page->setLineColor(new Zend_Pdf_Color_Rgb(1,1,1));    
	                                $page->drawRectangle(55, ($this->y-4), $padded_right, ($this->y+10));
	                                $page->setFillColor(new Zend_Pdf_Color_GrayScale(0));                
	                                $warning = Mage::helper('sales')->__('Stock Warning').'      '.Mage::helper('sales')->__('SKU').': '.$sku.'    '.Mage::helper('sales')->__('Net Stock After All Picks').' : '.$sku_stock[$sku];
	                                $page->drawText($warning, 60, $this->y , 'UTF-8');
	                                $this->y -= 4;
								}
                            }
                            $this->y -= ($font_size_body+2);
                        }
                    }
                }
            
                if($from_shipment == 'shipment')
                {
                    $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                    $this->y -= 30;
                    $page->drawText(Mage::helper('sales')->__('Shipments included').':', 30, $this->y , 'UTF-8');

                    foreach ($shipment_list as $k => $value)
                    {
                        $this->y -= $font_size_body;
                        $page->drawText('#'.$value.' ('.Mage::helper('sales')->__('order').' #'.$order_list[$k].' : '.$name_list[$k].')', 30, $this->y , 'UTF-8');
                    }
                }

                // end roll_SKU
                // $page->setFillColor(new Zend_Pdf_Color_Rgb(0,0,0));
                $this->y -= 30;
                // $this->_setFontItalic($page,12);
        
			


                if($showcount_yn == 1 || $showcost_yn == 1 || $order_count_yn == 1)
                {   
                    $shipYbox = 0;
                    if($from_shipment == 'shipment') $shipYbox += 10;
                    if($showcost_yn == 1) $shipYbox += 10;
                    if($order_count_yn == 1) $shipYbox += 10;

					if (($this->y - $shipYbox) < 60)
					{
						if($page_count == 1)
						{
							$this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
							$page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y - 15), 'UTF-8');
						}
						$page = $this->newPage();
						$page_count ++;
						$this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
						$page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y + 15), 'UTF-8');
					}
	                $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);

					$page->setFillColor($white_bkg_color);            
                    $page->setLineColor($orange_bkg_color);    
                    $page->setLineWidth(4); 
                    
                    $page->drawRectangle(355, ($this->y-34-$shipYbox), 568, ($this->y+10+$font_size_body));
                    $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                }
            
        
            
                if($showcount_yn == 1)
                {
                    if($from_shipment == 'shipment')
                    {
                        $page->drawText(Mage::helper('sales')->__('Total item quantity ordered').' : '.$total_quantity, 375, $this->y , 'UTF-8');
                        $this->y -= 20;
                        $page->drawText(Mage::helper('sales')->__('Total item quantity shipped this time').' : '.$count, 375, $this->y , 'UTF-8');
                    }
                    else
                    {
                        $page->drawText(Mage::helper('sales')->__('Total item quantity').' : '.$total_quantity, 375, $this->y , 'UTF-8');
                    }
                }
                
                if($order_count_yn == 1)
                {
                    $this->y -= 20;
                    // if($from_shipment == 'shipment') $page->drawText('Total cost these shipments : '.$currency_symbol."  ".$total_cost, 375, $this->y , 'UTF-8');
                    //else 
                    $page->drawText(Mage::helper('sales')->__('Total orders').' : '.$order_count, 375, $this->y , 'UTF-8');
                }
                
                if($showcost_yn == 1)
                {
                    $this->y -= 20;
                    if($from_shipment == 'shipment') $page->drawText(Mage::helper('sales')->__('Total cost these shipments').' : '.$currency_symbol."  ".$total_cost, 375, $this->y , 'UTF-8');
                    else $page->drawText(Mage::helper('sales')->__('Total cost').' : '.$currency_symbol."  ".$total_cost, 375, $this->y , 'UTF-8');
                }
                
                if($total_paid_subtotal_yn == 1)
                {
                    $this->y -= 20;
                    if($from_shipment == 'shipment') $page->drawText(Mage::helper('sales')->__('Total paid this shipment').' : '.$currency_symbol."  ".round($total_paid,2), 375, $this->y , 'UTF-8');
                    else $page->drawText(Mage::helper('sales')->__('Total paid').' : '.$currency_symbol."  ".round($total_paid,2), 375, $this->y , 'UTF-8');
                }
            
                if($shipping_subtotal_yn == 1)
                {
                    $this->y -= 20;
                    $page->drawText(Mage::helper('sales')->__('Total shipping paid (ex. tax)').' : '.$shipping_currency.$shipping_currency_symbol.' '.round($total_shipping_cost['shipping_ex_tax'],2), 375, $this->y , 'UTF-8');
                    $this->y -= 20;
                    $page->drawText(Mage::helper('sales')->__('Total shipping paid (inc. tax)').' : '.$shipping_currency.$shipping_currency_symbol.' '.round($total_shipping_cost['shipping_plus_tax'],2), 375, $this->y , 'UTF-8');
                }
            
                if($printdates == 1)
                {
                    $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-3), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                    $page->drawText(Mage::helper('sales')->__('Printed:').'   '.date('D jS M Y G:i', Mage::getModel('core/date')->timestamp(time())), 160, 18, 'UTF-8');
                }
            }
            unset($processed_skus);
        }
    }
    else
    {
            $this->y = ($page_top-43);//777;
            
            $total_quantity     = 0;
            $total_cost         = 0;    
            $sheet_has_bundles     = false;
    
    
            if($picklogo == 1)
            {                    
                $packlogo = Mage::getStoreConfig('pickpack_options/wonder/pack_logo', $order->getStore()->getId());
                if($packlogo)
                {
                    $packlogo = Mage::getStoreConfig('system/filesystem/media', $order->getStore()->getId()) . '/moogento/pickpack/logo_pack/' . $packlogo;
                    if (is_file($packlogo)) {    
                        $packlogo = Zend_Pdf_Image::imageWithPath($packlogo);            
                        $page->drawImage($packlogo, 27, ($page_top-36), 296, ($page_top+5));
                    }
                }
                $this->_setFont($page, $font_style_header, $font_size_header, $font_family_header, $non_standard_characters, $font_color_header);    
                if($output == 'trolleybox') 
				{
					$picklist_title .= Mage::helper('sales')->__('Trolleybox Pick List');
				}
				else
				{
					if($from_shipment == 'shipment')
					{
						$page->drawText(Mage::helper('sales')->__('Shipment-combined Pick List'), 325, ($page_top-10), 'UTF-8');        
					}
					else
					{
						$page->drawText(Mage::helper('sales')->__('Order-combined Pick List'), 325, ($page_top-10), 'UTF-8');        
					}
				}
                // $page->drawText(Mage::helper('sales')->__('Supplier : '.$supplier), 325, 790, 'UTF-8');
                $page->setFillColor($font_color_header_zend);            
                $page->setLineColor($font_color_header_zend);
                $page->setLineWidth(0.5);            
                $page->drawRectangle(304, ($page_top-36), 316, ($page_top+5));
                // $this->y -= 10;
                $page->drawRectangle(27, $this->y, $padded_right, ($this->y - 1));
                $this->y -= 40;
            }
            else
            {
                   $this->_setFont($page, $font_style_header, ($font_size_header+2), $font_family_header, $non_standard_characters, $font_color_header);
                
                $mage_timestamp = Mage::getModel('core/date')->timestamp(time());
                $date_format = preg_replace('~(.*): ~','',$date_format);
                $order_date = date($date_format,$mage_timestamp);                            

                $picklist_title = '';
                if($printdates == 'yestitle') $picklist_title = $order_date.' ';

                if($output == 'trolleybox') 
				{
					$picklist_title .= Mage::helper('sales')->__('Trolleybox Pick List');
				}
				else
				{
					if($from_shipment == 'shipment')
					{
						$picklist_title .= Mage::helper('sales')->__('Shipment-combined Pick List');
					}
					else
					{
						$picklist_title .= Mage::helper('sales')->__('Order-combined Pick List');    
					}
				}
                $page->drawText($picklist_title, 31, ($page_top-10), 'UTF-8');
                
                $page->setLineColor($font_color_header_zend);
                $page->setFillColor($font_color_header_zend);
                $page->drawRectangle(27, ($page_top-17), $padded_right, ($page_top-16));
            }


            // roll sku foreach
            // roll_SKU

            
            $max_qty_length_display = 0;

            if($from_shipment != 'shipment')
            {
                $max_qty_length_display = (($max_qty_length-2)*$font_size_body);
            }
            else
            {
                $max_qty_length_display = ((($max_qty_length+5)*($font_size_body*1.1)*1.4)-57);
            }
            
            // make sure values don't overlap qty and ' x '
            $skuXreal    = ($col_title_position_sku[1]+$max_qty_length_display);
            $xX = ($qtyX+10);
            if($skuXreal < ($xX + (2 * $font_size_body) + 5)) 
			{
				$skuXreal = ($xX + (2 * $font_size_body) + 5);
				$col_title_position_sku[1] = $skuXreal;
			}
            if($col_title_position_attr2[1] < ($xX + (2 * $font_size_body) + 5)) $col_title_position_attr2[1] = ($xX + (2 * $font_size_body) + 5);
            if($col_title_position_name[1] < ($xX + (2 * $font_size_body) + 5)) $col_title_position_name[1] = ($xX + (2 * $font_size_body) + 5);
            if($skuXreal > $col_title_position_attr2[1])
            {
                $maxWidthSku = ($padded_right - $skuXreal + 20);
                
                // $max_chars = 20;
                $font_temp = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
                $font_size_compare = ($font_size_body);
                $line_width = $this->parseString('1234567890',$font_temp,$font_size_compare); // bigger = left
                $char_width = $line_width/10;
                $max_chars = round($maxWidthSku/$char_width);
            }
                    
            $processed_skus = array();
            
            $page_count = 1;
            $grey_next_line = 0;
            $thisYnext = 0;
            $thisYorig = 0;
        

            $this->_setFont($page, 'bold', $font_size_body+2, $font_family_body, $non_standard_characters, $font_color_subtitles);

			if($qty_yn == 1) $page->drawText(Mage::helper('sales')->__($col_title_position_qty[0]), $col_title_position_qty[1], $this->y, 'UTF-8');
			
			if($nameyn == 1) 
			{
				$page->drawText(Mage::helper('sales')->__($col_title_position_name[0]), ($col_title_position_name[1]+$productXInc+$first_item_title_shift_items), $this->y, 'UTF-8');
			}
			
			if($product_images_yn == 1)
			{
				$page->drawText(Mage::helper('sales')->__($col_title_product_images[0]), ($col_title_product_images[1]), $this->y, 'UTF-8');
			}

			if($combined_sku_yn == 1)
			{
				$page->drawText(Mage::helper('sales')->__($col_title_position_sku[0]), ($col_title_position_sku[1]), $this->y, 'UTF-8');
			}

			if($shelving_yn == 1)
			{
				$page->drawText(Mage::helper('sales')->__($col_title_position_attr1[0]), ($col_title_position_attr1[1]), $this->y, 'UTF-8');
			}

			if($extra_yn == 1)
			{
				$page->drawText(Mage::helper('sales')->__($col_title_position_attr2[0]), ($col_title_position_attr2[1]), $this->y, 'UTF-8');
			}

			if($extra3_yn == 1)
			{
				$page->drawText(Mage::helper('sales')->__($col_title_position_attr3[0]), ($col_title_position_attr3[1]), $this->y, 'UTF-8');
			}

			if($stockcheck_yn == 1) 
			{
				$page->drawText(Mage::helper('sales')->__($col_title_position_stock[0]), $col_title_position_stock[1], $this->y, 'UTF-8');
			}
			
			if($trolleybox_yn == 1) 
			{
				$page->drawText(Mage::helper('sales')->__($col_title_position_trolleybox[0]), $col_title_position_trolleybox[1], $this->y, 'UTF-8');
			}

			$this->y -= ($font_size_subtitles*1.5);
            $sku_master_runcount 			= 0;   
            $trolleybox_current_trolley_id 	= 1;
       
           	foreach($sku_master as $key => $value)
            {
				if(($show_bundle_parent_yn == 0) && ($sku_master[$key]['product_type'] == 'bundle')) continue;
				
				if(($this->y<60) || (($output == 'trolleybox') && ($sku_master[$key]['trolleybox_trolley_id'] != $trolleybox_current_trolley_id)))
				{
					$trolleybox_current_trolley_id = $sku_master[$key]['trolleybox_trolley_id'];
					if($page_count == 1)
					{
						$this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
						$page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y - 15), 'UTF-8');
					}
					$page = $this->newPage();
					$page_count ++;
					$this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
					$page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y + 15), 'UTF-8');
				}
                    
				$sku_master_runcount ++;
				$sku = $value['sku'];    
               	$this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                
                //if(!in_array($sku,$processed_skus) && $sku != '')
                if((!in_array($sku,$processed_skus) || ($trolleybox_yn == 1)) && $sku != '')
                {
                    $processed_skus[] = $sku;

                    if(isset($sku_qty[$sku])) $total_quantity += $sku_qty[$sku];    
					else $sku_qty[$sku] = 0;
					if(!isset($sku_cost[$sku])) $sku_cost[$sku] = 0;
					
					//$total_quantity = $total_quantity + $sku_qty[$sku];    
                    if($from_shipment == 'shipment')
                    {
                        $total_cost = $total_cost + ($sku_cost[$sku]*$sku_sqty[$sku]);    
                    }
                    else
                    {
                        $total_cost = $total_cost + ($sku_cost[$sku]*$sku_qty[$sku]);    
                    }
                

                    
                    if($grey_next_line == 1)
                    {
                        $page->setFillColor($grey_bkg_color);            
                        $page->setLineColor($grey_bkg_color);   

						$grey_box_y1 = ($this->y-($font_size_body/5));
						$grey_box_y2 = ($this->y+($font_size_body*0.85));
						
 						if(($product_images_yn == 1) && isset($sku_image_paths[$sku]['path'][0]))
						{
								$grey_box_y1 = ($this->y - $sku_image_paths[$sku]['height']-$font_size_body-5-1.5);
								$grey_box_y2 = ($this->y - $font_size_body-5+1.5);
						}
						
						$page->drawRectangle(25, $grey_box_y1, $padded_right, $grey_box_y2);
                        $grey_next_line = 0;
                    }
                    else $grey_next_line = 1;
					
					/**
					images start	
					*/
			        if(($product_images_yn == 1) && isset($sku_image_paths[$sku]['path'][0]))
					{		
						$product_images_line_nudge 	= 0;
						$product_images_line_nudge = ($sku_image_paths[$sku]['height']/2);
						if($product_images_border_color_temp != '#FFFFFF')
                        {
							$product_images_line_nudge += 1.5;
						}
						
						if($sku_master_runcount == 1) $this->y += ($product_images_line_nudge);	
								
						$image_x_addon				= 0;
						$image_x_addon_2 			= 0;
						$x1        					= $col_title_product_images[1];
	                    $y1         				= ($this->y - $sku_image_paths[$sku]['height']-$font_size_body-5);
	                    $x2         				= ($col_title_product_images[1] + $sku_image_paths[$sku]['width']);
	                    $y2         				= ($this->y -$font_size_body-5);
						// $image_x_addon += ($count*($sku_image_path['width'] + 10)); // shift the 2nd image over
						// $image_x_addon_2 += (($count-1)*($sku_image_path['width'] + 10)); // shift the 2nd image over

						if(($this->y - $sku_image_paths[$sku]['height'] - 3) < (20+($font_size_subtitles*2)))
						{
							if($page_count == 1 && $return_address_yn == 0 && $bottom_shipping_address_yn == 0)
							{
								$this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
								$page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($font_size_subtitles * 2), 'UTF-8');
							}
							$page = $this->newPage();
							$page_count ++;
							$this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);

							if($second_page_start == 'asfirst') $this->y = $items_header_top_firstpage;
							else $this->y = $page_top;

							$page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y), 'UTF-8');
							$this->y = ($this->y - ($font_size_subtitles*2));

							if(strtoupper($background_color_subtitles) != '#FFFFFF')
							{
								$page->setFillColor($background_color_subtitles_zend);            
								$page->setLineColor($background_color_subtitles_zend);    
								$page->setLineWidth(0.5);
								if($fill_product_header_yn == 0)
								{
									$page->drawLine($padded_left, ($this->y-($font_size_subtitles/1.5)-1.5), ($padded_right), ($this->y-($font_size_subtitles/1.5)-1.5));
									$page->drawLine($padded_left, ($this->y+$font_size_subtitles+1.5+1.5), ($padded_right), ($this->y+$font_size_subtitles+1.5+1.5));
								}
								else
								{
									$page->drawRectangle($padded_left, ($this->y-($font_size_subtitles/1.5)), $padded_right, ($this->y+$font_size_subtitles+1.5));
								}
							}
							
							$this->_setFont($page, 'bold', $font_size_body+2, $font_family_body, $non_standard_characters, $font_color_subtitles);

							if($qty_yn == 1) $page->drawText(Mage::helper('sales')->__($col_title_position_qty[0]), $col_title_position_qty[1], $this->y, 'UTF-8');

							if($nameyn == 1) 
							{
								$page->drawText(Mage::helper('sales')->__($col_title_position_name[0]), ($col_title_position_name[1]+$productXInc+$first_item_title_shift_items), $this->y, 'UTF-8');
							}

							if($product_images_yn == 1)
							{
								$page->drawText(Mage::helper('sales')->__($col_title_product_images[0]), ($col_title_product_images[1]), $this->y, 'UTF-8');
							}

							if($combined_sku_yn == 1)
							{
								$page->drawText(Mage::helper('sales')->__($col_title_position_sku[0]), ($col_title_position_sku[1]), $this->y, 'UTF-8');
							}

							if($shelving_yn == 1)
							{
								$page->drawText(Mage::helper('sales')->__($col_title_position_attr1[0]), ($col_title_position_attr1[1]), $this->y, 'UTF-8');
							}

							if($extra_yn == 1)
							{
								$page->drawText(Mage::helper('sales')->__($col_title_position_attr2[0]), ($col_title_position_attr2[1]), $this->y, 'UTF-8');
							}

							if($extra3_yn == 1)
							{
								$page->drawText(Mage::helper('sales')->__($col_title_position_attr3[0]), ($col_title_position_attr3[1]), $this->y, 'UTF-8');
							}

							if($stockcheck_yn == 1) 
							{
								$page->drawText(Mage::helper('sales')->__($col_title_position_stock[0]), $col_title_position_stock[1], $this->y, 'UTF-8');
							}

							$this->y -= ($font_size_subtitles*1.5);
							$this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
							// reset y-pos so need to re-calculate image location
		                    $y1         = ($this->y - $sku_image_paths[$sku]['height'] -$font_size_body-5);
		                    $y2         = ($this->y -$font_size_body-5);
						}
						
						if($product_images_border_color_temp != '#FFFFFF')
                        {        
                            $page->setLineWidth(0.5);
                            $page->setFillColor($product_images_border_color);            
                            $page->setLineColor($product_images_border_color);    
                            $page->drawRectangle(($x1 - 1.5 + $image_x_addon_2), ($y1 - 1.5), ($x2 + 1.5 + $image_x_addon_2), ($y2 + 1.5));
                            $page->setFillColor($black_color);
                        }

						$image = Zend_Pdf_Image::imageWithPath($sku_image_paths[$sku]['path'][0]);
						$page->drawImage($image, $x1+$image_x_addon_2, $y1, $x2+$image_x_addon_2, $y2);
				
						$this->y -= (15+$sku_image_paths[$sku]['height']);
						if(!isset($product_build_value['bundle_options_sku']))
						{
							$this->y += ($product_images_line_nudge-($font_size_body/2));
						}
						$has_shown_product_image = 1;					
					}
					/**
					images end	
					*/

                    $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                    
                    if($tickbox != 'no')// && !in_array($sku,$pickpack_options_count_filter_array))
                    {
                        $page->setFillColor($white_color);            
                        $page->setLineColor($black_color);  
						$page->setLineWidth(1.5);
  
						$tickbox_y = $this->y;
                        if(isset($sku_type[$sku]) && ($sku_type[$sku] == 'bundle')) 
						{
						    $page->drawCircle(30.5, ($this->y+3.5), 3.5);
						    $sheet_has_bundles = true;
						}
						else
						{
							$page->drawRectangle(27, $tickbox_y, 34, ($tickbox_y+7));
						}
                        $page->setFillColor($font_color_body_zend);
                    }
                    	
                    				
                    if($from_shipment == 'shipment'){
                        $qty_string = 's:'.(int)$sku_sqty[$sku] . ' / ts:'.$sku_tqty[$sku]. ' / o:'.$sku_qty[$sku];
                    }else{
                        $qty_string = $sku_qty[$sku];
                    }                   
                                    
                    $name_addon = '';                
                    $sku_addon = '';
                    if($shelving_yn == 1)
                    {
						$show_this = '';
						if(($trolleybox_yn == 0) && isset($sku_shelving[$sku])) $show_this = $sku_shelving[$sku];
						elseif(($trolleybox_yn == 1) && isset($sku_master[$key]['sort'])) $show_this = $sku_master[$key]['sort'];
						
                        if($shelvingpos == 'col')
                        {
                            $page->drawText('['.$show_this.']', $col_title_position_attr1[1], $this->y , 'UTF-8');
                        }
                        else
                        {
                            if($combined_sku_yn == 1) $sku_addon = ' / ['.$show_this.']';
                            elseif($pickpack_name_yn_combined == 1) $name_addon = ' / ['.$show_this.']';
                        }
                    }
                  
                    if($trolleybox_yn == 1) 
					{
						$trolley_id_display = $sku_master[$key]['trolleybox_box_id'];
						if($show_orderid_with_trolleyboxid_yn == 1) $trolley_id_display .= ' ('.$sku_master[$key]['order_id'].')';
						$page->drawText($trolley_id_display, $col_title_position_trolleybox[1], $this->y, 'UTF-8');
					}
              
                    $display_sku = '';
                    if(isset($sku_sku[$sku])) $display_sku = htmlspecialchars_decode($sku_sku[$sku]);
					elseif($trolleybox_yn == 0) continue; // i.e. skip this one if no sku record
					
                    if(isset($sku_order_id_options[$sku]) && $sku_order_id_options[$sku] != '' && ($options_yn == 'inline'))
                    {
                        $display_sku .= ' '.$sku_order_id_options[$sku];
                    }
                
                    if(($qty_yn == 1) && ($output != 'trolleybox')) $page->drawText($qty_string, ($col_title_position_qty[1]+7), $this->y , 'UTF-8');
                    elseif(($qty_yn == 1) && ($output == 'trolleybox')) $page->drawText('1', ($col_title_position_qty[1]+7), $this->y , 'UTF-8');
                    
                    if($combined_sku_yn == 1)
                    {
                        $displaySkuReal = $display_sku.$sku_addon;
                    
                        // if sku and extra attribute switched pos
                        if(($extra_yn == 1) && $skuXreal > $col_title_position_attr2[1])
                        {
                            if(strlen($displaySkuReal) > $max_chars)
                            {
                                $chunks = str_split($displaySkuReal,$max_chars);
                            
                                $thisYorig = $this->y;
                                $lines = 0;
                                foreach($chunks as $key => $chunk)
                                {
                                    if($grey_next_line == 0 && $lines > 0)
                                    {
                                        $page->setFillColor($grey_bkg_color);            
                                        $page->setLineColor($grey_bkg_color);    
                                        $page->drawRectangle(25, ($this->y-($font_size_body/5)), $padded_right, ($this->y+($font_size_body*1.1)));
                                        $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                                        $page->drawText($chunk, ($skuXreal+8), $this->y , 'UTF-8');
                                    }
                                    else $page->drawText($chunk.'...', $skuXreal, $this->y , 'UTF-8');
                                    $this->y -= ($font_size_body+3);
                                    $lines ++;
                                }
                                $this->y = $thisYorig;
                            
                                unset($chunks);
                            }
                            else $page->drawText($displaySkuReal, $skuXreal, $this->y , 'UTF-8');
                        
                        }
                        else $page->drawText($displaySkuReal, $skuXreal, $this->y , 'UTF-8');
                    }

                    // extra attribute #2 (#3 inc shelf)
                    if($extra3_yn == 1) $page->drawText($sku_extra3[$sku], $col_title_position_attr3[1], $this->y , 'UTF-8');
                    // extra attribute #1 (#2 inc shelf)
                    if($extra_yn == 1)     $page->drawText($sku_extra[$sku], $col_title_position_attr2[1], $this->y , 'UTF-8');
                    
                    if($nameyn == 1)
                    {
                        if(isset($options_sku_parent) && is_array($options_sku_parent[$sku]))
                        {
                            $this->y -= ($font_size_body+3);
                            if($grey_next_line == 0)
                            {
                                $page->setFillColor($grey_bkg_color);            
                                $page->setLineColor($grey_bkg_color);    
                                $page->drawRectangle(25, ($this->y-($font_size_body/5)), $padded_right, ($this->y+($font_size_body*1.1)));
                                $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                            }
                            $page->drawText('( '.$sku_name[$sku].' )'.$name_addon, ($skuXreal+4), $this->y , 'UTF-8');
                        }
                        else $page->drawText($sku_name[$sku].$name_addon, $col_title_position_name[1], $this->y , 'UTF-8');
                    }
                    
                    $options_splits = array();
                    if($options_yn == 'newline') 
                    {
                        $options_splits = explode('[',$sku_order_id_options[$sku]);
                        $this->_setFont($page, $font_style_body, ($font_size_body-2), $font_family_body, $non_standard_characters, $font_color_body);
                        
                        foreach($options_splits as $key => $options_split)
                        {
                            $options_split = trim($options_split);
                            if($options_split != '') $page->drawText('[ '.$options_split, ($skuXreal+4), $this->y , 'UTF-8');
                            $this->y -= 12;
                        }
                        $this->_setFont($page, $font_style_body, ($font_size_body), $font_family_body, $non_standard_characters, $font_color_body);
                        
                    }
                    elseif($options_yn == 'newskuparent')
                    {
                        $this->_setFont($page, $font_style_body, ($font_size_body-2), $font_family_body, $non_standard_characters, $font_color_body);
                        
                        //$options_sku_parent[$sku][$options_sku_single] = ($sku_qty[$sku]);
                        if(is_array($options_sku_parent[$sku]))
                        {
                            ksort($options_sku_parent[$sku]);
                        
                            foreach($options_sku_parent[$sku] as $options_sku_single => $options_sku_qty)
                            {
                                $this->y -= 12;
                                
                                if ($this->y<70)
                                {
                                    if($page_count == 1)
                                    {
                                        $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                                        $page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y - ($font_size_subtitles * 2)), 'UTF-8');
                                    }
                                    $page = $this->newPage();
                                    $page_count ++;
                                    $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                                    $page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y + 15), 'UTF-8');
                                }
                                
                                $options_sku_single = trim($options_sku_single);
                                $options_sku_qty = trim($options_sku_qty);
                                
                                if(!in_array($options_sku_single,$pickpack_options_count_filter_array)) $total_quantity = ($total_quantity + $options_sku_qty);
                                
                                if($grey_next_line == 0)
                                {
                                    $page->setFillColor($grey_bkg_color);            
                                    $page->setLineColor($grey_bkg_color);    
                                    $page->drawRectangle(25, ($this->y-(($font_size_body-2)/2)), $padded_right, ($this->y+(($font_size_body-1)*1.1)));
                                    $this->_setFont($page, $font_style_body, ($font_size_body-2), $font_family_body, $non_standard_characters, $font_color_body);
                                }
                                
                                if(!in_array($options_sku_single,$pickpack_options_count_filter_array))
                                {
                                    if($tickbox != 'no' && !in_array($sku,$pickpack_options_count_filter_array))
                                    {
                                        $page->setFillColor($white_color);            
                                        $page->setLineColor($black_color);    
                                        $page->setLineWidth(0.5);            
                                        $page->drawRectangle(28, ($this->y-1), 34, ($this->y+5));
                                        $page->setFillColor($font_color_body_zend);
                                        $page->setLineWidth(1);            
                                    }
                                    
                                    $page->drawText($options_sku_qty, ($qtyX+4), $this->y , 'UTF-8');
                                    $page->drawText(' x', ($xX+$max_qty_length_display+4), $this->y , 'UTF-8');
                                }
                                if($options_sku_single != '') $page->drawText('[ '.$options_sku_single.' ]', ($skuXreal+4), $this->y , 'UTF-8');
                                
                                $sku_name[$options_sku_single] = trim(str_replace(array('[',']'),'',$sku_name[$options_sku_single]));
                                $sku_name[$options_sku_single] = preg_replace('~^select ~i','',$sku_name[$options_sku_single]);
                                $sku_name[$options_sku_single] = preg_replace('~^enter ~i','',$sku_name[$options_sku_single]);
                                $sku_name[$options_sku_single] = preg_replace('~^would you Like to ~i','',$sku_name[$options_sku_single]);
                                $sku_name[$options_sku_single] = preg_replace('~\((.*)\)~i','',$sku_name[$options_sku_single]);
                                 
                                if($nameyn == 1) $page->drawText($sku_name[$options_sku_single], ($col_title_position_name[1]+4), $this->y , 'UTF-8');
                                
                            }
                        }
                        $this->_setFont($page, $font_style_body, ($font_size_body), $font_family_body, $non_standard_characters, $font_color_body);
                        
                    }
                    
                    // stockcheck = 'notify if stock < this'
                    // $sku_stock[$sku] = current stock (after this order has been placed as it will have been taken off during ordering process)
                    if($stockcheck_yn == 1) 
                    {
						if($sku_stock[$sku] < $stockcheck)
						{
                        	$this->_setFont($page, $font_style_body, ($font_size_body), $font_family_body, $non_standard_characters, $font_color_body);
	                        $page->setFillColor($red_bkg_color);            
	                        $page->setLineColor(new Zend_Pdf_Color_Rgb(1,1,1));

	                        if($col_title_position_stock[1] > 1)
	                        {
	                            $page->setLineColor($red_bkg_color);
	                            $page->drawRectangle($col_title_position_stock[1]-2+7, ($this->y-1.5), ($col_title_position_stock[1]+($font_size_body*(1.5+(0.5*strlen($sku_stock[$sku]))))+2+7), ($this->y+($font_size_body-1.5)));
	                            $page->setFillColor(new Zend_Pdf_Color_GrayScale(0));                
	                            $page->drawText('{ ! '.$sku_stock[$sku].'}', $col_title_position_stock[1]+7, $this->y , 'UTF-8');
	                        }
	                        else
	                        {    
	                            $this->y -= 12;
	                            $page->drawRectangle(55, ($this->y-4), $padded_right, ($this->y+10));
	                            $page->setFillColor(new Zend_Pdf_Color_GrayScale(0));                
	                            $warning = 'Stock Warning      SKU: '.$sku.'    Net Stock After All Picks : '.$sku_stock[$sku];
	                            $page->drawText($warning, 60, $this->y , 'UTF-8');
	                            $this->y -= 4;
	                        }
						}
                    }
                    if(isset($lines) && $lines != 0)
                    {
                        $this->y -= ($lines*($font_size_body+3));
                        $lines = 0;
                        
                        // $this->y = $thisYnext;
                        //                     //$thisYnext = 0;
                    }
                    else $this->y -= ($font_size_body+3);
                  
                }
            }
            // end roll_SKU
            $thisYbase = ($this->y-50);

            if($from_shipment == 'shipment')
            {
                
                $thisYbase = ($thisYbase + ($font_size_body*3));
                $this->y = $thisYbase;
                
                $box_top = $this->y;//($this->y+10+$font_size_body+1);
                $box_bottom = ($this->y-(($font_size_body+1)*(count($shipment_list)+1))-($font_size_body*2));
                $box_bottom_page2 = 0;
                
                if($box_bottom < 60) 
                {
                    // total height = box_top - box_bottom;
                    if((($box_bottom * -1)+$box_bottom) < 0) $box_bottom_page2 = $box_top + ($box_bottom - 60);
                    else $box_bottom_page2 = ($box_top - $box_bottom + 60);
    
                    $box_bottom = 50;
                }
                $page->setFillColor($white_bkg_color);            
                $page->setLineColor($orange_bkg_color);    
                $page->setLineWidth(4);
                $page->drawRectangle(25, $box_bottom, 320, $box_top);
                
                $this->y -= ($font_size_body*2);
                
                $this->_setFont($page, 'bold', $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                $page->drawText(Mage::helper('sales')->__('Shipments included').':', 35, $this->y , 'UTF-8');
                $this->y -= 5;
                $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);

                $i = 0;
                foreach ($shipment_list as $k => $value)
                {
                    if ($this->y<70)
                    {
                        if($page_count == 1)
                        {
                            $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                            $page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y - ($font_size_subtitles * 2)), 'UTF-8');
                        }
                        $page = $this->newPage();
                        $page_count ++;
                        $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                        $page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y + 15), 'UTF-8');
                                                
                        if($page_count > 1)
                        {
                            $page->setFillColor($white_bkg_color);            
                            $page->setLineColor($orange_bkg_color);    
                            $page->setLineWidth(4);
                            $page->drawRectangle(25, $box_bottom_page2, 320, ($page_top-($font_size_body*2)));
                            $this->y = ($page_top-($font_size_body*3));
                        }                    
                    }
                    
                    $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);    
                    
                    $this->y -= ($font_size_body+1);
                    
                    $page->drawText('#'.$value.' ['.$name_list[$k].'] (order #'.$order_list[$k].')', 35, $this->y , 'UTF-8');
                    $i ++;
                }
                $this->y += 30;
                $this->y += (15*$i);
            }
            
            $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
            
            if(($showcount_yn == 1) || ($showcost_yn == 1) || ($order_count_yn == 1) || ($total_paid_subtotal_yn == 1) )
            {
                if($page_count == 1) $this->y = $thisYbase;
                // else $this->y = ($page_top-($font_size_body*2));
                

                $shipYbox = 0;    
                if($from_shipment == 'shipment')                 $shipYbox += $font_size_body*2;
                if($order_count_yn == 1)         $shipYbox += $font_size_body*2;
                if($total_paid_subtotal_yn == 1)$shipYbox += $font_size_body*2;
                if($shipping_subtotal_yn == 1)     
                {
                    if($total_shipping_cost['shipping_ex_tax'] > 0) $shipYbox += $font_size_body*2;
                    if($total_shipping_cost['shipping_plus_tax'] > 0) $shipYbox += $font_size_body*2;
                }
                if($sheet_has_bundles === true) $shipYbox += ($font_size_subtitles+4);

				if (($this->y - $shipYbox) < 60)
				{
					if($page_count == 1)
					{
						$this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
						$page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y - 15), 'UTF-8');
					}
					$page = $this->newPage();
					$page_count ++;
					$this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-2), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
					$page->drawText('-- '.Mage::helper('sales')->__('Page').' '.$page_count.' --', 250, ($this->y + 15), 'UTF-8');
				}
                
                $page->setFillColor($white_bkg_color);            
                $page->setLineColor($orange_bkg_color);    
                $page->setLineWidth(4);
                
                $page->drawRectangle(340, ($this->y-34-$shipYbox), ($padded_right-2), $this->y);
                $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
            }
            
            if($showcount_yn == 1)
            {            
                $this->y -= ($font_size_body*2);
                
                if($from_shipment == 'shipment')
                {
                    $this->_setFont($page, 'bold', $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                    $page->drawText(Mage::helper('sales')->__('Total item quantity shipped this time').' : '.$count, 360, $this->y , 'UTF-8');
                    $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                    $this->y -= 12;
                    $page->drawText(Mage::helper('sales')->__('Total item quantity shipped all time').' : '.$count_all, 360, $this->y , 'UTF-8');
                    $this->y -= 12;
                    $page->drawText(Mage::helper('sales')->__('Total item quantity ordered').' : '.$total_quantity, 360, $this->y , 'UTF-8');
                    $this->y -= 8;
                    $page->drawText('---------------------------------------------------', 360, $this->y , 'UTF-8');
                    $this->y -= 8;
                    $page->drawText(Mage::helper('sales')->__('Qty remaining to be shipped').' : '.($total_quantity-$count_all), 360, $this->y , 'UTF-8');
                    
                }
                else
                {
                    $page->drawText(Mage::helper('sales')->__('Total item quantity').' : '.$total_quantity, 360, $this->y , 'UTF-8');
                }                
            }

            if($order_count_yn == 1)
            {
                $this->y -= $font_size_body*1.4;
                $page->drawText(Mage::helper('sales')->__('Total orders').' : '.$order_count, 360, $this->y , 'UTF-8');
            }
            
            if($showcost_yn == 1)
            {
                $this->y -= $font_size_body*1.4;
                if($from_shipment == 'shipment') $page->drawText(Mage::helper('sales')->__('Total cost these shipments').' : '.$currency_symbol."  ".$total_cost, 375, $this->y , 'UTF-8');
                else $page->drawText(Mage::helper('sales')->__('Total cost').' : '.$currency_symbol."  ".($total_cost), 360, $this->y , 'UTF-8');
            }
            
            if($total_paid_subtotal_yn == 1)
            {
                $this->y -= $font_size_body*1.4;
                if($from_shipment == 'shipment') $page->drawText(Mage::helper('sales')->__('Total paid this shipment').' : '.$currency_symbol."  ".round($total_paid,2), 360, $this->y , 'UTF-8');
                else $page->drawText(Mage::helper('sales')->__('Total paid').' : '.$currency_symbol."  ".round($total_paid,2), 360, $this->y , 'UTF-8');
            }
            
            if($shipping_subtotal_yn == 1)
            {
                if($total_shipping_cost['shipping_ex_tax'] > 0)
                {
                    $this->y -= $font_size_body*1.4;
                    $page->drawText(Mage::helper('sales')->__('Total shipping paid (ex. tax)').' : '.$shipping_currency.$shipping_currency_symbol.' '.round($total_shipping_cost['shipping_ex_tax'],2), 360, $this->y , 'UTF-8');
                }
                
                if($total_shipping_cost['shipping_plus_tax'] > 0)
                {
                    $this->y -= $font_size_body*1.4;
                    $page->drawText(Mage::helper('sales')->__('Total shipping paid (inc. tax)').' : '.$shipping_currency.$shipping_currency_symbol.' '.round($total_shipping_cost['shipping_plus_tax'],2), 360, $this->y , 'UTF-8');
                }
            }
            
        
            if($sheet_has_bundles === true)
            {
                // $this->y -= 8;
                $this->y -= $font_size_body*1.4;
                $page->setFillColor($white_color);            
                $page->setLineColor($black_color);    
                $page->setLineWidth(0.5);
                $page->drawCircle(363.5, ($this->y+3.5), 3.5);
                $page->setFillColor($black_color);            
                $page->drawText(Mage::helper('sales')->__('Key : Bundle Parent'), 373.5, $this->y , 'UTF-8');
            }
            
            if($error_product_count > 0)
            {
                    $this->y -= $font_size_body*1.4;
                    $page->drawText(Mage::helper('sales')->__('Error Product Count').' : '.$error_product_count, 360, $this->y , 'UTF-8');
            }
            
            if($printdates == 1)
            {
                $this->_setFont($page, $font_style_subtitles, ($font_size_subtitles-3), $font_family_subtitles, $non_standard_characters, $font_color_subtitles);
                $page->drawText(Mage::helper('sales')->__('Printed').':   '.date('D jS M Y G:i', Mage::getModel('core/date')->timestamp(time())), 160, 18, 'UTF-8');
            }
    }
    

    $this->_afterGetPdf();

    return $pdf;    
    /**
    getPickCOMBINED Template - END
    *********************************************
    ************************************************/
}












 /**
   getPick Out-of-Stock Template - START
    ************************************************/

public function getPickStock($orders=array())
{
    
    
    /**
     * get store id
     */
    $store_id = Mage::app()->getStore()->getId();

    $csv_or_pdf = trim($this->_getConfig('csv_or_pdf', 'pdf', false,'stock'));
    $csv_output = '';
    
    if($csv_or_pdf == 'pdf')
    {
        $this->_beforeGetPdf();
        $this->_initRenderer('invoices');

        $pdf = new Zend_Pdf();
        $this->_setPdf($pdf);
        $style = new Zend_Pdf_Style();
    
        $page_size = $this->_getConfig('page_size', 'a4', false,'general');
    
        if($page_size == 'letter') 
        {
            $page = $pdf->newPage(Zend_Pdf_Page::SIZE_LETTER);
            $page_top = 770;$padded_right = 587;
        }
        elseif($page_size == 'a4') 
        {
            $page = $pdf->newPage(Zend_Pdf_Page::SIZE_A4);
            $page_top = 820;$padded_right = 570;
        }
        elseif($page_size == 'a5landscape') 
        {
            $page = $pdf->newPage('596:421');                    
            $page_top = 395;$padded_right = 573;
        }
    
        $pdf->pages[] = $page;
  

        $skuX = 67;
        $qtyX = 40;
        $productX = 250;
        $font_size_overall = 15;
        $font_size_productline = 9;
        $total_quantity = 0;
        $total_cost = 0;
        $red_bkg_color             = new Zend_Pdf_Color_Html('lightCoral');
        $green_bkg_color = new Zend_Pdf_Color_Html('lightGreen');
        $grey_bkg_color            = new Zend_Pdf_Color_GrayScale(0.7);
        $dk_grey_bkg_color        = new Zend_Pdf_Color_GrayScale(0.3);//darkCyan
        $dk_cyan_bkg_color         = new Zend_Pdf_Color_Html('darkCyan');//darkOliveGreen
        $dk_og_bkg_color         = new Zend_Pdf_Color_Html('darkOliveGreen');//darkOliveGreen
    
        $white_bkg_color         = new Zend_Pdf_Color_Html('white');
        $orange_bkg_color         = new Zend_Pdf_Color_Html('Orange');
    
        $black_color             = new Zend_Pdf_Color_Rgb(0,0,0);
        $grey_color             = new Zend_Pdf_Color_GrayScale(0.3);
        $greyout_color             = new Zend_Pdf_Color_GrayScale(0.6);
        $white_color             = new Zend_Pdf_Color_GrayScale(1);
    
        $font_family_header_default = 'helvetica';
        $font_size_header_default = 16;
        $font_style_header_default = 'bolditalic';
        $font_color_header_default = 'darkOliveGreen';
        $font_family_subtitles_default = 'helvetica';
        $font_style_subtitles_default = 'bold';
        $font_size_subtitles_default = 15;
        $font_color_subtitles_default = '#222222';
        $background_color_subtitles_default = '#999999';
        $font_family_body_default = 'helvetica';
        $font_size_body_default = 10;
        $font_style_body_default = 'regular';
        $font_color_body_default = 'Black';

        $font_family_header = $this->_getConfig('font_family_header', $font_family_header_default, false,'general');
        $font_style_header = $this->_getConfig('font_style_header', $font_style_header_default, false,'general');
        $font_size_header = $this->_getConfig('font_size_header', $font_size_header_default, false,'general');
        $font_color_header = trim($this->_getConfig('font_color_header', $font_color_header_default, false,'general'));
        $font_family_subtitles = $this->_getConfig('font_family_subtitles', $font_family_subtitles_default, false,'general');
        $font_style_subtitles = $this->_getConfig('font_style_subtitles', $font_style_subtitles_default, false,'general');
        $font_size_subtitles = $this->_getConfig('font_size_subtitles', $font_size_subtitles_default, false,'general');
        $font_color_subtitles = trim($this->_getConfig('font_color_subtitles', $font_color_subtitles_default, false,'general'));
        $background_color_subtitles = trim($this->_getConfig('background_color_subtitles', $background_color_subtitles_default, false,'general'));
        $font_family_body = $this->_getConfig('font_family_body', $font_family_body_default, false,'general');
        $font_style_body = $this->_getConfig('font_style_body', $font_style_body_default, false,'general');
        $font_size_body = $this->_getConfig('font_size_body', $font_size_body_default, false,'general');
        $font_color_body = trim($this->_getConfig('font_color_body', $font_color_body_default, false,'general'));
        $background_color_subtitles_zend = new Zend_Pdf_Color_Html($background_color_subtitles);    
        $font_color_header_zend = new Zend_Pdf_Color_Html($font_color_header);    
        $font_color_subtitles_zend = new Zend_Pdf_Color_Html($font_color_subtitles);    
        $font_color_body_zend = new Zend_Pdf_Color_Html($font_color_body);
    
        $non_standard_characters     = $this->_getConfig('non_standard_characters', 0, false,'general');

		$barcode_type        = $this->_getConfig('font_family_barcode', 'code128', false,'general',$store_id);
		switch ($barcode_type) 
		{
			case 'code128':
				$font_family_barcode 	= 'Code128bWin.ttf';
				break;

			case 'code39':
				$font_family_barcode 	= 'CODE39.ttf';
				
				break;	

			case 'code39x':
				$font_family_barcode 	= 'CODE39X.ttf';
				
				break;

			default:
				$font_family_barcode 	= 'Code128bWin.ttf';
				break;
		}
		
        $shelvingpos = $this->_getConfig('shelvingpos', 'col', false,'general'); //col/sku
        $shelvingX             = $this->_getConfig('shelving_nudge', 200, true,'general');
        $namenudge             = $this->_getConfig('pickpack_namenudge_combined', 250, true,'messages');
     }
    elseif($csv_or_pdf == 'csv')
    {
        $csv_output = '';
        $column_separator         = ',';//$this->_getConfig('csv_field_separator',',', false,'general');
        $row_ending                = "\n"; 
    }

    $product_id = NULL; // get it's ID
    $qty_in_stock = NULL;
    $sku_stock = array();
    $sku_qty = array();
    $sku_cost = array();
    // pickpack_cost
    $showcost_yn_default        = 0;
    $showcount_yn_default        = 0;
    $currency_default            = 'USD';
    
    $shelving_yn_default        = 0;
    $shelving_attribute_default = 'shelf';
    $shelvingX_default             = 200;
    $supplier_yn_default         = 0;
    $supplier_attribute_default = 'supplier';
    $namenudgeYN_default        = 0;
    // $min_qty_in_stock[$sku]_yn_default         = 0;
    //     $min_qty_in_stock[$sku]_default         = 1;
    
    $split_supplier_yn_default     = 'no';
    $supplier_attribute_default = 'supplier';
    $supplier_options_default     = 'filter';
    $supplier_login_default        = '';
    $tickbox_default            = 'no'; //no, pick, pickpack
    
    $add_ordered_qty            = $this->_getConfig('add_ordered_qty', 0, false,'stock');
    // $split_supplier_yn             = $this->_getConfig('pickpack_split_supplier_yn', $split_supplier_yn_default, false,'general');
    $split_supplier_yn_temp     = $this->_getConfig('pickpack_split_supplier_yn', $split_supplier_yn_default, false,'general');
    $split_supplier_options     = $this->_getConfig('pickpack_split_supplier_options', 'no', false,'general');
    $split_supplier_yn = 'no';
    if($split_supplier_yn_temp == 1)
    {
        $split_supplier_yn = $split_supplier_options;
    }
    $supplier_attribute         = $this->_getConfig('pickpack_supplier_attribute', $supplier_attribute_default, false,'general');
    $supplier_options             = $this->_getConfig('pickpack_supplier_options', $supplier_options_default, false,'general');
    //$supplier_login             = $this->_getConfig('pickpack_supplier_login', $supplier_login_default, false,'general');
    
    $userId                     = Mage::getSingleton('admin/session')->getUser() ? Mage::getSingleton('admin/session')->getUser()->getId(): 0;
    $user                       = ($userId !== 0) ? Mage::getModel('admin/user')->load($userId): '';
    $username                   = (!empty($user['username'])) ? $user['username']:'';

    $supplier_login_pre         = $this->_getConfig('pickpack_supplier_login', '', false,'general');
    $supplier_login_pre         = str_replace(array("\n",','),';',$supplier_login_pre);
    $supplier_login_pre         = explode(';',$supplier_login_pre);

    foreach($supplier_login_pre as $key => $value)
    {
        $supplier_login_single = explode(':',$value);
        if(preg_match('~'.$username.'~i',$supplier_login_single[0])) 
        {
            if($supplier_login_single[1] != 'all') $supplier_login = trim($supplier_login_single[1]);
            else $supplier_login = '';
        }
    }
    
    $tickbox                     = $this->_getConfig('pickpack_tickbox', $tickbox_default, false,'general');
    $picklogo                     = $this->_getConfig('pickpack_picklogo', 0, false,'general');
    
    $showcount_yn         = $this->_getConfig('pickpack_count', $showcount_yn_default, false,'messages');

    $showcost_yn         = $this->_getConfig('pickpack_cost', $showcost_yn_default, false,'messages');
    $currency             = $this->_getConfig('pickpack_currency', $currency_default, false,'messages');
    $currency_symbol     = Mage::app()->getLocale()->currency($currency)->getSymbol();
    
    $stockcheck_yn         = 1;//$this->_getConfig('pickpack_showstock_yn_combined', $min_qty_in_stock[$sku]_yn_default, false,'messages');
    $stockcheck_solo     = $this->_getConfig('stock_stock', 1, false,'stock');
    $min_qty_in_stock     = array();

    $shelving_yn         = $this->_getConfig('pickpack_shelving_yn_stock', 0, false,'stock');

    $infoline_yn         = $this->_getConfig('pickpack_infoline_yn_stock', 0, false,'stock');
    $name_yn             = $this->_getConfig('pickpack_name_yn_stock', 0, false,'stock');
    $shelving_attribute = trim($this->_getConfig('pickpack_shelving_stock', '', false,'stock'));

    $nameyn             = $name_yn;//$this->_getConfig('pickpack_name_yn_combined', $namenudgeYN_default, false,'messages');
    if($shelving_attribute == '') $shelving_yn = 0;
    
    $min_qty_in_stock     = array();
    $sku_master            = array();
    $pre_stock1 = trim(preg_replace("/[^\n\r;,\"\'a-zA-Z0-9\-\_]/", '', $this->_getConfig('min_qty_in_stock', '', false,'stock')));
    if($pre_stock1 != '')
    {
        $pre_stock1 = str_replace(array("\n","\r",';;'),';',$pre_stock1);

        // no empty lines
        $pre_stock2 = preg_split('~;~', $pre_stock1, -1, PREG_SPLIT_NO_EMPTY);    

        foreach($pre_stock2 as $pre_stock)
        {
            $pre_stock3 = explode(',',$pre_stock);
            foreach($pre_stock3 as $del)// as $sku => $value)
            {
                $sku         = $pre_stock3[0];
                $value         = $pre_stock3[1];
                $product_id = Mage::getModel('catalog/product')->setStoreId($store_id)->getIdBySku($sku);

                if(Mage::getModel('cataloginventory/stock_item')->loadByProduct($product_id)->getQty()) 
                {
                    // $product_temp     = Mage::getModel('cataloginventory/stock_item')->loadByProduct($product_id);
                    $product_temp     = Mage::getModel('catalog/product')->setStoreId($store_id)->loadByAttribute('sku', $sku, array('cost','name','simple_sku','qty'));            
                    
                    $qty_in_stock     = round($product_temp->getQty());    
                    $cost             = (is_object($product_temp)?$product_temp->getCost():0);
                }
                else 
                {
                    $qty_in_stock = 0;
                    $cost = 0;
                }
                
                if($qty_in_stock < $value)
                {
                    // comment next lines to not have these custom SKUs added when there are no orders for them
                    // (will still not show if there is enough stock)
                    $sku_master[$sku]         = $sku;
                    $min_qty_in_stock[$sku] = $value;
                    $sku_stock[$sku]         = $qty_in_stock;
                    $sku_cost[$sku]            = $cost;
                    $sku_qty_ordered[$sku]    = 0;
                }
                
            }
        }
    }

    foreach ($orders as $orderSingle) 
    {
        $order = Mage::getModel('sales/order')->load($orderSingle);    
            
        $order_id  = $order->getRealOrderId();

        if(!isset($order_id_master[$order_id])) $order_id_master[$order_id] = 0;        

        $itemsCollection =  $order->getAllVisibleItems();//$order->getItemsCollection();
        // $total_items     = count($itemsCollection);
        
        foreach ($itemsCollection as $item)
        {        
            if($item->getProductType() == Mage_Catalog_Model_Product_Type::TYPE_CONFIGURABLE) 
            {
                // any products actually go thru here?
                $sku = $item->getProductOptionByCode('simple_sku');
                $product_id = Mage::getModel('catalog/product')->setStoreId($store_id)->getIdBySku($sku);
            } 
            else 
            {
                $sku = $item->getSku();
                $product_id = $item->getProductId(); // get it's ID            
            }    
            
            $qty_in_stock = 0;
            $product = Mage::getModel('catalog/product')->setStoreId($store_id)->loadByAttribute('sku', $sku, array('cost',$shelving_attribute,'name','simple_sku','qty'));            
            if(Mage::getModel('cataloginventory/stock_item')->loadByProduct($product_id)->getQty()) 
            {
                $qty_in_stock = round(Mage::getModel('cataloginventory/stock_item')->loadByProduct($product_id)->getQty());
            }
            
            $shelving = '';
            $supplier = '';
            
            if($shelving_yn == 1)
            {
                if(Mage::getModel('catalog/product')->setStoreId($store_id)->load($product_id))
                {
                        $_newProduct = Mage::getModel('catalog/product')->setStoreId($store_id)->load($product_id);  
                    if($_newProduct->getData($shelving_attribute)) $shelving = $_newProduct->getData($shelving_attribute);
                }
                elseif($product->getData($shelving_attribute))
                {
                         $shelving = $product->getData($shelving_attribute);
                }
                if(Mage::getModel('catalog/product')->setStoreId($store_id)->load($product_id)->getAttributeText($shelving_attribute))
                {
                    $shelving = Mage::getModel('catalog/product')->setStoreId($store_id)->load($product_id)->getAttributeText($shelving_attribute);
                }
                elseif($product[$shelving_attribute]) $shelving = $product[$shelving_attribute];

                if(is_array($shelving)) $shelving = implode(',',$shelving);

                if(isset($sku_shelving[$sku]) && trim(strtoupper($sku_shelving[$sku])) != trim(strtoupper($shelving))) $sku_shelving[$sku] .= ','.trim($shelving);
                else $sku_shelving[$sku] = trim($shelving);
                $sku_shelving[$sku] = preg_replace('~,$~','',$sku_shelving[$sku]);
            }
            

            if($split_supplier_yn != 'no')
            {
                if(Mage::getModel('catalog/product')->setStoreId($store_id)->load($product_id))
                {
                        $_newProduct = Mage::getModel('catalog/product')->setStoreId($store_id)->load($product_id);  
                    if($_newProduct->getData($supplier_attribute)) $supplier = $_newProduct->getData(''.$supplier_attribute.'');
                }
                elseif($product->getData(''.$supplier_attribute.''))
                {
                         $supplier = $product->getData($supplier_attribute);
                }
                if(Mage::getModel('catalog/product')->setStoreId($store_id)->load($product_id)->getAttributeText($supplier_attribute))
                {
                    $supplier = Mage::getModel('catalog/product')->setStoreId($store_id)->load($product_id)->getAttributeText($supplier_attribute);
                }
                elseif($product[$supplier_attribute]) $supplier = $product[$supplier_attribute];
                
                if(is_array($supplier)) $supplier = implode(',',$supplier);
                if(!$supplier) $supplier = '~Not Set~';    
                
                $supplier = trim(strtoupper($supplier));
                
                if(isset($sku_supplier[$sku]) && $sku_supplier[$sku] != $supplier) $sku_supplier[$sku] .= ','.$supplier;
                else $sku_supplier[$sku] = $supplier;
                $sku_supplier[$sku] = preg_replace('~,$~','',$sku_supplier[$sku]);
                
                if(!isset($supplier_master[$supplier])) $supplier_master[$supplier] = $supplier;

                $order_id_master[$order_id] .= ','.$supplier;
            }

                        
            // qty in this order of this sku
            $qty_ordered= $item->getIsQtyDecimal() ? $item->getQtyOrdered() : (int) $item->getQtyOrdered();

            if($add_ordered_qty == 1)
            {
                if(isset($sku_qty_ordered[$sku])) $sku_qty_ordered[$sku] += $qty_ordered;
                else $sku_qty_ordered[$sku] = $qty_ordered;
            }
            else $sku_qty_ordered[$sku] = 0;
            
            $sku_qty[$sku] = $qty_in_stock;
        
            $sku_cost[$sku] = (is_object($product)?$product->getCost():0);
            // $total_cost = $total_cost + $cost;

            $sku_master[$sku] = $sku;
            if(Mage::getModel('catalog/product')->setStoreId($store_id)->load($product_id) && isset($configurable_names) && $configurable_names == 'simple')
            {
                $_newProduct = Mage::getModel('catalog/product')->setStoreId($store_id)->load($product_id);  
                if($_newProduct->getData('name')) $sku_name[$sku] = $_newProduct->getData('name');
            }
            else $sku_name[$sku] = $item->getName();
            
            $sku_stock[$sku] = $qty_in_stock;
            
            // here we can set custom min-qty-in-stock for skus which we want custom stock minimums
            if(!isset($min_qty_in_stock[$sku])) $min_qty_in_stock[$sku] = $stockcheck_solo;
            
            if(($qty_in_stock-$qty_ordered) < $min_qty_in_stock[$sku])
            {
                if(!isset($supplier_master[$supplier])) $supplier_master[$supplier] = $supplier;
                else $supplier_master[$supplier] .= ','.$supplier;
            }
    
        
        }
        
    }

    // $nitems = array();
    
    if(is_array($sku_master)) ksort($sku_master);
    
    if(isset($supplier_master) && is_array($supplier_master)) ksort($supplier_master);
	elseif(!isset($supplier_master))
	{
		$split_supplier_yn == 0;
		$supplier_master = '';
	}
    $supplier_previous         = '';
    $supplier_item_action     = '';
    $first_page_yn             = 'y';
    
    
    if($split_supplier_yn == 1)
    {
        foreach($supplier_master as $supplier =>$value)
        {
            $supplier_skip_order = FALSE;
        
            if($supplier_skip_order == FALSE)
            {    
                $total_quantity = 0;    
                $total_cost = 0;    
            
                if($first_page_yn == 'n') $page = $this->newPage();
                else $first_page_yn = 'n';

                if($picklogo == 1 && ($csv_or_pdf == 'pdf'))
                {                    
                    $packlogo = Mage::getStoreConfig('pickpack_options/wonder/pack_logo', $order->getStore()->getId());
                    if($packlogo)
                    {
                        $packlogo = Mage::getStoreConfig('system/filesystem/media',$order->getStore()->getId()) . '/moogento/pickpack/logo_pack/' . $packlogo;
                        if (is_file($packlogo)) {    
                            $packlogo = Zend_Pdf_Image::imageWithPath($packlogo);            
                            $page->drawImage($packlogo, 27, 784, 296, 825);
                        }
                    }
                    $this->_setFont($page, $font_style_header, $font_size_header, $font_family_header, $non_standard_characters, $font_color_header);    
                    $page->drawText(Mage::helper('sales')->__('Out-of-stock Pick List'), 325, 810, 'UTF-8');        
                    $page->drawText(Mage::helper('sales')->__('Supplier').' : '.$supplier, 325, 790, 'UTF-8');
                    $page->setFillColor($font_color_header_zend);            
                    $page->setLineColor($font_color_header_zend);
                    $page->setLineWidth(0.5);            
                    $page->drawRectangle(304, 784, 316, 825);
                    $page->drawRectangle(27, $this->y, $padded_right, ($this->y + 1));
                    $this->y -= 40;
                }
                elseif($csv_or_pdf == 'pdf')
                {
                       $this->_setFont($page, $font_style_header, ($font_size_header+2), $font_family_header, $non_standard_characters, $font_color_header);
                    $page->drawText(Mage::helper('sales')->__('Out-of-stock Pick List, Supplier').' : '.$supplier, 31, 810, 'UTF-8');
                    $page->setLineColor($font_color_header_zend);
                    $page->setFillColor($font_color_header_zend);
                    $page->setLineWidth(0.5);            
                    $page->drawRectangle(27, 803, $padded_right, 804);
                }
                elseif($csv_or_pdf == 'csv')
                {
                    $csv_output .= $column_separator.Mage::helper('sales')->__('Out-of-stock Pick List').$row_ending.$row_ending;
                }
            
                $this->y = 777;            
                $processed_skus = array();
                $outofstock_check = false;
            
                // roll_SKU
                foreach($sku_master as $key =>$sku)
                {        
                    if(!in_array($sku,$processed_skus) && ($sku_stock[$sku] < $min_qty_in_stock[$sku]))
                    {
                        $processed_skus[] = $sku;
                        $outofstock_check = true;
                    
                        $supplier_item_action = 'keep';
                        // if set to filter and a name and this is the name, then print
                        if($supplier_options == 'filter' && isset($supplier_login) && (strtoupper($sku_supplier[$sku]) == strtoupper($supplier_login)) )//grey //split
                        {
                            $supplier_item_action = 'keep';
                        }
                        elseif($supplier_options == 'filter' && isset($supplier_login) && ($supplier_login != '') && (strtoupper($sku_supplier[$sku]) != strtoupper($supplier_login)) )//grey //split
                        {
                            $supplier_item_action = 'hide';
                        }
                        elseif($supplier_options == 'grey' && isset($supplier_login) && (strtoupper($sku_supplier[$sku]) == strtoupper($supplier_login)) )//grey //split
                        {
                            $supplier_item_action = 'keep';
                        }
                        elseif($supplier_options == 'grey' && isset($supplier_login) && $supplier_login != '' && (strtoupper($sku_supplier[$sku]) != strtoupper($supplier_login)) )//grey //split
                        {
                            $supplier_item_action = 'keepGrey';
                        }
                        elseif($supplier_options == 'grey' && ($supplier_login == '') && (strtoupper($sku_supplier[$sku]) != strtoupper($supplier) ) )
                        {
                            $supplier_item_action = 'keepGrey';
                        }
                        elseif($supplier_options == 'filter' && ($supplier_login == '') && (strtoupper($sku_supplier[$sku]) != strtoupper($supplier) ) )
                        {
                            $supplier_item_action = 'hide';
                        }
                        elseif($supplier_options == 'grey' && ($supplier_login == '') && (strtoupper($sku_supplier[$sku]) == strtoupper($supplier) ) )
                        {
                            $supplier_item_action = 'keep';
                        }
                        elseif($supplier_options == 'filter' && ($supplier_login == '') && (strtoupper($sku_supplier[$sku]) == strtoupper($supplier) ) )
                        {
                            $supplier_item_action = 'keep';
                        }
                        elseif($supplier_options == 'grey') $supplier_item_action = 'keepGrey';
                        elseif($supplier_options == 'filter') $supplier_item_action = 'hide';

                        $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);

                        if($supplier_item_action != 'hide' && trim($supplier_item_action) != '')
                        {
                            if ($this->y<15) $page = $this->newPage();
                            if($csv_or_pdf == 'pdf') $page->setFillColor($black_color);
                            if($supplier_item_action == 'keepGrey' && ($csv_or_pdf == 'pdf')) 
                            {
                                $page->setFillColor($greyout_color);
                            }
                            else
                            {
                                
                                $total_quantity = $total_quantity + ($min_qty_in_stock[$sku] - $sku_stock[$sku] + $sku_qty_ordered[$sku]);//$sku_qty[$sku];    
                                $total_cost = $total_cost + (($min_qty_in_stock[$sku] - $sku_stock[$sku] + $sku_qty_ordered[$sku]) * $sku_cost[$sku]);    
                            
                            }
                            // $page->drawText($sku_qty[$sku]. ' x ', $qtyX, $this->y , 'UTF-8');
                            //                             $page->drawText($sku, $skuX, $this->y , 'UTF-8');
                            //                             if($nameyn == 1) $page->drawText($sku_name[$sku], intval($namenudge), $this->y , 'UTF-8');
                            //                             if($shelving_yn == 1 && $sku_shelving[$sku]) $page->drawText('['.$sku_shelving[$sku].']', $shelvingX, $this->y , 'UTF-8');
                            //                             if(($sku_stock[$sku] < $min_qty_in_stock[$sku]) && $min_qty_in_stock[$sku]_yn == 1 && $supplier_item_action != 'keepGrey') 
                            //                             {
                            //                                 $this->_setFont($page, $font_style_body, ($font_size_body-2), $font_family_body, $non_standard_characters, $font_color_body);
                            //                                 
                            //                                 $this->y -= 12;
                            //                                 $page->setFillColor($red_bkg_color);            
                            //                                 $page->setLineColor(new Zend_Pdf_Color_Rgb(1,1,1));    
                            //                                 $page->drawRectangle(55, ($this->y-4), $padded_right, ($this->y+10));
                            //                                 $page->setFillColor(new Zend_Pdf_Color_GrayScale(0));                
                            //                                 $warning = 'Stock Warning      SKU: '.$sku.'    Net Stock After All Picks : '.$sku_stock[$sku];
                            //                                 $page->drawText($warning, 60, $this->y , 'UTF-8');
                            //                                 $this->y -= 4;
                            //                             }
                            if($csv_or_pdf == 'pdf')
                            {
                                if ($this->y<15) $page = $this->newPage();
                                $page->setFillColor($black_color);
                                $page->drawText(($min_qty_in_stock[$sku] - $sku_stock[$sku] + $sku_qty_ordered[$sku]). ' x ', $qtyX, $this->y , 'UTF-8');

                                $page->drawText($sku, $skuX, $this->y , 'UTF-8');
                                if($nameyn == 1) $page->drawText($sku_name[$sku], intval($namenudge), $this->y , 'UTF-8');
                                if($shelving_yn == 1 && $sku_shelving[$sku]) $page->drawText('['.$sku_shelving[$sku].']', $shelvingX, $this->y , 'UTF-8');
                                if(($infoline_yn == 1) && (($sku_stock[$sku] + $sku_qty_ordered[$sku]) < $min_qty_in_stock[$sku]) && ($stockcheck_yn == 1)) 
                                {
                                    $this->_setFont($page, $font_style_body, ($font_size_body-2), $font_family_body, $non_standard_characters, $font_color_body);

                                    $this->y -= 14;
                                    $page->setFillColor($red_bkg_color);            
                                    $page->setLineColor($red_bkg_color);    
                                    $page->drawRectangle(55, ($this->y-4), $padded_right, ($this->y+10));
                                    $page->setFillColor(new Zend_Pdf_Color_GrayScale(0));                
                                    $warning = 'Stock Warning      SKU: '.$sku.'    Net Stock After All Picks : '.($sku_stock[$sku]-$sku_qty_ordered[$sku]);
                                    $page->drawText($warning, 60, $this->y , 'UTF-8');

                                    $need = 'Need '.($min_qty_in_stock[$sku] - $sku_stock[$sku] + $sku_qty_ordered[$sku]).' to restock to '.$min_qty_in_stock[$sku].' . . ('.$sku_qty[$sku].' going out in all picks)';
                                    $this->y -= 14;
                                    $page->setFillColor($green_bkg_color);    
                                    $page->setLineColor($green_bkg_color);
                                    $page->drawRectangle(55, ($this->y-4), $padded_right, ($this->y+10));
                                    $page->setFillColor(new Zend_Pdf_Color_GrayScale(0));        
                                    $page->drawText($need, 60, $this->y , 'UTF-8');

                                    $this->y -= 4;

                                }
                                $this->y -= 12;
                            } // end if pdf
                            elseif($csv_or_pdf == 'csv')
                            {
                                $csv_output .= ($min_qty_in_stock[$sku] - $sku_stock[$sku] + $sku_qty_ordered[$sku]).$column_separator.$sku.$column_separator;
                                if($nameyn == 1) $csv_output .= $sku_name[$sku].$column_separator;
                                if($shelving_yn == 1 && $sku_shelving[$sku]) $csv_output .= '['.$sku_shelving[$sku].$column_separator;
                            }
                        }
                    }// end if supplier_skip
                }
            }
            // end roll_SKU
            if($csv_or_pdf == 'pdf')
            {
                $page->setFillColor(new Zend_Pdf_Color_Rgb(0,0,0));
                $this->y -= 30;
                $this->_setFontItalic($page,12);
            
                if(($showcount_yn == 1) || $showcost_yn == 1)
                {
                    $page->setFillColor($white_bkg_color);            
                    $page->setLineColor($orange_bkg_color);    
                    $page->setLineWidth(4);    
                    $page->drawRectangle(355, ($this->y-34), 568, ($this->y+10+$font_size_body));
                    $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                }
            }
            else $csv_output .= $row_ending;
            
            if($showcount_yn == 1)
            {
                if($csv_or_pdf == 'pdf') $page->drawText(Mage::helper('sales')->__('Total quantity').' : '.$total_quantity, 375, $this->y , 'UTF-8');
                elseif($csv_or_pdf == 'csv') $csv_output .= "\n\n".$column_separator.Mage::helper('sales')->__('Total quantity').' : '.$total_quantity.$column_separator;
                $this->y -= 20;
            }
            
            if($showcost_yn == 1)
            {
                if($csv_or_pdf == 'pdf') $page->drawText(Mage::helper('sales')->__('Total cost').' : '.$currency_symbol."  ".$total_cost, 375, $this->y , 'UTF-8');
                elseif($csv_or_pdf == 'csv') $csv_output .= "\n".$column_separator.Mage::helper('sales')->__('Total cost').' : '.$currency_symbol."  ".$total_cost;
            }
            
            $printdates = Mage::getStoreConfig('pickpack_options/picks/pickpack_packprint');
            if($printdates!=1)
            {
                if($csv_or_pdf == 'pdf') 
                {
                    $this->_setFontBold($page);
                    $page->drawText(Mage::helper('sales')->__('Printed:').'   '.date('D jS M Y G:i', Mage::getModel('core/date')->timestamp(time())), 210, 18, 'UTF-8').$column_separator;
                }
                elseif($csv_or_pdf == 'csv') 
                {
                    $csv_output .= "\n".$column_separator.Mage::helper('sales')->__('Printed:').'   '.date('D jS M Y G:i', Mage::getModel('core/date')->timestamp(time())).$column_separator;
                }
            }
        }
    }
    else
    {
        $total_quantity = 0;
        $total_cost = 0;
        if($csv_or_pdf == 'pdf') 
        {
            $this->y = 777;

            if($picklogo == 1)
            {                    
                $packlogo = Mage::getStoreConfig('pickpack_options/wonder/pack_logo', $order->getStore()->getId());
                if($packlogo)
                {
                    $packlogo = Mage::getStoreConfig('system/filesystem/media', $order->getStore()->getId()) . '/moogento/pickpack/logo_pack/' . $packlogo;
                    if (is_file($packlogo)) 
                    {    
                        $packlogo = Zend_Pdf_Image::imageWithPath($packlogo);            
                        $page->drawImage($packlogo, 27, 784, 296, 825);
                    }
                }
                $this->_setFont($page, $font_style_header, ($font_size_header+4), $font_family_header, $non_standard_characters, $font_color_header);    
                $page->drawText(Mage::helper('sales')->__('Out-of-stock Pick List'), 325, 810, 'UTF-8');        
                $page->setFillColor($font_color_header_zend);            
                $page->setLineColor($font_color_header_zend);
                $page->setLineWidth(0.5);            
                $page->drawRectangle(304, 784, 316, 825);
                $page->drawRectangle(27, $this->y, $padded_right, ($this->y + 1));
                $this->y -= 40;
            }
            else
            {
                   $this->_setFont($page, $font_style_header, ($font_size_header+4), $font_family_header, $non_standard_characters, $font_color_header);
                $page->drawText(Mage::helper('sales')->__('Out-of-stock Pick List'), 31, 810, 'UTF-8');
                $page->setLineColor($font_color_header_zend);
                $page->setFillColor($font_color_header_zend);
                $page->drawRectangle(27, 803, $padded_right, 804);
            }

        }
        elseif($csv_or_pdf == 'csv') 
        {
            $csv_output .= $column_separator.Mage::helper('sales')->__('Out-of-stock Pick List').$row_ending.$row_ending;
        }

		if(!isset($sku_test)) $sku_test = array();

        // roll sku foreach
        // roll_SKU
        $processed_skus = array();

        foreach($sku_master as $key =>$sku)
        {        
            if($csv_or_pdf == 'pdf') $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
            
            if(!in_array($sku,$processed_skus) && ($sku_stock[$sku] < $min_qty_in_stock[$sku]))
            {
                $processed_skus[] = $sku;
            
                $total_quantity = $total_quantity + ($min_qty_in_stock[$sku] - $sku_stock[$sku] + $sku_qty_ordered[$sku]);//$sku_qty[$sku];    
                $total_cost = $total_cost + (($min_qty_in_stock[$sku] - $sku_stock[$sku] + $sku_qty_ordered[$sku]) * $sku_cost[$sku]);    
            
                if($csv_or_pdf == 'pdf')
                {
                    if ($this->y<15) $page = $this->newPage();
                    $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, 'Black');
                
                    $page->drawText(($min_qty_in_stock[$sku] - $sku_stock[$sku] + $sku_qty_ordered[$sku]). ' x ', $qtyX, $this->y , 'UTF-8');
                
                    $page->drawText($sku, $skuX, $this->y , 'UTF-8');
                    if($nameyn == 1) $page->drawText($sku_name[$sku], intval($namenudge), $this->y , 'UTF-8');
                    if($shelving_yn == 1 && $sku_shelving[$sku]) $page->drawText('['.$sku_shelving[$sku].']', $shelvingX, $this->y , 'UTF-8');
                    if(($infoline_yn == 1) && ($sku_stock[$sku] < ($min_qty_in_stock[$sku] + $sku_qty_ordered[$sku])) && $stockcheck_yn == 1) 
                    {
                        $this->_setFont($page, $font_style_body, ($font_size_body-2), $font_family_body, $non_standard_characters, $font_color_body);
                    
                        $this->y -= 14;
                        $page->setFillColor($red_bkg_color);            
                        $page->setLineColor($red_bkg_color);    
                        $page->drawRectangle(55, ($this->y-4), $padded_right, ($this->y+10));
                        $page->setFillColor(new Zend_Pdf_Color_GrayScale(0));                
                        $warning = Mage::helper('sales')->__('Stock Warning').'      '.Mage::helper('sales')->__('SKU').': '.$sku.'    '.Mage::helper('sales')->__('Net Stock After All Picks').' : '.$sku_stock[$sku];
                        $page->drawText($warning, 60, $this->y , 'UTF-8');
                    
                        $need = Mage::helper('sales')->__('Need').' '.($min_qty_in_stock[$sku] - $sku_stock[$sku] + $sku_qty_ordered[$sku]).' '.Mage::helper('sales')->__('to restock to').' '.$min_qty_in_stock[$sku].' . . ('.$sku_qty[$sku].' '.Mage::helper('sales')->__('going out in all picks').')';
                        $this->y -= 14;
                        $page->setFillColor($green_bkg_color);    
                        $page->setLineColor($green_bkg_color);
                        $page->drawRectangle(55, ($this->y-4), $padded_right, ($this->y+10));
                        $page->setFillColor(new Zend_Pdf_Color_GrayScale(0));        
                        $page->drawText($need, 60, $this->y , 'UTF-8');
                    
                        $this->y -= 4;
                    
                    }
                    $this->y -= 12;
                } //end if pdf
                elseif($csv_or_pdf == 'csv') 
                {
                    $csv_output .= ($min_qty_in_stock[$sku] - $sku_stock[$sku] + $sku_qty_ordered[$sku]).$column_separator.$sku.$column_separator;
                    if($nameyn == 1) $csv_output .= $sku_name[$sku].$column_separator;
                    if($shelving_yn == 1 && $sku_shelving[$sku]) $csv_output .= '['.$sku_shelving[$sku].$column_separator;
                    $csv_output .= $row_ending;
                }
            }
        }

            // end roll_SKU
            if($csv_or_pdf == 'pdf')
            {
                $page->setFillColor(new Zend_Pdf_Color_Rgb(0,0,0));
                $this->y -= 30;
                $this->_setFontItalic($page,12);
            
                if(($showcount_yn == 1) || $showcost_yn == 1)
                {
                    $page->setFillColor($white_bkg_color);            
                    $page->setLineColor($orange_bkg_color);    
                    $page->setLineWidth(4);    
                    $page->drawRectangle(355, ($this->y-34), 568, ($this->y+10+$font_size_body));
                    $this->_setFont($page, $font_style_body, $font_size_body, $font_family_body, $non_standard_characters, $font_color_body);
                }
            }
            else $csv_output .= $row_ending;
            
            if($showcount_yn == 1)
            {
                if($csv_or_pdf == 'pdf') 
                {
                    $page->drawText(Mage::helper('sales')->__('Total quantity').' : '.$total_quantity, 375, $this->y , 'UTF-8');
                    $this->y -= 20;
                }
                elseif($csv_or_pdf == 'csv') $csv_output .= $column_separator.Mage::helper('sales')->__('Total quantity').' : '.$total_quantity.$row_ending;
            }
            if($showcost_yn == 1)
            {
                if($csv_or_pdf == 'pdf') $page->drawText(Mage::helper('sales')->__('Total cost').' : '.$currency_symbol."  ".$total_cost, 375, $this->y , 'UTF-8');
                elseif($csv_or_pdf == 'csv') $csv_output .= $column_separator.Mage::helper('sales')->__('Total cost').' : '.$currency_symbol."  ".$total_cost.$row_ending;
            }
            $printdates = Mage::getStoreConfig('pickpack_options/picks/pickpack_packprint');
            if($printdates != 1)
            {
                if($csv_or_pdf == 'pdf') 
                {
                    $this->_setFontBold($page);
                    $page->drawText(Mage::helper('sales')->__('Printed:').'   '.date('D jS M Y G:i', Mage::getModel('core/date')->timestamp(time())), 210, 18, 'UTF-8');
                }
                elseif($csv_or_pdf == 'csv') 
                {
                    $csv_output .= $column_separator.Mage::helper('sales')->__('Printed:').'   '.date('D jS M Y G:i', Mage::getModel('core/date')->timestamp(time())).$row_ending;
                }
            }
    } // end 'no supplier split'
    
    if($csv_or_pdf == 'pdf') 
    {
        $this->_afterGetPdf();
        return $pdf;    
    }
    else return $csv_output;
    /**
    getPickSTOCK 22222 Template - END
    *********************************************
    ************************************************/
}






 /**
   getLabel Template - START
    ************************************************/

    public function getLabel($orders=array())
    {
/*
        Paper Keywords and paper size in points

        Letter         612x792
        LetterSmall     612x792
        Tabloid         792x1224
        Ledger        1224x792
        Legal         612x1008
        Statement     396x612
        Executive     540x720
        A0               2384x3371
        A1              1685x2384
        A2        1190x1684
        A3         842x1190
        A4         595x842
        A4Small         595x842
        A5         420x595
        B4         729x1032
        B5         516x729
        Envelope     ???x???
        Folio         612x936
        Quarto         610x780
        10x14         720x1008
*/  
        // $paper_width     = $this->_getConfig('paper_width', 595, false,'label');
        // $paper_height     = $this->_getConfig('paper_height', 842, false,'label');

        $store_id 	= Mage::app()->getStore()->getId();   
      	$this->_beforeGetPdf();
        $this->_initRenderer('invoices');
        $pdf = new Zend_Pdf();
        $this->_setPdf($pdf);
        $style = new Zend_Pdf_Style();
        
        $page_size = $this->_getConfig('page_size', 'a4', false,'label');

        if($page_size == 'letter') 
        {
            $page = $pdf->newPage(Zend_Pdf_Page::SIZE_LETTER);
            $page_top = 770;$padded_right = 587;
            $paper_width     = 612;
            $paper_height     = 792;
            $label_width     = $this->_getConfig('label_width_letter', 190, false,'label');
            $label_height     = $this->_getConfig('label_height_letter', 168, false,'label');
            $paper_margin     = explode(",", $this->_getConfig('paper_margin_letter', '22,30,22,30',false,'label'));               
            $label_padding     = explode(",", $this->_getConfig('label_padding_letter', '5,5,5,5',false,'label'));
            $nudge_shipping_address = explode(",", $this->_getConfig('nudge_shipping_address_letter', '0,0',false,'label'));
            $show_address_barcode_yn = $this->_getConfig('show_address_barcode_yn_letter', 0, false,'label');
        }
        elseif($page_size == 'a4') 
        {
            $page = $pdf->newPage(Zend_Pdf_Page::SIZE_A4);
            $page_top = 820;$padded_right = 570;
            $paper_width     = 595;
            $paper_height     = 842;
            $label_width     = $this->_getConfig('label_width', 190, false,'label');
            $label_height     = $this->_getConfig('label_height', 168, false,'label');
            $paper_margin     = explode(",", $this->_getConfig('paper_margin', '22,30,22,30',false,'label'));               
            $label_padding     = explode(",", $this->_getConfig('label_padding', '5,5,5,5',false,'label'));
            $nudge_shipping_address = explode(",", $this->_getConfig('nudge_shipping_address', '0,0',false,'label'));
            $show_address_barcode_yn = $this->_getConfig('show_address_barcode_yn', 0, false,'label');
        }
        elseif($page_size == 'zebra') 
        {
            $page = $pdf->newPage('288:432');                    
            $page_top = 430;$padded_right = 286;
            $paper_width     = 288;
            $paper_height     = 432;
            $label_width     = $this->_getConfig('label_width_zebra', 190, false,'label');
            $label_height     = $this->_getConfig('label_height_zebra', 168, false,'label');
            $paper_margin     = explode(",", $this->_getConfig('paper_margin_zebra', '22,30,22,30',false,'label'));               
            $label_padding     = explode(",", $this->_getConfig('label_padding_zebra', '10,5,5,5',false,'label'));
            $nudge_shipping_address = explode(",", $this->_getConfig('nudge_shipping_address_zebra', '0,0',false,'label'));
            $nudge_shipping_address[1] -= 85;
            $show_address_barcode_yn = $this->_getConfig('show_address_barcode_yn_zebra', 0, false,'label');
            $ship_image1_yn        = null;
            $ship_image1_nudge     = null;
            $ship_image1_match    = null;
            $ship_image2_yn        = null;
            $ship_image2_nudge     = null;
            $ship_image2_match    = null;
            $ship_image3_yn        = null;
            $ship_image3_nudge     = null;
            $ship_image3_match    = null;
            
            $ship_image1_yn        = $this->_getConfig('label_shiplogo1_yn', 0, false,'label');
            if($ship_image1_yn == 1)
            {
                $ship_image1_nudge     = explode(",", $this->_getConfig('label_nudge_shiplogo1', '0,0',false,'label'));
                $ship_image1_match    = trim(strtolower($this->_getConfig('shiplogo1_match', '', false,'label')));
            
                $ship_image2_yn        = $this->_getConfig('label_shiplogo2_yn', 0, false,'label');
                if($ship_image2_yn == 1)
                {
                    $ship_image2_nudge     = explode(",", $this->_getConfig('label_nudge_shiplogo2', '0,0',false,'label'));
                    $ship_image2_match    = trim(strtolower($this->_getConfig('shiplogo2_match', '', false,'label')));
                
                    $ship_image3_yn        = $this->_getConfig('label_shiplogo3_yn', 0, false,'label');
                    if($ship_image3_yn == 1)
                    {
                        $ship_image3_nudge     = explode(",", $this->_getConfig('label_nudge_shiplogo3', '0,0',false,'label'));
                        $ship_image3_match    = trim(strtolower($this->_getConfig('shiplogo3_match', '', false,'label')));
                    }
                }    
            }    
         }
        else
        {
            $label_width     = 190;
            $label_height     = 168;
            $paper_margin     = explode(",", '22,30,22,30');               
            $label_padding     = explode(",", '5,5,5,5');
            $nudge_shipping_address = explode(",", $this->_getConfig('nudge_shipping_address', '0,0',true,'label'));
            $show_address_barcode_yn = $this->_getConfig('show_address_barcode_yn', 0, false,'label');
        }
        
        if($page_size != 'zebra')
        {
            $ship_image1_yn        = null;
            $ship_image1_nudge     = null;
            $ship_image1_match    = null;
            $ship_image2_yn        = null;
            $ship_image2_nudge     = null;
            $ship_image2_match    = null;
            $ship_image3_yn        = null;
            $ship_image3_nudge     = null;
            $ship_image3_match    = null;
        }
        
        $top_left_x                             = ($paper_margin[1]+$label_padding[1]);//40;
        $top_left_y                             = ($paper_height-($paper_margin[0]+$label_padding[0])); //1

        $available_width = $label_width - $label_padding[1] - $label_padding[3];

        $show_order_id_yn = $this->_getConfig('label_show_order_id_yn', 1, false,'label');
        $show_barcode_yn = $this->_getConfig('label_barcode', 0, false,'label');

        $font_family_label 			= $this->_getConfig('font_family_label', 'helvetica', false,'label',$store_id);
        $font_style_label 			= $this->_getConfig('font_style_label', 'regular', false,'label',$store_id);
        $font_size_label 			= $this->_getConfig('font_size_label', 15, false,'label',$store_id);
        $font_color_label 			= trim($this->_getConfig('font_color_label', 'Black', false,'label',$store_id));
    
		$non_standard_characters    = $this->_getConfig('non_standard_characters', 0, false,'general',$store_id);

		if($non_standard_characters == 'msgothic')
        {
            $font_family_label 			= 'msgothic';
            $non_standard_characters 	= 1;
        }
        elseif($non_standard_characters == 'tahoma')
        {
            $font_family_label 			= 'tahoma';
            $non_standard_characters 	= 1;
        }
        elseif($non_standard_characters == 'garuda')
        {
            $font_family_label 			= 'garuda';
            $non_standard_characters 	= 1;
        }
        elseif($non_standard_characters == 'sawasdee')
        {
            $font_family_label 			= 'sawasdee';
            $non_standard_characters 	= 1;
        }
        elseif($non_standard_characters == 'kinnari')
        {
            $font_family_label 			= 'kinnari';
            $non_standard_characters 	= 1;
        }
        elseif($non_standard_characters == 'purisa')
        {
            $font_family_label 			= 'purisa';
            $non_standard_characters 	= 1;
        }

        $override_address_format_yn = 1;
        $customer_email_yn          = $this->_getConfig('customer_email_yn', 0,false,'general');
        $customer_phone_yn          = $this->_getConfig('customer_phone_yn', 0,false,'general');
        $address_format             = $this->_getConfig('address_format', '', false,'general'); //col/sku
        $address_countryskip        = $this->_getConfig('address_countryskip', 0,false,'general');
        $return_address_yn          = $this->_getConfig('label_return_address_yn', 0,false,'label');  // 0,1,yesside             

        if($return_address_yn == 'yesside')
        {
            $font_family_return_label = $this->_getConfig('font_family_return_label_side', 'helvetica', false,'label',$store_id);
            $font_style_return_label  = $this->_getConfig('font_style_return_label_side', 'regular', false,'label',$store_id);
            $font_size_return_label   = $this->_getConfig('font_size_return_label_side', 9, false,'label',$store_id);
            $font_color_return_label  = trim($this->_getConfig('font_color_return_label_side', 'Black', false,'label',$store_id));                
        }
        elseif($return_address_yn == '1')
        {
            $font_family_return_label	= $this->_getConfig('font_family_return_label', 'helvetica', false,'label',$store_id);
            $font_style_return_label	= $this->_getConfig('font_style_return_label', 'regular', false,'label',$store_id);
            $font_size_return_label     = $this->_getConfig('font_size_return_label', 9, false,'label',$store_id);
            $font_color_return_label    = trim($this->_getConfig('font_color_return_label', 'Black', false,'label',$store_id));
        }
        $capitalize_label_yn        = $this->_getConfig('capitalize_label_yn', 0,false,'general',$store_id);   // o,usonly,1           

		$barcode_type        = $this->_getConfig('font_family_barcode', 'code128', false,'general',$store_id);
		switch ($barcode_type) 
		{
			case 'code128':
				$font_family_barcode 	= 'Code128bWin.ttf';
				break;

			case 'code39':
				$font_family_barcode 	= 'CODE39.ttf';
				
				break;	

			case 'code39x':
				$font_family_barcode 	= 'CODE39X.ttf';
				
				break;

			default:
				$font_family_barcode 	= 'Code128bWin.ttf';
				break;
		}
		
        $label_logo_yn           = $this->_getConfig('label_logo_yn2', 0,false,'label',$store_id);            
        // $label_logo_image          = $this->_getConfig('label_logo', '',false,'label');            
        $label_logo_xy            = explode(",", $this->_getConfig('label_nudgelogo', '0,0',false,'label',$store_id));     //0,0
        $label_logo_text_xy        = explode(",", $this->_getConfig('label_nudgelogo_text', '0,0',false,'label',$store_id));     //0,0

        $boldLastAddressLineYNDefault     = 'Y';
        $fontColorGrey                    = 0.6;
        $fontColorReturnAddressFooter     = 0.2;
        $boxBkgColorDefault                = 0.7;
        
        $red_bkg_color             = new Zend_Pdf_Color_Html('lightCoral');
        $grey_bkg_color            = new Zend_Pdf_Color_GrayScale(0.7);
        $dk_grey_bkg_color        = new Zend_Pdf_Color_GrayScale(0.3);//darkCyan
        $dk_cyan_bkg_color         = new Zend_Pdf_Color_Html('darkCyan');//darkOliveGreen
        $dk_og_bkg_color         = new Zend_Pdf_Color_Html('darkOliveGreen');//darkOliveGreen
        $black_color             = new Zend_Pdf_Color_Rgb(0,0,0);
        $grey_color             = new Zend_Pdf_Color_GrayScale(0.3);
        $greyout_color             = new Zend_Pdf_Color_GrayScale(0.6);
        $white_color             = new Zend_Pdf_Color_GrayScale(1);

        $boldLastAddressLineYN        = $boldLastAddressLineYNDefault;
        $font_size_titles             = 14;
        $boxBkgColor                = $boxBkgColorDefault;

        $split_supplier_yn_default     = 0;
        $supplier_attribute_default = 'supplier';
        $supplier_options_default     = 'filter';
        $supplier_login_default        = '';

        $pdf->pages[] = $page;
           // $current_y = $page->getHeight();
    
        $current_column = 0;
        $current_row     = 0;
        $address_count    = 0;
        $count            = 0;
        
        $current_x = $top_left_x;
        $current_y = $top_left_y;
        
        $temp_y = $current_y;
        $temp_x = $current_x;
        
    
            foreach ($orders as $orderSingle) 
            {
                $font_size_adjust = 0;
                    
                if($address_count > 0)
                {
                    // going top left down, then across
                    // if last label bigger than 1 label, start on fresh
                    if(($current_y - $temp_y) > ($label_height-$label_padding[0]-$label_padding[3])) $current_y = ($current_y - $label_height);
                    if(($temp_y - $label_height - $paper_margin[3]) < 0) 
                    {
                        $current_y = $top_left_y;
                        if(($current_x + $label_width + $paper_margin[2]) > $paper_width)
                        {
                            $page = $this->newPageLabel();
                            
                            $current_x = $top_left_x;
                        }
                        else {$current_x += $label_width;}
                    }
                    else {$current_y -= $label_height;}
                }
                $address_count ++;
                
                $temp_y = $current_y;
                $temp_x = $current_x;
                
                $order = Mage::getModel('sales/order')->load($orderSingle);        
                $order_id  = $order->getRealOrderId();
                
                // store-specific options
                $store_id                 = $order->getStore()->getId();
                
                $nudge_barcode     = explode(",", $this->_getConfig('nudge_barcode_letter', '0,0',true,'label',$store_id));
                
                if($return_address_yn == 'yesside')
                {
                    $return_address             = $this->_getConfig('label_return_address_side', '',false,'label',$store_id);    
                    
                    if($page_size == 'a4')
                    { 
                        $return_label_nudge_xy         = explode(",", $this->_getConfig('nudge_return_label_side_a4', '0,0',true,'label',$store_id));               
                        $nudge_barcode                 = explode(",", $this->_getConfig('nudge_barcode_a4', '0,0',true,'label',$store_id));
                    }
                    elseif($page_size == 'zebra')
                    { 
                        $return_label_nudge_xy         = explode(",", $this->_getConfig('nudge_return_label_side_zebra', '0,0',true,'label',$store_id));              
                        $return_label_nudge_xy[0] -= 230;
                        $return_label_nudge_xy[1] -= 210;              
                        $nudge_barcode                 = explode(",", $this->_getConfig('nudge_barcode_zebra', '0,0',true,'label',$store_id));
                        $nudge_barcode[0] += 10;
                    }
                    else
                    { 
                        $return_label_nudge_xy         = explode(",", $this->_getConfig('nudge_return_label_side', '0,0',true,'label',$store_id));               
                    }
                }
                elseif($return_address_yn == '1')
                {
                    $return_address             = $this->_getConfig('label_return_address', '',false,'label',$store_id);    

                    if($page_size == 'a4')
                    { 
                        $return_label_nudge_xy         = explode(",", $this->_getConfig('nudge_return_label_a4', '0,0',true,'label',$store_id));               
                        $nudge_barcode                 = explode(",", $this->_getConfig('nudge_barcode_a4', '0,0',true,'label',$store_id));
                    }
                    elseif($page_size == 'zebra')
                    {                         
                        $return_label_nudge_xy         = explode(",", $this->_getConfig('nudge_return_label_zebra', '0,0',true,'label',$store_id));               
                        $return_label_nudge_xy[0] -= 230;
                        $return_label_nudge_xy[1] -= 210;
                        $nudge_barcode                 = explode(",", $this->_getConfig('nudge_barcode_zebra', '0,0',true,'label',$store_id));
                        $nudge_barcode[0] += 10;
                    }
                    else
                    { 
                        $return_label_nudge_xy         = explode(",", $this->_getConfig('nudge_return_label_letter', '0,0',true,'label',$store_id));               
                    }
                }
                $itemsCollection =  $order->getAllVisibleItems();
                $customer_email = '';
                if($order->getCustomerEmail()) $customer_email = trim($order->getCustomerEmail());
                $customer_phone = '';
                if($order->getShippingAddress()->getTelephone()) $customer_phone = trim($order->getShippingAddress()->getTelephone());
            
                $shipping_address = array();
                $shipping_address['company'] = $order->getShippingAddress()->getCompany();
                $shipping_address['prefix'] = $order->getShippingAddress()->getPrefix();
                $shipping_address['suffix'] = $order->getShippingAddress()->getSuffix();
                $shipping_address['name'] = $order->getShippingAddress()->getName();
                $i = 0;
                while($i < 10)
                {
                    if($order->getShippingAddress()->getStreet($i) && !is_array($order->getShippingAddress()->getStreet($i)))
                    {
                        if(isset($shipping_address['street'])) $shipping_address['street'] .= ", \n";
                        else $shipping_address['street'] = '';
                        $shipping_address['street'] .= $order->getShippingAddress()->getStreet($i);
                    }
                    $i ++;
                }
                if($shipping_address['street'] != '') $shipping_address['street'] .= ',';
                
                $shipping_address['city'] = $order->getShippingAddress()->getCity();
                $shipping_address['postcode'] = strtoupper($order->getShippingAddress()->getPostcode());
                $shipping_address['region'] = $order->getShippingAddress()->getRegion();
                $shipping_address_country = Mage::app()->getLocale()->getCountryTranslation($order->getShippingAddress()->getCountryId());
                $shipping_address['country'] = $shipping_address_country;                    
                if(trim($address_countryskip) != '') $shipping_address['country'] = trim(str_ireplace($address_countryskip,'',$shipping_address['country']));
                $address_format_set = str_replace(array("\n",'<br />','<br/>',"\r"),'',$address_format);

                foreach($shipping_address as $key =>$value)
                {
                    $value = trim($value);
                    $key = trim($key);

                    $value = preg_replace('~\,$~','',$value);
                    $value = str_replace(',,',',',$value);
                    
                    if(($capitalize_label_yn == 1) || (($capitalize_label_yn == 'usonly') && (strtolower($shipping_address_country) == 'united states')))
                    {
                        $value = trim(strtoupper($value));
                        // remove line-end commas for USPS
                        if(strtolower($shipping_address_country) == 'united states') $value = preg_replace('~,$~','',$value);
                        $font_size_adjust = 2;
                    }
                    
                    if($value != '' && !is_array($value))
                    {                    
                        preg_match('~\{if '.$key.'\}(.*)\{\/if '.$key.'\}~Uis',$address_format_set,$if_contents);
                       
						if(isset($if_contents[1])) 
						{
							$if_contents[1] = str_replace('{'.$key.'}',$value,$if_contents[1]);
						}
						if(isset($if_contents[0]) && isset($if_contents[1]))
						{
							$address_format_set = str_replace($if_contents[0],$if_contents[1],$address_format_set);
						}
						
                        $address_format_set = str_replace('{'.$key.'}',$value,$address_format_set);
                    }
                    elseif(!is_array($value))
                    {
                        $address_format_set = preg_replace('~\{if '.$key.'\}(.*)\{/if '.$key.'\}~Uis','',$address_format_set);    
                        $address_format_set = str_replace('{'.$key.'}','',$address_format_set);
                    }    
                }
                 
                 
                $address_format_set = str_replace(array('||','|'),'|',trim($address_format_set));
                $address_format_set = str_replace(
                    array("\t",'    ','    ','    ','   ','  ',',.','.,','␣,',' ,',',,','ENGLAND'),
                    array(', ',', ',' ',' ',' ',' ',',',',',',',',',',',''),
                    trim($address_format_set));
                
                $address_format_set = str_replace('|,|','|',$address_format_set);
                $address_format_set = trim(str_replace('|',"\n",trim($address_format_set)));
                
                $address_format_set = str_ireplace(array('{if street}','{street}','{/if street}','{if street1}','{street1}','{/if street1}','{if street2}','{street2}','{/if street2}','{if street3}','{street3}','{/if street3}','{if street4}','{street4}','{/if street4}','{if street5}','{street5}','{/if street5}','{if city}','{city}','{/if city}'),'',$address_format_set);
                $address_format_set = str_replace("\n,\n","\n",$address_format_set);
                                
                $shippingAddressArray = explode("\n",$address_format_set);
                $count = (count($shippingAddressArray)-1);
        
                $addressLine = '';
                $line_height = (1*$font_size_label);
                
                $stop_address = FALSE;
                
                if($label_logo_yn == 1)
                {
                    //                         {
                    if ($order->getStoreId()) $store_id = $order->getStoreId();
                    else $store_id = null;
                    
                    $label_logo_image          = $this->_getConfig('label_logo', '',false,'label',$store_id);            
                    
                    if($label_logo_image)
                    {
                        $labellogo_path = Mage::getBaseDir('media') . '/moogento/pickpack/logo_label/' . $label_logo_image;

                        if (is_file($labellogo_path)) 
                        {    
                            $labellogo = Zend_Pdf_Image::imageWithPath($labellogo_path);    
                            
                            if($page_size == 'zebra') 
                            {
                                $height = $label_height;
                                $width  = $label_width;
                                
                                $x1 = 0;
                                $x2 = $width;
                                $y1 = 0;
                                $y2 = $height;
                            }
                            else
                            {
                                $height = ($label_height*0.9);
                                $width  = ($label_width*0.9);
                                
                                $x1 = ($current_x+$label_logo_xy[0]);
                                $x2 = ($current_x+$label_logo_xy[0]+$width);
                                $y1 = ($current_y+$label_logo_xy[1]-$height);
                                $y2 = ($current_y+$label_logo_xy[1]);
                            }
                            
                            $page->drawImage($labellogo, $x1, $y1, $x2, $y2);
                        }
                    }
                }
    
                if ($order->getStoreId()) $store = $order->getStoreId();
                else $store = null;
                $shipping_method     = clean_method($order->getShippingDescription(),'shipping');
                $haystack             = preg_replace("/[^\-\(\)\{\}\_a-z0-9\s]/", '', strtolower($shipping_method));
                
                if(isset($ship_image1_yn) && $ship_image1_yn == 1)
                {                        
                    $option_group         = 'label';
                    $box1_shown            = false;
                    $box2_shown            = false;
                    $box3_shown            = false;
                    $filename_folder    = '';
                    $sub_folder         = '';
                    $default_ship_image_x = 208;
                    $default_ship_image_y = 360;
                    $ship_image_width    = 155; // pt @ 300dpi
                    $ship_image_height    = 85; // pt @ 300dpi

                    if(strpos($haystack, $ship_image1_match) !== false)
                    {
                        $filename_folder     = 'label_shiplogo1';
                        $sub_folder         = 'shiplogo1';
                        $ship_image_nudge    = $ship_image1_nudge;
                    }
                    elseif(strpos($haystack, $ship_image2_match) !== false)
                    {
                        $filename_folder     = 'label_shiplogo2';
                        $sub_folder         = 'shiplogo2';
                        $ship_image_nudge    = $ship_image2_nudge;
                    }
                    elseif(strpos($haystack, $ship_image3_match) !== false)
                    {
                        $filename_folder     = 'label_shiplogo3';
                        $sub_folder         = 'shiplogo3';
                        $ship_image_nudge    = $ship_image3_nudge;
                    }
                                    
                    $packlogo_filename = Mage::getStoreConfig('pickpack_options/'.$option_group.'/'.$filename_folder, $store);
                    if($packlogo_filename)
                    {
                        // $packlogo_path = Mage::getStoreConfig('system/filesystem/media', $store) . '/moogento/pickpack/'.$sub_folder.'/' . $packlogo_filename;
                        $packlogo_path = Mage::getBaseDir('media') . '/moogento/pickpack/'.$sub_folder.'/' . $packlogo_filename;
                        
                        if (is_file($packlogo_path)) 
                        {    
                            $x1 = $default_ship_image_x + $ship_image_nudge[0] - ($ship_image_width/2); //$ship_image_nudge    = $ship_image1_nudge;
                            $x2 = $default_ship_image_x + $ship_image_nudge[0] + ($ship_image_width/2);
                            $y1 = $default_ship_image_y + $ship_image_nudge[1] - ($ship_image_height/2);
                            $y2 = $default_ship_image_y + $ship_image_nudge[1] + ($ship_image_height/2);
                            
                            $packlogo = Zend_Pdf_Image::imageWithPath($packlogo_path);            
                            $page->drawImage($packlogo, $x1, $y1, $x2, $y2);
                        }
                    }    
                    unset($packlogo_filename);
                    unset($packlogo);
                    unset($packlogo_path);
                }
                
                // }
                
                if($show_barcode_yn == 1)
                {
                    $barcode_font_size = 16;
                    $barcodeString = $this->convertToBarcodeString($order_id,$barcode_type);
                    $barcodeWidth = 1.35*$this->parseString($order_id,Zend_Pdf_Font::fontWithPath(dirname(__FILE__)  . '/' . $font_family_barcode), $barcode_font_size);
                    $page->setFillColor($white_color);
                    $page->setLineColor($white_color);
                    $page->drawRectangle(($temp_x + ($label_width*0.9) - $barcodeWidth - 5), ($temp_y+16), ($temp_x + ($label_width*0.9)), ($temp_y - 2));
                    $page->setFillColor(new Zend_Pdf_Color_RGB(0, 0, 0));
                    $page->setFont(Zend_Pdf_Font::fontWithPath(dirname(__FILE__)  . '/' . $font_family_barcode), $barcode_font_size);
                    $order_barcode_x = ($temp_x + ($label_width*0.9) - $barcodeWidth + $nudge_barcode[0]);
                    $order_barcode_y =  ($temp_y - 4 + $nudge_barcode[1]);
                    $page->drawText($barcodeString, $order_barcode_x, $order_barcode_y, 'CP1252');
                    $page->setFillColor($white_color);
                    $page->setLineColor($white_color);
                    $page->drawRectangle(($order_barcode_x - $barcodeWidth - 5), ($order_barcode_y-2), ($order_barcode_x + ($label_width*1)), ($order_barcode_y +($barcode_font_size/3)));
                }
                
                if($show_order_id_yn == 1)
                {
                    $this->_setFont($page, $font_style_label, ($font_size_label-2), $font_family_label, $non_standard_characters, $font_color_label);
                    if($page_size == 'zebra') $page->drawText('#'.$order_id, $temp_x, $temp_y+5, 'UTF-8');
                    else $page->drawText('#'.$order_id, $temp_x, $temp_y, 'UTF-8');
                    $temp_y -= ($line_height*0.4);
                    // $temp_y -= ($line_height*0.2);
                    // $page->setLineWidth(1);
                    //                     $page->setLineColor($black_color);
                    //                     $page->drawLine($temp_x, $temp_y, ($temp_x + ($label_width*0.9)), ($temp_y-1));
                    //                     $temp_y -= ($line_height*0.2);
                }
                $this->_setFont($page, $font_style_label, $font_size_label, $font_family_label, $non_standard_characters, $font_color_label);
                
				$i = 0;
				$line_height_top = (1.07*$font_size_label);
				$line_height_bottom = (1.05*$font_size_label);
				$i_space = 0;

				$shipping_line_count = (count($shippingAddressArray)-1);
				$line_addon=0;
				$token_addon = 0;
				
				// if($non_standard_characters != 1)
				// {
                $font_temp 	= Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
				// }
				// else $font_temp = Zend_Pdf_Font::fontWithPath(dirname(__FILE__)  . '/' . $font_family_label.'.ttf');
                $font_size_compare = $font_size_label;
                $line_width = $this->parseString('1234567890',$font_temp,$font_size_compare); // bigger = left
                $char_width = $line_width/10;
                $max_chars 	= round(($label_width*0.9)/$char_width);
    
                    foreach($shippingAddressArray as $i =>$value)
                    {
                        $skip 		= 0;                        
                        $line_bold 	= 0;
                        if($i == $shipping_line_count) 
                        {
                            $line_bold = 1;
                            $value 	= preg_replace('~,$~','',$value);
                        }
                        $value 		= trim($value);
                
                        $i_space 	= ($i_space+1);
                        if($i > 0) 
                        {
                            if((trim($shippingAddressArray[($i-1)])) == '') $i_space = ($i_space-1);
                        }

                        $this->_setFont($page, $font_style_label, ($font_size_label-$font_size_adjust), $font_family_label, $non_standard_characters, $font_color_label);
                        if($line_bold == 1) 
                        {
                            $this->_setFont($page, 'bold', ($font_size_label+2-$font_size_adjust), $font_family_label, $non_standard_characters, $font_color_label);
                            $line_addon = ($font_size_label*0.1);
                        }
                        
                        $value= utf8_wordwrap($value, $max_chars);
              
                        $address_line_x = $temp_x;
                        $address_line_y = $temp_y;
                        $returns_side_x = round($address_line_x + ($label_width*0.8));
                        $returns_side_y = ($address_line_y-12);

                        if($label_logo_yn == 1)
                        {
                            $address_line_x = ($temp_x + $label_logo_text_xy[0]);
                            $address_line_y = ($temp_y + $label_logo_text_xy[1]);                    
                        }
                        
                        // shipping address nudge
                        $address_line_x = $address_line_x + $nudge_shipping_address[0];
                        $address_line_y = $address_line_y + $nudge_shipping_address[1];
                        
                        $this_address_line_y = '';
                        $token = strtok($value, "\n");
                        while ($token != false) 
                        {
                            $this_address_line_y = ($address_line_y-($line_height_top*$i_space)-$line_addon-$token_addon);
                            $page->drawText(trim($token), $address_line_x, $this_address_line_y, 'UTF-8');
                            $token_addon += $font_size_label;
                            $token = strtok("\n");
                        }
                        $i_space = ($i_space-1);
                        $i ++;
                    }
                    $subheader_start = $this_address_line_y-($font_size_label*1);
                    $barcode_y = ($this_address_line_y-($line_height_top*$i_space)-$line_addon-$token_addon);
                    $barcode_x = $address_line_x;
                    
                    if($order->getShippingAddress()->getPostcode()) 
					{
						$zipcode = trim(strtoupper($order->getShippingAddress()->getPostcode()));
					}
					if($customer_phone_yn != 'no' && $customer_phone != '')
                    {
                        $i_space += 1;
                        $value 				= 'T: '.$customer_phone;
                        $line_addon=($font_size_label*0.5);                                
                        $address_line_x 	= $temp_x;
                        $address_line_y 	= $subheader_start;

                        $this->_setFont($page, 'regular', ($font_size_label-2), $font_family_label, $non_standard_characters, 'Gray');

                        if($customer_phone_yn != 'yesdetails') 
						{
							$page->drawText($value, $address_line_x, $address_line_y, 'UTF-8');
						}
                        $subheader_start -= ($font_size_label);
                        $barcode_y = $address_line_y;
                        $barcode_x = $address_line_x;
                    }

                    if($customer_email_yn != 'no' && $customer_email != '')
                    {
                        $i_space += 1;
                        $value = 'E: '.$customer_email;
                        $address_line_x = $temp_x;
                        $address_line_y = $subheader_start;                    
                        $this->_setFont($page, 'regular', ($font_size_label-2), $font_family_label, $non_standard_characters, 'Gray');
                        if($customer_email_yn != 'yesdetails') 
                        {
                            $page->drawText($value, $address_line_x, $address_line_y, 'UTF-8');
                            $subheader_start -= ($font_size_label);
                        }
                        
                        $barcode_y = $address_line_y;
                        $barcode_x = $address_line_x;
                    }
                    
                    // logo on side
                    $i = 0;
                    if($return_address_yn == 'yesside')
                    {
                        while($i < $address_count)
                        {
                            // return_label_nudge_xy
                            $temp_r_y = ($returns_side_y + $return_label_nudge_xy[1]);
                            $temp_r_x = ($returns_side_x + $return_label_nudge_xy[0]);
                            $return_address_lines = explode("\n", $return_address);

                            $this->_setFont($page, $font_style_return_label, $font_size_return_label, $font_family_return_label, $non_standard_characters, $font_color_return_label);
                            
                            $return_address_title_fontsize = 0;
                            $from_text = Mage::helper('sales')->__('From');
                            if(preg_match('~^'.$from_text.'~',$return_address_lines[0]))
                            {
                                $return_address_title_fontsize = -2;
                                if($font_size_return_label > 10) $return_address_title_fontsize = 2;
                                $this->_setFontRegular($page, ($font_size_return_label-$return_address_title_fontsize));  
                                $this->_setFont($page, $font_style_return_label, ($font_size_return_label-$return_address_title_fontsize), $font_family_return_label, $non_standard_characters, $font_color_return_label);
                                $page->drawText($return_address_lines[0], $temp_r_x, $temp_r_y, 'UTF-8');
                            }
                            else $page->drawText($return_address_lines[0], $temp_r_x, $temp_r_y, 'UTF-8');
                            
                            $this->_setFont($page, $font_style_return_label, $font_size_return_label, $font_family_return_label, $non_standard_characters, $font_color_return_label);
                            
                            $line_height = ($font_size_return_label-($return_address_title_fontsize*2));
                            foreach ($return_address_lines as $key =>$value)
                            {
                                if ($value!=='' && $key > 0)
                                {
                                    $page->drawText(trim(strip_tags($value)), $temp_r_x, ($temp_r_y-$line_height), 'UTF-8');
                                    $line_height += $font_size_return_label;
                                }
                            }
                            $i ++;
                        }
                    }
                    
                    if($show_address_barcode_yn == 1 && $zipcode != '')
                    {
                        $barcode_font_size = 28;
                        $barcode_y = ($subheader_start-($font_size_return_label/2)-($barcode_font_size/1.6));
                        $barcode_x = $address_line_x;
                        $barcodeString = $this->convertToBarcodeString($zipcode,$barcode_type);
                        $barcodeWidth = 1.35*$this->parseString($zipcode,Zend_Pdf_Font::fontWithPath(dirname(__FILE__)  . '/' . $font_family_barcode), $barcode_font_size);
                        $page->setLineColor($black_color);
                        $page->setFillColor($black_color);//new Zend_Pdf_Color_RGB(0, 0, 0));
                        $page->setFont(Zend_Pdf_Font::fontWithPath(dirname(__FILE__)  . '/' . $font_family_barcode), $barcode_font_size);
                        $page->drawText($barcodeString, $barcode_x, ($barcode_y - 4), 'CP1252');
                        $page->setFillColor($white_color);
                        $page->setLineColor($white_color);
                        $page->drawRectangle(($barcode_x - $barcodeWidth - 5), ($barcode_y-($barcode_font_size/6)), ($barcode_x + ($label_width*1)), ($barcode_y +($barcode_font_size/2)));
                    }
        }    
        
        $i = 0;
        if($return_address_yn === 1)
        {
            while($i < $address_count)
            {
                    // going top left down, then across
                    // if last label bigger than 1 label, start on fresh
            
                if(($current_y - $temp_y) > $label_height) $current_y = ($current_y - $label_height);
                if(($temp_y - $label_height) < 0) 
                {
                    $current_y = $top_left_y;
                    if(($current_x + $label_width) > $paper_width)
                    {
                        $page = $this->newPageLabel();
                        
                        $current_x = $top_left_x;
                    }
                    else {$current_x += $label_width;}
                }
                else {$current_y -= $label_height;}
                
                
                $temp_y = $current_y;
                $temp_x = $current_x; 
                
                // footer store address
                $this->_setFont($page, $font_style_return_label, ($font_size_return_label+2), $font_family_return_label, $non_standard_characters, $font_color_return_label);
                $page->drawText(Mage::helper('sales')->__('From').' :', $temp_x, $temp_y, 'UTF-8');
                $this->_setFont($page, $font_style_return_label, $font_size_return_label, $font_family_return_label, $non_standard_characters, $font_color_return_label);
                $line_height = 15;
                foreach (explode("\n", $return_address) as $value)
                {
                    if ($value!=='')
                    {
                        $page->drawText(trim(strip_tags($value)), $temp_x, ($temp_y-$line_height), 'UTF-8');    
                        $line_height = ($line_height + $font_size_return_label);
                    }
                }
                $i ++;
            }
        }
                            
        $this->_afterGetPdf();
        return $pdf;
    }

        
    /**
    getLabel Template - END
    *********************************************
    ************************************************/

/**
    getCSV_DHL_Easylog_Export - getCsvDhlEasylogExport - START
**/
/*    Order of the attributes:
    1. Sender-ID
    2. Process-ID
    3. Participation-ID
    4. Product-ID
    5. Service/Return
    6. title
    7. Name 1
    8. Name 2
    9. Street + No.
    10. Country
    11. ZIP
    12. City
    13. Customer-ID
    14. free (can be empty)
    15. free (can be empty)
    16. weight
    17. description (just for worldwide packages)
    18. free (can be empty)
    19. packing list id
    20. value of goods (can be empty)
    21. free (can be empty)
    22. client
    
*/
    public function getCsvDhlEasylogExport($orders=array(), $from_shipment = 'order')
    {

    /**
     * get store id
     */
    $store_id = Mage::app()->getStore()->getId();

    $csv_output ='';
    foreach ($orders as $orderSingle) 
    {
        $order = Mage::getModel('sales/order')->load($orderSingle);
        
        $row = array();
        // 1. Sender ID
        $row[] = 'x';
        // Process ID, Participation ID, Product-ID
        switch($order->getShippingAddress()->getCountry()){
            case 'DE':
                //2. Process-ID
                $row[] = '01';
                //3. Participation-ID
                $row[] = '10';
                // 4. Product-ID
                $row[] = '101';
                break;
            default:
                //Todo: Switch between worldwide and europe;
                // 2. Process-ID
                $row[] = '54';
                // 3. Participation-ID
                $row[] = '07';
                // 4. Product-ID
                $row[] = '5401';
                break;
        }
        // 5. Service/Return : Return-Label (active!)
        $row[] = '703';
        // 6. Title
        $row[] = '&-!';
        // 7. Name 1
        $row[] = $order->getShippingAddress()->getFirstname().' '.$order->getShippingAddress()->getLastname();
        // 8. Name 2 - in our case the company name
        $row[] = $order->getShippingAddress()->getCompany();        
        // 9. Street + No.
        $row[] = $order->getShippingAddress()->getStreet(1);    
        // 10. Country
        $row[] = $order->getShippingAddress()->getCountry();
        // 11. ZIP
        $row[] = strtoupper($order->getShippingAddress()->getPostcode());    
        // 12. City
        $row[] = $order->getShippingAddress()->getCity();
        // 13. Customer-ID
        $row[] = $order->getCustomerId();
        // 14. free (can be empty)
        $row[] = '&-!';
        // 15. free (can be empty)
        $row[] = '&-!';
        // 16. weight (default-value of 2kg for shoes)
        $row[] = '2,00';
        // 17. description
        switch($order->getShippingAddress()->getCountry()){
            case 'DE':
            // 17. description
                $row[] = 'x';
                break;
            default:
                //Todo: Switch between worldwide and europe;
                // 17. description
                $row[] = 'x';
                break;
        }    
        // 18. free (can be empty)
        $row[] = '&-!';
        // 19. packing list id
        $row[] = $order->getRealOrderId();
        // 20. value of goods
        $row[] = '&-!';
        // 21. free
        $row[] = '&-!';        
        // 22. client
        $row[] = 'x';                
            
                                
        $row_string = implode(';',$row);
        $row_string = utf8_decode($row_string);
        $csv_output .= str_replace('&-!','',$row_string);
        $csv_output .= "\n";
    }

    return $csv_output;
}

/**
    getCSV_DHL_Easylog_Export - getCsvDhlEasylogExport
    - END
**/

/**
    getCSV_orders - START
**/
    public function getCsvOrders($orders=array(), $from_shipment = 'order')
    {
	    $debug 					= 0;
	
	    $column_headers 		= '';
		$csv_output				= '';
	    $field_quotes			= '"';
	    $column_map 			= array();
		$custom_attributes 		= array();
		$row 					= array();
		
	    $address_format_default 	= '{if ship_company}{ship_company},{/if ship_company}
{if ship_name}{ship_name},{/if ship_name}
{if ship_streets}{ship_streets},{/if ship_streets}
{if ship_city}{ship_city},{/if ship_city}
{if ship_postcode}{ship_postcode} {/if ship_postcode}{if ship_region}{ship_region},{/if ship_region}
{ship_country}';
	    $address_format         = $this->_getConfig('address_format', $address_format_default, false,'csvorders'); //col/sku
	    
	    $address_countryskip    = $this->_getConfig('address_countryskip', 0,false,'general');
		
		
	    $column_separator 		= $this->_getConfig('csv_field_separator',',', false,'general'); 
	    $column_mapping_pre 	= trim($this->_getConfig('column_mapping_csvorders', '', false,'csvorders')); //col/sku
	    $column_mapping_pre 	= trim(str_replace(array("\n","\r","\t",';;;',';;'),';',$column_mapping_pre));
	    $column_mapping_pre 	= str_ireplace(array(':;'),':[ ];',$column_mapping_pre);
		$column_mapping_pre = preg_replace('~[;]$~','',$column_mapping_pre);

	    $column_mapping_array 	= explode(';',$column_mapping_pre);
	    foreach($column_mapping_array as $key => $value)
	    {
			$key = trim($key);
	        $column_mapping_sub_array = explode(':',$value);

	        if($key != '')
	        {
	            $key = trim($column_mapping_sub_array[0]);
	            if(isset($column_mapping_sub_array[1])) $value = trim($column_mapping_sub_array[1]);

	            $column_map[$key] = $value;

	  			// add custom columns to pull attribute info
				if ( (strpos($value, '%') === false) && (strpos($value, '[') === false) && ($value != '')) 
				{
					if(is_array($value)) $value = implode(',',$value);
					$custom_attributes[] = $value;
				}

	            $column_headers .= $field_quotes.$key.$field_quotes.$column_separator;
	        }

	        $key 	= '';
	        $value 	= '';
	    }

		// get rid of trailing comma
	    $column_headers = preg_replace('~[;,'.$column_separator.']$~',"\n",$column_headers);

	    $csv_output = $column_headers;

	    foreach ($orders as $orderSingle) 
	    {
	        $order 			= Mage::getModel('sales/order')->load($orderSingle);
        	$order_id 		= $order->getRealOrderId();
			$row[$order_id] = array();
	        
			$row[$order_id]['order_id'] = $order_id;
			   $row[$order_id]['order_date'] = '';
            if($order->getCreatedAtStoreDate()) 
            {
                $row[$order_id]['order_date']         = Mage::helper('core')->formatDate($order->getCreatedAtStoreDate(), 'short', false);
            }    

            /*
            $extra_order_info_array = $order->getPayment()->getAdditionalInformation();
            if(isset($extra_order_info_array['personalnumber'])) $row[$order_id]['personalnumber'] = $extra_order_info_array['personalnumber'];
            if(isset($extra_order_info_array['klarna_personalnumber']))
            {
                $row[$order_id]['personalnumber'] = $extra_order_info_array['klarna_personalnumber'];
            }
            else $row[$order_id]['personalnumber']     = '';
			*/
            
			$row[$order_id]['shipping_paid_plus_tax']= number_format($order->getShippingInclTax(),2); // number_format as well as round to show eg 2.00
			$row[$order_id]['shipping_paid'] 		= number_format($order->getShippingAmount(),2);
			$row[$order_id]['ship_method'] 			= clean_method($order->getShippingDescription(),'shipping');
			$row[$order_id]['payment_method'] 		= clean_method($order->getPayment()->getMethodInstance()->getTitle(),'payment');
            $row[$order_id]['order_status']			= $order->getStatus();
            $row[$order_id]['order_status_label']	= $order->getStatusLabel();
            $row[$order_id]['store_id']             = $order->getStore()->getId();
            $row[$order_id]['store']                = $order->getStore()->getGroup()->getName();
            $row[$order_id]['website']             	= $order->getStore()->getWebsite()->getName();

            if(trim($order->getCustomerId()) != '') $row[$order_id]['customer_id'] 		= trim($order->getCustomerId());
			else $row[$order_id]['customer_id'] = '';

            $row[$order_id]['ship_prefix'] 			= $order->getShippingAddress()->getPrefix();
            $row[$order_id]['ship_suffix'] 			= $order->getShippingAddress()->getSuffix();
            $row[$order_id]['ship_name']			= $order->getShippingAddress()->getName();
            $row[$order_id]['ship_firstname']		= $order->getShippingAddress()->getFirstname();
            $row[$order_id]['ship_lastname']		= $order->getShippingAddress()->getLastname();
			$row[$order_id]['ship_fullname']		= $order->getShippingAddress()->getPrefix().' '.$order->getShippingAddress()->getFirstname().' '.$order->getShippingAddress()->getLastname();
			if($order->getShippingAddress()->getPrefix() != '')
			{
				$row[$order_id]['ship_fullname']		= $order->getShippingAddress()->getPrefix().' '.$row[$order_id]['ship_fullname'];
			}
			if($order->getShippingAddress()->getSuffix() != '')
			{
				$row[$order_id]['ship_fullname']		= $row[$order_id]['ship_fullname'].' '.$order->getShippingAddress()->getSuffix();
			}
            $row[$order_id]['ship_company']			= $order->getShippingAddress()->getCompany();
            $row[$order_id]['ship_address'] 		= '';//trim(str_replace(array('|',"\n",$address_countryskip,',,'),',',implode(',',$this->_formatAddress($order->getShippingAddress()->format('text'))))); 
			$row[$order_id]['ship_address']			= preg_replace('~,$~','',$row[$order_id]['ship_address']);
            $row[$order_id]['ship_streets']			= '';
            if($order->getShippingAddress()->getStreetFull()) 
            {
                $row[$order_id]['ship_streets']     = $order->getShippingAddress()->getStreetFull();
            }
			$row[$order_id]['ship_street1']			= '';
            if($order->getShippingAddress()->getStreet(1)) 
            {
                $row[$order_id]['ship_street1']     = $order->getShippingAddress()->getStreet(1);
            }
            $row[$order_id]['ship_street2']         = '';
            if($order->getShippingAddress()->getStreet(2)) 
            {
                $row[$order_id]['ship_street2']     = $order->getShippingAddress()->getStreet(2);
            } 
            $row[$order_id]['ship_street3']         = '';
            if($order->getShippingAddress()->getStreet(3)) 
            {
                $row[$order_id]['ship_street3']     = $order->getShippingAddress()->getStreet(3);
            }
            $row[$order_id]['ship_street4']         = '';
            if($order->getShippingAddress()->getStreet(4)) 
            {
                $row[$order_id]['ship_street4']     = $order->getShippingAddress()->getStreet(4);
            }               

            $row[$order_id]['ship_city']			= $order->getShippingAddress()->getCity();
            $row[$order_id]['ship_region']			= $order->getShippingAddress()->getRegion();
            $row[$order_id]['ship_region_code']		= $order->getShippingAddress()->getRegionCode();
            $row[$order_id]['ship_postcode']		= strtoupper($order->getShippingAddress()->getPostcode());
            $row[$order_id]['ship_country_code']    = $order->getShippingAddress()->getCountry();//    = $shipping_address['country'];
            $row[$order_id]['ship_country'] = Mage::app()->getLocale()->getCountryTranslation($order->getShippingAddress()->getCountryId());                    
            $row[$order_id]['ship_region_filtered'] = '';
            if(trim(strtolower($row[$order_id]['ship_country'])) != 'us') 
            {
                $row[$order_id]['ship_region_filtered'] = $row[$order_id]['ship_region_code'];//'Y';
            }
            $row[$order_id]['ship_telephone']		= $order->getShippingAddress()->getTelephone();
            $row[$order_id]['ship_email']			= '';//trim($order->getCustomerEmail());

            $row[$order_id]['bill_prefix'] 			= $order->getBillingAddress()->getPrefix();
            $row[$order_id]['bill_suffix'] 			= $order->getBillingAddress()->getSuffix();
            $row[$order_id]['bill_name']			= $order->getBillingAddress()->getName();
            $row[$order_id]['bill_firstname']		= $order->getBillingAddress()->getFirstname();
            $row[$order_id]['bill_lastname']		= $order->getBillingAddress()->getLastname();
			$row[$order_id]['bill_fullname']		= $order->getBillingAddress()->getFirstname().' '.$order->getBillingAddress()->getLastname();
			if($order->getBillingAddress()->getPrefix() != '')
			{
				$row[$order_id]['bill_fullname']		= $order->getBillingAddress()->getPrefix().' '.$row[$order_id]['bill_fullname'];
			}
			if($order->getBillingAddress()->getSuffix() != '')
			{
				$row[$order_id]['bill_fullname']		= $row[$order_id]['bill_fullname'].' '.$order->getBillingAddress()->getSuffix();
			}
			
            $row[$order_id]['bill_company']			= $order->getBillingAddress()->getCompany();
        	$row[$order_id]['bill_address'] 		= trim(str_replace(array('|',$address_countryskip,',,'),',',implode(',',$this->_formatAddress($order->getBillingAddress()->format('pdf'))))); 
			$row[$order_id]['bill_address']			= preg_replace('~,$~','',$row[$order_id]['bill_address']);
            $row[$order_id]['bill_streets']			= '';
            if($order->getBillingAddress()->getStreetFull()) 
            {
                $row[$order_id]['bill_streets']     = $order->getBillingAddress()->getStreetFull();
            }
			$row[$order_id]['bill_street1']         = '';
            if($order->getBillingAddress()->getStreet(1)) 
            {
                $row[$order_id]['bill_street1']     = $order->getBillingAddress()->getStreet(1);
            }
            $row[$order_id]['bill_street2']         = '';
            if($order->getBillingAddress()->getStreet(2)) 
            {
                $row[$order_id]['bill_street2']     = $order->getBillingAddress()->getStreet(2);
            }     
            $row[$order_id]['bill_street3']         = '';
            if($order->getBillingAddress()->getStreet(2)) 
            {
                $row[$order_id]['bill_street3']     = $order->getBillingAddress()->getStreet(3);
            }
            $row[$order_id]['bill_street4']         = '';
            if($order->getBillingAddress()->getStreet(4)) 
            {
                $row[$order_id]['bill_street4']     = $order->getBillingAddress()->getStreet(4);
            }               
            $row[$order_id]['bill_city']			= $order->getBillingAddress()->getCity();
            $row[$order_id]['bill_region']			= $order->getBillingAddress()->getRegion();
            $row[$order_id]['bill_region_code']		= $order->getBillingAddress()->getRegionCode();
            $row[$order_id]['bill_postcode']		= strtoupper($order->getBillingAddress()->getPostcode());
            $row[$order_id]['bill_country_code']	= $order->getBillingAddress()->getCountry();
            $row[$order_id]['bill_country'] 		= Mage::app()->getLocale()->getCountryTranslation($order->getBillingAddress()->getCountryId());                    
            $row[$order_id]['bill_region_filtered'] = '';
            if(trim(strtolower($row[$order_id]['bill_country'])) != 'us') 
            {
                $row[$order_id]['bill_region_filtered'] = $row[$order_id]['bill_region_code'];//'Y';
            }
            $row[$order_id]['bill_telephone']		= $order->getBillingAddress()->getTelephone();
            $row[$order_id]['bill_email']			= trim($order->getCustomerEmail());

            $row[$order_id]['newsletter_subscription_status'] = '0';
            if(isset($row[$order_id]['bill_email']))
            {
                $readConnection = Mage::getSingleton('core/resource')->getConnection('core_read'); 
                $newsletter_sub_result = $readConnection->fetchAll("SELECT subscriber_status FROM newsletter_subscriber WHERE subscriber_email = '".$row[$order_id]['bill_email']."' LIMIT 1;");
                if(is_array($newsletter_sub_result) || !isset($newsletter_sub_result)) $newsletter_sub_result = 0;
                $row[$order_id]['newsletter_subscription_status'] = trim($newsletter_sub_result);
            }
            
            // process shipping address
            $address_format_this_order 	= $address_format;
			$address_format_pieces_pre 	= array();
			$address_pieces 			= array();
			$address_piece 				= '';
			preg_match_all('~\{(.+)\}~U',$address_format,$address_pieces_pre);
			$address_pieces = array_unique($address_pieces_pre[1]);			
			foreach($address_pieces as $address_piece)
			{
				$address_value = '';
				if(isset($row[$order_id][$address_piece]) && ($row[$order_id][$address_piece] != ''))
				{
					$address_value = str_replace("\n",', ',$row[$order_id][$address_piece]);
				}
				$address_format_this_order = str_ireplace('{'.$address_piece.'}',$address_value,$address_format_this_order);
			}
			$address_format_this_order = preg_replace('~\{(.*)}~U','',$address_format_this_order);
			$address_format_this_order = str_ireplace(array("\n",',,'),',',$address_format_this_order);
			$address_format_this_order = preg_replace('~,$~','',$address_format_this_order);
			$address_format_this_order = preg_replace('~^,~','',$address_format_this_order);
			$row[$order_id]['ship_address'] = $address_format_this_order;

            // order info
			$items 			= $order->getAllItems();                  
			$item_qty 		= 0;
			$order_qty 		= 0;
			$qty_shipped 	= 0;
			$item_weight	= 0;
			$order_weight	= 0;
			$shipping_weight= 0;
			
			foreach ($items as $item) 
			{
				// $item_qty = $item->getQty();
				// $item_weight = $item->getWeight();
				
				$qty_adjust = 0;
				$qty_shipped = $item->getQtyShipped();
				if($item->getQtyShipped() == 0) $qty_shipped = $item->getQtyToShip(); // maybe add these two together for multipart shipments?
				if($item->getProductType() == Mage_Catalog_Model_Product_Type::TYPE_BUNDLE) $qty_adjust = 1;
				if($item->getProductType() == Mage_Catalog_Model_Product_Type::TYPE_CONFIGURABLE) $qty_adjust = 1;

				$item_qty 		= $qty_shipped - $qty_adjust; 				
				$item_weight 	= $item->getWeight();
				
				$order_qty 		+= $item_qty; 
				$order_weight 	+= ($item_weight * $item_qty);
			}    
			             
            $row[$order_id]['qty']						= $order_qty;
            $row[$order_id]['qty_items']				= $order_qty; // maybe qty is more obvious tag...
            
 			// $shipping_weight 						= $order->getWeight(); // doesn't work
 			$shipping_weight							= $order_weight;
			$row[$order_id]['weight']					= $shipping_weight;
			$row[$order_id]['weight_kg_suffix']			= $shipping_weight.' kg';
			$row[$order_id]['weight_lb_suffix']			= $shipping_weight.' lb';
			$row[$order_id]['weight_kg_to_lb']			= round(($shipping_weight * '2.2046226'),2);
			$row[$order_id]['weight_lb_to_kg']			= round(($shipping_weight * '0.45359237'),2);
			$row[$order_id]['weight_kg_to_lb_suffix'] 	= round(($shipping_weight * '2.2046226'),2).' lb';
			$row[$order_id]['weight_lb_to_kg_suffix'] 	= round(($shipping_weight * '0.45359237'),2).' kg';

/*
// country-specific results like this :
	        switch($order->getShippingAddress()->getCountry()){
	            case 'DE':
	                //2. Process-ID
	                $row[] = '01';
	                //3. Participation-ID
	                $row[] = '10';
	                // 4. Product-ID
	                $row[] = '101';
	                break;
	            default:
	                //Todo: Switch between worldwide and europe;
	                // 2. Process-ID
	                $row[] = '54';
	                // 3. Participation-ID
	                $row[] = '07';
	                // 4. Product-ID
	                $row[] = '5401';
	                break;
	        }
*/
	    }

/**
	can sort $row here
*/ 
		foreach($row as $order_id => $field_value)
		{
			foreach($column_map as $column_header => $column_attribute)
			{
			    // if value needs filling
			    $attribute_base = strtolower(trim(str_replace('%','',$column_attribute)));
			    if(preg_match('~%~',$column_attribute))// && in_array($attribute_base,$permittable_values))
			    {
			        if(!isset($row[$order_id][$attribute_base])) $row[$order_id][$attribute_base] = '';
			        $csv_output .= $field_quotes.$row[$order_id][$attribute_base].$field_quotes.$column_separator;
			    }
			    elseif(preg_match('~\[~',$column_attribute))
			    {
			        $csv_output .= $field_quotes.str_replace(array('[',']'),'',$column_attribute).$field_quotes.$column_separator;
			    }
			    // elseif($attribute_base != '')
			    // 			    {
			    // 			        if(isset($sku_color[$order_id][$sku][$column_attribute]))
			    // 			        {
			    // 			            $csv_output .= $field_quotes.$sku_color[$order_id][$sku][$column_attribute].$field_quotes.$column_separator;
			    // 			        }
			    // 			        else $csv_output .= $field_quotes.$field_quotes.$column_separator;
			    // 			    }
			    else $csv_output .= $field_quotes.$field_quotes.$column_separator;
			}

			// get rid of trailing comma
		    $csv_output = preg_replace('~['.$column_separator.']$~',"\n",$csv_output);
		}
	    return $csv_output;
}

/**
    / getCSV orders - END
**/

 /**
   getCSVPickSeparated 2222222  Template - START
    ************************************************/

public function getCsvPickSeparated2($orders=array(), $from_shipment = 'order')
{
    $debug = 0;

    $total_quantity = 0;
    $total_cost = 0;
    
    $column_headers = '';
    $column_separator         = $this->_getConfig('csv_field_separator', ',', false,'general'); 
    $field_quotes             = '"';
    
    $column_map = array();
	$custom_attributes = array();

    $column_mapping_pre = trim($this->_getConfig('column_mapping', '', false,'csvpick')); //col/sku
    
    $column_mapping_pre = trim(str_replace(array("\n","\r","\t",';;;',';;'),';',$column_mapping_pre));
    $column_mapping_pre = str_ireplace(array(':;'),':[ ];',$column_mapping_pre);
    
    $column_mapping_array = explode(';',$column_mapping_pre);
    
    foreach($column_mapping_array as $key => $value)
    {
        $column_mapping_sub_array = explode(':',$value);
        
        if(trim($key) != '')
        {
            $key = trim($column_mapping_sub_array[0]);
            if(isset($column_mapping_sub_array[1])) $value = trim($column_mapping_sub_array[1]);
            
            $column_map[$key] = $value;
            
  			// add custom columns to pull attribute info
			if ( (strpos($value, '%') === false) && (strpos($value, '[') === false) && ($value != '')) {
				if(is_array($value)) $value = implode(',',$value);
				$custom_attributes[] = $value;
			}

            $column_headers .= $field_quotes.$key.$field_quotes.$column_separator;
        }
        
        $key = '';
        $value = '';
    }
        
    $column_headers = preg_replace('~[;,]$~',"\n",$column_headers);
    
    $csv_output = $column_headers;
        
    $configurable_names = $this->_getConfig('pickpack_configname_separated', 'simple', false,'picks'); //col/sku
    $configurable_names_attribute = trim($this->_getConfig('pickpack_configname_attribute_separated', '', false,'picks')); //col/sku
    if($configurable_names != 'custom') $configurable_names_attribute = '';
    
    $product_id 	= NULL; // get it's ID
    $stock 			= NULL;
    $sku_stock 		= array();
    $product_id		= NULL; // get it's ID
    $stock			= NULL;

    $options_yn_base 				= $this->_getConfig('separated_options_yn', 0, false,'picks'); // no, inline, newline
    $options_yn						= $this->_getConfig('separated_options_yn', 0, false,'picks'); // no, inline, newline
    if($options_yn_base == 0) $options_yn = 0;
    $pickpack_options_filter_yn 	= $this->_getConfig('separated_options_filter_yn', 0, false,'picks');
    $pickpack_options_filter     	= $this->_getConfig('separated_options_filter', 0, false,'picks');
    $pickpack_options_filter_array 	= array();
    if($pickpack_options_filter_yn == 0) $pickpack_options_filter = '';
    elseif(trim($pickpack_options_filter) != '')
    {
        $pickpack_options_filter_array = explode(',',$pickpack_options_filter);
        foreach($pickpack_options_filter_array as $key => $value)
        {
            $pickpack_options_filter_array[$key] = trim($value);
        }
    }
    $pickpack_options_count_filter_array = array();
    $pickpack_options_count_filter     = $this->_getConfig('separated_options_count_filter', 0, false,'picks');
    if($pickpack_options_filter_yn == 0) $pickpack_options_count_filter = '';
    elseif(trim($pickpack_options_count_filter) != '')
    {
        $pickpack_options_count_filter_array = explode(',',$pickpack_options_count_filter);
        foreach($pickpack_options_count_filter_array as $key => $value)
        {
            $pickpack_options_count_filter_array[$key] = trim($value);
        }
    }
    
    $skuXInc = 0;
    
    /**
     * get store id
     */
    $store_id = Mage::app()->getStore()->getId();

    $order_id_master = array();
    $sku_order_suppliers = array();
    $sku_shelving = array();
    $sku_shipping_address = array();
    $sku_order_id_options = array();
    $sku_bundle = array();
    $address_data = array();
    
    foreach ($orders as $orderSingle) 
    {
        $order = Mage::getModel('sales/order')->load($orderSingle);        
        $putOrderId = $order->getRealOrderId();
        $order_id  = $putOrderId;

            $if_contents = array();

            $address_data[$order_id]['order_date'] = '';
            $address_data[$order_id]['order_date_plus48h'] = '';
            if($order->getCreatedAtStoreDate()) 
            {
                $address_data[$order_id]['order_date']         = Mage::helper('core')->formatDate($order->getCreatedAtStoreDate(), 'short', false);
                //date('m/d/Y',$order->getCreatedAtStoreDate());
                //$address_data[$order_id]['order_date_plus48h'] = date('m/d/Y',($order->getCreatedAtStoreDate() + (60*60*48)) );
            }    
            
// echo '<br /><br />$order->getPayment()->getAdditionalInformation();: '.pre($order->getPayment()->getAdditionalInformation());

            $extra_order_info_array = $order->getPayment()->getAdditionalInformation();

            if(isset($extra_order_info_array['personalnumber'])) $address_data[$order_id]['personalnumber'] = $extra_order_info_array['personalnumber'];
            if(isset($extra_order_info_array['klarna_personalnumber']))
            {
                $address_data[$order_id]['personalnumber'] = $extra_order_info_array['klarna_personalnumber'];
            }
            else $address_data[$order_id]['personalnumber']     = '';

            $sku_shipping_method[$order_id]                     = clean_method($order->getShippingDescription(),'shipping');
            $address_data[$order_id]['shipping_description']     = $sku_shipping_method[$order_id];
            
            $paymentInfo     = $order->getPayment()->getMethodInstance()->getTitle();
            // $paymentInfo     = Mage::helper('payment')->getInfoBlock($order->getPayment())->setIsSecureMode(true)->toHtml();
            $payment_test     = clean_method($paymentInfo,'payment');
            
            $address_data[$order_id]['payment_method']             = $payment_test;//$payment_test;
            $address_data[$order_id]['order_status']             = $order->getStatus();//$_order->getStatusLabel()
            
            $address_data[$order_id]['store']                 = $order->getStore()->getGroup()->getName();
            $address_data[$order_id]['website']             = $order->getStore()->getWebsite()->getName();//->getStore()->getGroup()->getName();

            if(trim($order->getCustomerId()) != '' && !isset($address_data[$order_id]['customer_id']))
			{
				$address_data[$order_id]['customer_id'] 		= trim($order->getCustomerId());
			}
			else
			{
				$address_data[$order_id]['customer_id'] = '';
			}
            
            $address_data[$order_id]['ship-name']         = $order->getShippingAddress()->getName();
            $address_data[$order_id]['ship-firstname']         = $order->getShippingAddress()->getFirstname();
            $address_data[$order_id]['ship-lastname']         = $order->getShippingAddress()->getLastname();
            $address_data[$order_id]['ship-companyname']     = $order->getShippingAddress()->getCompany();
            $address_data[$order_id]['ship-street1']         = '';
            if($order->getShippingAddress()->getStreet(1)) 
            {
                $address_data[$order_id]['ship-street1']     = $order->getShippingAddress()->getStreet(1);
            }
            $address_data[$order_id]['ship-street2']         = '';
            if($order->getShippingAddress()->getStreet(2)) 
            {
                $address_data[$order_id]['ship-street2']     = $order->getShippingAddress()->getStreet(2);
            }                

            $address_data[$order_id]['ship-city']             = $order->getShippingAddress()->getCity();
            $address_data[$order_id]['ship-region']         = $order->getShippingAddress()->getRegion();
            $address_data[$order_id]['ship-region-code']     = $order->getShippingAddress()->getRegionCode();
            $address_data[$order_id]['ship-postcode']         = strtoupper($order->getShippingAddress()->getPostcode());
            $address_data[$order_id]['ship-country']         = $order->getShippingAddress()->getCountry();//    = $shipping_address['country'];
            $address_data[$order_id]['ship-region-filtered'] = '';
            if(trim(strtolower($address_data[$order_id]['ship-country'])) != 'us') 
            {
                $address_data[$order_id]['ship-region-filtered']     = $address_data[$order_id]['ship-region-code'];//'Y';
            }
            $address_data[$order_id]['ship-telephone']         = $order->getShippingAddress()->getTelephone();
            $address_data[$order_id]['ship-email']             = '';//trim($order->getCustomerEmail());
            
            //
            $address_data[$order_id]['bill-name']         = $order->getBillingAddress()->getName();
            $address_data[$order_id]['bill-firstname']         = $order->getBillingAddress()->getFirstname();
            $address_data[$order_id]['bill-lastname']         = $order->getBillingAddress()->getLastname();
            $address_data[$order_id]['bill-companyname']     = $order->getBillingAddress()->getCompany();
            $address_data[$order_id]['bill-street1']         = '';
            if($order->getBillingAddress()->getStreet(1)) 
            {
                $address_data[$order_id]['bill-street1']     = $order->getBillingAddress()->getStreet(1);
            }
            $address_data[$order_id]['bill-street2']         = '';
            if($order->getBillingAddress()->getStreet(2)) 
            {
                $address_data[$order_id]['bill-street2']     = $order->getBillingAddress()->getStreet(2);
            }                    
            $address_data[$order_id]['bill-city']             = $order->getBillingAddress()->getCity();
            $address_data[$order_id]['bill-region']         = $order->getBillingAddress()->getRegion();
            $address_data[$order_id]['bill-region-code']     = $order->getBillingAddress()->getRegionCode();
            $address_data[$order_id]['bill-postcode']         = strtoupper($order->getBillingAddress()->getPostcode());
            $address_data[$order_id]['bill-country']         = $order->getBillingAddress()->getCountry();//    = $shipping_address['country'];
            $address_data[$order_id]['bill-region-filtered'] = '';
            if(trim(strtolower($address_data[$order_id]['bill-country'])) != 'us') 
            {
                $address_data[$order_id]['bill-region-filtered']     = $address_data[$order_id]['bill-region-code'];//'Y';
            }
            $address_data[$order_id]['bill-telephone']         = $order->getBillingAddress()->getTelephone();
            $address_data[$order_id]['bill-email']             = trim($order->getCustomerEmail());
            
            $address_data[$order_id]['subscription_status'] = '0';
            if(isset($address_data[$order_id]['bill-email']))
            {
                $readConnection = Mage::getSingleton('core/resource')->getConnection('core_read'); 
                $newsletter_sub_result = $readConnection->fetchAll("SELECT subscriber_status FROM newsletter_subscriber WHERE subscriber_email = '".$address_data[$order_id]['bill-email']."' LIMIT 1;");
				if(is_array($newsletter_sub_result) || !isset($newsletter_sub_result)) $newsletter_sub_result = 0;
                $address_data[$order_id]['subscription_status'] = trim($newsletter_sub_result);                
            }
            
        if(!isset($order_id_master[$order_id])) $order_id_master[$order_id] = 0;
        
        $address_data[$order_id]['ddate'] = '';
        $address_data[$order_id]['dtime'] = '';
        $address_data[$order_id]['ddatetime'] = '';
        
        if(Mage::getResourceModel('ddate/ddate'))
        {
            $ddate = Mage::getResourceModel('ddate/ddate')->getDdateByOrder($order->getIncrementId());
            /*  $ddate is an array()   and delivery date and delivery time is one of
            elements of this array */

            $address_data[$order_id]['ddate'] = $ddate['ddate'];   /* return ddate. example : 2011-12-27 */
            $address_data[$order_id]['dtime'] = $ddate['dtime'] ;  /* return ddtime . Example : 3:00-7:00 */        
            $address_data[$order_id]['ddatetime'] = $ddate['ddate'].' '.$ddate['dtime'] ;  /* return ddtime . Example : 3:00-7:00 */        
        }
         
        $itemsCollection =  $order->getAllVisibleItems();//$order->getItemsCollection();
       
        if(!isset($productXInc)) $productXInc = 0;
    
        $product_build_item = array();
        $product_build = array();
        $coun = 1;

        foreach ($itemsCollection as $item)
        {            
            if($item->getProductType() == Mage_Catalog_Model_Product_Type::TYPE_CONFIGURABLE) 
            {
                // any products actually go thru here?
                $sku = $item->getProductOptionByCode('simple_sku');
                $product_id = Mage::getModel('catalog/product')->setStoreId($store_id)->getIdBySku($sku);
            } 
            else 
            {
                $sku = $item->getSku();
                $product_id = $item->getProductId(); // get it's ID            
            }    
        
            // if show options as counted groups
            if($options_yn == 1)
            {
                $full_sku = trim($item->getSku());    
                $parent_sku = preg_replace('~\-(.*)$~','',$full_sku);
                $sku = $parent_sku;    
                $product_build_item[] = $sku;//.'-'.$coun;    
                $product_build[$sku]['sku'] = $sku;            
                $product_sku = $sku;
                $product_build[$sku]['sku'] = $product_sku;        
            }
            else
            {
                // unique item id
                $product_build_item[] = $sku.'-'.$coun;    
                $product_build[$sku.'-'.$coun]['sku'] = $sku;            
                $product_sku = $sku;
                $sku = $sku.'-'.$coun;
                $product_build[$sku]['sku'] = $product_sku;
            }
            
            //         
            $options = $item->getProductOptions();
/*
    [options] => Array
            (
                [0] => Array
                    (
                        [label] => Styrka
                        [value] => -6.50
                        [print_value] => -6.50
                        [option_id] => 278
                        [option_type] => drop_down
                        [option_value] => 4152
                        [custom_view] => 
                    )

            )
    
*/
            $shelving = '';
            $supplier = '';
            $sku_colors_sizes = array();
            
            $attribute_array = array('color','size','style','siennastyle','season');
            
            // add in custom attributes to pull details
			if(is_array($custom_attributes))
			{
				foreach($custom_attributes as $value)
				{
					$attribute_array[] = $value;
				}
			}
			
            foreach($attribute_array as $key => $value)
            {
                $shelving_attribute = $value;
                $sku_color[$order_id][$sku][$shelving_attribute] = '';

                if(Mage::getModel('catalog/product')->load($product_id)->getData($shelving_attribute))
                {
                    $attributeValue = Mage::getModel('catalog/product')->load($product_id)->getData($shelving_attribute);
                
                    $attributeName = $shelving_attribute;
                    $product = Mage::getModel('catalog/product');
                    $collection = Mage::getResourceModel('eav/entity_attribute_collection')
                    ->setEntityTypeFilter($product->getResource()->getTypeId())
                    ->addFieldToFilter('attribute_code', $attributeName);

                    $attribute = $collection->getFirstItem()->setEntity($product->getResource());

                    $attributeOptions = $attribute->getSource()->getAllOptions(false);
                    if(!empty($attributeOptions))
                    {                        
                        $result = search($attributeOptions,'value',$attributeValue);
                
                        if(isset($result[0]['label'])) 
                        {
                            $sku_color[$order_id][$sku][$shelving_attribute] = preg_replace('/[^a-zA-Z0-9\s\.\-]/', '', $result[0]['label']);
                        }
                    }
                    else 
                    {
                        $sku_color[$order_id][$sku][$shelving_attribute] = preg_replace('/[^a-zA-Z0-9\s\.\-]/', '', $attributeValue);
                    }
                }                            
            }    

            
            /********************************************************/
            // qty in this order of this sku
            $qty = $item->getIsQtyDecimal() ? $item->getQtyOrdered() : (int) $item->getQtyOrdered();        
            $sqty = $item->getIsQtyDecimal() ? $item->getQtyShipped() : (int) $item->getQtyShipped();
            // total qty in all orders for this sku
            if(isset($sku_qty[$sku])) $sku_qty[$sku] = ($sku_qty[$sku]+$qty);
            else $sku_qty[$sku] = $qty;
            $total_quantity = $total_quantity + $qty;

            $cost = 0;
            if(isset($product)) $cost = ($qty*$product->getCost());
            $total_cost = $total_cost + $cost;

            $sku_master[$sku] = $sku;
            
            $price = $item->getPrice();
            
            $address_data[$sku]['sku_price'] = $price;
            
            if(isset($address_data[$order_id]['order_qty'])) $address_data[$order_id]['order_qty'] = ($address_data[$order_id]['order_qty']+$qty);
            else $address_data[$order_id]['order_qty'] = $qty;

            $address_data[$order_id]['order_price'] = (float)($order->getSubtotal());
            
            if(Mage::getModel('catalog/product')->setStoreId($store_id)->load($product_id) && $configurable_names == 'simple')
            {
                $_newProduct = Mage::getModel('catalog/product')->setStoreId($store_id)->load($product_id);  
                if($_newProduct->getData('name')) $sku_name[$sku] = $_newProduct->getData('name');
            }
            elseif($configurable_names == 'configurable') $sku_name[$sku] = $item->getName();
            elseif($configurable_names == 'custom' && $configurable_names_attribute != '')
            {
                $customname = '';
                
                if(Mage::getModel('catalog/product')->setStoreId($store_id)->load($product_id))
                {
                    $_newProduct = Mage::getModel('catalog/product')->setStoreId($store_id)->load($product_id);  
                    if($_newProduct->getData($configurable_names_attribute)) $customname = $_newProduct->getData(''.$configurable_names_attribute.'');
                }
                elseif($product->getData(''.$configurable_names_attribute.''))
                {
                    $customname = $product->getData($configurable_names_attribute);
                }
                else $customname = '';

                if(trim($customname) != '')
                {
                    if(Mage::getModel('catalog/product')->setStoreId($store_id)->load($product_id)->getAttributeText($configurable_names_attribute))
                    {
                        $customname = Mage::getModel('catalog/product')->setStoreId($store_id)->load($product_id)->getAttributeText($configurable_names_attribute);
                    }
                    elseif($product[$configurable_names_attribute]) $customname = $product[$configurable_names_attribute];
                    else $customname = '';
                }

                if(trim($customname) != '')
                {
                    if(is_array($customname)) $customname = implode(',',$customname);
                    $customname = preg_replace('~,$~','',$customname);
                }
                else $customname = '';
                
                 $sku_name[$sku] = $customname;
            }
            
            $address_data[$sku]['sku_name'] = $item->getName();//$sku_name[$sku];
            $address_data[$sku]['sku_name'] = preg_replace('/[^a-zA-Z0-9\.\s]/', '', $address_data[$sku]['sku_name']);
            
            if(isset($options['options']) && is_array($options['options']))
            {
                $i = 0;
                if(isset($options['options'][$i])) $continue = 1;
                while($continue == 1)
                {
                    $options_name_temp[$i] = trim(htmlspecialchars_decode($options['options'][$i]['label'].' : '.$options['options'][$i]['value']));
                    $options_name_temp[$i] = str_replace(array('select ','enter ','would you Like to ','please enter ','your '),'',$options_name_temp[$i]);
                    $options_name_temp[$i] = preg_replace('~\((.*)\)~i','',$options_name_temp[$i]);
                    
                    $options_name_temp_nolabel[$i] = trim(htmlspecialchars_decode($options['options'][$i]['value']));
                    $options_name_temp_nolabel[$i] = str_replace(array('select ','enter ','would you Like to ','please enter ','your '),'',$options_name_temp_nolabel[$i]);
                    $options_name_temp_nolabel[$i] = preg_replace('~\((.*)\)~i','',$options_name_temp_nolabel[$i]);
                        
                    $i ++;
                    $continue = 0;
                    if(isset($options['options'][$i])) $continue = 1;
                }
                
                $plus_options[$order_id][$sku] = implode('_',$options_name_temp);
                $plus_options_nolabel[$order_id][$sku] = implode('_',$options_name_temp_nolabel);
                $i             = 0;
                $continue     = 0;
                $opt_count     = 0;
                
                if(isset($options['options'][$i])) $continue = 1;
    
                $sku_order_id_options[$order_id][$sku] = array();
                
                while($continue == 1)
                {                    
                    if($i > 0) $sku_order_id_options[$order_id][$sku] .= ' ';
                    $sku_order_id_options[$order_id][$sku] .= htmlspecialchars_decode('[ '.$options['options'][$i]['label'].' : '.$options['options'][$i]['value'].' ]');
                    
                        // if show options as a group
                        if($options_yn != 0 && $opt_count == 0)
                        {
                            $full_sku     = trim($item->getSku());    
                            $parent_sku = preg_replace('~\-(.*)$~','',$full_sku);
                            $full_sku     = preg_replace('~^'.$parent_sku.'\-~','',$full_sku);
                            $options_sku_array = array();
                            $options_sku_array = explode('-',$full_sku);
                            if(!isset($options_sku_parent[$order_id])) $options_sku_parent[$order_id] = array();
                            if(!isset($options_sku_parent[$order_id][$sku])) $options_sku_parent[$order_id][$sku] = array();
                            
                            $opt_count = 0;
                            foreach ($options_sku_array as $k => $options_sku_single)
                            {    
                                if(!isset($options_sku_parent[$order_id][$sku][$options_sku_single])) $options_sku_parent[$order_id][$sku][$options_sku_single] = '';
                        
                                if(isset($options_name_temp[$opt_count])) $options_name[$order_id][$sku][$options_sku_single] = $options_name_temp[$opt_count];
                                
                                if(isset($options_sku[$order_id][$options_sku_single]) && (!in_array($options_sku_single,$pickpack_options_filter_array)))
                                {
                                    $options_sku[$order_id][$options_sku_single] = ($sku_qty[$sku] + $options_sku[$order_id][$options_sku_single]);
                                    $options_sku_parent[$order_id][$sku][$options_sku_single] = ($qty + $options_sku_parent[$order_id][$sku][$options_sku_single]);
                                }
                                elseif(!in_array($options_sku_single,$pickpack_options_filter_array))
                                {
                                    $options_sku[$order_id][$options_sku_single] = ($sku_qty[$sku]);
                                    $options_sku_parent[$order_id][$sku][$options_sku_single] = $qty;//($sku_qty[$sku]);
                                }

                                $opt_count ++;
                            }        
                            unset($options_name_temp);    
                        }

                    $i ++;
                    $continue = 0;
                    if(isset($options['options'][$i])) $continue = 1;
                }
            }
            unset($options_name_temp);

            $sku_stock[$sku] = $stock;
            
            if(isset($sku_order_id_qty[$order_id][$sku])){
                $sku_order_id_qty[$order_id][$sku] = ($sku_order_id_qty[$order_id][$sku]+$qty); 
                $sku_order_id_sqty[$order_id][$sku] = ($sku_order_id_sqty[$order_id][$sku]+$sqty); 
                $sku_order_id_sku[$order_id][$sku] = $product_sku; 
            }else{
                $sku_order_id_qty[$order_id][$sku] = $qty;
                $sku_order_id_sqty[$order_id][$sku] = $sqty; 
                $sku_order_id_sku[$order_id][$sku] = $product_sku; 
            } 

            if(!isset($max_qty_length)) $max_qty_length = 2;
            if(strlen($sku_order_id_qty[$order_id][$sku]) > $max_qty_length) $max_qty_length = strlen($sku_order_id_qty[$order_id][$sku]);
            if(strlen($sku_order_id_sqty[$order_id][$sku]) > $max_qty_length) $max_qty_length = strlen($sku_order_id_sqty[$order_id][$sku]);


            if(isset($split_supplier_yn) && $split_supplier_yn != 'no')
            {
                // if(!in_array($supplier,$sku_order_suppliers[$order_id])) $sku_order_suppliers[$order_id][] = $supplier;
                if(!isset($sku_order_suppliers[$order_id])) $sku_order_suppliers[$order_id][] = $supplier;
                elseif(!in_array($supplier,$sku_order_suppliers[$order_id])) $sku_order_suppliers[$order_id][] = $supplier;
            }
            $coun ++;
            
        }
        
        
        if(isset($sku_bundle[$order_id]) && is_array($sku_bundle[$order_id])) ksort($sku_bundle[$order_id]);
    }

    $processed_skus = array();
    
    if(isset($order_id_master) && is_array($order_id_master)) ksort($order_id_master);
    if(isset($sku_order_id_qty) && is_array($sku_order_id_qty)) ksort($sku_order_id_qty);
    if(isset($sku_master) && is_array($sku_master)) ksort($sku_master);
    if(isset($supplier_master) && is_array($supplier_master)) ksort($supplier_master);
    $supplier_previous         = '';
    $supplier_item_action     = '';


    // roll_orderID
    foreach($order_id_master as $order_id =>$value)
    {    
        foreach($sku_order_id_qty[$order_id] as $sku =>$qty)
        {            
            unset($csv_data);
            $sku_addon = '';
            $max_qty_length_display = 0;
            $display_sku = '';
            $display_sku = htmlspecialchars_decode($sku_order_id_sku[$order_id][$sku]);
    
            $csv_data['qty']                 = $qty;
            $csv_data['sku']                 = $display_sku;
            
            $linker                         = '';
            if($plus_options[$order_id][$sku] != '') $linker = '_';
            
            $csv_data['sku_plus_options']     = $display_sku.$linker.$plus_options[$order_id][$sku];
            $csv_data['sku_plus_options_nolabel'] = $display_sku.$linker.$plus_options_nolabel[$order_id][$sku];
            $csv_data['product_name']         = $address_data[$sku]['sku_name'];
            $csv_data['sku_price']             = round($address_data[$sku]['sku_price'],2);
            $csv_data['order_price']         = round($address_data[$order_id]['order_price'],2);
            $csv_data['order_qty']             = $address_data[$order_id]['order_qty'];
            $csv_data['description']         = trim($item->getDescription());
            $csv_data['short_description']     = trim($item->getShortDescription());
            $csv_data['website']             = $address_data[$order_id]['website'];
            $csv_data['store']                 = $address_data[$order_id]['store'];
            $csv_data['order_id']             = $order_id;
            
            if(!isset($csv_data['order_sku_count_pre'][$order_id][$sku])) $csv_data['order_sku_count_pre'][$order_id][$sku] = 1;
            else $csv_data['order_sku_count_pre'][$order_id][$sku] ++;
            $csv_data['order_sku_count']     = $order_id.'_'.$csv_data['sku'];
            if($csv_data['order_sku_count_pre'][$order_id][$sku] > 1) $csv_data['order_sku_count'] .= '_'.$csv_data['order_sku_count_pre'][$order_id][$sku];
                        
            $csv_data['subscription_status']= $address_data[$order_id]['subscription_status'];
            $csv_data['personalnumber']     = $address_data[$order_id]['personalnumber'];
            $csv_data['order_status']         = $address_data[$order_id]['order_status'];
            $csv_data['payment_method']     = $address_data[$order_id]['payment_method'];
            $csv_data['shipping_description'] = $address_data[$order_id]['shipping_description'];
            $csv_data['customer_id']         = $address_data[$order_id]['customer_id'];
            $csv_data['order_date']         = $address_data[$order_id]['order_date'];
            $csv_data['order_date_plus48h'] = $address_data[$order_id]['order_date_plus48h'];

            $csv_data['ddate']                 = $address_data[$order_id]['ddate'];
            $csv_data['dtime']                 = $address_data[$order_id]['dtime'];
            $csv_data['ddatetime']             = $address_data[$order_id]['ddatetime'];

            $csv_data['ship-name']             = $address_data[$order_id]['ship-name'];
            $csv_data['ship-firstname']     = $address_data[$order_id]['ship-firstname'];
            $csv_data['ship-lastname']         = $address_data[$order_id]['ship-lastname'];
            $csv_data['ship-companyname']     = $address_data[$order_id]['ship-companyname'];
            $csv_data['ship-street1']         = $address_data[$order_id]['ship-street1'];
            $csv_data['ship-street2']         = $address_data[$order_id]['ship-street2'];
            $csv_data['ship-city']             = $address_data[$order_id]['ship-city'];
            $csv_data['ship-region']         = $address_data[$order_id]['ship-region'];
            $csv_data['ship-region-code']     = $address_data[$order_id]['ship-region-code'];
            $csv_data['ship-postcode']         = $address_data[$order_id]['ship-postcode'];
            $csv_data['ship-country']         = $address_data[$order_id]['ship-country'];
            $csv_data['ship-region-filtered'] = $address_data[$order_id]['ship-region-filtered'];
            $csv_data['ship-telephone']     = $address_data[$order_id]['ship-telephone'];
        
            $csv_data['bill-name']             = $address_data[$order_id]['bill-name'];
            $csv_data['bill-firstname']     = $address_data[$order_id]['bill-firstname'];
            $csv_data['bill-lastname']         = $address_data[$order_id]['bill-lastname'];
            $csv_data['bill-companyname']     = $address_data[$order_id]['bill-companyname'];
            $csv_data['bill-street1']         = $address_data[$order_id]['bill-street1'];
            $csv_data['bill-street2']         = $address_data[$order_id]['bill-street2'];
            $csv_data['bill-city']             = $address_data[$order_id]['bill-city'];
            $csv_data['bill-region']         = $address_data[$order_id]['bill-region'];
            $csv_data['bill-region-code']     = $address_data[$order_id]['bill-region-code'];
            $csv_data['bill-postcode']         = $address_data[$order_id]['bill-postcode'];
            $csv_data['bill-country']         = $address_data[$order_id]['bill-country'];
            $csv_data['bill-region-filtered'] = $address_data[$order_id]['bill-region-filtered'];
            $csv_data['bill-telephone']     = $address_data[$order_id]['bill-telephone'];
            $csv_data['bill-email']         = $address_data[$order_id]['bill-email'];
        
            // custom mucking about
            /*
            if(preg_match('~UPS~',$address_data[$order_id]['shipping_description']))
                        {
                            $address_data[$order_id]['shipping_description_filtered']     = 'UPS';
                            $address_data[$order_id]['billing_option_filtered']         = 'Prepaid';
                            $address_data[$order_id]['ship_service_filtered']             = 'ups ground - residential';
                            $csv_data['shipping_description_filtered']                     = $address_data[$order_id]['shipping_description_filtered'];
                            $csv_data['billing_option_filtered']                         = $address_data[$order_id]['billing_option_filtered'];
                            $csv_data['ship_service_filtered']                             = $address_data[$order_id]['ship_service_filtered'];
                        }
                        else
                        {
                            $address_data[$order_id]['shipping_description_filtered']     = 'Fedex';
                            $address_data[$order_id]['billing_option_filtered']         = 'Sender';
                            $address_data[$order_id]['ship_service_filtered']             = 'fedex ground - residential';
                            $csv_data['shipping_description_filtered']                     = $address_data[$order_id]['shipping_description_filtered'];
                            $csv_data['billing_option_filtered']                         = $address_data[$order_id]['billing_option_filtered'];
                            $csv_data['ship_service_filtered']                             = $address_data[$order_id]['ship_service_filtered'];
                        }*/
            
            foreach($column_map as $column_header => $column_attribute)
            {
                // if value needs filling
                $attribute_base = strtolower(trim(str_replace('%','',$column_attribute)));
                if(preg_match('~%~',$column_attribute))// && in_array($attribute_base,$permittable_values))
                {
                    if(!isset($csv_data[$attribute_base])) $csv_data[$attribute_base] = '';
                    $csv_output .= $field_quotes.$csv_data[$attribute_base].$field_quotes.$column_separator;
                }
                elseif(preg_match('~\[~',$column_attribute))
                {
                    $csv_output .= $field_quotes.str_replace(array('[',']'),'',$column_attribute).$field_quotes.$column_separator;
                }
                elseif($attribute_base != '')
                {
                    if(isset($sku_color[$order_id][$sku][$column_attribute]))
                    {
                        $csv_output .= $field_quotes.$sku_color[$order_id][$sku][$column_attribute].$field_quotes.$column_separator;
                    }
                    else $csv_output .= $field_quotes.$field_quotes.$column_separator;
                }
                else $csv_output .= $field_quotes.$field_quotes.$column_separator;
            }
            $csv_output .= "\n";
        }// end roll_SKU    
    }// end roll_Order

    return $csv_output;
        
    /**
    getCSVPickseparated2 222222222 Template - END
    *********************************************
    ************************************************/
}



 /**
   getCSVPickCombined  Template - START
    ************************************************/

public function getCsvPickCombined($orders=array(), $from_shipment = 'order', $manifest_or_picklist = 'picklist')
{
    $debug                             = 0;
    $total_quantity                 = 0;
    $total_cost                     = 0;
    $column_headers                 = '';
    // $column_separator                 = ',';
    $column_separator               = $this->_getConfig('csv_field_separator', ',', false,'general'); 
    $csv_field_separator         	= $column_separator;
    
    $field_separator                 = '"';
    $column_separator_headers         = $column_separator;//',';
    $column_map                     = array();
    $group_manifest_by_category_yn     = 0;
    $cost_multiplier                 = 1;
    $cost_base_to_display_rate        = 1;
    $cost_round                     = 0;
    $weight_round                     = 0;
    $is_excel                         = 0;
    $skuXInc                         = 0;
    $store_id                         = Mage::app()->getStore()->getId();
    $order_id_master                 = array();
    $sku_shelving                     = array();
    $sku_shipping_address             = array();
    $sku_order_id_options             = array();
    $sku_bundle                     = array();
    $address_data                     = array();
    $sku_stock                         = array();
    $product_id                     = NULL;
    $stock                             = NULL;
    $key                             = '';
    $value                             = '';
    
    $cost_prefix                     = trim($this->_getConfig('cost_prefix', '', false,'csvmanifestcombined'));
    $column_mapping_pre             = $this->_getConfig('column_mapping', '', false,'csvpickcombined');
    $configurable_names             = $this->_getConfig('name_display_choice', 'simple', false,'csvpickcombined');
    $configurable_names_attribute     = trim($this->_getConfig('name_display_choice_attribute_separated', '', false,'csvpickcombined'));
    
    
    $sku_order_id_qty                = array();
    $combo_sku_order_id_qty            = array();
    $combo_category_qty                = array();
    
    /**
    cargo manifest csv/xml    
    */
    if($manifest_or_picklist == 'manifest')
    {
        $store_id = 0;//$order->getStore()->getId();
        
        $is_excel                     = $this->_getConfig('is_excel_yn', 0, false,'csvmanifestcombined');
        $column_mapping_pre_a         = $this->_getConfig('pre_cells', '', false,'csvmanifestcombined');
        $column_mapping_pre_a         = str_replace(array('"',',','][','[',']'),array('""','','"'.$column_separator_headers.'"','"','"'),$column_mapping_pre_a);
        $date_format                  = str_replace(',',' ',$this->_getConfig('date_format', '', false,'general',$store_id));
        $column_mapping_pre_a         = str_replace('%date%',date($date_format,time()),$column_mapping_pre_a);
        $column_mapping_pre_a         = '{b}'.$column_mapping_pre_a ."\n".'" "'."\n";
        $column_mapping_pre           = $this->_getConfig('column_mapping', '', false,'csvmanifestcombined');
        $category_translation         = $this->_getConfig('category_translation', '', false,'csvmanifestcombined');
        $group_manifest_by_category_yn = $this->_getConfig('group_manifest_by_category_yn', 1, false,'csvmanifestcombined',$store_id);
    
        if($group_manifest_by_category_yn == 1) 
        {
            $column_mapping_pre     = $this->_getConfig('column_mapping_grouped_cats', '', false,'csvmanifestcombined');
        }
        $cost_multiplier            = $this->_getConfig('cost_multiplier', 1, false,'csvmanifestcombined');
        $cost_base_to_display_rate  = $this->_getConfig('cost_base_to_display_rate', 1, false,'csvmanifestcombined');
        $cost_round                 = $this->_getConfig('cost_round', 0, false,'csvmanifestcombined');
        $weight_round               = $this->_getConfig('weight_round', 2, false,'csvmanifestcombined');
        $weight_multiplier          = $this->_getConfig('weight_multiplier', 1, false,'csvmanifestcombined');
        $configurable_names         = $this->_getConfig('name_display_choice', 'simple', false,'csvmanifestcombined');
        $configurable_names_attribute = trim($this->_getConfig('name_display_choice_attribute_separated', '', false,'csvmanifestcombined'));
    }
    
    if($configurable_names != 'custom') 
    {
        $configurable_names_attribute = '';    
    }


    $column_mapping_pre             = trim(str_ireplace(array("\n","\r","\t"),'',$column_mapping_pre));
    $column_mapping_array             = explode(';',$column_mapping_pre);
    foreach($column_mapping_array as $key => $value)
    {
        $column_mapping_sub_array     = explode(':',$value);
        
        if(trim($key) != '')
        {
            $key                     = trim($column_mapping_sub_array[0]);
            if(isset($column_mapping_sub_array[1])) 
            {
                $value                 = trim($column_mapping_sub_array[1]);
            }
            $column_map[$key]         = $value;
            
            if($is_excel == 1) 
            {
                if(preg_match('~product_category~',$value)) $column_headers .= '{merge}';                
                $column_headers .= $field_separator.'{b}'.$key.$field_separator.$column_separator;
            }
            else $column_headers .= $field_separator.$key.$field_separator.$column_separator;
        }
        unset($key);
        unset($value);
    }
    
    if(($manifest_or_picklist == 'manifest') && isset($category_translation))
    {
        $category_translation             = trim(str_ireplace(array("\n","\r","\t"),'',$category_translation));
        $category_translation_array     = explode(';',$category_translation);
        foreach($category_translation_array as $key => $value)
        {
            $category_translation_sub_array     = explode(':',$value);
        
            if(trim($key) != '')
            {
                $key                     = trim(strtolower($category_translation_sub_array[0]));
                if(isset($category_translation_sub_array[1])) 
                {
                    $value                 = trim($category_translation_sub_array[1]);
                }
                $category_map[$key]     = $value;
            }
            unset($key);
            unset($value);
        }
    }
        
    $box_number                        = 1;
    $column_headers                 = preg_replace('~,$~','',trim(str_replace(',,',',',$column_headers)));
    $csv_output_start                 = $column_headers."\n";    
    
    // $csv_output[$box_number]        = $csv_output_start.'"{b}Box #'.$box_number.'"'."\n";;
    //

    foreach ($orders as $orderSingle) 
    {
        $order                 = Mage::getModel('sales/order')->load($orderSingle);        
        $putOrderId         = $order->getRealOrderId();
        $order_id              = $putOrderId;
        $itemsCollection     = $order->getAllVisibleItems();//$order->getItemsCollection();    
        $product_build_item = array();
        $product_build         = array();
        $order_status        = $order->getStatus();
        $box_number            = preg_replace('~[^0-9]~','', $order_status);

        if(!is_numeric($box_number)) $box_number = 1;

        if(!isset($csv_output[$box_number])) $csv_output[$box_number] = '"{h2-i}Box #'.$box_number.'"'."\n".$csv_output_start;

        $coun                 = 1;
        foreach ($itemsCollection as $item)
        {            
            if($item->getProductType() == Mage_Catalog_Model_Product_Type::TYPE_CONFIGURABLE) 
            {
                // any products actually go thru here?
                $sku = $item->getProductOptionByCode('simple_sku');
                $product_id = Mage::getModel('catalog/product')->setStoreId($store_id)->getIdBySku($sku);
            } 
            else 
            {
                $sku = $item->getSku();
                $product_id = $item->getProductId(); // get it's ID            
            }    
        
            $product         = Mage::getModel('catalog/product')->load($product_id);
            # Get product's category collection object
            $catCollection     = $product->getCategoryCollection();
            # export this collection to array so we could iterate on it's elements
            $categs         = $catCollection->exportToArray();
            $categsToLinks     = array();
            # Get categories names
            foreach($categs as $cat)
            {
                $categsToLinks [] = Mage::getModel('catalog/category')->load($cat['entity_id'])->getName();
            }
            foreach($categsToLinks as $ind=>$cat)
            {
                if(isset($category_map[strtolower($cat)])) $cat = $category_map[strtolower($cat)];
                if(!empty($category_label)) $category_label = $category_label.', '.$cat;
                else $category_label = $cat;
            }
            $address_data[$sku]['category'] = $category_label;
            unset($category_label);
        
            // unique item id
            $product_build_item[]         = $sku.'-'.$coun;    
            $product_build[$sku.'-'.$coun]['sku'] = $sku;            
            $product_sku                 = $sku;
            $sku                         = $sku.'-'.$coun;
            $product_build[$sku]['sku'] = $product_sku;

            $shelving             = '';
            $supplier             = '';
            $sku_colors_sizes     = array();
            $category_cost         = array();
            
            $attribute_array     = array('color','size','style','cost','season');
            foreach($attribute_array as $key => $value)
            {
                if (isset($shelving_attribute)) {
                    $sku_color[$product_sku][$shelving_attribute] = '';
                }

                if(Mage::getModel('catalog/product')->load($product_id)->getData($value))
                {
                    $attributeValue = Mage::getModel('catalog/product')->load($product_id)->getData($value);
                    $product         = Mage::getModel('catalog/product');
                    $collection     = Mage::getResourceModel('eav/entity_attribute_collection')
                    ->setEntityTypeFilter($product->getResource()->getTypeId())
                    ->addFieldToFilter('attribute_code', $value);

                    $attribute             = $collection->getFirstItem()->setEntity($product->getResource());
                    $attributeOptions     = $attribute->getSource()->getAllOptions(false);
                    if(!empty($attributeOptions))
                    {                        
                        $result = search($attributeOptions,'value',$attributeValue);
                
                        if(isset($result[0]['label'])) 
                        {
                            $sku_color[$product_sku][$value] = preg_replace('/[^a-zA-Z0-9\s\.\-]/', '', $result[0]['label']);
                        }
                    }
                    else 
                    {
                        $sku_color[$product_sku][$value] = preg_replace('/[^a-zA-Z0-9\s\.\-]/', '', $attributeValue);
                    }
                }
            }    

            /********************************************************/
            // qty in this order of this sku
            $qty = $item->getIsQtyDecimal() ? $item->getQtyOrdered() : (int) $item->getQtyOrdered();        
            // total qty in all orders for this sku
            if(isset($sku_qty[$sku])) $sku_qty[$sku] = ($sku_qty[$sku]+$qty);
            else $sku_qty[$sku] = $qty;
            $total_quantity     = $total_quantity + $qty;

            $cost                 = 0;
            if(isset($product)) 
            {
                $cost             = ($qty*$product->getCost());
            }
            $total_cost         = $total_cost + $cost;
            $sku_master[$sku]     = $sku;        
                
            $price                 = $item->getPrice();
            $address_data[$product_sku]['sku_price'] = $price;
            
            if(isset($address_data['order_qty'])) $address_data['order_qty'] = ($address_data['order_qty']+$qty);
            else $address_data['order_qty'] = $qty;

            $address_data['order_price'] = (float)($order->getSubtotal());
            
            if(Mage::getModel('catalog/product')->setStoreId($store_id)->load($product_id) && $configurable_names == 'simple')
            {
                $_newProduct = Mage::getModel('catalog/product')->setStoreId($store_id)->load($product_id);  
                if($_newProduct->getData('name')) $sku_name[$sku] = $_newProduct->getData('name');
            }
            elseif($configurable_names == 'configurable') $sku_name[$sku] = $item->getName();
            elseif($configurable_names == 'custom' && $configurable_names_attribute != '')
            {
                $customname = '';
                
                if(Mage::getModel('catalog/product')->setStoreId($store_id)->load($product_id))
                {
                    $_newProduct = Mage::getModel('catalog/product')->setStoreId($store_id)->load($product_id);  
                    if($_newProduct->getData($configurable_names_attribute)) $customname = $_newProduct->getData(''.$configurable_names_attribute.'');
                }
                elseif($product->getData(''.$configurable_names_attribute.''))
                {
                    $customname = $product->getData($configurable_names_attribute);
                }
                else $customname = '';

                if(trim($customname) != '')
                {
                    if(Mage::getModel('catalog/product')->setStoreId($store_id)->load($product_id)->getAttributeText($configurable_names_attribute))
                    {
                        $customname = Mage::getModel('catalog/product')->setStoreId($store_id)->load($product_id)->getAttributeText($configurable_names_attribute);
                    }
                    elseif($product[$configurable_names_attribute]) $customname = $product[$configurable_names_attribute];
                    else $customname = '';
                }

                if(trim($customname) != '')
                {
                    if(is_array($customname)) $customname = implode(',',$customname);
                    $customname = preg_replace('~,$~','',$customname);
                }
                else $customname = '';
                
                 $sku_name[$sku] = $customname;
            }
            
            $address_data[$product_sku]['sku_name'] = $sku_name[$sku];//$item->getName();
            $address_data[$product_sku]['sku_name'] = preg_replace('/[^a-zA-Z0-9\.\s]/', '', $address_data[$product_sku]['sku_name']);
            
            $sku_stock[$sku]     = $stock;
            $real_sku             = $product_build[$sku]['sku'];
            
            if(isset($sku_order_id_qty[$box_number][$real_sku])){
                $sku_order_id_qty[$box_number][$real_sku] += $qty;
                $combo_sku_order_id_qty[$real_sku] += $qty;
                // $sku_order_id_sqty[$real_sku] += $sqty;
                $sku_order_id_sku[$real_sku] = $product_sku;
            }else{
                $sku_order_id_qty[$box_number][$real_sku] = $qty;
                $combo_sku_order_id_qty[$real_sku] = $qty;
                // $sku_order_id_sqty[$real_sku] = $sqty; 
                $sku_order_id_sku[$real_sku] = $product_sku; 
            } 
            
            $product_category = $address_data[$real_sku]['category'];
            
            if(isset($category_qty[$box_number][$product_category][$real_sku])){
                $category_qty[$box_number][$product_category][$real_sku] += $qty;
                $combo_category_qty[$product_category][$real_sku] += $qty;
                // $category_sqty[$product_category][$real_sku] += $sqty;
            }else{
                $category_qty[$box_number][$product_category][$real_sku] = $qty;
                $combo_category_qty[$product_category][$real_sku] = $qty;
                // $category_sqty[$product_category][$real_sku] = $sqty; 
            }
            
            if(!isset($address_data[$box_number][$product_sku]['sku_cost'])) $address_data[$box_number][$product_sku]['sku_cost'] = 0;
            if(!isset($address_data[$box_number][$product_sku]['sku_weight'])) $address_data[$box_number][$product_sku]['sku_weight'] = 0;

            // category
            if($item->getData('cost') || $item->getData('base_cost') || (isset($sku_color) && isset($sku_color[$real_sku]['cost'])))
            {        
                $unit_cost = 0;
                
                if($item->getData('cost') && $item->getData('cost') > 0) $unit_cost = $item->getData('cost');
                elseif($item->getData('base_cost') && $item->getData('base_cost') > 0) $unit_cost = $item->getData('base_cost');
                elseif($sku_color[$real_sku]['cost']) $unit_cost = ($sku_color[$real_sku]['cost']/10000);
                
                if(isset($unit_cost)) $unit_cost = ($cost_multiplier * $cost_base_to_display_rate * $unit_cost);

                $address_data[$box_number][$product_sku]['sku_cost'] = $unit_cost;
            }
            
            if($item->getWeight())
            {        
                $unit_weight = 0;
                
                if($item->getWeight() && $item->getWeight() > 0) $unit_weight = $item->getWeight();
                
                if(isset($unit_weight) && isset($weight_multiplier)) $unit_weight = ($weight_multiplier * $unit_weight);

                $address_data[$box_number][$product_sku]['sku_weight'] = $unit_weight;
            }
            $coun ++;            
        }
        
        if(isset($sku_bundle) && is_array($sku_bundle)) ksort($sku_bundle);
    }
        
    if(isset($sku_order_id_qty) && is_array($sku_order_id_qty)) ksort($sku_order_id_qty);
    
    $supplier_previous         = '';
    $supplier_item_action     = '';
    $csv_output_product_list = '';
    $processed_skus = array();
    
    if($group_manifest_by_category_yn == 0)
    {
        foreach($sku_order_id_qty as $box_number => $sku_qty_array)
        {
            unset($csv_output_product_list);
            foreach($sku_qty_array as $sku =>$qty)
            {
                unset($csv_data);
                $sku_addon = '';
                $max_qty_length_display = 0;
                $display_sku = '';
                $display_sku = htmlspecialchars_decode($sku_order_id_sku[$sku]);        

                $csv_data['qty']                 = $qty;
                $csv_data['sku']                 = $display_sku;
                $csv_data['product_category']     = str_replace(',',' +',@$address_data[$sku]['category']);
                $csv_data['product_name']         = @$address_data[$sku]['sku_name'];//@$product_name;
                $csv_data['average_unit_weight'] = round(@$address_data[$sku]['sku_weight'],2);
                $csv_data['total_weight']         = round((@$address_data[$sku]['sku_weight']*$qty),2);
                $csv_data['sku_price']             = round(@$address_data[$sku]['sku_price'],2);
                $csv_data['sku_cost']             = round(@$address_data[$sku]['sku_cost'],2);
                $csv_data['average_unit_cost']     = round(@$address_data[$sku]['sku_cost'],2);
                $csv_data['total_cost']         = round((@$address_data[$sku]['sku_cost']*$qty),2);
                $csv_data['total_price']         = round((@$address_data[$sku]['sku_price'] * $qty),2);
                $csv_data['order_price']         = round(@$address_data['order_price'],2);
                $csv_data['order_qty']             = @$address_data['order_qty'];
                $csv_data['description']         = trim($item->getDescription());
                $csv_data['short_description']     = trim($item->getShortDescription());
                $csv_data['website']             = @$address_data['website'];
                $csv_data['store']                 = @$address_data['store'];
                $csv_data['order_id']             = $order_id;
        
                $csv_output_product_list        = '';
            
                foreach($column_map as $column_header => $column_attribute)
                {
                    // if value needs filling
                    $attribute_base = strtolower(trim(str_replace('%','',$column_attribute)));
                    if(preg_match('~%~',$column_attribute))
                    {
                        if(!isset($csv_data[$attribute_base])) $csv_data[$attribute_base] = '';
                        $csv_output_product_list .= $field_separator.$csv_data[$attribute_base].$field_separator.$column_separator;
                    }
                    elseif(preg_match('~\[~',$column_attribute))
                    {
                        $csv_output_product_list .= $field_separator.str_replace(array('[',']'),'',$column_attribute).$field_separator.$column_separator;
                    }
                    else 
                    {
                        if(isset($sku_color[$sku][$column_attribute]))
                        {
                            $csv_output_product_list .= $field_separator.$sku_color[$sku][$column_attribute].$field_separator.$column_separator;
                        }
                        else $csv_output_product_list .= $column_separator;
                    }
                }
                $csv_output_product_list = preg_replace('~,$~','',$csv_output_product_list)."\n";
            }// end roll_sku
            $csv_output[$box_number] .= $csv_output_product_list;
            
        } // end roll box
        
    }// end if group by category == 0
    else
    {
        $_cat_qty         = array();
        $_cat_cost         = array();
        $sku_qty         = array();
        $grand_total     = array();
        $sku_addon         = '';
        $max_qty_length_display = 0;
        $grand_total['cost']     = 0;
        $grand_total['qty']     = 0;
        unset($csv_data);
        $csv_data                 = array();
        $csv_data['total_cost'] = 0;
        $super_grand_total         = array();
        $super_grand_total['qty']     = 0;
        $super_grand_total['cost']     = 0;
        $combo_cat_cost                = array();
        $combo_cat_qty                = array();
        $csv_output[99]                = ''; //combo
        
        foreach($category_qty as $box_number => $sku_qty_array)
        {
            $_cat_qty[$box_number] = array();
            
            foreach($sku_qty_array as $cat_name => $sku_qty)
            {
            
                foreach($sku_qty as $cat_sku => $cat_sku_qty)
                {
                    if(isset($_cat_qty[$box_number][$cat_name])) $_cat_qty[$box_number][$cat_name] += $cat_sku_qty;
                    else $_cat_qty[$box_number][$cat_name] = $cat_sku_qty;
                    
                    //combo
                    if(isset($_cat_qty[99][$cat_name])) $_cat_qty[99][$cat_name] += $cat_sku_qty;
                    else $_cat_qty[99][$cat_name] = $cat_sku_qty;
        
            /**
            Could make this commented out but an option, so that it shows each boxes specific weights and costs, instead of the averages
            */
            /*
                    if(isset($_cat_cost[$box_number][$cat_name]) && isset($address_data[$box_number][$cat_sku]['sku_cost']) && isset($cat_sku_qty)) 
                                {
                                    $_cat_cost[$box_number][$cat_name] += ($address_data[$box_number][$cat_sku]['sku_cost']*$cat_sku_qty);
                                }
                                elseif(isset($address_data[$box_number][$cat_sku]['sku_cost']) && isset($cat_sku_qty)) 
                                {
                                    $_cat_cost[$box_number][$cat_name] = ($address_data[$box_number][$cat_sku]['sku_cost']*$cat_sku_qty);
                                }
                                
                                if(isset($_cat_weight[$box_number][$cat_name]) && isset($address_data[$box_number][$cat_sku]['sku_weight']) && isset($cat_sku_qty)) 
                                {
                                    $_cat_weight[$box_number][$cat_name] += ($address_data[$box_number][$cat_sku]['sku_weight']*$cat_sku_qty);
                                }
                                elseif(isset($address_data[$box_number][$cat_sku]['sku_weight']) && isset($cat_sku_qty)) 
                                {
                                    $_cat_weight[$box_number][$cat_name] = ($address_data[$box_number][$cat_sku]['sku_weight']*$cat_sku_qty);
                                }*/
            
                    
                    //combo
                    if(isset($_cat_cost[99][$cat_name]) && isset($address_data[$box_number][$cat_sku]['sku_cost']) && isset($cat_sku_qty)) 
                    {
                        $_cat_cost[99][$cat_name] += ($address_data[$box_number][$cat_sku]['sku_cost']*$cat_sku_qty);
                    }
                    elseif(isset($address_data[$box_number][$cat_sku]['sku_cost']) && isset($cat_sku_qty)) 
                    {
                        $_cat_cost[99][$cat_name] = ($address_data[$box_number][$cat_sku]['sku_cost']*$cat_sku_qty);
                    }
                    
                    if(isset($_cat_weight[99][$cat_name]) && isset($address_data[$box_number][$cat_sku]['sku_weight']) && isset($cat_sku_qty)) 
                    {
                        $_cat_weight[99][$cat_name] += ($address_data[$box_number][$cat_sku]['sku_weight']*$cat_sku_qty);
                    }
                    elseif(isset($address_data[$box_number][$cat_sku]['sku_weight']) && isset($cat_sku_qty)) 
                    {
                        $_cat_weight[99][$cat_name] = ($address_data[$box_number][$cat_sku]['sku_weight']*$cat_sku_qty);
                    }
                }
            }
        }

        // put compilation at end, to get correct grand totals
        ksort($_cat_qty);

        foreach($_cat_qty as $box_number => $sku_qty_array)
        {
            $csv_output_product_list     = '';
            $grand_total['cost']        = 0;
            $grand_total['qty']            = 0;
            
            foreach($sku_qty_array as $_cat_name => $cat_qty)
            {
                reset($csv_data);
                $csv_data['qty']                 = $cat_qty;
                $csv_data['product_category']     = '{merge}'.str_replace(',',' +',$_cat_name);
                // use average value for all items in this category
                if(isset($_cat_cost[99][$_cat_name])) $csv_data['total_cost'] = round($_cat_cost[99][$_cat_name],$cost_round);
                // elseif(isset($_cat_cost[$box_number][$_cat_name])) $csv_data['total_cost'] = round($_cat_cost[$box_number][$_cat_name],$cost_round);
                $csv_data['average_unit_cost']    = round(($csv_data['total_cost']/$_cat_qty[99][$_cat_name]),$cost_round);
                // flip back to make total cost = qty * rounded unit cost
                $csv_data['total_cost']            = round(($csv_data['average_unit_cost']*$csv_data['qty']),$cost_round);
            
                if(isset($_cat_weight[99][$_cat_name])) $csv_data['total_weight'] = round($_cat_weight[99][$_cat_name],$weight_round);
                // elseif(isset($_cat_weight[$box_number][$_cat_name])) $csv_data['total_weight'] = round($_cat_weight[$box_number][$_cat_name],$weight_round);
                $csv_data['average_unit_weight']    = round(($csv_data['total_weight']/$_cat_qty[99][$_cat_name]),$weight_round);
                // flip back to make total weight = qty * rounded unit weight
                $csv_data['total_weight']            = round(($csv_data['average_unit_weight']*$csv_data['qty']),$weight_round);
                
                $grand_total['cost'] += $csv_data['total_cost'];
                $grand_total['qty'] += $csv_data['qty'];
            
                foreach($column_map as $column_header => $column_attribute)
                {
                    $currency_prefix = '';
                    if(preg_match('~cost~i',$column_header)) $currency_prefix = '{rt}'.$cost_prefix .' ';
                    if(preg_match('~weight~i',$column_header)) $currency_prefix = '{rt}';
                
                    // if value needs filling
                    $attribute_base = strtolower(trim(str_replace('%','',$column_attribute)));
                    if(preg_match('~%~',$column_attribute))
                    {
                        if(!isset($csv_data[$attribute_base])) $csv_data[$attribute_base] = '';
                        $csv_output_product_list .= $field_separator.$currency_prefix.$csv_data[$attribute_base].$field_separator.$column_separator;
                    }
                    elseif(preg_match('~\[~',$column_attribute))
                    {
                        $csv_output_product_list .= $field_separator.$currency_prefix.str_replace(array('[',']'),'',$column_attribute).$field_separator.$column_separator;
                    }
                    else 
                    {
                        if(isset($sku_color[$sku][$column_attribute]))
                        {
                            $csv_output_product_list .= $field_separator.$currency_prefix.$sku_color[$sku][$column_attribute].$field_separator.$column_separator;
                        }
                        else $csv_output_product_list .= $column_separator;
                    }
                }

                $csv_output_product_list = preg_replace('~,$~','',$csv_output_product_list)."\n";
            }
            $csv_output[$box_number] .= $csv_output_product_list;
            
            if($box_number != 99)
            {
                $csv_output[$box_number] .= "\n".'" "," ","{merge}{b-rt}Total Value Of Goods:","{b-rt}'.$cost_prefix .' '.$grand_total['cost'].'"';
                $csv_output[$box_number] .= "\n".'" "," ","{merge}{b-rt}Total Qty:","{b-rt}'.$grand_total['qty'].'"';
            
                $super_grand_total['qty'] += $grand_total['qty'];
                $super_grand_total['cost'] += $grand_total['cost'];
            }
            
        }

        $csv_output_complete = $column_mapping_pre_a.'{h2}{merge2}PACKING LIST';
        ksort($csv_output);
        foreach($csv_output as $box_number => $box_contents)
        {
            if($box_number != 99) $csv_output_complete .= "\n\n".$csv_output[$box_number];
        }
        
        $csv_output_complete .= "\n\n\n".'{h2}{merge2}CLASSIFICATION SUMMARY'."\n\n".$csv_output_start;//.$csv_output_product_list."\n";
        
        $csv_output[99] .= "\n".'" "," ","{merge}{b-rt}Total Value Of Goods:","{b-rt}'.$cost_prefix .' '.$super_grand_total['cost'].'"';
        $csv_output[99] .= "\n".'" "," ","{merge}{b-rt}Total Qty:","{b-rt}'.$super_grand_total['qty'].'"';
        
        $csv_output_complete .= $csv_output[99];
        
        // print_r($csv_output_complete);exit;
        
        // $csv_output_product_list_box = '" ",'.str_replace("\n","\n".'" ",',$csv_output_end);
        // $column_headers_box = '"{b}Box #",'.$column_headers;
        
        // $csv_output_product_list = '" ",'.str_replace("\n","\n".'" ",',$csv_output_product_list);
        // $column_headers = '" ",'.$column_headers;

        
        /**
            If Excel...
        */        
        if($is_excel == 1)
        {
                require 'lib/php-export-data.class.php';

                // 'browser' tells the library to stream the data directly to the browser.
                // other options are 'file' or 'string'
                $fileName = 'combined-shipping-manifest_'.Mage::getSingleton('core/date')->date('Y-m-d_H').'.xml';
                $exporter = new ExportDataExcel('browser', $fileName);
                $exporter->initialize(); // starts streaming data to web browser
            
                $csv_output_array = explode("\n",$csv_output_complete);
                foreach($csv_output_array as $key => $csv_line)
                {
                    $exporter->addRow(explode(',',str_replace(array('\"','"',"\n"),array("'",'',''),$csv_line)));
                }
                $exporter->finalize();
                exit;
        }
        else
        {
            $csv_output_complete = str_replace(array('{right}','{left}','{rt}','{lt}','{b-rt}','{b-lt}','{b}','{u}','{i}','{ub}','{ubi}','{h1}','{h2}','{h1-i}','{h2-i}','{merge}','{merge2}','{merge3}'),'',$csv_output_complete);
        }
    }
    
    if($manifest_or_picklist != 'manifest')
    {
        // ie order-combined csv, not cargo manifest
        $csv_output_complete = $column_headers."\n".$csv_output_product_list;
    }
    
    if(!isset($csv_output_complete)) $csv_output_complete = '';
        
    return $csv_output_complete;
        
    /**
    getCSVPickCombined 222222222 Template - END
    *********************************************
    ************************************************/
}

    public function getPdfPicklist($order){
        
        
        /**
         * get store id
         */
        $store_id = Mage::app()->getStore()->getId();

        $this->_beforeGetPdf();
        $this->_initRenderer('invoices');

        $pdf = new Zend_Pdf();
        $this->_setPdf($pdf);
        $style = new Zend_Pdf_Style();
        $this->_setFontBold($page, 10);
        /***********************************************
        * PickList Template - START
        ************************************************/ 
            
        //foreach ($invoices as $invoice)
        {              
           
            if ($order->getStoreId()) {
                Mage::app()->getLocale()->emulate($order->getStoreId());
            }
            
            $page_size = $this->_getConfig('page_size', 'a4', false,'general');

            if($page_size == 'letter') 
            {
                $page = $pdf->newPage(Zend_Pdf_Page::SIZE_LETTER);
                $page_top = 770;$padded_right = 587;
            }
            elseif($page_size == 'a4') 
            {
                $page = $pdf->newPage(Zend_Pdf_Page::SIZE_A4);
                $page_top = 820;$padded_right = 570;
            }
            elseif($page_size == 'a5landscape') 
            {
                $page = $pdf->newPage('596:421');                    
                $page_top = 395;$padded_right = 573;
            }
            
            $pdf->pages[] = $page;           
            
                        
            /***********************************************************
            * CONFIGURATIONS
            ***********************************************************/
            
            // all y values must be positive, all x positive
            // bottom left is 0,0
            
            ## DEFAULT VALUES
            $columnYNudgeDefault        = 600;
            $barcodeXYDefault           = '468,800';
            $customerIdXYDefault        = '390,705';
            $orderDateXYDefault         = '160,755';
            $orderIdXYDefault           = '40,755';
            $addressXYDefault           = '40,705';  
            $addressFooterXYDefault     = '50,105'; // * new
            $returnAddressFooterXYDefault = '320,105'; // * new
            
            $cutoff_noDefault           = 10;
            $font_size_returnaddressDefault= 9;

            $skuXDefault                = 300;
            $qtyXDefault                = 40;
            $productXDefault            = 80;
            $colorXDefault              = 345;
            $sizeXDefault               = 430;
            $priceXDefault              = 505; 
           
            $colorAttributeNameDefault     = 'color';
            $sizeAttributeNameDefault    = 'size';

            $show_return_logo_ynDefault    = 'Y';
            $return_logo_XYDefault        = '312,115';
            
            // hard-coded (not an option in config yet)
            
            $showPriceYNDefault            = 'N';
            $showColorYNDefault            = 'N';
            $showSizeYNDefault            = 'N';
            $boldLastAddressLineYNDefault = 'Y';
            $fontColorGrey                = 0.8;
            $fontColorReturnAddressFooter = 0.2;
            //
            $showPriceYN                = $showPriceYNDefault;
            $showColorYN                = $showColorYNDefault;
            $showSizeYN                    = $showSizeYNDefault;
            $boldLastAddressLineYN        = $boldLastAddressLineYNDefault;
             $font_size_returnaddresstop     = 8;
            $font_size_titles             = 14;

            $columnYNudge           = $this->_getConfig('pack_column', $columnYNudgeDefault);
            $showBarCode            = $this->_getConfig('pickpack_packbarcode', 0, false); 
                         
            $barcodeXY              = explode(",", $this->_getConfig('pack_barcode', $barcodeXYDefault));               
            $orderDateXY            = explode(",", $this->_getConfig('pack_order', $orderDateXYDefault));
            $customerIdXY           = explode(",", $this->_getConfig('pack_cid', $customerIdXYDefault));
            $orderIdXY              = explode(",", $this->_getConfig('pack_oid', $orderIdXYDefault));                        

            $color_attribute_name     = $this->_getConfig('color_attribute_name', $colorAttributeNameDefault,false);
            $size_attribute_name     = $this->_getConfig('size_attribute_name', $sizeAttributeNameDefault,false);
            
            $customerNameXY         = explode(",", $this->_getConfig('pack_customer', $customerNameXYDefault)); 
            $addressXY                 = explode(",", $this->_getConfig('pack_customeraddress', $addressXYDefault));
            $addressFooterXY         =  explode(",", $this->_getConfig('footer_address', $addressFooterXYDefault));
            
            $cutoff_no              = $this->_getConfig('pack_noofitems', $cutoff_noDefault, false);
            $font_size_overall       = 9;
            $font_size_productline   = 9;
            $font_size_returnaddress = $font_size_returnaddressDefault;
            $font_size_shipaddress   = 13;
            
			$barcode_type        = $this->_getConfig('font_family_barcode', 'code128', false,'general',$store_id);
			switch ($barcode_type) 
			{
				case 'code128':
					$font_family_barcode 	= 'Code128bWin.ttf';
					break;

				case 'code39':
					$font_family_barcode 	= 'CODE39.ttf';
					
					break;	

				case 'code39x':
					$font_family_barcode 	= 'CODE39X.ttf';
					
					break;

				default:
					$font_family_barcode 	= 'Code128bWin.ttf';
					break;
			}
			
            $skuX                   = $skuXDefault;
            $qtyX                   = $qtyXDefault;
            $productX               = $this->_getConfig('pack_product', $productXDefault);
            $colorX                 = $this->_getConfig('pack_color', $colorXDefault);
            $sizeX                  = $this->_getConfig('pack_size', $sizeXDefault);
            $priceX                 = $this->_getConfig('pack_price', $priceXDefault);            
                  
             $non_standard_characters     = $this->_getConfig('non_standard_characters', 0, false,'general');

            $this->y        = $page->getHeight();
             /***********************************************************
            * CONFIGURATIONS
            ***********************************************************/
            $page->setFillColor(new Zend_Pdf_Color_GrayScale(0));
            $this->_setFontRegular($page, $font_size_overall);         
             
            # BARCODE
            if(1 == $showBarCode){
                $barcodeString = $this->convertToBarcodeString($order->getRealOrderId(),$barcode_type);
                $page->setFont(Zend_Pdf_Font::fontWithPath(dirname(__FILE__)  . '/' . $font_family_barcode), 16);  
                $page->drawText($barcodeString, $barcodeXY[0], $barcodeXY[1], 'CP1252');               
                $page->setFillColor(new Zend_Pdf_Color_GrayScale(0));
                $this->_setFontRegular($page, $font_size_overall);
            }            
                        
            # HEADER 

            // draw box behind order ID#
            $page->setFillColor(new Zend_Pdf_Color_GrayScale(0.92));            
            $page->setLineColor(new Zend_Pdf_Color_GrayScale(0.92));            
            $page->drawRectangle(20, ($orderIdXY[1]-5), $padded_right, ($orderIdXY[1]+18));
            $page->setFillColor(new Zend_Pdf_Color_GrayScale(0));            

            $this->_setFontBold($page,($font_size_titles+4));
            
            $order_date = '';
            if($order->getCreatedAtStoreDate()) $order_date = Mage::helper('core')->formatDate($order->getCreatedAtStoreDate(), 'medium', false);
        
            $page->drawText('/   '.$order_date, $orderDateXY[0], $orderDateXY[1], 'UTF-8');
            $page->drawText('#'.$order->getRealOrderId(), $orderIdXY[0], $orderIdXY[1], 'UTF-8');
            $this->_setFontRegular($page, $font_size_overall);

            // header logo
               $this->insertLogo($page, $page_size,'pack',$order->getStore());
   
               // HEADER STORE ADDRESS
            $this->y = 820;
            $this->_setFontRegular($page, $font_size_returnaddresstop);
            foreach (explode("\n", Mage::getStoreConfig('sales/identity/address', $order->getStore())) as $value)
            {
                if ($value!=='')
                {
                    $page->drawText(trim(strip_tags($value)), 320, $this->y, 'UTF-8');
                    $this->y -=6;
                }
            }
            $this->_setFontRegular($page, $font_size_overall);         

            // HEADER LINES
            // return address
            $page->setFillColor(new Zend_Pdf_Color_GrayScale(0));
            $page->setLineWidth(12);
            $page->setLineColor(new Zend_Pdf_Color_GrayScale(0.8));
            $page->drawLine(310, 795, 310, 825);
            
            # HEADER SHIPPING ADDRESS
            $shippingAddressFlat = implode(',',$this->_formatAddress($order->getShippingAddress()->format('pdf'))); 
               $shippingAddressArray = explode(',',str_replace(',','~,',$shippingAddressFlat));

            $this->_setFontBold($page,$font_size_titles);
            $page->drawText(Mage::helper('sales')->__('shipping address'), $addressXY[0], ($addressXY[1]+20), 'UTF-8');
            $this->_setFontRegular($page, $font_size_overall);
            
            $line_height = 0;

            foreach($shippingAddressArray as $item)
            {
                if((($addressXY[1]-$line_height) > 0) && $addressXY[0] > 0)
                {
                    $item = trim(str_replace('~',',',$item));
                    $page->drawText($item, $addressXY[0], ($addressXY[1]-$line_height), 'UTF-8');
                    $line_height = ($line_height + $font_size_overall);
                }
            }

            
            # FOOTER

            // order ID / address
            $page->setFillColor(new Zend_Pdf_Color_Rgb($fontColorGrey, $fontColorGrey, $fontColorGrey));
            $this->_setFontBold($page,($font_size_titles-3));
            $page->drawText('#'.$order->getRealOrderId(), $addressFooterXY[0], ($addressFooterXY[1]+20), 'UTF-8');           
            $this->_setFontRegular($page, $font_size_overall);         
            $page->setFillColor(new Zend_Pdf_Color_Rgb(0,0,0));
            
            $line_height = 0;
            $item_prev = '';
            $this->_setFontRegular($page, $font_size_shipaddress);  
            
            $i = 0;
            while($shippingAddressArray[$i])
            {
                
                if(isset($shippingAddressArray[$i]) && (($addressFooterXY[1]-$line_height) > 0) && $addressFooterXY[0] > 0)
                {
                    
                    
                    if(preg_match('~T:~',$shippingAddressArray[$i]))
                    {    
                        // phone line, grey it bracket it
                        $shippingAddressArray[$i] = trim(str_replace('~','',$shippingAddressArray[$i]));
                        $line_height = ($line_height + ($font_size_shipaddress/2));
                        $this->_setFontRegular($page, ($font_size_shipaddress-2));  
                        $page->setFillColor(new Zend_Pdf_Color_Rgb(($fontColorGrey-0.2), ($fontColorGrey-0.2), ($fontColorGrey-0.2)));
                        $shippingAddressArray[$i] = '[ '.$shippingAddressArray[$i].' ]';
                    }
                    else
                    {
                        // regular line or last line
                        $this->_setFontRegular($page, $font_size_shipaddress); 
                        
                        if(!isset($shippingAddressArray[($i+1)]) || preg_match('~T:~',$shippingAddressArray[($i+1)]))
                        {
                            // last line, lets bold it and make it a bit bigger
                            $shippingAddressArray[$i] = trim(str_replace('~','',$shippingAddressArray[$i]));
                            if($boldLastAddressLineYN == 'Y')
                            {
                                $this->_setFontBold($page, ($font_size_shipaddress+2));  
                                $line_height = ($line_height + 2);
                            }
                        }
                        else
                        {
                            $shippingAddressArray[$i] = trim(str_replace('~',',',$shippingAddressArray[$i]));
                        }
                        $page->setFillColor(new Zend_Pdf_Color_Rgb(0,0,0));
                    }
                    $page->drawText($shippingAddressArray[$i], $addressFooterXY[0], ($addressFooterXY[1]-$line_height), 'UTF-8');
                    $line_height = ($line_height + $font_size_shipaddress);
                }
                $i ++;
            }    
            $page->setFillColor(new Zend_Pdf_Color_Rgb(0,0,0));
            
            
            // footer return address logo
            if($show_return_logo_yn == 'Y')
            {
                $image = Mage::getStoreConfig('pickpack_options/wonder/pickpack_logo', $order->getStore());
                if ($image) 
                {
                    $image = Mage::getStoreConfig('system/filesystem/media', $order->getStore()) . '/moogento/pickpack/logo_third/' . $image;
                    if (is_file($image)) 
                    {
                        $image = Zend_Pdf_Image::imageWithPath($image);
                        // $page->drawImage($image, 315+$newlogo[1], 180+$newlogo[0], 500+$newlogo[0], 200+$newlogo[0]);
                        $page->drawImage($image, $return_logo_XY[0], $return_logo_XY[1], ($return_logo_XY[0]+185), ($return_logo_XY[1]+20));
                    }
                }
            }
            
            // footer store address
            $this->_setFontRegular($page, $font_size_returnaddress);  
            $page->setFillColor(new Zend_Pdf_Color_Rgb($fontColorReturnAddressFooter,$fontColorReturnAddressFooter,$fontColorReturnAddressFooter));       
               // $store_address = $this->insertAddress($page, 'bottom', $order->getStore());
            // $this->y = 105;
            $page->drawText(Mage::helper('sales')->__('From').' :', $returnAddressFooterXY[0], $returnAddressFooterXY[1], 'UTF-8');
            // $this->y -=18;
            $line_height = 15;
            foreach (explode("\n", Mage::getStoreConfig('sales/identity/address', $order->getStore())) as $value)
            {
                if ($value!=='')
                {
                    $page->drawText(trim(strip_tags($value)), $returnAddressFooterXY[0], ($returnAddressFooterXY[1]-$line_height), 'UTF-8');    
                    $line_height = ($line_height + $font_size_returnaddress);
                }
                
            }
            $this->_setFontRegular($page, $font_size_overall);         
            
            # ITEMS
            $this->y         = $columnYNudge;  
            $this->_itemsY   = $this->y;  

            // draw box behind table headers
            $page->setFillColor(new Zend_Pdf_Color_GrayScale(0.92));            
            $page->setLineColor(new Zend_Pdf_Color_GrayScale(0.92));            
            $page->drawRectangle((20), ($columnYNudge-2), ($padded_right), ($columnYNudge+10));

            /* Add table head */
            $page->setFillColor(new Zend_Pdf_Color_Rgb(($fontColorGrey-0.5),($fontColorGrey-0.5),($fontColorGrey-0.5)));
            $this->_setFontBold($page,($font_size_titles));
            $page->drawText(Mage::helper('sales')->__('qty'), $qtyX, $this->y, 'UTF-8');
            $page->drawText(Mage::helper('sales')->__('items'), $productX, $this->y, 'UTF-8');
            $page->drawText(Mage::helper('sales')->__('codes'), $skuX, $this->y, 'UTF-8');
            if($showPriceYN == 'Y') $page->drawText(Mage::helper('sales')->__('Price'), $priceX, $this->y, 'UTF-8');
            
        
            $this->y = ($this->y - 28);

            $counter = 1;   
            $itemsCollection =  $order->getAllVisibleItems();//$order->getItemsCollection();
            $total_items     = count($itemsCollection);
            
            $page->setFillColor(new Zend_Pdf_Color_GrayScale(0));
            $this->_setFontRegular($page, $font_size_productline);                      
            foreach ($itemsCollection as $item)
            {
                 #if(!$item->isDummy())
                 {               
                                     
                    $size = '';
                    $color = ''; 
                    $options = $item->getProductOptions();
                    $color_attribute_id = Mage::getModel('eav/entity_attribute')->loadByCode('catalog_product', $color_attribute_name)->getAttributeId();//272
                    $size_attribute_id = Mage::getModel('eav/entity_attribute')->loadByCode('catalog_product', $size_attribute_name)->getAttributeId();//525
                    
                    $size_id  = $options['info_buyRequest']['super_attribute'][$size_attribute_id]; #size
                    $color_id = $options['info_buyRequest']['super_attribute'][$color_attribute_id]; #color                    
                    $sizeCollection = Mage::getResourceModel('eav/entity_attribute_option_collection')                
                    ->setStoreFilter(0)                   
                    ->setAttributeFilter($size_attribute_id)                    
                    ->load(); 
                    foreach($sizeCollection as $_size){                        
                        if($_size->getOptionId() == $size_id){
                            $size = $_size->getValue();
                            break;
                        }
                    }                    
                   
                    $colorCollection = Mage::getResourceModel('eav/entity_attribute_option_collection')                
                    ->setStoreFilter(0)                   
                    ->setAttributeFilter($color_attribute_id)                    
                    ->load();         
                    foreach($colorCollection as $_color){                        
                        if($_color->getOptionId() == $color_id){
                            $color = $_color->getValue();
                            break;
                        }
                    }                   
                                   
                                
                    $qty = $item->getIsQtyDecimal() ? $item->getQtyOrdered() : (int) $item->getQtyOrdered();
                    
                    $qty_string = ($from_shipment == 'shipment') ? 's:'.(int)$item->getQtyShipped() . ' / o:'.$qty : $qty;

                    $page->drawText($qty_string, ($qtyX+8), $this->y , 'UTF-8');
                    $page->drawText($item->getSku(), $skuX, $this->y , 'UTF-8');
                    $page->drawText($item->getName(), $productX, $this->y , 'UTF-8');
                    
                    if($showColorYN == 'Y')
                    {
                        $page->drawText($color, $colorX, $this->y , 'UTF-8');
                    }
                    
                    if($showSizeYN == 'Y')
                    {
                        $page->drawText($size, $sizeX, $this->y , 'UTF-8');                    
                    }
                    
                    // show price if set to show
                    if($showPriceYN == 'Y')
                    {
                        $price = $qty * $item->getPriceInclTax();
                        $page->drawText(number_format($price, 2, '.', ','), $priceX, $this->y , 'UTF-8');
                    }
                    
                    $this->y -= 15;
                    
                    if(($counter % $cutoff_no) == 0 && $counter != $total_items){
                        $page = $this->newPage2();
                    }
                    
                    $counter++;
                }
            }             
        }            
        /***********************************************
        * PickList Template - END
        ************************************************/
        $this->_afterGetPdf();
        return $pdf;
    }


    
    public function getPdf($invoices = array())
    {
        
        /**
         * get store id
         */
        $store_id = Mage::app()->getStore()->getId();

        $show_price = 0;
        $this->_beforeGetPdf();
        $this->_initRenderer('invoices');

        $pdf = new Zend_Pdf();
        $this->_setPdf($pdf);
        $style = new Zend_Pdf_Style();
        $this->_setFontBold($page, 10);
        
         
            foreach ($invoices as $invoice)
            {
                if ($invoice->getStoreId()) {
                    Mage::app()->getLocale()->emulate($invoice->getStoreId());
                }
                
                $page_size = $this->_getConfig('page_size', 'a4', false,'general');

                if($page_size == 'letter') 
                {
                    $page = $pdf->newPage(Zend_Pdf_Page::SIZE_LETTER);
                    $page_top = 770;$padded_right = 587;
                }
                elseif($page_size == 'a4') 
                {
                    $page = $pdf->newPage(Zend_Pdf_Page::SIZE_A4);
                    $page_top = 820;$padded_right = 570;
                }
                elseif($page_size == 'a5landscape') 
                {
                    $page = $pdf->newPage('596:421');                    
                    $page_top = 395;$padded_right = 573;
                }
                
                $pdf->pages[] = $page;
    
                $order = $invoice->getOrder();
    
                /* Add image */
                $this->insertLogo($page, $page_size,'pack',$order->getStore());
    
                /* Add address */
                $store_address = $this->insertAddress($page, 'top', $order->getStore());
    
                /* Add head */
                $this->insertOrder($page, $order, Mage::getStoreConfigFlag(self::XML_PATH_SALES_PDF_INVOICE_PUT_ORDER_ID, $order->getStoreId()));
    
    			$barcode_type        = $this->_getConfig('font_family_barcode', 'code128', false,'general',$store_id);
				switch ($barcode_type) 
				{
					case 'code128':
						$font_family_barcode 	= 'Code128bWin.ttf';
						break;

					case 'code39':
						$font_family_barcode 	= 'CODE39.ttf';
						
						break;	

					case 'code39x':
						$font_family_barcode 	= 'CODE39X.ttf';
						
						break;

					default:
						$font_family_barcode 	= 'Code128bWin.ttf';
						break;
				}
				
                $barcode = Mage::getStoreConfig('pickpack_options/wonder/pickpack_packbarcode');
                if($barcode==1){
                    $barcodeString = $this->convertToBarcodeString($order->getRealOrderId(),$barcode_type);
                    $page->setFillColor(new Zend_Pdf_Color_RGB(0, 0, 0));
                    $page->setFont(Zend_Pdf_Font::fontWithPath(dirname(__FILE__)  . '/' . $font_family_barcode), 18);
                    $page->drawText($barcodeString, 452, 800, 'CP1252');
                }
    
                $page->setFillColor(new Zend_Pdf_Color_GrayScale(1));
                $this->_setFontRegular($page);
                //$page->drawText(Mage::helper('sales')->__('Invoice # ') . $invoice->getIncrementId(), 35, 780, 'UTF-8');
    
                /* Add products list table */        
                $page->setFillColor(new Zend_Pdf_Color_Rgb(0.93, 0.92, 0.92));
                $page->setLineColor(new Zend_Pdf_Color_GrayScale(0.92));            
                $this->_setFontItalic($page,14);
            
    
                //                   ? xpos header rectangle  ? width            ? height header rectangle
                $page->drawRectangle(25, $this->y, $padded_right, $this->y -20);
    
                // HEIGHT PRODUCTS HEADER lINE
                $this->y -=15;
    
                /* Add table head */
                $page->setFillColor(new Zend_Pdf_Color_RGB(0.4, 0.4, 0.4));
                $page->drawText(Mage::helper('sales')->__('items'), 35, $this->y, 'UTF-8');
                $page->drawText(Mage::helper('sales')->__('codes'), 255, $this->y, 'UTF-8');
                if($show_price > 0) $page->drawText(Mage::helper('sales')->__('Price'), 370, $this->y, 'UTF-8');
                $page->drawText(Mage::helper('sales')->__('numbers'), 420, $this->y, 'UTF-8');
                // $page->drawText(Mage::helper('sales')->__('Tax'), 480, $this->y, 'UTF-8');
                if($show_price > 0) $page->drawText(Mage::helper('sales')->__('Subtotal'), 525, $this->y, 'UTF-8');
                
            
                $this->y -=20;
    
                $page->setFillColor(new Zend_Pdf_Color_GrayScale(0));
    
                /* Add body */
                foreach ($invoice->getAllItems() as $item)
                {
                    if ($item->getOrderItem()->getParentItem())
                    {
                        continue;
                    }
    
                    if ($this->y < 15)
                    {
                        $page = $this->newPage(array('table_header' => true));
                    }
    
                    /* Draw item */
                    $page = $this->_drawItem($item, $page, $order);
                    $this->y -=8;
                }
    
                /* Add totals */
                if($show_price > 0) $page = $this->insertTotals($page, $invoice);
    
                // bottom address label
                $this->y =115;
    
                /* Add table head */
                $page->setFillColor(new Zend_Pdf_Color_RGB(0.4, 0.4, 0.4));    
                    
                /* Add bottom store address */
                $store_address = $this->insertAddress($page, 'bottom', $order->getStore());
                $this->y -=20;
                if ($invoice->getStoreId())
                {
                    Mage::app()->getLocale()->revert();
                }
    
            }
        
        
        
        $this->_afterGetPdf();
        return $pdf;
    }

    /**
     * Create new page and assign to PDF object
     *
     * @param array $settings
     * @return Zend_Pdf_Page
     */
    public function newPage(array $settings = array())
    {
        $page_size = $this->_getConfig('page_size', 'a4', false,'general');
        if($page_size == 'letter') 
        {
            $settings['page_size'] = Zend_Pdf_Page::SIZE_LETTER;
            $page_top = 770;$padded_right = 587;
        }
        else if($page_size == 'a4') 
        {
            $settings['page_size'] = Zend_Pdf_Page::SIZE_A4;
            
            // $page = $pdf->newPage(Zend_Pdf_Page::SIZE_A4);
            $page_top = 820;$padded_right = 570;
        }
        elseif($page_size == 'a5landscape') 
        {
            $settings['page_size'] = '596:421';
            
            // $page = $pdf->newPage('596:421');                    
            $page_top = 395;$padded_right = 573;
        }

        $pageSize = !empty($settings['page_size']) ? $settings['page_size'] : Zend_Pdf_Page::SIZE_A4;
        $page = $this->_getPdf()->newPage($pageSize);
        
        $this->_getPdf()->pages[] = $page;
        $this->y = ($page_top-20);

        return $page;
    }
    
    public function newPageLabel(array $settings = array())
    {
        $page_size = $this->_getConfig('page_size', 'a4', false,'label');
        if($page_size == 'letter') 
        {
            $settings['page_size'] = Zend_Pdf_Page::SIZE_LETTER;
            $page_top = 770;$padded_right = 587;
        }
        else if($page_size == 'a4') 
        {
            $settings['page_size'] = Zend_Pdf_Page::SIZE_A4;
            
            // $page = $pdf->newPage(Zend_Pdf_Page::SIZE_A4);
            $page_top = 820;$padded_right = 570;
        }
        elseif($page_size == 'a5landscape') 
        {
            $settings['page_size'] = '596:421';
            
            // $page = $pdf->newPage('596:421');                    
            $page_top = 395;$padded_right = 573;
        }
        elseif($page_size == 'zebra') 
        {
            $settings['page_size'] = '288:432';
            
            // $page = $pdf->newPage('596:421');                    
            $page_top = 286;$padded_right = 430;
        }

        $pageSize = !empty($settings['page_size']) ? $settings['page_size'] : Zend_Pdf_Page::SIZE_A4;
        $page = $this->_getPdf()->newPage($pageSize);
        
        $this->_getPdf()->pages[] = $page;
        $this->y = ($page_top-20);

        return $page;
    }
    
    private function newPage2(){
        
        $page_size = $this->_getConfig('page_size', 'a4', false,'general');
        
        if($page_size == 'letter') 
        {
            $page = $pdf->newPage(Zend_Pdf_Page::SIZE_LETTER);
            $page_top = 770;$padded_right = 587;
        }
        elseif($page_size == 'a4') 
        {
            $page = $pdf->newPage(Zend_Pdf_Page::SIZE_A4);
            $page_top = 820;$padded_right = 570;
        }
        
        $this->_getPdf()->pages[]     = $page;
        $this->y                      = $this->_itemsY;  
        
        $font_size_productline   = $this->_getConfig('pickpack_fontsizeproductline', 9, false);
        $page->setFillColor(new Zend_Pdf_Color_GrayScale(0));
        $this->_setFontRegular($page, $font_size_productline);       
        return $page;    
    }  
    
    
        

     private function _getConfig($field, $default = '', $add_default = true, $group = 'wonder', $store = null){
        $value = trim(Mage::getStoreConfig('pickpack_options/'.$group.'/'.$field, $store));

        if(strstr($field,'_color') !== FALSE) 
        {
            if($value != 0 && $value != 1)
            {            
                $value = checkColor($value);
            }
        }

        if($value == '')
        {
            return $default;
        }
        else
        {
			if($field == 'csv_field_separator' && $value == ',') return $value;
            // if(preg_match('~[a-zA-Z0-9]~',$value) === true && (strpos($value, ',') !== false) && (strpos($default, ',') !== false))// && (strpos($value, "\n")))
            if(($value!=='') && (strpos($value, ',') !== false) && (strpos($default, ',') !== false))// && (strpos($value, "\n")))
            {
                $values = explode(",", $value);
                $defaults = explode(",", $default);

                if($add_default===true)
                {
                    $value = ($values[0] + $defaults[0]) . ',' . ($values[1] + $defaults[1]);
                }     
                else
                {
                    $value = '';
                    $count = 0;
					$default_count = count($defaults);
                    foreach($defaults as $i => $v)                    
                    {
                        //if($value != '') $value .= ',';
						if(($count != ($default_count)) && ($count != 0)) $value .= ',';
                        if(isset($values[$i]) && $values[$i] != '') $value .= $values[$i];
                        else $value .= $v;
                        $count ++;
                    }
                }
            }
            else
            {
                $value = ($add_default) ? ($value + $default) : $value; 
            }            
            return $value;
        }
    }

    private function parseString($string, $font=null, $fontsize=null) 
    { 
        if (is_null($font)) $font = $this->_font; 
        if (is_null($fontsize)) $fontsize = $this->_fontsize; 
    
        $drawingString = iconv('UTF-8', 'UTF-16BE//TRANSLIT//IGNORE', $string);
        $characters = array(); 
        for ($i = 0; $i < strlen($drawingString); $i++) 
        { 
            $characters[] = (ord($drawingString[$i++]) << 8) | ord($drawingString[$i]); 
        } 
        $glyphs = $font->glyphNumbersForCharacters($characters); 
        $widths = $font->widthsForGlyphs($glyphs); 
        $stringWidth = (array_sum($widths) / $font->getUnitsPerEm()) * $fontsize; 
        return $stringWidth; 
    }
}
?>